/* CanvasText.c generated by valac 0.45.3, the Vala compiler
 * generated from CanvasText.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <libxml/tree.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <pango/pangocairo.h>

#define TYPE_CANVAS_TEXT (canvas_text_get_type ())
#define CANVAS_TEXT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CANVAS_TEXT, CanvasText))
#define CANVAS_TEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CANVAS_TEXT, CanvasTextClass))
#define IS_CANVAS_TEXT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CANVAS_TEXT))
#define IS_CANVAS_TEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CANVAS_TEXT))
#define CANVAS_TEXT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CANVAS_TEXT, CanvasTextClass))

typedef struct _CanvasText CanvasText;
typedef struct _CanvasTextClass CanvasTextClass;
typedef struct _CanvasTextPrivate CanvasTextPrivate;
enum  {
	CANVAS_TEXT_0_PROPERTY,
	CANVAS_TEXT_TEXT_PROPERTY,
	CANVAS_TEXT_POSX_PROPERTY,
	CANVAS_TEXT_POSY_PROPERTY,
	CANVAS_TEXT_WIDTH_PROPERTY,
	CANVAS_TEXT_HEIGHT_PROPERTY,
	CANVAS_TEXT_MARKUP_PROPERTY,
	CANVAS_TEXT_EDIT_PROPERTY,
	CANVAS_TEXT_NUM_PROPERTIES
};
static GParamSpec* canvas_text_properties[CANVAS_TEXT_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_THEME (theme_get_type ())
#define THEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME, Theme))
#define THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME, ThemeClass))
#define IS_THEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME))
#define IS_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME))
#define THEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME, ThemeClass))

typedef struct _Theme Theme;
typedef struct _ThemeClass ThemeClass;
#define _pango_layout_line_unref0(var) ((var == NULL) ? NULL : (var = (pango_layout_line_unref (var), NULL)))
enum  {
	CANVAS_TEXT_RESIZED_SIGNAL,
	CANVAS_TEXT_NUM_SIGNALS
};
static guint canvas_text_signals[CANVAS_TEXT_NUM_SIGNALS] = {0};

struct _CanvasText {
	GObject parent_instance;
	CanvasTextPrivate * priv;
};

struct _CanvasTextClass {
	GObjectClass parent_class;
	void (*load) (CanvasText* self, xmlNode* n);
	void (*resize) (CanvasText* self, gdouble diff);
};

struct _CanvasTextPrivate {
	gchar* _text;
	gboolean _markup;
	gboolean _edit;
	gint _cursor;
	gint _column;
	PangoLayout* _pango_layout;
	gint _selstart;
	gint _selend;
	gint _selanchor;
	gdouble _max_width;
	gdouble _width;
	gdouble _height;
	gdouble _posx;
	gdouble _posy;
};

static gint CanvasText_private_offset;
static gpointer canvas_text_parent_class = NULL;

GType canvas_text_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CanvasText, g_object_unref)
GType draw_area_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DrawArea, g_object_unref)
CanvasText* canvas_text_new (DrawArea* da,
                             gdouble max_width);
CanvasText* canvas_text_construct (GType object_type,
                                   DrawArea* da,
                                   gdouble max_width);
void canvas_text_update_size (CanvasText* self,
                              gboolean call_resized);
CanvasText* canvas_text_new_with_text (DrawArea* da,
                                       gdouble max_width,
                                       const gchar* txt);
CanvasText* canvas_text_construct_with_text (GType object_type,
                                             DrawArea* da,
                                             gdouble max_width,
                                             const gchar* txt);
void canvas_text_copy (CanvasText* self,
                       CanvasText* ct);
gdouble canvas_text_get_posx (CanvasText* self);
void canvas_text_set_posx (CanvasText* self,
                           gdouble value);
gdouble canvas_text_get_posy (CanvasText* self);
void canvas_text_set_posy (CanvasText* self,
                           gdouble value);
const gchar* canvas_text_get_text (CanvasText* self);
gint canvas_text_max_width (CanvasText* self);
void canvas_text_set_font (CanvasText* self,
                           PangoFontDescription* font);
gboolean canvas_text_is_wrapped (CanvasText* self);
gboolean canvas_text_is_within (CanvasText* self,
                                gdouble x,
                                gdouble y);
gboolean utils_is_within_bounds (gdouble x,
                                 gdouble y,
                                 gdouble bx,
                                 gdouble by,
                                 gdouble bw,
                                 gdouble bh);
void canvas_text_load (CanvasText* self,
                       xmlNode* n);
static void canvas_text_real_load (CanvasText* self,
                            xmlNode* n);
void canvas_text_set_text (CanvasText* self,
                           const gchar* value);
static gchar* canvas_text_unmarkup (CanvasText* self,
                             const gchar* markup);
GType theme_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Theme, g_object_unref)
static gchar* canvas_text_name_markup (CanvasText* self,
                                Theme* theme);
gchar* utils_color_from_rgba (GdkRGBA* rgba);
void theme_get_textsel_foreground (Theme* self,
                                   GdkRGBA * result);
void theme_get_textsel_background (Theme* self,
                                   GdkRGBA * result);
gboolean canvas_text_get_markup (CanvasText* self);
gboolean canvas_text_get_edit (CanvasText* self);
void canvas_text_resize (CanvasText* self,
                         gdouble diff);
static void canvas_text_real_resize (CanvasText* self,
                              gdouble diff);
static void canvas_text_update_column (CanvasText* self);
void canvas_text_set_cursor_at_char (CanvasText* self,
                                     gdouble x,
                                     gdouble y,
                                     gboolean motion);
void canvas_text_set_cursor_at_word (CanvasText* self,
                                     gdouble x,
                                     gdouble y,
                                     gboolean motion);
void canvas_text_clear_selection (CanvasText* self);
static void canvas_text_adjust_selection (CanvasText* self,
                                   gint last_cursor);
void canvas_text_set_cursor_none (CanvasText* self);
void canvas_text_set_cursor_all (CanvasText* self,
                                 gboolean motion);
static void canvas_text_cursor_by_char (CanvasText* self,
                                 gint dir);
void canvas_text_move_cursor (CanvasText* self,
                              gint dir);
void canvas_text_selection_by_char (CanvasText* self,
                                    gint dir);
static void canvas_text_cursor_by_line (CanvasText* self,
                                 gint dir);
void canvas_text_move_cursor_vertically (CanvasText* self,
                                         gint dir);
void canvas_text_selection_vertically (CanvasText* self,
                                       gint dir);
void canvas_text_move_cursor_to_start (CanvasText* self);
void canvas_text_move_cursor_to_end (CanvasText* self);
void canvas_text_selection_to_start (CanvasText* self);
void canvas_text_selection_to_end (CanvasText* self);
static gint canvas_text_find_word (CanvasText* self,
                            gint start,
                            gint dir);
void canvas_text_move_cursor_by_word (CanvasText* self,
                                      gint dir);
void canvas_text_selection_by_word (CanvasText* self,
                                    gint dir);
void canvas_text_backspace (CanvasText* self);
void canvas_text_delete (CanvasText* self);
void canvas_text_insert (CanvasText* self,
                         const gchar* s);
gchar* canvas_text_get_selected_text (CanvasText* self);
void canvas_text_get_cursor_pos (CanvasText* self,
                                 gint* x,
                                 gint* ytop,
                                 gint* ybot);
void canvas_text_draw (CanvasText* self,
                       cairo_t* ctx,
                       Theme* theme,
                       GdkRGBA* fg,
                       gdouble alpha);
void utils_set_context_color_with_alpha (cairo_t* ctx,
                                         GdkRGBA* color,
                                         gdouble alpha);
void theme_get_text_cursor (Theme* self,
                            GdkRGBA * result);
gdouble canvas_text_get_width (CanvasText* self);
gdouble canvas_text_get_height (CanvasText* self);
void canvas_text_set_markup (CanvasText* self,
                             gboolean value);
void canvas_text_set_edit (CanvasText* self,
                           gboolean value);
static void canvas_text_finalize (GObject * obj);
static void _vala_canvas_text_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_canvas_text_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

static inline gpointer
canvas_text_get_instance_private (CanvasText* self)
{
	return G_STRUCT_MEMBER_P (self, CanvasText_private_offset);
}

CanvasText*
canvas_text_construct (GType object_type,
                       DrawArea* da,
                       gdouble max_width)
{
	CanvasText * self = NULL;
	PangoLayout* _tmp0_;
	PangoLayout* _tmp1_;
	PangoLayout* _tmp2_;
#line 95 "../src/CanvasText.vala"
	g_return_val_if_fail (da != NULL, NULL);
#line 95 "../src/CanvasText.vala"
	self = (CanvasText*) g_object_new (object_type, NULL);
#line 96 "../src/CanvasText.vala"
	self->priv->_max_width = max_width;
#line 97 "../src/CanvasText.vala"
	_tmp0_ = gtk_widget_create_pango_layout ((GtkWidget*) da, NULL);
#line 97 "../src/CanvasText.vala"
	_g_object_unref0 (self->priv->_pango_layout);
#line 97 "../src/CanvasText.vala"
	self->priv->_pango_layout = _tmp0_;
#line 98 "../src/CanvasText.vala"
	_tmp1_ = self->priv->_pango_layout;
#line 98 "../src/CanvasText.vala"
	pango_layout_set_wrap (_tmp1_, PANGO_WRAP_WORD_CHAR);
#line 99 "../src/CanvasText.vala"
	_tmp2_ = self->priv->_pango_layout;
#line 99 "../src/CanvasText.vala"
	pango_layout_set_width (_tmp2_, ((gint) self->priv->_max_width) * PANGO_SCALE);
#line 100 "../src/CanvasText.vala"
	canvas_text_update_size (self, FALSE);
#line 95 "../src/CanvasText.vala"
	return self;
#line 298 "CanvasText.c"
}

CanvasText*
canvas_text_new (DrawArea* da,
                 gdouble max_width)
{
#line 95 "../src/CanvasText.vala"
	return canvas_text_construct (TYPE_CANVAS_TEXT, da, max_width);
#line 307 "CanvasText.c"
}

CanvasText*
canvas_text_construct_with_text (GType object_type,
                                 DrawArea* da,
                                 gdouble max_width,
                                 const gchar* txt)
{
	CanvasText * self = NULL;
	PangoLayout* _tmp0_;
	PangoLayout* _tmp1_;
	PangoLayout* _tmp2_;
	gchar* _tmp3_;
#line 104 "../src/CanvasText.vala"
	g_return_val_if_fail (da != NULL, NULL);
#line 104 "../src/CanvasText.vala"
	g_return_val_if_fail (txt != NULL, NULL);
#line 104 "../src/CanvasText.vala"
	self = (CanvasText*) g_object_new (object_type, NULL);
#line 105 "../src/CanvasText.vala"
	self->priv->_max_width = max_width;
#line 106 "../src/CanvasText.vala"
	_tmp0_ = gtk_widget_create_pango_layout ((GtkWidget*) da, txt);
#line 106 "../src/CanvasText.vala"
	_g_object_unref0 (self->priv->_pango_layout);
#line 106 "../src/CanvasText.vala"
	self->priv->_pango_layout = _tmp0_;
#line 107 "../src/CanvasText.vala"
	_tmp1_ = self->priv->_pango_layout;
#line 107 "../src/CanvasText.vala"
	pango_layout_set_wrap (_tmp1_, PANGO_WRAP_WORD_CHAR);
#line 108 "../src/CanvasText.vala"
	_tmp2_ = self->priv->_pango_layout;
#line 108 "../src/CanvasText.vala"
	pango_layout_set_width (_tmp2_, ((gint) self->priv->_max_width) * PANGO_SCALE);
#line 109 "../src/CanvasText.vala"
	_tmp3_ = g_strdup (txt);
#line 109 "../src/CanvasText.vala"
	_g_free0 (self->priv->_text);
#line 109 "../src/CanvasText.vala"
	self->priv->_text = _tmp3_;
#line 110 "../src/CanvasText.vala"
	canvas_text_update_size (self, FALSE);
#line 104 "../src/CanvasText.vala"
	return self;
#line 353 "CanvasText.c"
}

CanvasText*
canvas_text_new_with_text (DrawArea* da,
                           gdouble max_width,
                           const gchar* txt)
{
#line 104 "../src/CanvasText.vala"
	return canvas_text_construct_with_text (TYPE_CANVAS_TEXT, da, max_width, txt);
#line 363 "CanvasText.c"
}

void
canvas_text_copy (CanvasText* self,
                  CanvasText* ct)
{
	gdouble _tmp0_;
	gdouble _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	PangoLayout* _tmp5_;
	PangoLayout* _tmp6_;
	PangoFontDescription* _tmp7_;
	PangoLayout* _tmp8_;
#line 114 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 114 "../src/CanvasText.vala"
	g_return_if_fail (ct != NULL);
#line 115 "../src/CanvasText.vala"
	_tmp0_ = ct->priv->_posx;
#line 115 "../src/CanvasText.vala"
	canvas_text_set_posx (self, _tmp0_);
#line 116 "../src/CanvasText.vala"
	_tmp1_ = ct->priv->_posy;
#line 116 "../src/CanvasText.vala"
	canvas_text_set_posy (self, _tmp1_);
#line 117 "../src/CanvasText.vala"
	self->priv->_max_width = ct->priv->_max_width;
#line 118 "../src/CanvasText.vala"
	_tmp2_ = canvas_text_get_text (ct);
#line 118 "../src/CanvasText.vala"
	_tmp3_ = _tmp2_;
#line 118 "../src/CanvasText.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 118 "../src/CanvasText.vala"
	_g_free0 (self->priv->_text);
#line 118 "../src/CanvasText.vala"
	self->priv->_text = _tmp4_;
#line 119 "../src/CanvasText.vala"
	_tmp5_ = self->priv->_pango_layout;
#line 119 "../src/CanvasText.vala"
	_tmp6_ = ct->priv->_pango_layout;
#line 119 "../src/CanvasText.vala"
	_tmp7_ = pango_layout_get_font_description (_tmp6_);
#line 119 "../src/CanvasText.vala"
	pango_layout_set_font_description (_tmp5_, _tmp7_);
#line 120 "../src/CanvasText.vala"
	_tmp8_ = self->priv->_pango_layout;
#line 120 "../src/CanvasText.vala"
	pango_layout_set_width (_tmp8_, ((gint) self->priv->_max_width) * PANGO_SCALE);
#line 121 "../src/CanvasText.vala"
	canvas_text_update_size (self, TRUE);
#line 417 "CanvasText.c"
}

gint
canvas_text_max_width (CanvasText* self)
{
	gint result = 0;
#line 125 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 126 "../src/CanvasText.vala"
	result = (gint) self->priv->_max_width;
#line 126 "../src/CanvasText.vala"
	return result;
#line 430 "CanvasText.c"
}

void
canvas_text_set_font (CanvasText* self,
                      PangoFontDescription* font)
{
	PangoLayout* _tmp0_;
#line 130 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 130 "../src/CanvasText.vala"
	g_return_if_fail (font != NULL);
#line 131 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_pango_layout;
#line 131 "../src/CanvasText.vala"
	pango_layout_set_font_description (_tmp0_, font);
#line 132 "../src/CanvasText.vala"
	canvas_text_update_size (self, TRUE);
#line 448 "CanvasText.c"
}

gboolean
canvas_text_is_wrapped (CanvasText* self)
{
	gboolean result = FALSE;
	PangoLayout* _tmp0_;
#line 136 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 137 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_pango_layout;
#line 137 "../src/CanvasText.vala"
	result = pango_layout_is_wrapped (_tmp0_);
#line 137 "../src/CanvasText.vala"
	return result;
#line 464 "CanvasText.c"
}

gboolean
canvas_text_is_within (CanvasText* self,
                       gdouble x,
                       gdouble y)
{
	gboolean result = FALSE;
	gdouble _tmp0_;
	gdouble _tmp1_;
#line 141 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 142 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_posx;
#line 142 "../src/CanvasText.vala"
	_tmp1_ = self->priv->_posy;
#line 142 "../src/CanvasText.vala"
	result = utils_is_within_bounds (x, y, _tmp0_, _tmp1_, self->priv->_width, self->priv->_height);
#line 142 "../src/CanvasText.vala"
	return result;
#line 485 "CanvasText.c"
}

static gdouble
double_parse (const gchar* str)
{
	gdouble result = 0.0;
#line 944 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0.0);
#line 945 "glib-2.0.vapi"
	result = g_ascii_strtod (str, NULL);
#line 945 "glib-2.0.vapi"
	return result;
#line 498 "CanvasText.c"
}

static void
canvas_text_real_load (CanvasText* self,
                       xmlNode* n)
{
	gchar* x = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* y = NULL;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* mw = NULL;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gboolean _tmp10_ = FALSE;
	xmlNode* _tmp11_;
#line 148 "../src/CanvasText.vala"
	_tmp0_ = (gchar*) xmlGetProp (n, (xmlChar*) "posx");
#line 148 "../src/CanvasText.vala"
	x = _tmp0_;
#line 149 "../src/CanvasText.vala"
	_tmp1_ = x;
#line 149 "../src/CanvasText.vala"
	if (_tmp1_ != NULL) {
#line 524 "CanvasText.c"
		const gchar* _tmp2_;
#line 150 "../src/CanvasText.vala"
		_tmp2_ = x;
#line 150 "../src/CanvasText.vala"
		canvas_text_set_posx (self, double_parse (_tmp2_));
#line 530 "CanvasText.c"
	}
#line 153 "../src/CanvasText.vala"
	_tmp3_ = (gchar*) xmlGetProp (n, (xmlChar*) "posy");
#line 153 "../src/CanvasText.vala"
	y = _tmp3_;
#line 154 "../src/CanvasText.vala"
	_tmp4_ = y;
#line 154 "../src/CanvasText.vala"
	if (_tmp4_ != NULL) {
#line 540 "CanvasText.c"
		const gchar* _tmp5_;
#line 155 "../src/CanvasText.vala"
		_tmp5_ = y;
#line 155 "../src/CanvasText.vala"
		canvas_text_set_posy (self, double_parse (_tmp5_));
#line 546 "CanvasText.c"
	}
#line 158 "../src/CanvasText.vala"
	_tmp6_ = (gchar*) xmlGetProp (n, (xmlChar*) "maxwidth");
#line 158 "../src/CanvasText.vala"
	mw = _tmp6_;
#line 159 "../src/CanvasText.vala"
	_tmp7_ = mw;
#line 159 "../src/CanvasText.vala"
	if (_tmp7_ != NULL) {
#line 556 "CanvasText.c"
		const gchar* _tmp8_;
		PangoLayout* _tmp9_;
#line 160 "../src/CanvasText.vala"
		_tmp8_ = mw;
#line 160 "../src/CanvasText.vala"
		self->priv->_max_width = double_parse (_tmp8_);
#line 161 "../src/CanvasText.vala"
		_tmp9_ = self->priv->_pango_layout;
#line 161 "../src/CanvasText.vala"
		pango_layout_set_width (_tmp9_, ((gint) self->priv->_max_width) * PANGO_SCALE);
#line 567 "CanvasText.c"
	}
#line 164 "../src/CanvasText.vala"
	_tmp11_ = n->children;
#line 164 "../src/CanvasText.vala"
	if (_tmp11_ != NULL) {
#line 573 "CanvasText.c"
		xmlNode* _tmp12_;
		xmlElementType _tmp13_;
#line 164 "../src/CanvasText.vala"
		_tmp12_ = n->children;
#line 164 "../src/CanvasText.vala"
		_tmp13_ = _tmp12_->type;
#line 164 "../src/CanvasText.vala"
		_tmp10_ = _tmp13_ == XML_TEXT_NODE;
#line 582 "CanvasText.c"
	} else {
#line 164 "../src/CanvasText.vala"
		_tmp10_ = FALSE;
#line 586 "CanvasText.c"
	}
#line 164 "../src/CanvasText.vala"
	if (_tmp10_) {
#line 590 "CanvasText.c"
		xmlNode* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 165 "../src/CanvasText.vala"
		_tmp14_ = n->children;
#line 165 "../src/CanvasText.vala"
		_tmp15_ = (gchar*) xmlNodeGetContent (_tmp14_);
#line 165 "../src/CanvasText.vala"
		_tmp16_ = _tmp15_;
#line 165 "../src/CanvasText.vala"
		canvas_text_set_text (self, _tmp16_);
#line 165 "../src/CanvasText.vala"
		_g_free0 (_tmp16_);
#line 604 "CanvasText.c"
	}
#line 146 "../src/CanvasText.vala"
	_g_free0 (mw);
#line 146 "../src/CanvasText.vala"
	_g_free0 (y);
#line 146 "../src/CanvasText.vala"
	_g_free0 (x);
#line 612 "CanvasText.c"
}

void
canvas_text_load (CanvasText* self,
                  xmlNode* n)
{
#line 146 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 146 "../src/CanvasText.vala"
	CANVAS_TEXT_GET_CLASS (self)->load (self, n);
#line 623 "CanvasText.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 1480 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1480 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1480 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1481 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1481 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 645 "CanvasText.c"
	} else {
#line 1481 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 649 "CanvasText.c"
	}
#line 1481 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1481 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 655 "CanvasText.c"
	} else {
#line 1481 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 659 "CanvasText.c"
	}
#line 1481 "glib-2.0.vapi"
	if (_tmp0_) {
#line 663 "CanvasText.c"
		gchar* _tmp2_;
#line 1482 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1482 "glib-2.0.vapi"
		result = _tmp2_;
#line 1482 "glib-2.0.vapi"
		return result;
#line 671 "CanvasText.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1485 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1485 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1485 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1485 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1485 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1485 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1485 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1485 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 699 "CanvasText.c"
				goto __catch18_g_regex_error;
			}
#line 1485 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1485 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1485 "glib-2.0.vapi"
			return NULL;
#line 708 "CanvasText.c"
		}
#line 1486 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1486 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1486 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1486 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1486 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1486 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 722 "CanvasText.c"
				goto __catch18_g_regex_error;
			}
#line 1486 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1486 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1486 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1486 "glib-2.0.vapi"
			return NULL;
#line 733 "CanvasText.c"
		}
#line 1486 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1486 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1486 "glib-2.0.vapi"
		result = _tmp10_;
#line 1486 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1486 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1486 "glib-2.0.vapi"
		return result;
#line 747 "CanvasText.c"
	}
	goto __finally18;
	__catch18_g_regex_error:
	{
		GError* e = NULL;
#line 1484 "glib-2.0.vapi"
		e = _inner_error0_;
#line 1484 "glib-2.0.vapi"
		_inner_error0_ = NULL;
#line 1488 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1484 "glib-2.0.vapi"
		_g_error_free0 (e);
#line 761 "CanvasText.c"
	}
	__finally18:
#line 1484 "glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1484 "glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1484 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1484 "glib-2.0.vapi"
		return NULL;
#line 772 "CanvasText.c"
	}
}

static gchar*
canvas_text_unmarkup (CanvasText* self,
                      const gchar* markup)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 171 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 171 "../src/CanvasText.vala"
	g_return_val_if_fail (markup != NULL, NULL);
#line 172 "../src/CanvasText.vala"
	_tmp0_ = string_replace (markup, "&", "&amp;");
#line 172 "../src/CanvasText.vala"
	_tmp1_ = _tmp0_;
#line 172 "../src/CanvasText.vala"
	_tmp2_ = string_replace (_tmp1_, "<", "&lt;");
#line 172 "../src/CanvasText.vala"
	_tmp3_ = _tmp2_;
#line 172 "../src/CanvasText.vala"
	_tmp4_ = string_replace (_tmp3_, ">", "&gt;");
#line 172 "../src/CanvasText.vala"
	_tmp5_ = _tmp4_;
#line 172 "../src/CanvasText.vala"
	_g_free0 (_tmp3_);
#line 172 "../src/CanvasText.vala"
	_g_free0 (_tmp1_);
#line 172 "../src/CanvasText.vala"
	result = _tmp5_;
#line 172 "../src/CanvasText.vala"
	return result;
#line 811 "CanvasText.c"
}

static gint
string_index_of_nth_char (const gchar* self,
                          glong c)
{
	gint result = 0;
	gchar* _tmp0_;
#line 1230 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1231 "glib-2.0.vapi"
	_tmp0_ = g_utf8_offset_to_pointer (self, c);
#line 1231 "glib-2.0.vapi"
	result = (gint) (_tmp0_ - ((gchar*) self));
#line 1231 "glib-2.0.vapi"
	return result;
#line 828 "CanvasText.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
#line 1428 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1429 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1429 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1429 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1430 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1431 "glib-2.0.vapi"
		start = string_length + start;
#line 855 "CanvasText.c"
	}
#line 1433 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1434 "glib-2.0.vapi"
		end = string_length + end;
#line 861 "CanvasText.c"
	}
#line 1436 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1436 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 867 "CanvasText.c"
	} else {
#line 1436 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 871 "CanvasText.c"
	}
#line 1436 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1437 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1437 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 879 "CanvasText.c"
	} else {
#line 1437 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 883 "CanvasText.c"
	}
#line 1437 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1438 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1439 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1439 "glib-2.0.vapi"
	result = _tmp4_;
#line 1439 "glib-2.0.vapi"
	return result;
#line 895 "CanvasText.c"
}

static gchar*
canvas_text_name_markup (CanvasText* self,
                         Theme* theme)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp52_ = NULL;
	gboolean _tmp53_ = FALSE;
	gboolean _tmp54_;
	gboolean _tmp55_;
#line 176 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 177 "../src/CanvasText.vala"
	if (self->priv->_selstart != self->priv->_selend) {
#line 177 "../src/CanvasText.vala"
		_tmp0_ = theme != NULL;
#line 914 "CanvasText.c"
	} else {
#line 177 "../src/CanvasText.vala"
		_tmp0_ = FALSE;
#line 918 "CanvasText.c"
	}
#line 177 "../src/CanvasText.vala"
	if (_tmp0_) {
#line 922 "CanvasText.c"
		gchar* fg = NULL;
		GdkRGBA _tmp1_ = {0};
		GdkRGBA _tmp2_;
		gchar* _tmp3_;
		gchar* bg = NULL;
		GdkRGBA _tmp4_ = {0};
		GdkRGBA _tmp5_;
		gchar* _tmp6_;
		gint spos = 0;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gint epos = 0;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* begtext = NULL;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* endtext = NULL;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* seltext = NULL;
		const gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		const gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		const gchar* _tmp35_;
		const gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
		const gchar* _tmp45_;
		const gchar* _tmp46_;
		gchar* _tmp47_;
		gchar* _tmp48_;
		const gchar* _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_;
#line 178 "../src/CanvasText.vala"
		theme_get_textsel_foreground (theme, &_tmp1_);
#line 178 "../src/CanvasText.vala"
		_tmp2_ = _tmp1_;
#line 178 "../src/CanvasText.vala"
		_tmp3_ = utils_color_from_rgba (&_tmp2_);
#line 178 "../src/CanvasText.vala"
		fg = _tmp3_;
#line 179 "../src/CanvasText.vala"
		theme_get_textsel_background (theme, &_tmp4_);
#line 179 "../src/CanvasText.vala"
		_tmp5_ = _tmp4_;
#line 179 "../src/CanvasText.vala"
		_tmp6_ = utils_color_from_rgba (&_tmp5_);
#line 179 "../src/CanvasText.vala"
		bg = _tmp6_;
#line 180 "../src/CanvasText.vala"
		_tmp7_ = canvas_text_get_text (self);
#line 180 "../src/CanvasText.vala"
		_tmp8_ = _tmp7_;
#line 180 "../src/CanvasText.vala"
		spos = string_index_of_nth_char (_tmp8_, (glong) self->priv->_selstart);
#line 181 "../src/CanvasText.vala"
		_tmp9_ = canvas_text_get_text (self);
#line 181 "../src/CanvasText.vala"
		_tmp10_ = _tmp9_;
#line 181 "../src/CanvasText.vala"
		epos = string_index_of_nth_char (_tmp10_, (glong) self->priv->_selend);
#line 182 "../src/CanvasText.vala"
		_tmp11_ = canvas_text_get_text (self);
#line 182 "../src/CanvasText.vala"
		_tmp12_ = _tmp11_;
#line 182 "../src/CanvasText.vala"
		_tmp13_ = string_slice (_tmp12_, (glong) 0, (glong) spos);
#line 182 "../src/CanvasText.vala"
		_tmp14_ = _tmp13_;
#line 182 "../src/CanvasText.vala"
		_tmp15_ = canvas_text_unmarkup (self, _tmp14_);
#line 182 "../src/CanvasText.vala"
		_tmp16_ = _tmp15_;
#line 182 "../src/CanvasText.vala"
		_g_free0 (_tmp14_);
#line 182 "../src/CanvasText.vala"
		begtext = _tmp16_;
#line 183 "../src/CanvasText.vala"
		_tmp17_ = canvas_text_get_text (self);
#line 183 "../src/CanvasText.vala"
		_tmp18_ = _tmp17_;
#line 183 "../src/CanvasText.vala"
		_tmp19_ = canvas_text_get_text (self);
#line 183 "../src/CanvasText.vala"
		_tmp20_ = _tmp19_;
#line 183 "../src/CanvasText.vala"
		_tmp21_ = string_slice (_tmp18_, (glong) epos, (glong) g_utf8_strlen (_tmp20_, (gssize) -1));
#line 183 "../src/CanvasText.vala"
		_tmp22_ = _tmp21_;
#line 183 "../src/CanvasText.vala"
		_tmp23_ = canvas_text_unmarkup (self, _tmp22_);
#line 183 "../src/CanvasText.vala"
		_tmp24_ = _tmp23_;
#line 183 "../src/CanvasText.vala"
		_g_free0 (_tmp22_);
#line 183 "../src/CanvasText.vala"
		endtext = _tmp24_;
#line 184 "../src/CanvasText.vala"
		_tmp25_ = fg;
#line 184 "../src/CanvasText.vala"
		_tmp26_ = g_strconcat ("<span foreground=\"", _tmp25_, NULL);
#line 184 "../src/CanvasText.vala"
		_tmp27_ = _tmp26_;
#line 184 "../src/CanvasText.vala"
		_tmp28_ = g_strconcat (_tmp27_, "\" background=\"", NULL);
#line 184 "../src/CanvasText.vala"
		_tmp29_ = _tmp28_;
#line 184 "../src/CanvasText.vala"
		_tmp30_ = bg;
#line 184 "../src/CanvasText.vala"
		_tmp31_ = g_strconcat (_tmp29_, _tmp30_, NULL);
#line 184 "../src/CanvasText.vala"
		_tmp32_ = _tmp31_;
#line 184 "../src/CanvasText.vala"
		_tmp33_ = g_strconcat (_tmp32_, "\">", NULL);
#line 184 "../src/CanvasText.vala"
		_tmp34_ = _tmp33_;
#line 184 "../src/CanvasText.vala"
		_tmp35_ = canvas_text_get_text (self);
#line 184 "../src/CanvasText.vala"
		_tmp36_ = _tmp35_;
#line 184 "../src/CanvasText.vala"
		_tmp37_ = string_slice (_tmp36_, (glong) spos, (glong) epos);
#line 184 "../src/CanvasText.vala"
		_tmp38_ = _tmp37_;
#line 184 "../src/CanvasText.vala"
		_tmp39_ = canvas_text_unmarkup (self, _tmp38_);
#line 184 "../src/CanvasText.vala"
		_tmp40_ = _tmp39_;
#line 184 "../src/CanvasText.vala"
		_tmp41_ = g_strconcat (_tmp34_, _tmp40_, NULL);
#line 184 "../src/CanvasText.vala"
		_tmp42_ = _tmp41_;
#line 184 "../src/CanvasText.vala"
		_tmp43_ = g_strconcat (_tmp42_, "</span>", NULL);
#line 184 "../src/CanvasText.vala"
		_tmp44_ = _tmp43_;
#line 184 "../src/CanvasText.vala"
		_g_free0 (_tmp42_);
#line 184 "../src/CanvasText.vala"
		_g_free0 (_tmp40_);
#line 184 "../src/CanvasText.vala"
		_g_free0 (_tmp38_);
#line 184 "../src/CanvasText.vala"
		_g_free0 (_tmp34_);
#line 184 "../src/CanvasText.vala"
		_g_free0 (_tmp32_);
#line 184 "../src/CanvasText.vala"
		_g_free0 (_tmp29_);
#line 184 "../src/CanvasText.vala"
		_g_free0 (_tmp27_);
#line 184 "../src/CanvasText.vala"
		seltext = _tmp44_;
#line 185 "../src/CanvasText.vala"
		_tmp45_ = begtext;
#line 185 "../src/CanvasText.vala"
		_tmp46_ = seltext;
#line 185 "../src/CanvasText.vala"
		_tmp47_ = g_strconcat (_tmp45_, _tmp46_, NULL);
#line 185 "../src/CanvasText.vala"
		_tmp48_ = _tmp47_;
#line 185 "../src/CanvasText.vala"
		_tmp49_ = endtext;
#line 185 "../src/CanvasText.vala"
		_tmp50_ = g_strconcat (_tmp48_, _tmp49_, NULL);
#line 185 "../src/CanvasText.vala"
		_tmp51_ = _tmp50_;
#line 185 "../src/CanvasText.vala"
		_g_free0 (_tmp48_);
#line 185 "../src/CanvasText.vala"
		result = _tmp51_;
#line 185 "../src/CanvasText.vala"
		_g_free0 (seltext);
#line 185 "../src/CanvasText.vala"
		_g_free0 (endtext);
#line 185 "../src/CanvasText.vala"
		_g_free0 (begtext);
#line 185 "../src/CanvasText.vala"
		_g_free0 (bg);
#line 185 "../src/CanvasText.vala"
		_g_free0 (fg);
#line 185 "../src/CanvasText.vala"
		return result;
#line 1131 "CanvasText.c"
	}
#line 187 "../src/CanvasText.vala"
	_tmp54_ = canvas_text_get_markup (self);
#line 187 "../src/CanvasText.vala"
	_tmp55_ = _tmp54_;
#line 187 "../src/CanvasText.vala"
	if (_tmp55_) {
#line 187 "../src/CanvasText.vala"
		_tmp53_ = TRUE;
#line 1141 "CanvasText.c"
	} else {
		gboolean _tmp56_;
		gboolean _tmp57_;
#line 187 "../src/CanvasText.vala"
		_tmp56_ = canvas_text_get_edit (self);
#line 187 "../src/CanvasText.vala"
		_tmp57_ = _tmp56_;
#line 187 "../src/CanvasText.vala"
		_tmp53_ = _tmp57_;
#line 1151 "CanvasText.c"
	}
#line 187 "../src/CanvasText.vala"
	if (_tmp53_) {
#line 1155 "CanvasText.c"
		const gchar* _tmp58_;
		const gchar* _tmp59_;
		gchar* _tmp60_;
#line 187 "../src/CanvasText.vala"
		_tmp58_ = canvas_text_get_text (self);
#line 187 "../src/CanvasText.vala"
		_tmp59_ = _tmp58_;
#line 187 "../src/CanvasText.vala"
		_tmp60_ = g_strdup (_tmp59_);
#line 187 "../src/CanvasText.vala"
		_g_free0 (_tmp52_);
#line 187 "../src/CanvasText.vala"
		_tmp52_ = _tmp60_;
#line 1169 "CanvasText.c"
	} else {
		const gchar* _tmp61_;
		const gchar* _tmp62_;
		gchar* _tmp63_;
#line 187 "../src/CanvasText.vala"
		_tmp61_ = canvas_text_get_text (self);
#line 187 "../src/CanvasText.vala"
		_tmp62_ = _tmp61_;
#line 187 "../src/CanvasText.vala"
		_tmp63_ = canvas_text_unmarkup (self, _tmp62_);
#line 187 "../src/CanvasText.vala"
		_g_free0 (_tmp52_);
#line 187 "../src/CanvasText.vala"
		_tmp52_ = _tmp63_;
#line 1184 "CanvasText.c"
	}
#line 187 "../src/CanvasText.vala"
	result = _tmp52_;
#line 187 "../src/CanvasText.vala"
	return result;
#line 1190 "CanvasText.c"
}

void
canvas_text_update_size (CanvasText* self,
                         gboolean call_resized)
{
	PangoLayout* _tmp0_;
#line 193 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 194 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_pango_layout;
#line 194 "../src/CanvasText.vala"
	if (_tmp0_ != NULL) {
#line 1204 "CanvasText.c"
		gint text_width = 0;
		gint text_height = 0;
		PangoLayout* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		PangoLayout* _tmp4_;
		gint _tmp5_ = 0;
		gint _tmp6_ = 0;
#line 196 "../src/CanvasText.vala"
		_tmp1_ = self->priv->_pango_layout;
#line 196 "../src/CanvasText.vala"
		_tmp2_ = canvas_text_name_markup (self, NULL);
#line 196 "../src/CanvasText.vala"
		_tmp3_ = _tmp2_;
#line 196 "../src/CanvasText.vala"
		pango_layout_set_markup (_tmp1_, _tmp3_, -1);
#line 196 "../src/CanvasText.vala"
		_g_free0 (_tmp3_);
#line 197 "../src/CanvasText.vala"
		_tmp4_ = self->priv->_pango_layout;
#line 197 "../src/CanvasText.vala"
		pango_layout_get_size (_tmp4_, &_tmp5_, &_tmp6_);
#line 197 "../src/CanvasText.vala"
		text_width = _tmp5_;
#line 197 "../src/CanvasText.vala"
		text_height = _tmp6_;
#line 198 "../src/CanvasText.vala"
		self->priv->_width = (gdouble) (text_width / PANGO_SCALE);
#line 199 "../src/CanvasText.vala"
		self->priv->_height = (gdouble) (text_height / PANGO_SCALE);
#line 200 "../src/CanvasText.vala"
		if (call_resized) {
#line 201 "../src/CanvasText.vala"
			g_signal_emit (self, canvas_text_signals[CANVAS_TEXT_RESIZED_SIGNAL], 0);
#line 1239 "CanvasText.c"
		}
	}
}

static void
canvas_text_real_resize (CanvasText* self,
                         gdouble diff)
{
	PangoLayout* _tmp0_;
#line 208 "../src/CanvasText.vala"
	self->priv->_max_width = self->priv->_max_width + diff;
#line 209 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_pango_layout;
#line 209 "../src/CanvasText.vala"
	pango_layout_set_width (_tmp0_, ((gint) self->priv->_max_width) * PANGO_SCALE);
#line 210 "../src/CanvasText.vala"
	canvas_text_update_size (self, TRUE);
#line 1257 "CanvasText.c"
}

void
canvas_text_resize (CanvasText* self,
                    gdouble diff)
{
#line 207 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 207 "../src/CanvasText.vala"
	CANVAS_TEXT_GET_CLASS (self)->resize (self, diff);
#line 1268 "CanvasText.c"
}

static void
canvas_text_update_column (CanvasText* self)
{
	gint line = 0;
	gint cpos = 0;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	PangoLayout* _tmp2_;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
#line 214 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 216 "../src/CanvasText.vala"
	_tmp0_ = canvas_text_get_text (self);
#line 216 "../src/CanvasText.vala"
	_tmp1_ = _tmp0_;
#line 216 "../src/CanvasText.vala"
	cpos = string_index_of_nth_char (_tmp1_, (glong) self->priv->_cursor);
#line 217 "../src/CanvasText.vala"
	_tmp2_ = self->priv->_pango_layout;
#line 217 "../src/CanvasText.vala"
	pango_layout_index_to_line_x (_tmp2_, cpos, FALSE, &_tmp3_, &_tmp4_);
#line 217 "../src/CanvasText.vala"
	line = _tmp3_;
#line 217 "../src/CanvasText.vala"
	self->priv->_column = _tmp4_;
#line 1297 "CanvasText.c"
}

void
canvas_text_set_cursor_at_char (CanvasText* self,
                                gdouble x,
                                gdouble y,
                                gboolean motion)
{
	gint cursor = 0;
	gint trailing = 0;
	gint adjusted_x = 0;
	gdouble _tmp0_;
	gint adjusted_y = 0;
	gdouble _tmp1_;
	PangoLayout* _tmp2_;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gboolean _tmp5_;
#line 221 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 223 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_posx;
#line 223 "../src/CanvasText.vala"
	adjusted_x = ((gint) (x - _tmp0_)) * PANGO_SCALE;
#line 224 "../src/CanvasText.vala"
	_tmp1_ = self->priv->_posy;
#line 224 "../src/CanvasText.vala"
	adjusted_y = ((gint) (y - _tmp1_)) * PANGO_SCALE;
#line 225 "../src/CanvasText.vala"
	_tmp2_ = self->priv->_pango_layout;
#line 225 "../src/CanvasText.vala"
	_tmp5_ = pango_layout_xy_to_index (_tmp2_, adjusted_x, adjusted_y, &_tmp3_, &_tmp4_);
#line 225 "../src/CanvasText.vala"
	cursor = _tmp3_;
#line 225 "../src/CanvasText.vala"
	trailing = _tmp4_;
#line 225 "../src/CanvasText.vala"
	if (_tmp5_) {
#line 1336 "CanvasText.c"
		gint cindex = 0;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 226 "../src/CanvasText.vala"
		_tmp6_ = canvas_text_get_text (self);
#line 226 "../src/CanvasText.vala"
		_tmp7_ = _tmp6_;
#line 226 "../src/CanvasText.vala"
		cindex = g_utf8_strlen (_tmp7_, (gssize) (cursor + trailing));
#line 227 "../src/CanvasText.vala"
		if (motion) {
#line 228 "../src/CanvasText.vala"
			if (cindex > self->priv->_selanchor) {
#line 229 "../src/CanvasText.vala"
				self->priv->_selend = cindex;
#line 1352 "CanvasText.c"
			} else {
#line 230 "../src/CanvasText.vala"
				if (cindex < self->priv->_selanchor) {
#line 231 "../src/CanvasText.vala"
					self->priv->_selstart = cindex;
#line 1358 "CanvasText.c"
				} else {
#line 233 "../src/CanvasText.vala"
					self->priv->_selstart = cindex;
#line 234 "../src/CanvasText.vala"
					self->priv->_selend = cindex;
#line 1364 "CanvasText.c"
				}
			}
		} else {
#line 237 "../src/CanvasText.vala"
			self->priv->_selstart = cindex;
#line 238 "../src/CanvasText.vala"
			self->priv->_selend = cindex;
#line 239 "../src/CanvasText.vala"
			self->priv->_selanchor = cindex;
#line 1374 "CanvasText.c"
		}
#line 241 "../src/CanvasText.vala"
		self->priv->_cursor = self->priv->_selend;
#line 242 "../src/CanvasText.vala"
		canvas_text_update_column (self);
#line 1380 "CanvasText.c"
	}
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1395 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1395 "glib-2.0.vapi"
	end = _tmp0_;
#line 1396 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1396 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1397 "glib-2.0.vapi"
		result = maxlen;
#line 1397 "glib-2.0.vapi"
		return result;
#line 1404 "CanvasText.c"
	} else {
		gchar* _tmp2_;
#line 1399 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1399 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1399 "glib-2.0.vapi"
		return result;
#line 1413 "CanvasText.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
#line 1406 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1408 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1408 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 1432 "CanvasText.c"
	} else {
#line 1408 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1436 "CanvasText.c"
	}
#line 1408 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1410 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 1442 "CanvasText.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1412 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1412 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1412 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 1452 "CanvasText.c"
	}
#line 1415 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1416 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1417 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 1460 "CanvasText.c"
	} else {
#line 1419 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 1464 "CanvasText.c"
	}
#line 1421 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1422 "glib-2.0.vapi"
		len = string_length - offset;
#line 1470 "CanvasText.c"
	}
#line 1424 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1425 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1425 "glib-2.0.vapi"
	result = _tmp3_;
#line 1425 "glib-2.0.vapi"
	return result;
#line 1480 "CanvasText.c"
}

static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1091 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1091 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1092 "glib-2.0.vapi"
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1092 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1094 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1094 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 1504 "CanvasText.c"
		gchar* _tmp2_;
#line 1095 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1095 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1095 "glib-2.0.vapi"
		return result;
#line 1512 "CanvasText.c"
	} else {
#line 1097 "glib-2.0.vapi"
		result = -1;
#line 1097 "glib-2.0.vapi"
		return result;
#line 1518 "CanvasText.c"
	}
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1081 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1081 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1082 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1082 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1084 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1084 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 1543 "CanvasText.c"
		gchar* _tmp2_;
#line 1085 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1085 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1085 "glib-2.0.vapi"
		return result;
#line 1551 "CanvasText.c"
	} else {
#line 1087 "glib-2.0.vapi"
		result = -1;
#line 1087 "glib-2.0.vapi"
		return result;
#line 1557 "CanvasText.c"
	}
}

void
canvas_text_set_cursor_at_word (CanvasText* self,
                                gdouble x,
                                gdouble y,
                                gboolean motion)
{
	gint cursor = 0;
	gint trailing = 0;
	gint adjusted_x = 0;
	gdouble _tmp0_;
	gint adjusted_y = 0;
	gdouble _tmp1_;
	PangoLayout* _tmp2_;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gboolean _tmp5_;
#line 247 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 249 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_posx;
#line 249 "../src/CanvasText.vala"
	adjusted_x = ((gint) (x - _tmp0_)) * PANGO_SCALE;
#line 250 "../src/CanvasText.vala"
	_tmp1_ = self->priv->_posy;
#line 250 "../src/CanvasText.vala"
	adjusted_y = ((gint) (y - _tmp1_)) * PANGO_SCALE;
#line 251 "../src/CanvasText.vala"
	_tmp2_ = self->priv->_pango_layout;
#line 251 "../src/CanvasText.vala"
	_tmp5_ = pango_layout_xy_to_index (_tmp2_, adjusted_x, adjusted_y, &_tmp3_, &_tmp4_);
#line 251 "../src/CanvasText.vala"
	cursor = _tmp3_;
#line 251 "../src/CanvasText.vala"
	trailing = _tmp4_;
#line 251 "../src/CanvasText.vala"
	if (_tmp5_) {
#line 1597 "CanvasText.c"
		gint word_start = 0;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gint _tmp10_;
		gint word_end = 0;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
#line 252 "../src/CanvasText.vala"
		cursor += trailing;
#line 253 "../src/CanvasText.vala"
		_tmp6_ = canvas_text_get_text (self);
#line 253 "../src/CanvasText.vala"
		_tmp7_ = _tmp6_;
#line 253 "../src/CanvasText.vala"
		_tmp8_ = string_substring (_tmp7_, (glong) 0, (glong) cursor);
#line 253 "../src/CanvasText.vala"
		_tmp9_ = _tmp8_;
#line 253 "../src/CanvasText.vala"
		_tmp10_ = string_last_index_of (_tmp9_, " ", 0);
#line 253 "../src/CanvasText.vala"
		_g_free0 (_tmp9_);
#line 253 "../src/CanvasText.vala"
		word_start = _tmp10_;
#line 254 "../src/CanvasText.vala"
		_tmp11_ = canvas_text_get_text (self);
#line 254 "../src/CanvasText.vala"
		_tmp12_ = _tmp11_;
#line 254 "../src/CanvasText.vala"
		word_end = string_index_of (_tmp12_, " ", cursor);
#line 255 "../src/CanvasText.vala"
		if (word_start == -1) {
#line 255 "../src/CanvasText.vala"
			self->priv->_selstart = 0;
#line 1633 "CanvasText.c"
		} else {
			gint windex = 0;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			gboolean _tmp15_ = FALSE;
#line 255 "../src/CanvasText.vala"
			_tmp13_ = canvas_text_get_text (self);
#line 255 "../src/CanvasText.vala"
			_tmp14_ = _tmp13_;
#line 255 "../src/CanvasText.vala"
			windex = g_utf8_strlen (_tmp14_, (gssize) word_start);
#line 255 "../src/CanvasText.vala"
			if (!motion) {
#line 255 "../src/CanvasText.vala"
				_tmp15_ = TRUE;
#line 1649 "CanvasText.c"
			} else {
#line 255 "../src/CanvasText.vala"
				_tmp15_ = windex < self->priv->_selanchor;
#line 1653 "CanvasText.c"
			}
#line 255 "../src/CanvasText.vala"
			if (_tmp15_) {
#line 255 "../src/CanvasText.vala"
				self->priv->_selstart = windex + 1;
#line 1659 "CanvasText.c"
			}
		}
#line 256 "../src/CanvasText.vala"
		if (word_end == -1) {
#line 1664 "CanvasText.c"
			const gchar* _tmp16_;
			const gchar* _tmp17_;
#line 257 "../src/CanvasText.vala"
			_tmp16_ = canvas_text_get_text (self);
#line 257 "../src/CanvasText.vala"
			_tmp17_ = _tmp16_;
#line 257 "../src/CanvasText.vala"
			self->priv->_selend = g_utf8_strlen (_tmp17_, (gssize) -1);
#line 1673 "CanvasText.c"
		} else {
			gint windex = 0;
			const gchar* _tmp18_;
			const gchar* _tmp19_;
			gboolean _tmp20_ = FALSE;
#line 259 "../src/CanvasText.vala"
			_tmp18_ = canvas_text_get_text (self);
#line 259 "../src/CanvasText.vala"
			_tmp19_ = _tmp18_;
#line 259 "../src/CanvasText.vala"
			windex = g_utf8_strlen (_tmp19_, (gssize) word_end);
#line 260 "../src/CanvasText.vala"
			if (!motion) {
#line 260 "../src/CanvasText.vala"
				_tmp20_ = TRUE;
#line 1689 "CanvasText.c"
			} else {
#line 260 "../src/CanvasText.vala"
				_tmp20_ = windex > self->priv->_selanchor;
#line 1693 "CanvasText.c"
			}
#line 260 "../src/CanvasText.vala"
			if (_tmp20_) {
#line 261 "../src/CanvasText.vala"
				self->priv->_selend = windex;
#line 1699 "CanvasText.c"
			}
		}
#line 264 "../src/CanvasText.vala"
		self->priv->_cursor = self->priv->_selend;
#line 265 "../src/CanvasText.vala"
		canvas_text_update_column (self);
#line 1706 "CanvasText.c"
	}
}

void
canvas_text_clear_selection (CanvasText* self)
{
#line 270 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 271 "../src/CanvasText.vala"
	self->priv->_selend = self->priv->_cursor;
#line 271 "../src/CanvasText.vala"
	self->priv->_selstart = self->priv->_selend;
#line 1719 "CanvasText.c"
}

static void
canvas_text_adjust_selection (CanvasText* self,
                              gint last_cursor)
{
#line 278 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 279 "../src/CanvasText.vala"
	if (last_cursor == self->priv->_selstart) {
#line 280 "../src/CanvasText.vala"
		if (self->priv->_cursor <= self->priv->_selend) {
#line 281 "../src/CanvasText.vala"
			self->priv->_selstart = self->priv->_cursor;
#line 1734 "CanvasText.c"
		} else {
#line 283 "../src/CanvasText.vala"
			self->priv->_selend = self->priv->_cursor;
#line 1738 "CanvasText.c"
		}
	} else {
#line 286 "../src/CanvasText.vala"
		if (self->priv->_cursor >= self->priv->_selstart) {
#line 287 "../src/CanvasText.vala"
			self->priv->_selend = self->priv->_cursor;
#line 1745 "CanvasText.c"
		} else {
#line 289 "../src/CanvasText.vala"
			self->priv->_selstart = self->priv->_cursor;
#line 1749 "CanvasText.c"
		}
	}
}

void
canvas_text_set_cursor_none (CanvasText* self)
{
#line 295 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 296 "../src/CanvasText.vala"
	canvas_text_clear_selection (self);
#line 1761 "CanvasText.c"
}

void
canvas_text_set_cursor_all (CanvasText* self,
                            gboolean motion)
{
#line 300 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 301 "../src/CanvasText.vala"
	if (!motion) {
#line 1772 "CanvasText.c"
		const gchar* _tmp0_;
		const gchar* _tmp1_;
#line 302 "../src/CanvasText.vala"
		self->priv->_selstart = 0;
#line 303 "../src/CanvasText.vala"
		_tmp0_ = canvas_text_get_text (self);
#line 303 "../src/CanvasText.vala"
		_tmp1_ = _tmp0_;
#line 303 "../src/CanvasText.vala"
		self->priv->_selend = g_utf8_strlen (_tmp1_, (gssize) -1);
#line 304 "../src/CanvasText.vala"
		self->priv->_selanchor = self->priv->_selend;
#line 305 "../src/CanvasText.vala"
		self->priv->_cursor = self->priv->_selend;
#line 1787 "CanvasText.c"
	}
}

static void
canvas_text_cursor_by_char (CanvasText* self,
                            gint dir)
{
	gint last = 0;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 310 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 311 "../src/CanvasText.vala"
	_tmp0_ = canvas_text_get_text (self);
#line 311 "../src/CanvasText.vala"
	_tmp1_ = _tmp0_;
#line 311 "../src/CanvasText.vala"
	last = g_utf8_strlen (_tmp1_, (gssize) -1);
#line 312 "../src/CanvasText.vala"
	self->priv->_cursor = self->priv->_cursor + dir;
#line 313 "../src/CanvasText.vala"
	if (self->priv->_cursor < 0) {
#line 314 "../src/CanvasText.vala"
		self->priv->_cursor = 0;
#line 1812 "CanvasText.c"
	} else {
#line 315 "../src/CanvasText.vala"
		if (self->priv->_cursor > last) {
#line 316 "../src/CanvasText.vala"
			self->priv->_cursor = last;
#line 1818 "CanvasText.c"
		}
	}
#line 318 "../src/CanvasText.vala"
	canvas_text_update_column (self);
#line 1823 "CanvasText.c"
}

void
canvas_text_move_cursor (CanvasText* self,
                         gint dir)
{
#line 322 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 323 "../src/CanvasText.vala"
	canvas_text_cursor_by_char (self, dir);
#line 324 "../src/CanvasText.vala"
	canvas_text_clear_selection (self);
#line 1836 "CanvasText.c"
}

void
canvas_text_selection_by_char (CanvasText* self,
                               gint dir)
{
	gint last_cursor = 0;
#line 328 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 329 "../src/CanvasText.vala"
	last_cursor = self->priv->_cursor;
#line 330 "../src/CanvasText.vala"
	canvas_text_cursor_by_char (self, dir);
#line 331 "../src/CanvasText.vala"
	canvas_text_adjust_selection (self, last_cursor);
#line 1852 "CanvasText.c"
}

static gpointer
_pango_layout_line_ref0 (gpointer self)
{
#line 346 "../src/CanvasText.vala"
	return self ? pango_layout_line_ref (self) : NULL;
#line 1860 "CanvasText.c"
}

static void
canvas_text_cursor_by_line (CanvasText* self,
                            gint dir)
{
	gint line = 0;
	gint x = 0;
	gint cpos = 0;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	PangoLayout* _tmp2_;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
#line 335 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 337 "../src/CanvasText.vala"
	_tmp0_ = canvas_text_get_text (self);
#line 337 "../src/CanvasText.vala"
	_tmp1_ = _tmp0_;
#line 337 "../src/CanvasText.vala"
	cpos = string_index_of_nth_char (_tmp1_, (glong) self->priv->_cursor);
#line 338 "../src/CanvasText.vala"
	_tmp2_ = self->priv->_pango_layout;
#line 338 "../src/CanvasText.vala"
	pango_layout_index_to_line_x (_tmp2_, cpos, FALSE, &_tmp3_, &_tmp4_);
#line 338 "../src/CanvasText.vala"
	line = _tmp3_;
#line 338 "../src/CanvasText.vala"
	x = _tmp4_;
#line 339 "../src/CanvasText.vala"
	line += dir;
#line 340 "../src/CanvasText.vala"
	if (line < 0) {
#line 341 "../src/CanvasText.vala"
		self->priv->_cursor = 0;
#line 1897 "CanvasText.c"
	} else {
		PangoLayout* _tmp5_;
#line 342 "../src/CanvasText.vala"
		_tmp5_ = self->priv->_pango_layout;
#line 342 "../src/CanvasText.vala"
		if (line >= pango_layout_get_line_count (_tmp5_)) {
#line 1904 "CanvasText.c"
			const gchar* _tmp6_;
			const gchar* _tmp7_;
#line 343 "../src/CanvasText.vala"
			_tmp6_ = canvas_text_get_text (self);
#line 343 "../src/CanvasText.vala"
			_tmp7_ = _tmp6_;
#line 343 "../src/CanvasText.vala"
			self->priv->_cursor = g_utf8_strlen (_tmp7_, (gssize) -1);
#line 1913 "CanvasText.c"
		} else {
			gint index = 0;
			gint trailing = 0;
			PangoLayoutLine* line_layout = NULL;
			PangoLayout* _tmp8_;
			PangoLayoutLine* _tmp9_;
			PangoLayoutLine* _tmp10_;
			PangoLayoutLine* _tmp11_;
			gint _tmp12_ = 0;
			gint _tmp13_ = 0;
			const gchar* _tmp14_;
			const gchar* _tmp15_;
#line 346 "../src/CanvasText.vala"
			_tmp8_ = self->priv->_pango_layout;
#line 346 "../src/CanvasText.vala"
			_tmp9_ = pango_layout_get_line (_tmp8_, line);
#line 346 "../src/CanvasText.vala"
			_tmp10_ = _pango_layout_line_ref0 (_tmp9_);
#line 346 "../src/CanvasText.vala"
			line_layout = _tmp10_;
#line 347 "../src/CanvasText.vala"
			_tmp11_ = line_layout;
#line 347 "../src/CanvasText.vala"
			pango_layout_line_x_to_index (_tmp11_, self->priv->_column, &_tmp12_, &_tmp13_);
#line 347 "../src/CanvasText.vala"
			index = _tmp12_;
#line 347 "../src/CanvasText.vala"
			trailing = _tmp13_;
#line 348 "../src/CanvasText.vala"
			_tmp14_ = canvas_text_get_text (self);
#line 348 "../src/CanvasText.vala"
			_tmp15_ = _tmp14_;
#line 348 "../src/CanvasText.vala"
			self->priv->_cursor = g_utf8_strlen (_tmp15_, (gssize) (index + trailing));
#line 342 "../src/CanvasText.vala"
			_pango_layout_line_unref0 (line_layout);
#line 1950 "CanvasText.c"
		}
	}
}

void
canvas_text_move_cursor_vertically (CanvasText* self,
                                    gint dir)
{
#line 356 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 357 "../src/CanvasText.vala"
	canvas_text_cursor_by_line (self, dir);
#line 358 "../src/CanvasText.vala"
	canvas_text_clear_selection (self);
#line 1965 "CanvasText.c"
}

void
canvas_text_selection_vertically (CanvasText* self,
                                  gint dir)
{
	gint last_cursor = 0;
#line 362 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 363 "../src/CanvasText.vala"
	last_cursor = self->priv->_cursor;
#line 364 "../src/CanvasText.vala"
	canvas_text_cursor_by_line (self, dir);
#line 365 "../src/CanvasText.vala"
	canvas_text_adjust_selection (self, last_cursor);
#line 1981 "CanvasText.c"
}

void
canvas_text_move_cursor_to_start (CanvasText* self)
{
#line 369 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 370 "../src/CanvasText.vala"
	self->priv->_cursor = 0;
#line 371 "../src/CanvasText.vala"
	canvas_text_clear_selection (self);
#line 1993 "CanvasText.c"
}

void
canvas_text_move_cursor_to_end (CanvasText* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 375 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 376 "../src/CanvasText.vala"
	_tmp0_ = canvas_text_get_text (self);
#line 376 "../src/CanvasText.vala"
	_tmp1_ = _tmp0_;
#line 376 "../src/CanvasText.vala"
	self->priv->_cursor = g_utf8_strlen (_tmp1_, (gssize) -1);
#line 377 "../src/CanvasText.vala"
	canvas_text_clear_selection (self);
#line 2011 "CanvasText.c"
}

void
canvas_text_selection_to_start (CanvasText* self)
{
#line 381 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 382 "../src/CanvasText.vala"
	if (self->priv->_selstart == self->priv->_selend) {
#line 383 "../src/CanvasText.vala"
		self->priv->_selstart = 0;
#line 384 "../src/CanvasText.vala"
		self->priv->_selend = self->priv->_cursor;
#line 385 "../src/CanvasText.vala"
		self->priv->_cursor = 0;
#line 2027 "CanvasText.c"
	} else {
#line 387 "../src/CanvasText.vala"
		self->priv->_selstart = 0;
#line 388 "../src/CanvasText.vala"
		self->priv->_cursor = 0;
#line 2033 "CanvasText.c"
	}
}

void
canvas_text_selection_to_end (CanvasText* self)
{
#line 393 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 394 "../src/CanvasText.vala"
	if (self->priv->_selstart == self->priv->_selend) {
#line 2044 "CanvasText.c"
		const gchar* _tmp0_;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
#line 395 "../src/CanvasText.vala"
		self->priv->_selstart = self->priv->_cursor;
#line 396 "../src/CanvasText.vala"
		_tmp0_ = canvas_text_get_text (self);
#line 396 "../src/CanvasText.vala"
		_tmp1_ = _tmp0_;
#line 396 "../src/CanvasText.vala"
		self->priv->_selend = g_utf8_strlen (_tmp1_, (gssize) -1);
#line 397 "../src/CanvasText.vala"
		_tmp2_ = canvas_text_get_text (self);
#line 397 "../src/CanvasText.vala"
		_tmp3_ = _tmp2_;
#line 397 "../src/CanvasText.vala"
		self->priv->_cursor = g_utf8_strlen (_tmp3_, (gssize) -1);
#line 2063 "CanvasText.c"
	} else {
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 399 "../src/CanvasText.vala"
		_tmp4_ = canvas_text_get_text (self);
#line 399 "../src/CanvasText.vala"
		_tmp5_ = _tmp4_;
#line 399 "../src/CanvasText.vala"
		self->priv->_selend = g_utf8_strlen (_tmp5_, (gssize) -1);
#line 400 "../src/CanvasText.vala"
		_tmp6_ = canvas_text_get_text (self);
#line 400 "../src/CanvasText.vala"
		_tmp7_ = _tmp6_;
#line 400 "../src/CanvasText.vala"
		self->priv->_cursor = g_utf8_strlen (_tmp7_, (gssize) -1);
#line 2081 "CanvasText.c"
	}
}

static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result = 0U;
#line 1210 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1211 "glib-2.0.vapi"
	result = g_utf8_get_char (((gchar*) self) + index);
#line 1211 "glib-2.0.vapi"
	return result;
#line 2096 "CanvasText.c"
}

static gint
canvas_text_find_word (CanvasText* self,
                       gint start,
                       gint dir)
{
	gint result = 0;
	gboolean alnum_found = FALSE;
#line 405 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 406 "../src/CanvasText.vala"
	alnum_found = FALSE;
#line 407 "../src/CanvasText.vala"
	if (dir == 1) {
#line 2112 "CanvasText.c"
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		{
			gint i = 0;
#line 408 "../src/CanvasText.vala"
			i = start;
#line 2119 "CanvasText.c"
			{
				gboolean _tmp0_ = FALSE;
#line 408 "../src/CanvasText.vala"
				_tmp0_ = TRUE;
#line 408 "../src/CanvasText.vala"
				while (TRUE) {
#line 2126 "CanvasText.c"
					const gchar* _tmp2_;
					const gchar* _tmp3_;
					gint index = 0;
					const gchar* _tmp4_;
					const gchar* _tmp5_;
					const gchar* _tmp6_;
					const gchar* _tmp7_;
#line 408 "../src/CanvasText.vala"
					if (!_tmp0_) {
#line 2136 "CanvasText.c"
						gint _tmp1_;
#line 408 "../src/CanvasText.vala"
						_tmp1_ = i;
#line 408 "../src/CanvasText.vala"
						i = _tmp1_ + 1;
#line 2142 "CanvasText.c"
					}
#line 408 "../src/CanvasText.vala"
					_tmp0_ = FALSE;
#line 408 "../src/CanvasText.vala"
					_tmp2_ = canvas_text_get_text (self);
#line 408 "../src/CanvasText.vala"
					_tmp3_ = _tmp2_;
#line 408 "../src/CanvasText.vala"
					if (!(i < g_utf8_strlen (_tmp3_, (gssize) -1))) {
#line 408 "../src/CanvasText.vala"
						break;
#line 2154 "CanvasText.c"
					}
#line 409 "../src/CanvasText.vala"
					_tmp4_ = canvas_text_get_text (self);
#line 409 "../src/CanvasText.vala"
					_tmp5_ = _tmp4_;
#line 409 "../src/CanvasText.vala"
					index = string_index_of_nth_char (_tmp5_, (glong) i);
#line 410 "../src/CanvasText.vala"
					_tmp6_ = canvas_text_get_text (self);
#line 410 "../src/CanvasText.vala"
					_tmp7_ = _tmp6_;
#line 410 "../src/CanvasText.vala"
					if (g_unichar_isalnum (string_get_char (_tmp7_, (glong) index))) {
#line 411 "../src/CanvasText.vala"
						alnum_found = TRUE;
#line 2170 "CanvasText.c"
					} else {
#line 412 "../src/CanvasText.vala"
						if (alnum_found) {
#line 413 "../src/CanvasText.vala"
							result = i;
#line 413 "../src/CanvasText.vala"
							return result;
#line 2178 "CanvasText.c"
						}
					}
				}
			}
		}
#line 416 "../src/CanvasText.vala"
		_tmp8_ = canvas_text_get_text (self);
#line 416 "../src/CanvasText.vala"
		_tmp9_ = _tmp8_;
#line 416 "../src/CanvasText.vala"
		result = g_utf8_strlen (_tmp9_, (gssize) -1);
#line 416 "../src/CanvasText.vala"
		return result;
#line 2192 "CanvasText.c"
	} else {
		{
			gint i = 0;
#line 418 "../src/CanvasText.vala"
			i = start - 1;
#line 2198 "CanvasText.c"
			{
				gboolean _tmp10_ = FALSE;
#line 418 "../src/CanvasText.vala"
				_tmp10_ = TRUE;
#line 418 "../src/CanvasText.vala"
				while (TRUE) {
#line 2205 "CanvasText.c"
					gint index = 0;
					const gchar* _tmp12_;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
					const gchar* _tmp15_;
#line 418 "../src/CanvasText.vala"
					if (!_tmp10_) {
#line 2213 "CanvasText.c"
						gint _tmp11_;
#line 418 "../src/CanvasText.vala"
						_tmp11_ = i;
#line 418 "../src/CanvasText.vala"
						i = _tmp11_ - 1;
#line 2219 "CanvasText.c"
					}
#line 418 "../src/CanvasText.vala"
					_tmp10_ = FALSE;
#line 418 "../src/CanvasText.vala"
					if (!(i >= 0)) {
#line 418 "../src/CanvasText.vala"
						break;
#line 2227 "CanvasText.c"
					}
#line 419 "../src/CanvasText.vala"
					_tmp12_ = canvas_text_get_text (self);
#line 419 "../src/CanvasText.vala"
					_tmp13_ = _tmp12_;
#line 419 "../src/CanvasText.vala"
					index = string_index_of_nth_char (_tmp13_, (glong) i);
#line 420 "../src/CanvasText.vala"
					_tmp14_ = canvas_text_get_text (self);
#line 420 "../src/CanvasText.vala"
					_tmp15_ = _tmp14_;
#line 420 "../src/CanvasText.vala"
					if (g_unichar_isalnum (string_get_char (_tmp15_, (glong) index))) {
#line 421 "../src/CanvasText.vala"
						alnum_found = TRUE;
#line 2243 "CanvasText.c"
					} else {
#line 422 "../src/CanvasText.vala"
						if (alnum_found) {
#line 423 "../src/CanvasText.vala"
							result = i + 1;
#line 423 "../src/CanvasText.vala"
							return result;
#line 2251 "CanvasText.c"
						}
					}
				}
			}
		}
#line 426 "../src/CanvasText.vala"
		result = 0;
#line 426 "../src/CanvasText.vala"
		return result;
#line 2261 "CanvasText.c"
	}
}

void
canvas_text_move_cursor_by_word (CanvasText* self,
                                 gint dir)
{
#line 431 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 432 "../src/CanvasText.vala"
	self->priv->_cursor = canvas_text_find_word (self, self->priv->_cursor, dir);
#line 433 "../src/CanvasText.vala"
	self->priv->_selend = self->priv->_selstart;
#line 2275 "CanvasText.c"
}

void
canvas_text_selection_by_word (CanvasText* self,
                               gint dir)
{
#line 437 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 438 "../src/CanvasText.vala"
	if (self->priv->_cursor == self->priv->_selstart) {
#line 439 "../src/CanvasText.vala"
		self->priv->_cursor = canvas_text_find_word (self, self->priv->_cursor, dir);
#line 440 "../src/CanvasText.vala"
		if (self->priv->_cursor <= self->priv->_selend) {
#line 441 "../src/CanvasText.vala"
			self->priv->_selstart = self->priv->_cursor;
#line 2292 "CanvasText.c"
		} else {
#line 443 "../src/CanvasText.vala"
			self->priv->_selstart = self->priv->_selend;
#line 444 "../src/CanvasText.vala"
			self->priv->_selend = self->priv->_cursor;
#line 2298 "CanvasText.c"
		}
	} else {
#line 447 "../src/CanvasText.vala"
		self->priv->_cursor = canvas_text_find_word (self, self->priv->_cursor, dir);
#line 448 "../src/CanvasText.vala"
		if (self->priv->_cursor >= self->priv->_selstart) {
#line 449 "../src/CanvasText.vala"
			self->priv->_selend = self->priv->_cursor;
#line 2307 "CanvasText.c"
		} else {
#line 451 "../src/CanvasText.vala"
			self->priv->_selend = self->priv->_selstart;
#line 452 "../src/CanvasText.vala"
			self->priv->_selstart = self->priv->_cursor;
#line 2313 "CanvasText.c"
		}
	}
}

static gchar*
string_splice (const gchar* self,
               glong start,
               glong end,
               const gchar* str)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gsize str_size = 0UL;
	const gchar* _result_ = NULL;
	void* _tmp6_;
	gchar* dest = NULL;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
#line 1442 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1443 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1443 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1443 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1444 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1445 "glib-2.0.vapi"
		start = string_length + start;
#line 2353 "CanvasText.c"
	}
#line 1447 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1448 "glib-2.0.vapi"
		end = string_length + end;
#line 2359 "CanvasText.c"
	}
#line 1450 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1450 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 2365 "CanvasText.c"
	} else {
#line 1450 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 2369 "CanvasText.c"
	}
#line 1450 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1451 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1451 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 2377 "CanvasText.c"
	} else {
#line 1451 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 2381 "CanvasText.c"
	}
#line 1451 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1452 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1455 "glib-2.0.vapi"
	if (str == NULL) {
#line 1456 "glib-2.0.vapi"
		str_size = (gsize) 0;
#line 2391 "CanvasText.c"
	} else {
		gint _tmp4_;
		gint _tmp5_;
#line 1458 "glib-2.0.vapi"
		_tmp4_ = strlen ((const gchar*) str);
#line 1458 "glib-2.0.vapi"
		_tmp5_ = _tmp4_;
#line 1458 "glib-2.0.vapi"
		str_size = (gsize) _tmp5_;
#line 2401 "CanvasText.c"
	}
#line 1461 "glib-2.0.vapi"
	_tmp6_ = g_malloc0 (((string_length - (end - start)) + str_size) + 1);
#line 1461 "glib-2.0.vapi"
	_result_ = _tmp6_;
#line 1463 "glib-2.0.vapi"
	_tmp7_ = _result_;
#line 1463 "glib-2.0.vapi"
	dest = (gchar*) _tmp7_;
#line 1465 "glib-2.0.vapi"
	_tmp8_ = dest;
#line 1465 "glib-2.0.vapi"
	memcpy (_tmp8_, self, (gsize) start);
#line 1466 "glib-2.0.vapi"
	_tmp9_ = dest;
#line 1466 "glib-2.0.vapi"
	dest = _tmp9_ + start;
#line 1468 "glib-2.0.vapi"
	_tmp10_ = dest;
#line 1468 "glib-2.0.vapi"
	memcpy (_tmp10_, str, str_size);
#line 1469 "glib-2.0.vapi"
	_tmp11_ = dest;
#line 1469 "glib-2.0.vapi"
	dest = _tmp11_ + str_size;
#line 1471 "glib-2.0.vapi"
	_tmp12_ = dest;
#line 1471 "glib-2.0.vapi"
	memcpy (_tmp12_, ((gchar*) self) + end, (gsize) (string_length - end));
#line 1473 "glib-2.0.vapi"
	_tmp13_ = _result_;
#line 1473 "glib-2.0.vapi"
	_result_ = NULL;
#line 1473 "glib-2.0.vapi"
	result = (gchar*) _tmp13_;
#line 1473 "glib-2.0.vapi"
	return result;
#line 2439 "CanvasText.c"
}

void
canvas_text_backspace (CanvasText* self)
{
#line 458 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 459 "../src/CanvasText.vala"
	if (self->priv->_cursor > 0) {
#line 460 "../src/CanvasText.vala"
		if (self->priv->_selstart != self->priv->_selend) {
#line 2451 "CanvasText.c"
			gint spos = 0;
			const gchar* _tmp0_;
			const gchar* _tmp1_;
			gint epos = 0;
			const gchar* _tmp2_;
			const gchar* _tmp3_;
			const gchar* _tmp4_;
			const gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
#line 461 "../src/CanvasText.vala"
			_tmp0_ = canvas_text_get_text (self);
#line 461 "../src/CanvasText.vala"
			_tmp1_ = _tmp0_;
#line 461 "../src/CanvasText.vala"
			spos = string_index_of_nth_char (_tmp1_, (glong) self->priv->_selstart);
#line 462 "../src/CanvasText.vala"
			_tmp2_ = canvas_text_get_text (self);
#line 462 "../src/CanvasText.vala"
			_tmp3_ = _tmp2_;
#line 462 "../src/CanvasText.vala"
			epos = string_index_of_nth_char (_tmp3_, (glong) self->priv->_selend);
#line 463 "../src/CanvasText.vala"
			_tmp4_ = canvas_text_get_text (self);
#line 463 "../src/CanvasText.vala"
			_tmp5_ = _tmp4_;
#line 463 "../src/CanvasText.vala"
			_tmp6_ = string_splice (_tmp5_, (glong) spos, (glong) epos, NULL);
#line 463 "../src/CanvasText.vala"
			_tmp7_ = _tmp6_;
#line 463 "../src/CanvasText.vala"
			canvas_text_set_text (self, _tmp7_);
#line 463 "../src/CanvasText.vala"
			_g_free0 (_tmp7_);
#line 464 "../src/CanvasText.vala"
			self->priv->_cursor = self->priv->_selstart;
#line 465 "../src/CanvasText.vala"
			self->priv->_selend = self->priv->_selstart;
#line 2490 "CanvasText.c"
		} else {
			gint spos = 0;
			const gchar* _tmp8_;
			const gchar* _tmp9_;
			gint epos = 0;
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gint _tmp16_;
#line 467 "../src/CanvasText.vala"
			_tmp8_ = canvas_text_get_text (self);
#line 467 "../src/CanvasText.vala"
			_tmp9_ = _tmp8_;
#line 467 "../src/CanvasText.vala"
			spos = string_index_of_nth_char (_tmp9_, (glong) (self->priv->_cursor - 1));
#line 468 "../src/CanvasText.vala"
			_tmp10_ = canvas_text_get_text (self);
#line 468 "../src/CanvasText.vala"
			_tmp11_ = _tmp10_;
#line 468 "../src/CanvasText.vala"
			epos = string_index_of_nth_char (_tmp11_, (glong) self->priv->_cursor);
#line 469 "../src/CanvasText.vala"
			_tmp12_ = canvas_text_get_text (self);
#line 469 "../src/CanvasText.vala"
			_tmp13_ = _tmp12_;
#line 469 "../src/CanvasText.vala"
			_tmp14_ = string_splice (_tmp13_, (glong) spos, (glong) epos, NULL);
#line 469 "../src/CanvasText.vala"
			_tmp15_ = _tmp14_;
#line 469 "../src/CanvasText.vala"
			canvas_text_set_text (self, _tmp15_);
#line 469 "../src/CanvasText.vala"
			_g_free0 (_tmp15_);
#line 470 "../src/CanvasText.vala"
			_tmp16_ = self->priv->_cursor;
#line 470 "../src/CanvasText.vala"
			self->priv->_cursor = _tmp16_ - 1;
#line 2531 "CanvasText.c"
		}
	}
}

void
canvas_text_delete (CanvasText* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 476 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 477 "../src/CanvasText.vala"
	_tmp0_ = canvas_text_get_text (self);
#line 477 "../src/CanvasText.vala"
	_tmp1_ = _tmp0_;
#line 477 "../src/CanvasText.vala"
	_tmp2_ = strlen (_tmp1_);
#line 477 "../src/CanvasText.vala"
	_tmp3_ = _tmp2_;
#line 477 "../src/CanvasText.vala"
	if (self->priv->_cursor < _tmp3_) {
#line 478 "../src/CanvasText.vala"
		if (self->priv->_selstart != self->priv->_selend) {
#line 2557 "CanvasText.c"
			gint spos = 0;
			const gchar* _tmp4_;
			const gchar* _tmp5_;
			gint epos = 0;
			const gchar* _tmp6_;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			const gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
#line 479 "../src/CanvasText.vala"
			_tmp4_ = canvas_text_get_text (self);
#line 479 "../src/CanvasText.vala"
			_tmp5_ = _tmp4_;
#line 479 "../src/CanvasText.vala"
			spos = string_index_of_nth_char (_tmp5_, (glong) self->priv->_selstart);
#line 480 "../src/CanvasText.vala"
			_tmp6_ = canvas_text_get_text (self);
#line 480 "../src/CanvasText.vala"
			_tmp7_ = _tmp6_;
#line 480 "../src/CanvasText.vala"
			epos = string_index_of_nth_char (_tmp7_, (glong) self->priv->_selend);
#line 481 "../src/CanvasText.vala"
			_tmp8_ = canvas_text_get_text (self);
#line 481 "../src/CanvasText.vala"
			_tmp9_ = _tmp8_;
#line 481 "../src/CanvasText.vala"
			_tmp10_ = string_splice (_tmp9_, (glong) spos, (glong) epos, NULL);
#line 481 "../src/CanvasText.vala"
			_tmp11_ = _tmp10_;
#line 481 "../src/CanvasText.vala"
			canvas_text_set_text (self, _tmp11_);
#line 481 "../src/CanvasText.vala"
			_g_free0 (_tmp11_);
#line 482 "../src/CanvasText.vala"
			self->priv->_cursor = self->priv->_selstart;
#line 483 "../src/CanvasText.vala"
			self->priv->_selend = self->priv->_selstart;
#line 2596 "CanvasText.c"
		} else {
			gint spos = 0;
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			gint epos = 0;
			const gchar* _tmp14_;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
			const gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
#line 485 "../src/CanvasText.vala"
			_tmp12_ = canvas_text_get_text (self);
#line 485 "../src/CanvasText.vala"
			_tmp13_ = _tmp12_;
#line 485 "../src/CanvasText.vala"
			spos = string_index_of_nth_char (_tmp13_, (glong) self->priv->_cursor);
#line 486 "../src/CanvasText.vala"
			_tmp14_ = canvas_text_get_text (self);
#line 486 "../src/CanvasText.vala"
			_tmp15_ = _tmp14_;
#line 486 "../src/CanvasText.vala"
			epos = string_index_of_nth_char (_tmp15_, (glong) (self->priv->_cursor + 1));
#line 487 "../src/CanvasText.vala"
			_tmp16_ = canvas_text_get_text (self);
#line 487 "../src/CanvasText.vala"
			_tmp17_ = _tmp16_;
#line 487 "../src/CanvasText.vala"
			_tmp18_ = string_splice (_tmp17_, (glong) spos, (glong) epos, NULL);
#line 487 "../src/CanvasText.vala"
			_tmp19_ = _tmp18_;
#line 487 "../src/CanvasText.vala"
			canvas_text_set_text (self, _tmp19_);
#line 487 "../src/CanvasText.vala"
			_g_free0 (_tmp19_);
#line 2632 "CanvasText.c"
		}
	}
}

void
canvas_text_insert (CanvasText* self,
                    const gchar* s)
{
	gint slen = 0;
#line 493 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 493 "../src/CanvasText.vala"
	g_return_if_fail (s != NULL);
#line 494 "../src/CanvasText.vala"
	slen = g_utf8_strlen (s, (gssize) -1);
#line 495 "../src/CanvasText.vala"
	if (self->priv->_selstart != self->priv->_selend) {
#line 2650 "CanvasText.c"
		gint spos = 0;
		const gchar* _tmp0_;
		const gchar* _tmp1_;
		gint epos = 0;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 496 "../src/CanvasText.vala"
		_tmp0_ = canvas_text_get_text (self);
#line 496 "../src/CanvasText.vala"
		_tmp1_ = _tmp0_;
#line 496 "../src/CanvasText.vala"
		spos = string_index_of_nth_char (_tmp1_, (glong) self->priv->_selstart);
#line 497 "../src/CanvasText.vala"
		_tmp2_ = canvas_text_get_text (self);
#line 497 "../src/CanvasText.vala"
		_tmp3_ = _tmp2_;
#line 497 "../src/CanvasText.vala"
		epos = string_index_of_nth_char (_tmp3_, (glong) self->priv->_selend);
#line 498 "../src/CanvasText.vala"
		_tmp4_ = canvas_text_get_text (self);
#line 498 "../src/CanvasText.vala"
		_tmp5_ = _tmp4_;
#line 498 "../src/CanvasText.vala"
		_tmp6_ = string_splice (_tmp5_, (glong) spos, (glong) epos, s);
#line 498 "../src/CanvasText.vala"
		_tmp7_ = _tmp6_;
#line 498 "../src/CanvasText.vala"
		canvas_text_set_text (self, _tmp7_);
#line 498 "../src/CanvasText.vala"
		_g_free0 (_tmp7_);
#line 499 "../src/CanvasText.vala"
		self->priv->_cursor = self->priv->_selstart + slen;
#line 500 "../src/CanvasText.vala"
		self->priv->_selend = self->priv->_selstart;
#line 2689 "CanvasText.c"
	} else {
		gint cpos = 0;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 502 "../src/CanvasText.vala"
		_tmp8_ = canvas_text_get_text (self);
#line 502 "../src/CanvasText.vala"
		_tmp9_ = _tmp8_;
#line 502 "../src/CanvasText.vala"
		cpos = string_index_of_nth_char (_tmp9_, (glong) self->priv->_cursor);
#line 503 "../src/CanvasText.vala"
		_tmp10_ = canvas_text_get_text (self);
#line 503 "../src/CanvasText.vala"
		_tmp11_ = _tmp10_;
#line 503 "../src/CanvasText.vala"
		_tmp12_ = string_splice (_tmp11_, (glong) cpos, (glong) cpos, s);
#line 503 "../src/CanvasText.vala"
		_tmp13_ = _tmp12_;
#line 503 "../src/CanvasText.vala"
		canvas_text_set_text (self, _tmp13_);
#line 503 "../src/CanvasText.vala"
		_g_free0 (_tmp13_);
#line 504 "../src/CanvasText.vala"
		self->priv->_cursor = self->priv->_cursor + slen;
#line 2718 "CanvasText.c"
	}
}

gchar*
canvas_text_get_selected_text (CanvasText* self)
{
	gchar* result = NULL;
#line 512 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 513 "../src/CanvasText.vala"
	if (self->priv->_selstart != self->priv->_selend) {
#line 2730 "CanvasText.c"
		gint spos = 0;
		const gchar* _tmp0_;
		const gchar* _tmp1_;
		gint epos = 0;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 514 "../src/CanvasText.vala"
		_tmp0_ = canvas_text_get_text (self);
#line 514 "../src/CanvasText.vala"
		_tmp1_ = _tmp0_;
#line 514 "../src/CanvasText.vala"
		spos = string_index_of_nth_char (_tmp1_, (glong) self->priv->_selstart);
#line 515 "../src/CanvasText.vala"
		_tmp2_ = canvas_text_get_text (self);
#line 515 "../src/CanvasText.vala"
		_tmp3_ = _tmp2_;
#line 515 "../src/CanvasText.vala"
		epos = string_index_of_nth_char (_tmp3_, (glong) self->priv->_selend);
#line 516 "../src/CanvasText.vala"
		_tmp4_ = canvas_text_get_text (self);
#line 516 "../src/CanvasText.vala"
		_tmp5_ = _tmp4_;
#line 516 "../src/CanvasText.vala"
		_tmp6_ = string_slice (_tmp5_, (glong) spos, (glong) epos);
#line 516 "../src/CanvasText.vala"
		result = _tmp6_;
#line 516 "../src/CanvasText.vala"
		return result;
#line 2762 "CanvasText.c"
	}
#line 518 "../src/CanvasText.vala"
	result = NULL;
#line 518 "../src/CanvasText.vala"
	return result;
#line 2768 "CanvasText.c"
}

void
canvas_text_get_cursor_pos (CanvasText* self,
                            gint* x,
                            gint* ytop,
                            gint* ybot)
{
	gint _vala_x = 0;
	gint _vala_ytop = 0;
	gint _vala_ybot = 0;
	gint index = 0;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	PangoRectangle rect = {0};
	PangoLayout* _tmp2_;
	PangoRectangle _tmp3_ = {0};
	gdouble _tmp4_;
	PangoRectangle _tmp5_;
	gdouble _tmp6_;
	PangoRectangle _tmp7_;
	PangoRectangle _tmp8_;
#line 522 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 523 "../src/CanvasText.vala"
	_tmp0_ = canvas_text_get_text (self);
#line 523 "../src/CanvasText.vala"
	_tmp1_ = _tmp0_;
#line 523 "../src/CanvasText.vala"
	index = string_index_of_nth_char (_tmp1_, (glong) self->priv->_cursor);
#line 524 "../src/CanvasText.vala"
	_tmp2_ = self->priv->_pango_layout;
#line 524 "../src/CanvasText.vala"
	pango_layout_index_to_pos (_tmp2_, index, &_tmp3_);
#line 524 "../src/CanvasText.vala"
	rect = _tmp3_;
#line 525 "../src/CanvasText.vala"
	_tmp4_ = self->priv->_posx;
#line 525 "../src/CanvasText.vala"
	_tmp5_ = rect;
#line 525 "../src/CanvasText.vala"
	_vala_x = (gint) (_tmp4_ + (_tmp5_.x / PANGO_SCALE));
#line 526 "../src/CanvasText.vala"
	_tmp6_ = self->priv->_posy;
#line 526 "../src/CanvasText.vala"
	_tmp7_ = rect;
#line 526 "../src/CanvasText.vala"
	_vala_ytop = (gint) (_tmp6_ + (_tmp7_.y / PANGO_SCALE));
#line 527 "../src/CanvasText.vala"
	_tmp8_ = rect;
#line 527 "../src/CanvasText.vala"
	_vala_ybot = _vala_ytop + ((gint) (_tmp8_.height / PANGO_SCALE));
#line 522 "../src/CanvasText.vala"
	if (x) {
#line 522 "../src/CanvasText.vala"
		*x = _vala_x;
#line 2825 "CanvasText.c"
	}
#line 522 "../src/CanvasText.vala"
	if (ytop) {
#line 522 "../src/CanvasText.vala"
		*ytop = _vala_ytop;
#line 2831 "CanvasText.c"
	}
#line 522 "../src/CanvasText.vala"
	if (ybot) {
#line 522 "../src/CanvasText.vala"
		*ybot = _vala_ybot;
#line 2837 "CanvasText.c"
	}
}

void
canvas_text_draw (CanvasText* self,
                  cairo_t* ctx,
                  Theme* theme,
                  GdkRGBA* fg,
                  gdouble alpha)
{
	PangoLayout* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	GdkRGBA _tmp5_;
	PangoLayout* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
#line 531 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 531 "../src/CanvasText.vala"
	g_return_if_fail (ctx != NULL);
#line 531 "../src/CanvasText.vala"
	g_return_if_fail (theme != NULL);
#line 531 "../src/CanvasText.vala"
	g_return_if_fail (fg != NULL);
#line 534 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_pango_layout;
#line 534 "../src/CanvasText.vala"
	_tmp1_ = canvas_text_name_markup (self, theme);
#line 534 "../src/CanvasText.vala"
	_tmp2_ = _tmp1_;
#line 534 "../src/CanvasText.vala"
	pango_layout_set_markup (_tmp0_, _tmp2_, -1);
#line 534 "../src/CanvasText.vala"
	_g_free0 (_tmp2_);
#line 537 "../src/CanvasText.vala"
	_tmp3_ = self->priv->_posx;
#line 537 "../src/CanvasText.vala"
	_tmp4_ = self->priv->_posy;
#line 537 "../src/CanvasText.vala"
	cairo_move_to (ctx, _tmp3_, _tmp4_);
#line 538 "../src/CanvasText.vala"
	_tmp5_ = *fg;
#line 538 "../src/CanvasText.vala"
	utils_set_context_color_with_alpha (ctx, &_tmp5_, alpha);
#line 539 "../src/CanvasText.vala"
	_tmp6_ = self->priv->_pango_layout;
#line 539 "../src/CanvasText.vala"
	pango_cairo_show_layout (ctx, _tmp6_);
#line 540 "../src/CanvasText.vala"
	cairo_new_path (ctx);
#line 543 "../src/CanvasText.vala"
	_tmp7_ = canvas_text_get_edit (self);
#line 543 "../src/CanvasText.vala"
	_tmp8_ = _tmp7_;
#line 543 "../src/CanvasText.vala"
	if (_tmp8_) {
#line 2897 "CanvasText.c"
		gint cpos = 0;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		PangoRectangle rect = {0};
		PangoLayout* _tmp11_;
		PangoRectangle _tmp12_ = {0};
		GdkRGBA _tmp13_ = {0};
		GdkRGBA _tmp14_;
		gdouble ix = 0.0;
		gdouble iy = 0.0;
		gdouble _tmp15_;
		PangoRectangle _tmp16_;
		gdouble _tmp17_;
		PangoRectangle _tmp18_;
		PangoRectangle _tmp19_;
#line 544 "../src/CanvasText.vala"
		_tmp9_ = canvas_text_get_text (self);
#line 544 "../src/CanvasText.vala"
		_tmp10_ = _tmp9_;
#line 544 "../src/CanvasText.vala"
		cpos = string_index_of_nth_char (_tmp10_, (glong) self->priv->_cursor);
#line 545 "../src/CanvasText.vala"
		_tmp11_ = self->priv->_pango_layout;
#line 545 "../src/CanvasText.vala"
		pango_layout_index_to_pos (_tmp11_, cpos, &_tmp12_);
#line 545 "../src/CanvasText.vala"
		rect = _tmp12_;
#line 546 "../src/CanvasText.vala"
		theme_get_text_cursor (theme, &_tmp13_);
#line 546 "../src/CanvasText.vala"
		_tmp14_ = _tmp13_;
#line 546 "../src/CanvasText.vala"
		utils_set_context_color_with_alpha (ctx, &_tmp14_, alpha);
#line 548 "../src/CanvasText.vala"
		_tmp15_ = self->priv->_posx;
#line 548 "../src/CanvasText.vala"
		_tmp16_ = rect;
#line 548 "../src/CanvasText.vala"
		ix = (_tmp15_ + (_tmp16_.x / PANGO_SCALE)) - 1;
#line 549 "../src/CanvasText.vala"
		_tmp17_ = self->priv->_posy;
#line 549 "../src/CanvasText.vala"
		_tmp18_ = rect;
#line 549 "../src/CanvasText.vala"
		iy = _tmp17_ + (_tmp18_.y / PANGO_SCALE);
#line 550 "../src/CanvasText.vala"
		_tmp19_ = rect;
#line 550 "../src/CanvasText.vala"
		cairo_rectangle (ctx, ix, iy, (gdouble) 1, (gdouble) (_tmp19_.height / PANGO_SCALE));
#line 551 "../src/CanvasText.vala"
		cairo_fill (ctx);
#line 2949 "CanvasText.c"
	}
}

const gchar*
canvas_text_get_text (CanvasText* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 49 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_text;
#line 50 "../src/CanvasText.vala"
	result = _tmp0_;
#line 50 "../src/CanvasText.vala"
	return result;
#line 2966 "CanvasText.c"
}

void
canvas_text_set_text (CanvasText* self,
                      const gchar* value)
{
	const gchar* _tmp0_;
#line 52 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 53 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_text;
#line 53 "../src/CanvasText.vala"
	if (g_strcmp0 (_tmp0_, value) != 0) {
#line 2980 "CanvasText.c"
		gchar* _tmp1_;
#line 54 "../src/CanvasText.vala"
		_tmp1_ = g_strdup (value);
#line 54 "../src/CanvasText.vala"
		_g_free0 (self->priv->_text);
#line 54 "../src/CanvasText.vala"
		self->priv->_text = _tmp1_;
#line 55 "../src/CanvasText.vala"
		canvas_text_update_size (self, TRUE);
#line 2990 "CanvasText.c"
	}
#line 52 "../src/CanvasText.vala"
	g_object_notify_by_pspec ((GObject *) self, canvas_text_properties[CANVAS_TEXT_TEXT_PROPERTY]);
#line 2994 "CanvasText.c"
}

gdouble
canvas_text_get_posx (CanvasText* self)
{
	gdouble result;
#line 59 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 59 "../src/CanvasText.vala"
	result = self->priv->_posx;
#line 59 "../src/CanvasText.vala"
	return result;
#line 3007 "CanvasText.c"
}

void
canvas_text_set_posx (CanvasText* self,
                      gdouble value)
{
#line 59 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 59 "../src/CanvasText.vala"
	if (canvas_text_get_posx (self) != value) {
#line 59 "../src/CanvasText.vala"
		self->priv->_posx = value;
#line 59 "../src/CanvasText.vala"
		g_object_notify_by_pspec ((GObject *) self, canvas_text_properties[CANVAS_TEXT_POSX_PROPERTY]);
#line 3022 "CanvasText.c"
	}
}

gdouble
canvas_text_get_posy (CanvasText* self)
{
	gdouble result;
#line 60 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 60 "../src/CanvasText.vala"
	result = self->priv->_posy;
#line 60 "../src/CanvasText.vala"
	return result;
#line 3036 "CanvasText.c"
}

void
canvas_text_set_posy (CanvasText* self,
                      gdouble value)
{
#line 60 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 60 "../src/CanvasText.vala"
	if (canvas_text_get_posy (self) != value) {
#line 60 "../src/CanvasText.vala"
		self->priv->_posy = value;
#line 60 "../src/CanvasText.vala"
		g_object_notify_by_pspec ((GObject *) self, canvas_text_properties[CANVAS_TEXT_POSY_PROPERTY]);
#line 3051 "CanvasText.c"
	}
}

gdouble
canvas_text_get_width (CanvasText* self)
{
	gdouble result;
#line 62 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 63 "../src/CanvasText.vala"
	result = self->priv->_width;
#line 63 "../src/CanvasText.vala"
	return result;
#line 3065 "CanvasText.c"
}

gdouble
canvas_text_get_height (CanvasText* self)
{
	gdouble result;
#line 67 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 68 "../src/CanvasText.vala"
	result = self->priv->_height;
#line 68 "../src/CanvasText.vala"
	return result;
#line 3078 "CanvasText.c"
}

gboolean
canvas_text_get_markup (CanvasText* self)
{
	gboolean result;
#line 72 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 73 "../src/CanvasText.vala"
	result = self->priv->_markup;
#line 73 "../src/CanvasText.vala"
	return result;
#line 3091 "CanvasText.c"
}

void
canvas_text_set_markup (CanvasText* self,
                        gboolean value)
{
#line 75 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 76 "../src/CanvasText.vala"
	if (self->priv->_markup != value) {
#line 77 "../src/CanvasText.vala"
		self->priv->_markup = value;
#line 78 "../src/CanvasText.vala"
		canvas_text_update_size (self, TRUE);
#line 3106 "CanvasText.c"
	}
#line 75 "../src/CanvasText.vala"
	g_object_notify_by_pspec ((GObject *) self, canvas_text_properties[CANVAS_TEXT_MARKUP_PROPERTY]);
#line 3110 "CanvasText.c"
}

gboolean
canvas_text_get_edit (CanvasText* self)
{
	gboolean result;
#line 83 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 84 "../src/CanvasText.vala"
	result = self->priv->_edit;
#line 84 "../src/CanvasText.vala"
	return result;
#line 3123 "CanvasText.c"
}

void
canvas_text_set_edit (CanvasText* self,
                      gboolean value)
{
#line 86 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 87 "../src/CanvasText.vala"
	if (self->priv->_edit != value) {
#line 88 "../src/CanvasText.vala"
		self->priv->_edit = value;
#line 89 "../src/CanvasText.vala"
		canvas_text_update_size (self, TRUE);
#line 3138 "CanvasText.c"
	}
#line 86 "../src/CanvasText.vala"
	g_object_notify_by_pspec ((GObject *) self, canvas_text_properties[CANVAS_TEXT_EDIT_PROPERTY]);
#line 3142 "CanvasText.c"
}

static void
canvas_text_class_init (CanvasTextClass * klass,
                        gpointer klass_data)
{
#line 28 "../src/CanvasText.vala"
	canvas_text_parent_class = g_type_class_peek_parent (klass);
#line 28 "../src/CanvasText.vala"
	g_type_class_adjust_private_offset (klass, &CanvasText_private_offset);
#line 28 "../src/CanvasText.vala"
	((CanvasTextClass *) klass)->load = (void (*) (CanvasText*, xmlNode*)) canvas_text_real_load;
#line 28 "../src/CanvasText.vala"
	((CanvasTextClass *) klass)->resize = (void (*) (CanvasText*, gdouble)) canvas_text_real_resize;
#line 28 "../src/CanvasText.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_canvas_text_get_property;
#line 28 "../src/CanvasText.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_canvas_text_set_property;
#line 28 "../src/CanvasText.vala"
	G_OBJECT_CLASS (klass)->finalize = canvas_text_finalize;
#line 28 "../src/CanvasText.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CANVAS_TEXT_TEXT_PROPERTY, canvas_text_properties[CANVAS_TEXT_TEXT_PROPERTY] = g_param_spec_string ("text", "text", "text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/CanvasText.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CANVAS_TEXT_POSX_PROPERTY, canvas_text_properties[CANVAS_TEXT_POSX_PROPERTY] = g_param_spec_double ("posx", "posx", "posx", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/CanvasText.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CANVAS_TEXT_POSY_PROPERTY, canvas_text_properties[CANVAS_TEXT_POSY_PROPERTY] = g_param_spec_double ("posy", "posy", "posy", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/CanvasText.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CANVAS_TEXT_WIDTH_PROPERTY, canvas_text_properties[CANVAS_TEXT_WIDTH_PROPERTY] = g_param_spec_double ("width", "width", "width", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 28 "../src/CanvasText.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CANVAS_TEXT_HEIGHT_PROPERTY, canvas_text_properties[CANVAS_TEXT_HEIGHT_PROPERTY] = g_param_spec_double ("height", "height", "height", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 28 "../src/CanvasText.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CANVAS_TEXT_MARKUP_PROPERTY, canvas_text_properties[CANVAS_TEXT_MARKUP_PROPERTY] = g_param_spec_boolean ("markup", "markup", "markup", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/CanvasText.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CANVAS_TEXT_EDIT_PROPERTY, canvas_text_properties[CANVAS_TEXT_EDIT_PROPERTY] = g_param_spec_boolean ("edit", "edit", "edit", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/CanvasText.vala"
	canvas_text_signals[CANVAS_TEXT_RESIZED_SIGNAL] = g_signal_new ("resized", TYPE_CANVAS_TEXT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3179 "CanvasText.c"
}

static void
canvas_text_instance_init (CanvasText * self,
                           gpointer klass)
{
	gchar* _tmp0_;
#line 28 "../src/CanvasText.vala"
	self->priv = canvas_text_get_instance_private (self);
#line 31 "../src/CanvasText.vala"
	_tmp0_ = g_strdup ("");
#line 31 "../src/CanvasText.vala"
	self->priv->_text = _tmp0_;
#line 32 "../src/CanvasText.vala"
	self->priv->_markup = TRUE;
#line 33 "../src/CanvasText.vala"
	self->priv->_edit = FALSE;
#line 34 "../src/CanvasText.vala"
	self->priv->_cursor = 0;
#line 35 "../src/CanvasText.vala"
	self->priv->_column = 0;
#line 36 "../src/CanvasText.vala"
	self->priv->_pango_layout = NULL;
#line 37 "../src/CanvasText.vala"
	self->priv->_selstart = 0;
#line 38 "../src/CanvasText.vala"
	self->priv->_selend = 0;
#line 39 "../src/CanvasText.vala"
	self->priv->_selanchor = 0;
#line 40 "../src/CanvasText.vala"
	self->priv->_max_width = (gdouble) 200;
#line 41 "../src/CanvasText.vala"
	self->priv->_width = (gdouble) 0;
#line 42 "../src/CanvasText.vala"
	self->priv->_height = (gdouble) 0;
#line 59 "../src/CanvasText.vala"
	self->priv->_posx = (gdouble) 0;
#line 60 "../src/CanvasText.vala"
	self->priv->_posy = (gdouble) 0;
#line 3219 "CanvasText.c"
}

static void
canvas_text_finalize (GObject * obj)
{
	CanvasText * self;
#line 28 "../src/CanvasText.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CANVAS_TEXT, CanvasText);
#line 31 "../src/CanvasText.vala"
	_g_free0 (self->priv->_text);
#line 36 "../src/CanvasText.vala"
	_g_object_unref0 (self->priv->_pango_layout);
#line 28 "../src/CanvasText.vala"
	G_OBJECT_CLASS (canvas_text_parent_class)->finalize (obj);
#line 3234 "CanvasText.c"
}

GType
canvas_text_get_type (void)
{
	static volatile gsize canvas_text_type_id__volatile = 0;
	if (g_once_init_enter (&canvas_text_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CanvasTextClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) canvas_text_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CanvasText), 0, (GInstanceInitFunc) canvas_text_instance_init, NULL };
		GType canvas_text_type_id;
		canvas_text_type_id = g_type_register_static (G_TYPE_OBJECT, "CanvasText", &g_define_type_info, 0);
		CanvasText_private_offset = g_type_add_instance_private (canvas_text_type_id, sizeof (CanvasTextPrivate));
		g_once_init_leave (&canvas_text_type_id__volatile, canvas_text_type_id);
	}
	return canvas_text_type_id__volatile;
}

static void
_vala_canvas_text_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	CanvasText * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CANVAS_TEXT, CanvasText);
#line 28 "../src/CanvasText.vala"
	switch (property_id) {
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_TEXT_PROPERTY:
#line 28 "../src/CanvasText.vala"
		g_value_set_string (value, canvas_text_get_text (self));
#line 28 "../src/CanvasText.vala"
		break;
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_POSX_PROPERTY:
#line 28 "../src/CanvasText.vala"
		g_value_set_double (value, canvas_text_get_posx (self));
#line 28 "../src/CanvasText.vala"
		break;
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_POSY_PROPERTY:
#line 28 "../src/CanvasText.vala"
		g_value_set_double (value, canvas_text_get_posy (self));
#line 28 "../src/CanvasText.vala"
		break;
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_WIDTH_PROPERTY:
#line 28 "../src/CanvasText.vala"
		g_value_set_double (value, canvas_text_get_width (self));
#line 28 "../src/CanvasText.vala"
		break;
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_HEIGHT_PROPERTY:
#line 28 "../src/CanvasText.vala"
		g_value_set_double (value, canvas_text_get_height (self));
#line 28 "../src/CanvasText.vala"
		break;
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_MARKUP_PROPERTY:
#line 28 "../src/CanvasText.vala"
		g_value_set_boolean (value, canvas_text_get_markup (self));
#line 28 "../src/CanvasText.vala"
		break;
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_EDIT_PROPERTY:
#line 28 "../src/CanvasText.vala"
		g_value_set_boolean (value, canvas_text_get_edit (self));
#line 28 "../src/CanvasText.vala"
		break;
#line 3303 "CanvasText.c"
		default:
#line 28 "../src/CanvasText.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../src/CanvasText.vala"
		break;
#line 3309 "CanvasText.c"
	}
}

static void
_vala_canvas_text_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	CanvasText * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CANVAS_TEXT, CanvasText);
#line 28 "../src/CanvasText.vala"
	switch (property_id) {
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_TEXT_PROPERTY:
#line 28 "../src/CanvasText.vala"
		canvas_text_set_text (self, g_value_get_string (value));
#line 28 "../src/CanvasText.vala"
		break;
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_POSX_PROPERTY:
#line 28 "../src/CanvasText.vala"
		canvas_text_set_posx (self, g_value_get_double (value));
#line 28 "../src/CanvasText.vala"
		break;
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_POSY_PROPERTY:
#line 28 "../src/CanvasText.vala"
		canvas_text_set_posy (self, g_value_get_double (value));
#line 28 "../src/CanvasText.vala"
		break;
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_MARKUP_PROPERTY:
#line 28 "../src/CanvasText.vala"
		canvas_text_set_markup (self, g_value_get_boolean (value));
#line 28 "../src/CanvasText.vala"
		break;
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_EDIT_PROPERTY:
#line 28 "../src/CanvasText.vala"
		canvas_text_set_edit (self, g_value_get_boolean (value));
#line 28 "../src/CanvasText.vala"
		break;
#line 3353 "CanvasText.c"
		default:
#line 28 "../src/CanvasText.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../src/CanvasText.vala"
		break;
#line 3359 "CanvasText.c"
	}
}

