/* Document.c generated by valac 0.45.3, the Vala compiler
 * generated from Document.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gstdio.h>
#include <libxml/tree.h>
#include <libxml/parser.h>

#define TYPE_DOCUMENT (document_get_type ())
#define DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DOCUMENT, Document))
#define DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DOCUMENT, DocumentClass))
#define IS_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DOCUMENT))
#define IS_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DOCUMENT))
#define DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DOCUMENT, DocumentClass))

typedef struct _Document Document;
typedef struct _DocumentClass DocumentClass;
typedef struct _DocumentPrivate DocumentPrivate;

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;

#define TYPE_IMAGE_MANAGER (image_manager_get_type ())
#define IMAGE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IMAGE_MANAGER, ImageManager))
#define IMAGE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_IMAGE_MANAGER, ImageManagerClass))
#define IS_IMAGE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IMAGE_MANAGER))
#define IS_IMAGE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_IMAGE_MANAGER))
#define IMAGE_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_IMAGE_MANAGER, ImageManagerClass))

typedef struct _ImageManager ImageManager;
typedef struct _ImageManagerClass ImageManagerClass;
enum  {
	DOCUMENT_0_PROPERTY,
	DOCUMENT_FILENAME_PROPERTY,
	DOCUMENT_LABEL_PROPERTY,
	DOCUMENT_SAVE_NEEDED_PROPERTY,
	DOCUMENT_NUM_PROPERTIES
};
static GParamSpec* document_properties[DOCUMENT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _image_manager_unref0(var) ((var == NULL) ? NULL : (var = (image_manager_unref (var), NULL)))

struct _Document {
	GObject parent_instance;
	DocumentPrivate * priv;
};

struct _DocumentClass {
	GObjectClass parent_class;
};

struct _DocumentPrivate {
	DrawArea* _da;
	GSettings* _settings;
	gchar* _filename;
	gboolean _from_user;
	ImageManager* _image_manager;
	gboolean _save_needed;
};

static gint Document_private_offset;
static gpointer document_parent_class = NULL;

GType document_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Document, g_object_unref)
GType draw_area_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DrawArea, g_object_unref)
gpointer image_manager_ref (gpointer instance);
void image_manager_unref (gpointer instance);
GParamSpec* param_spec_image_manager (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
void value_set_image_manager (GValue* value,
                              gpointer v_object);
void value_take_image_manager (GValue* value,
                               gpointer v_object);
gpointer value_get_image_manager (const GValue* value);
GType image_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ImageManager, image_manager_unref)
Document* document_new (DrawArea* da,
                        GSettings* settings);
Document* document_construct (GType object_type,
                              DrawArea* da,
                              GSettings* settings);
ImageManager* image_manager_new (void);
ImageManager* image_manager_construct (GType object_type);
static void document_canvas_changed (Document* self);
static void _document_canvas_changed_draw_area_changed (DrawArea* _sender,
                                                 gpointer self);
static void document_set_save_needed (Document* self,
                               gboolean value);
void document_auto_save (Document* self);
void document_load_filename (Document* self,
                             const gchar* fname,
                             gboolean saved);
void document_set_filename (Document* self,
                            const gchar* value);
gboolean document_is_saved (Document* self);
gboolean document_load (Document* self);
const gchar* document_get_filename (Document* self);
void draw_area_load (DrawArea* self,
                     xmlNode* n);
gboolean document_save (Document* self);
gboolean draw_area_save (DrawArea* self,
                         xmlNode* parent);
gboolean document_remove (Document* self);
gboolean document_get_save_needed (Document* self);
gchar* document_get_label (Document* self);
static void document_finalize (GObject * obj);
static void _vala_document_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec);
static void _vala_document_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec);

static inline gpointer
document_get_instance_private (Document* self)
{
	return G_STRUCT_MEMBER_P (self, Document_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 59 "../src/Document.vala"
	return self ? g_object_ref (self) : NULL;
#line 167 "Document.c"
}

static void
_document_canvas_changed_draw_area_changed (DrawArea* _sender,
                                            gpointer self)
{
#line 76 "../src/Document.vala"
	document_canvas_changed ((Document*) self);
#line 176 "Document.c"
}

Document*
document_construct (GType object_type,
                    DrawArea* da,
                    GSettings* settings)
{
	Document * self = NULL;
	DrawArea* _tmp0_;
	GSettings* _tmp1_;
	gchar* dir = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	ImageManager* _tmp12_;
	DrawArea* _tmp13_;
#line 57 "../src/Document.vala"
	g_return_val_if_fail (da != NULL, NULL);
#line 57 "../src/Document.vala"
	g_return_val_if_fail (settings != NULL, NULL);
#line 57 "../src/Document.vala"
	self = (Document*) g_object_new (object_type, NULL);
#line 59 "../src/Document.vala"
	_tmp0_ = _g_object_ref0 (da);
#line 59 "../src/Document.vala"
	_g_object_unref0 (self->priv->_da);
#line 59 "../src/Document.vala"
	self->priv->_da = _tmp0_;
#line 60 "../src/Document.vala"
	_tmp1_ = _g_object_ref0 (settings);
#line 60 "../src/Document.vala"
	_g_object_unref0 (self->priv->_settings);
#line 60 "../src/Document.vala"
	self->priv->_settings = _tmp1_;
#line 63 "../src/Document.vala"
	_tmp2_ = g_get_user_data_dir ();
#line 63 "../src/Document.vala"
	_tmp3_ = g_build_filename (_tmp2_, "minder", NULL);
#line 63 "../src/Document.vala"
	dir = _tmp3_;
#line 64 "../src/Document.vala"
	_tmp4_ = dir;
#line 64 "../src/Document.vala"
	if (g_mkdir_with_parents (_tmp4_, 0775) == 0) {
#line 221 "Document.c"
		gint i = 0;
#line 65 "../src/Document.vala"
		i = 1;
#line 225 "Document.c"
		{
			gboolean _tmp5_ = FALSE;
#line 66 "../src/Document.vala"
			_tmp5_ = TRUE;
#line 66 "../src/Document.vala"
			while (TRUE) {
#line 232 "Document.c"
				const gchar* _tmp7_;
				gint _tmp8_;
				gchar* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
#line 66 "../src/Document.vala"
				if (!_tmp5_) {
#line 240 "Document.c"
					const gchar* _tmp6_;
#line 68 "../src/Document.vala"
					_tmp6_ = self->priv->_filename;
#line 68 "../src/Document.vala"
					if (!g_file_test (_tmp6_, G_FILE_TEST_EXISTS)) {
#line 68 "../src/Document.vala"
						break;
#line 248 "Document.c"
					}
				}
#line 66 "../src/Document.vala"
				_tmp5_ = FALSE;
#line 67 "../src/Document.vala"
				_tmp7_ = dir;
#line 67 "../src/Document.vala"
				_tmp8_ = i;
#line 67 "../src/Document.vala"
				i = _tmp8_ + 1;
#line 67 "../src/Document.vala"
				_tmp9_ = g_strdup_printf ("unnamed%d.minder", _tmp8_);
#line 67 "../src/Document.vala"
				_tmp10_ = _tmp9_;
#line 67 "../src/Document.vala"
				_tmp11_ = g_build_filename (_tmp7_, _tmp10_, NULL);
#line 67 "../src/Document.vala"
				_g_free0 (self->priv->_filename);
#line 67 "../src/Document.vala"
				self->priv->_filename = _tmp11_;
#line 67 "../src/Document.vala"
				_g_free0 (_tmp10_);
#line 271 "Document.c"
			}
		}
#line 69 "../src/Document.vala"
		self->priv->_from_user = FALSE;
#line 276 "Document.c"
	}
#line 73 "../src/Document.vala"
	_tmp12_ = image_manager_new ();
#line 73 "../src/Document.vala"
	_image_manager_unref0 (self->priv->_image_manager);
#line 73 "../src/Document.vala"
	self->priv->_image_manager = _tmp12_;
#line 76 "../src/Document.vala"
	_tmp13_ = self->priv->_da;
#line 76 "../src/Document.vala"
	g_signal_connect_object (_tmp13_, "changed", (GCallback) _document_canvas_changed_draw_area_changed, self, 0);
#line 57 "../src/Document.vala"
	_g_free0 (dir);
#line 57 "../src/Document.vala"
	return self;
#line 292 "Document.c"
}

Document*
document_new (DrawArea* da,
              GSettings* settings)
{
#line 57 "../src/Document.vala"
	return document_construct (TYPE_DOCUMENT, da, settings);
#line 301 "Document.c"
}

static void
document_canvas_changed (Document* self)
{
#line 81 "../src/Document.vala"
	g_return_if_fail (self != NULL);
#line 82 "../src/Document.vala"
	document_set_save_needed (self, TRUE);
#line 83 "../src/Document.vala"
	document_auto_save (self);
#line 313 "Document.c"
}

void
document_load_filename (Document* self,
                        const gchar* fname,
                        gboolean saved)
{
#line 87 "../src/Document.vala"
	g_return_if_fail (self != NULL);
#line 87 "../src/Document.vala"
	g_return_if_fail (fname != NULL);
#line 88 "../src/Document.vala"
	document_set_filename (self, fname);
#line 89 "../src/Document.vala"
	self->priv->_from_user = saved;
#line 329 "Document.c"
}

gboolean
document_is_saved (Document* self)
{
	gboolean result = FALSE;
#line 93 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 94 "../src/Document.vala"
	result = self->priv->_from_user;
#line 94 "../src/Document.vala"
	return result;
#line 342 "Document.c"
}

gboolean
document_load (Document* self)
{
	gboolean result = FALSE;
	xmlDoc* doc = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	xmlDoc* _tmp2_;
	xmlDoc* _tmp3_;
	DrawArea* _tmp4_;
	xmlDoc* _tmp5_;
	xmlNode* _tmp6_;
	xmlDoc* _tmp7_;
#line 98 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 99 "../src/Document.vala"
	_tmp0_ = document_get_filename (self);
#line 99 "../src/Document.vala"
	_tmp1_ = _tmp0_;
#line 99 "../src/Document.vala"
	_tmp2_ = xmlParseFile (_tmp1_);
#line 99 "../src/Document.vala"
	doc = _tmp2_;
#line 100 "../src/Document.vala"
	_tmp3_ = doc;
#line 100 "../src/Document.vala"
	if (_tmp3_ == NULL) {
#line 101 "../src/Document.vala"
		result = FALSE;
#line 101 "../src/Document.vala"
		return result;
#line 376 "Document.c"
	}
#line 103 "../src/Document.vala"
	_tmp4_ = self->priv->_da;
#line 103 "../src/Document.vala"
	_tmp5_ = doc;
#line 103 "../src/Document.vala"
	_tmp6_ = xmlDocGetRootElement (_tmp5_);
#line 103 "../src/Document.vala"
	draw_area_load (_tmp4_, _tmp6_);
#line 104 "../src/Document.vala"
	_tmp7_ = doc;
#line 104 "../src/Document.vala"
	xmlFreeDoc (_tmp7_);
#line 105 "../src/Document.vala"
	result = TRUE;
#line 105 "../src/Document.vala"
	return result;
#line 394 "Document.c"
}

gboolean
document_save (Document* self)
{
	gboolean result = FALSE;
	xmlDoc* doc = NULL;
	xmlDoc* _tmp0_;
	xmlNode* root = NULL;
	xmlNode* _tmp1_;
	DrawArea* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
#line 109 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 110 "../src/Document.vala"
	_tmp0_ = xmlNewDoc ((xmlChar*) "1.0");
#line 110 "../src/Document.vala"
	doc = _tmp0_;
#line 111 "../src/Document.vala"
	_tmp1_ = xmlNewNode (NULL, (xmlChar*) "minder");
#line 111 "../src/Document.vala"
	root = _tmp1_;
#line 112 "../src/Document.vala"
	xmlDocSetRootElement (doc, root);
#line 113 "../src/Document.vala"
	_tmp2_ = self->priv->_da;
#line 113 "../src/Document.vala"
	draw_area_save (_tmp2_, root);
#line 114 "../src/Document.vala"
	_tmp3_ = document_get_filename (self);
#line 114 "../src/Document.vala"
	_tmp4_ = _tmp3_;
#line 114 "../src/Document.vala"
	xmlSaveFormatFile (_tmp4_, doc, 1);
#line 115 "../src/Document.vala"
	xmlFreeDoc (doc);
#line 116 "../src/Document.vala"
	document_set_save_needed (self, FALSE);
#line 117 "../src/Document.vala"
	result = TRUE;
#line 117 "../src/Document.vala"
	return result;
#line 438 "Document.c"
}

gboolean
document_remove (Document* self)
{
	gboolean result = FALSE;
#line 121 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 122 "../src/Document.vala"
	if (!self->priv->_from_user) {
#line 449 "Document.c"
		const gchar* _tmp0_;
#line 123 "../src/Document.vala"
		_tmp0_ = self->priv->_filename;
#line 123 "../src/Document.vala"
		g_unlink (_tmp0_);
#line 455 "Document.c"
	}
#line 125 "../src/Document.vala"
	result = TRUE;
#line 125 "../src/Document.vala"
	return result;
#line 461 "Document.c"
}

void
document_auto_save (Document* self)
{
	gboolean _tmp0_;
#line 129 "../src/Document.vala"
	g_return_if_fail (self != NULL);
#line 130 "../src/Document.vala"
	_tmp0_ = self->priv->_save_needed;
#line 130 "../src/Document.vala"
	if (_tmp0_) {
#line 131 "../src/Document.vala"
		document_save (self);
#line 476 "Document.c"
	}
}

const gchar*
document_get_filename (Document* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 45 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 46 "../src/Document.vala"
	_tmp0_ = self->priv->_filename;
#line 46 "../src/Document.vala"
	result = _tmp0_;
#line 46 "../src/Document.vala"
	return result;
#line 493 "Document.c"
}

void
document_set_filename (Document* self,
                       const gchar* value)
{
	const gchar* _tmp0_;
#line 36 "../src/Document.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/Document.vala"
	_tmp0_ = self->priv->_filename;
#line 37 "../src/Document.vala"
	if (g_strcmp0 (_tmp0_, value) != 0) {
#line 507 "Document.c"
		gchar* _tmp2_;
#line 38 "../src/Document.vala"
		if (!self->priv->_from_user) {
#line 511 "Document.c"
			const gchar* _tmp1_;
#line 39 "../src/Document.vala"
			_tmp1_ = self->priv->_filename;
#line 39 "../src/Document.vala"
			g_unlink (_tmp1_);
#line 517 "Document.c"
		}
#line 41 "../src/Document.vala"
		_tmp2_ = g_strdup (value);
#line 41 "../src/Document.vala"
		_g_free0 (self->priv->_filename);
#line 41 "../src/Document.vala"
		self->priv->_filename = _tmp2_;
#line 42 "../src/Document.vala"
		self->priv->_from_user = TRUE;
#line 527 "Document.c"
	}
#line 36 "../src/Document.vala"
	g_object_notify_by_pspec ((GObject *) self, document_properties[DOCUMENT_FILENAME_PROPERTY]);
#line 531 "Document.c"
}

gchar*
document_get_label (Document* self)
{
	gchar* result;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 50 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "../src/Document.vala"
	_tmp0_ = self->priv->_filename;
#line 51 "../src/Document.vala"
	_tmp1_ = g_path_get_basename (_tmp0_);
#line 51 "../src/Document.vala"
	result = _tmp1_;
#line 51 "../src/Document.vala"
	return result;
#line 550 "Document.c"
}

gboolean
document_get_save_needed (Document* self)
{
	gboolean result;
#line 54 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 54 "../src/Document.vala"
	result = self->priv->_save_needed;
#line 54 "../src/Document.vala"
	return result;
#line 563 "Document.c"
}

static void
document_set_save_needed (Document* self,
                          gboolean value)
{
#line 54 "../src/Document.vala"
	g_return_if_fail (self != NULL);
#line 54 "../src/Document.vala"
	if (document_get_save_needed (self) != value) {
#line 54 "../src/Document.vala"
		self->priv->_save_needed = value;
#line 54 "../src/Document.vala"
		g_object_notify_by_pspec ((GObject *) self, document_properties[DOCUMENT_SAVE_NEEDED_PROPERTY]);
#line 578 "Document.c"
	}
}

static void
document_class_init (DocumentClass * klass,
                     gpointer klass_data)
{
#line 26 "../src/Document.vala"
	document_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/Document.vala"
	g_type_class_adjust_private_offset (klass, &Document_private_offset);
#line 26 "../src/Document.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_document_get_property;
#line 26 "../src/Document.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_document_set_property;
#line 26 "../src/Document.vala"
	G_OBJECT_CLASS (klass)->finalize = document_finalize;
#line 26 "../src/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DOCUMENT_FILENAME_PROPERTY, document_properties[DOCUMENT_FILENAME_PROPERTY] = g_param_spec_string ("filename", "filename", "filename", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DOCUMENT_LABEL_PROPERTY, document_properties[DOCUMENT_LABEL_PROPERTY] = g_param_spec_string ("label", "label", "label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DOCUMENT_SAVE_NEEDED_PROPERTY, document_properties[DOCUMENT_SAVE_NEEDED_PROPERTY] = g_param_spec_boolean ("save-needed", "save-needed", "save-needed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 602 "Document.c"
}

static void
document_instance_init (Document * self,
                        gpointer klass)
{
#line 26 "../src/Document.vala"
	self->priv = document_get_instance_private (self);
#line 54 "../src/Document.vala"
	self->priv->_save_needed = FALSE;
#line 613 "Document.c"
}

static void
document_finalize (GObject * obj)
{
	Document * self;
#line 26 "../src/Document.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DOCUMENT, Document);
#line 28 "../src/Document.vala"
	_g_object_unref0 (self->priv->_da);
#line 29 "../src/Document.vala"
	_g_object_unref0 (self->priv->_settings);
#line 30 "../src/Document.vala"
	_g_free0 (self->priv->_filename);
#line 32 "../src/Document.vala"
	_image_manager_unref0 (self->priv->_image_manager);
#line 26 "../src/Document.vala"
	G_OBJECT_CLASS (document_parent_class)->finalize (obj);
#line 632 "Document.c"
}

GType
document_get_type (void)
{
	static volatile gsize document_type_id__volatile = 0;
	if (g_once_init_enter (&document_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DocumentClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) document_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Document), 0, (GInstanceInitFunc) document_instance_init, NULL };
		GType document_type_id;
		document_type_id = g_type_register_static (G_TYPE_OBJECT, "Document", &g_define_type_info, 0);
		Document_private_offset = g_type_add_instance_private (document_type_id, sizeof (DocumentPrivate));
		g_once_init_leave (&document_type_id__volatile, document_type_id);
	}
	return document_type_id__volatile;
}

static void
_vala_document_get_property (GObject * object,
                             guint property_id,
                             GValue * value,
                             GParamSpec * pspec)
{
	Document * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DOCUMENT, Document);
#line 26 "../src/Document.vala"
	switch (property_id) {
#line 26 "../src/Document.vala"
		case DOCUMENT_FILENAME_PROPERTY:
#line 26 "../src/Document.vala"
		g_value_set_string (value, document_get_filename (self));
#line 26 "../src/Document.vala"
		break;
#line 26 "../src/Document.vala"
		case DOCUMENT_LABEL_PROPERTY:
#line 26 "../src/Document.vala"
		g_value_take_string (value, document_get_label (self));
#line 26 "../src/Document.vala"
		break;
#line 26 "../src/Document.vala"
		case DOCUMENT_SAVE_NEEDED_PROPERTY:
#line 26 "../src/Document.vala"
		g_value_set_boolean (value, document_get_save_needed (self));
#line 26 "../src/Document.vala"
		break;
#line 677 "Document.c"
		default:
#line 26 "../src/Document.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/Document.vala"
		break;
#line 683 "Document.c"
	}
}

static void
_vala_document_set_property (GObject * object,
                             guint property_id,
                             const GValue * value,
                             GParamSpec * pspec)
{
	Document * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DOCUMENT, Document);
#line 26 "../src/Document.vala"
	switch (property_id) {
#line 26 "../src/Document.vala"
		case DOCUMENT_FILENAME_PROPERTY:
#line 26 "../src/Document.vala"
		document_set_filename (self, g_value_get_string (value));
#line 26 "../src/Document.vala"
		break;
#line 26 "../src/Document.vala"
		case DOCUMENT_SAVE_NEEDED_PROPERTY:
#line 26 "../src/Document.vala"
		document_set_save_needed (self, g_value_get_boolean (value));
#line 26 "../src/Document.vala"
		break;
#line 709 "Document.c"
		default:
#line 26 "../src/Document.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/Document.vala"
		break;
#line 715 "Document.c"
	}
}

