/* Layout.c generated by valac 0.45.3, the Vala compiler
 * generated from Layout.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

#define TYPE_LAYOUT (layout_get_type ())
#define LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LAYOUT, Layout))
#define LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LAYOUT, LayoutClass))
#define IS_LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LAYOUT))
#define IS_LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LAYOUT))
#define LAYOUT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LAYOUT, LayoutClass))

typedef struct _Layout Layout;
typedef struct _LayoutClass LayoutClass;
typedef struct _LayoutPrivate LayoutPrivate;
typedef enum  {
	NODE_SIDE_LEFT = 1,
	NODE_SIDE_TOP = 2,
	NODE_SIDE_RIGHT = 4,
	NODE_SIDE_BOTTOM = 8
} NodeSide;

#define TYPE_NODE_SIDE (node_side_get_type ())

#define TYPE_NODE (node_get_type ())
#define NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE, Node))
#define NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE, NodeClass))
#define IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE))
#define IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE))
#define NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE, NodeClass))

typedef struct _Node Node;
typedef struct _NodeClass NodeClass;
enum  {
	LAYOUT_0_PROPERTY,
	LAYOUT_NAME_PROPERTY,
	LAYOUT_ICON_PROPERTY,
	LAYOUT_BALANCEABLE_PROPERTY,
	LAYOUT_NUM_PROPERTIES
};
static GParamSpec* layout_properties[LAYOUT_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block13Data Block13Data;
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))

struct _Layout {
	GObject parent_instance;
	LayoutPrivate * priv;
	gdouble _pc_gap;
	gdouble _rt_gap;
};

struct _LayoutClass {
	GObjectClass parent_class;
	NodeSide (*side_mapping) (Layout* self, NodeSide side);
	void (*initialize) (Layout* self, Node* parent);
	void (*bbox) (Layout* self, Node* parent, gint side_mask, gdouble* x, gdouble* y, gdouble* w, gdouble* h);
	void (*adjust_tree) (Layout* self, Node* parent, gint child_index, gint side_mask, gdouble amount);
	void (*adjust_tree_all) (Layout* self, Node* n, gdouble amount);
	void (*propagate_side) (Layout* self, Node* parent, NodeSide side);
	NodeSide (*get_side) (Layout* self, Node* n);
	void (*set_side) (Layout* self, Node* current);
	void (*handle_update_by_edit) (Layout* self, Node* n, gdouble diffw, gdouble diffh);
	void (*handle_update_by_fold) (Layout* self, Node* n);
	gdouble (*get_insert_adjust) (Layout* self, Node* child);
	void (*handle_update_by_insert) (Layout* self, Node* parent, Node* child, gint pos);
	void (*handle_update_by_delete) (Layout* self, Node* parent, gint index, NodeSide side, gdouble size);
	void (*position_root) (Layout* self, Node* last, Node* n);
};

struct _LayoutPrivate {
	gchar* _name;
	gchar* _icon;
	gboolean _balanceable;
};

struct _Block13Data {
	int _ref_count_;
	Layout* self;
	Node* parent;
};

static gint Layout_private_offset;
static gpointer layout_parent_class = NULL;

GType layout_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Layout, g_object_unref)
GType node_side_get_type (void) G_GNUC_CONST;
GType node_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Node, g_object_unref)
Layout* layout_new (void);
Layout* layout_construct (GType object_type);
NodeSide layout_side_mapping (Layout* self,
                              NodeSide side);
static NodeSide layout_real_side_mapping (Layout* self,
                                   NodeSide side);
void layout_initialize (Layout* self,
                        Node* parent);
static void layout_real_initialize (Layout* self,
                             Node* parent);
static Block13Data* block13_data_ref (Block13Data* _data13_);
static void block13_data_unref (void * _userdata_);
GArray* node_children (Node* self);
NodeSide node_get_side (Node* self);
void node_set_side (Node* self,
                    NodeSide value);
static void __lambda34_ (Layout* self,
                  Node* item);
void node_detach (Node* self,
                  NodeSide side);
static void ___lambda34__gfunc (gconstpointer data,
                         gpointer self);
static void __lambda45_ (Block13Data* _data13_,
                  Node* item);
void node_attach_init (Node* self,
                       Node* parent,
                       gint index);
static void ___lambda45__gfunc (gconstpointer data,
                         gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_slist_free__g_object_unref0_ (GSList* self);
void layout_bbox (Layout* self,
                  Node* parent,
                  gint side_mask,
                  gdouble* x,
                  gdouble* y,
                  gdouble* w,
                  gdouble* h);
static void layout_real_bbox (Layout* self,
                       Node* parent,
                       gint side_mask,
                       gdouble* x,
                       gdouble* y,
                       gdouble* w,
                       gdouble* h);
void node_bbox (Node* self,
                gdouble* x,
                gdouble* y,
                gdouble* w,
                gdouble* h);
gboolean node_get_folded (Node* self);
static void layout_update_tree_size (Layout* self,
                              Node* n);
gint node_side_horizontal (void);
void node_set_tree_size (Node* self,
                         gdouble value);
gdouble layout_get_adjust (Layout* self,
                           Node* parent);
gdouble node_get_tree_size (Node* self);
void layout_adjust_tree (Layout* self,
                         Node* parent,
                         gint child_index,
                         gint side_mask,
                         gdouble amount);
static void layout_real_adjust_tree (Layout* self,
                              Node* parent,
                              gint child_index,
                              gint side_mask,
                              gdouble amount);
gdouble node_get_posy (Node* self);
void node_set_posy (Node* self,
                    gdouble value);
gdouble node_get_posx (Node* self);
void node_set_posx (Node* self,
                    gdouble value);
void layout_adjust_tree_all (Layout* self,
                             Node* n,
                             gdouble amount);
static void layout_real_adjust_tree_all (Layout* self,
                                  Node* n,
                                  gdouble amount);
Node* node_get_parent (Node* self);
gint node_index (Node* self);
void layout_propagate_side (Layout* self,
                            Node* parent,
                            NodeSide side);
static void layout_real_propagate_side (Layout* self,
                                 Node* parent,
                                 NodeSide side);
NodeSide layout_get_side (Layout* self,
                          Node* n);
static NodeSide layout_real_get_side (Layout* self,
                               Node* n);
Node* node_get_root (Node* self);
void layout_set_side (Layout* self,
                      Node* current);
static void layout_real_set_side (Layout* self,
                           Node* current);
gboolean node_is_root (Node* self);
void layout_handle_update_by_edit (Layout* self,
                                   Node* n,
                                   gdouble diffw,
                                   gdouble diffh);
static void layout_real_handle_update_by_edit (Layout* self,
                                        Node* n,
                                        gdouble diffw,
                                        gdouble diffh);
void node_adjust_posy_only (Node* self,
                            gdouble value);
void node_adjust_posx_only (Node* self,
                            gdouble value);
void layout_handle_update_by_fold (Layout* self,
                                   Node* n);
static void layout_real_handle_update_by_fold (Layout* self,
                                        Node* n);
static void layout_set_pc_gap (Layout* self,
                        Node* n);
gdouble node_task_width (Node* self);
gdouble layout_get_insert_adjust (Layout* self,
                                  Node* child);
static gdouble layout_real_get_insert_adjust (Layout* self,
                                       Node* child);
void layout_handle_update_by_insert (Layout* self,
                                     Node* parent,
                                     Node* child,
                                     gint pos);
static void layout_real_handle_update_by_insert (Layout* self,
                                          Node* parent,
                                          Node* child,
                                          gint pos);
gint node_side_count (Node* self,
                      NodeSide side);
void layout_handle_update_by_delete (Layout* self,
                                     Node* parent,
                                     gint index,
                                     NodeSide side,
                                     gdouble size);
static void layout_real_handle_update_by_delete (Layout* self,
                                          Node* parent,
                                          gint index,
                                          NodeSide side,
                                          gdouble size);
void layout_position_root (Layout* self,
                           Node* last,
                           Node* n);
static void layout_real_position_root (Layout* self,
                                Node* last,
                                Node* n);
const gchar* layout_get_name (Layout* self);
void layout_set_name (Layout* self,
                      const gchar* value);
const gchar* layout_get_icon (Layout* self);
void layout_set_icon (Layout* self,
                      const gchar* value);
gboolean layout_get_balanceable (Layout* self);
void layout_set_balanceable (Layout* self,
                             gboolean value);
static void layout_finalize (GObject * obj);
static void _vala_layout_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec);
static void _vala_layout_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec);

static inline gpointer
layout_get_instance_private (Layout* self)
{
	return G_STRUCT_MEMBER_P (self, Layout_private_offset);
}

Layout*
layout_construct (GType object_type)
{
	Layout * self = NULL;
#line 32 "../src/Layout.vala"
	self = (Layout*) g_object_new (object_type, NULL);
#line 32 "../src/Layout.vala"
	return self;
#line 300 "Layout.c"
}

Layout*
layout_new (void)
{
#line 32 "../src/Layout.vala"
	return layout_construct (TYPE_LAYOUT);
#line 308 "Layout.c"
}

static NodeSide
layout_real_side_mapping (Layout* self,
                          NodeSide side)
{
	NodeSide result = 0;
#line 39 "../src/Layout.vala"
	switch (side) {
#line 39 "../src/Layout.vala"
		case NODE_SIDE_LEFT:
#line 320 "Layout.c"
		{
#line 40 "../src/Layout.vala"
			result = NODE_SIDE_LEFT;
#line 40 "../src/Layout.vala"
			return result;
#line 326 "Layout.c"
		}
#line 39 "../src/Layout.vala"
		case NODE_SIDE_RIGHT:
#line 330 "Layout.c"
		{
#line 41 "../src/Layout.vala"
			result = NODE_SIDE_RIGHT;
#line 41 "../src/Layout.vala"
			return result;
#line 336 "Layout.c"
		}
#line 39 "../src/Layout.vala"
		case NODE_SIDE_TOP:
#line 340 "Layout.c"
		{
#line 42 "../src/Layout.vala"
			result = NODE_SIDE_LEFT;
#line 42 "../src/Layout.vala"
			return result;
#line 346 "Layout.c"
		}
#line 39 "../src/Layout.vala"
		case NODE_SIDE_BOTTOM:
#line 350 "Layout.c"
		{
#line 43 "../src/Layout.vala"
			result = NODE_SIDE_RIGHT;
#line 43 "../src/Layout.vala"
			return result;
#line 356 "Layout.c"
		}
		default:
#line 39 "../src/Layout.vala"
		break;
#line 361 "Layout.c"
	}
#line 45 "../src/Layout.vala"
	result = NODE_SIDE_RIGHT;
#line 45 "../src/Layout.vala"
	return result;
#line 367 "Layout.c"
}

NodeSide
layout_side_mapping (Layout* self,
                     NodeSide side)
{
#line 38 "../src/Layout.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 38 "../src/Layout.vala"
	return LAYOUT_GET_CLASS (self)->side_mapping (self, side);
#line 378 "Layout.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 49 "../src/Layout.vala"
	return self ? g_object_ref (self) : NULL;
#line 386 "Layout.c"
}

static Block13Data*
block13_data_ref (Block13Data* _data13_)
{
#line 49 "../src/Layout.vala"
	g_atomic_int_inc (&_data13_->_ref_count_);
#line 49 "../src/Layout.vala"
	return _data13_;
#line 396 "Layout.c"
}

static void
block13_data_unref (void * _userdata_)
{
	Block13Data* _data13_;
	_data13_ = (Block13Data*) _userdata_;
#line 49 "../src/Layout.vala"
	if (g_atomic_int_dec_and_test (&_data13_->_ref_count_)) {
#line 406 "Layout.c"
		Layout* self;
#line 49 "../src/Layout.vala"
		self = _data13_->self;
#line 49 "../src/Layout.vala"
		_g_object_unref0 (_data13_->parent);
#line 49 "../src/Layout.vala"
		_g_object_unref0 (self);
#line 49 "../src/Layout.vala"
		g_slice_free (Block13Data, _data13_);
#line 416 "Layout.c"
	}
}

static void
__lambda34_ (Layout* self,
             Node* item)
{
	NodeSide _tmp0_;
	NodeSide _tmp1_;
#line 57 "../src/Layout.vala"
	g_return_if_fail (item != NULL);
#line 58 "../src/Layout.vala"
	_tmp0_ = node_get_side (item);
#line 58 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 58 "../src/Layout.vala"
	node_detach (item, _tmp1_);
#line 434 "Layout.c"
}

static void
___lambda34__gfunc (gconstpointer data,
                    gpointer self)
{
#line 57 "../src/Layout.vala"
	__lambda34_ ((Layout*) self, (Node*) data);
#line 443 "Layout.c"
}

static void
__lambda45_ (Block13Data* _data13_,
             Node* item)
{
	Layout* self;
#line 60 "../src/Layout.vala"
	self = _data13_->self;
#line 60 "../src/Layout.vala"
	g_return_if_fail (item != NULL);
#line 61 "../src/Layout.vala"
	node_attach_init (item, _data13_->parent, -1);
#line 457 "Layout.c"
}

static void
___lambda45__gfunc (gconstpointer data,
                    gpointer self)
{
#line 60 "../src/Layout.vala"
	__lambda45_ (self, (Node*) data);
#line 466 "Layout.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 49 "../src/Layout.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 474 "Layout.c"
}

static inline void
_g_slist_free__g_object_unref0_ (GSList* self)
{
#line 49 "../src/Layout.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 482 "Layout.c"
}

static void
layout_real_initialize (Layout* self,
                        Node* parent)
{
	Block13Data* _data13_;
	Node* _tmp0_;
	GSList* list = NULL;
	GSList* _tmp18_;
	GSList* _tmp19_;
#line 49 "../src/Layout.vala"
	g_return_if_fail (parent != NULL);
#line 49 "../src/Layout.vala"
	_data13_ = g_slice_new0 (Block13Data);
#line 49 "../src/Layout.vala"
	_data13_->_ref_count_ = 1;
#line 49 "../src/Layout.vala"
	_data13_->self = g_object_ref (self);
#line 49 "../src/Layout.vala"
	_tmp0_ = _g_object_ref0 (parent);
#line 49 "../src/Layout.vala"
	_g_object_unref0 (_data13_->parent);
#line 49 "../src/Layout.vala"
	_data13_->parent = _tmp0_;
#line 50 "../src/Layout.vala"
	list = NULL;
#line 510 "Layout.c"
	{
		gint i = 0;
#line 51 "../src/Layout.vala"
		i = 0;
#line 515 "Layout.c"
		{
			gboolean _tmp1_ = FALSE;
#line 51 "../src/Layout.vala"
			_tmp1_ = TRUE;
#line 51 "../src/Layout.vala"
			while (TRUE) {
#line 522 "Layout.c"
				GArray* _tmp3_;
				GArray* _tmp4_;
				gboolean _tmp5_;
				Node* n = NULL;
				GArray* _tmp6_;
				GArray* _tmp7_;
				Node* _tmp8_;
				Node* _tmp9_;
				Node* _tmp10_;
				Node* _tmp11_;
				Node* _tmp12_;
				Node* _tmp13_;
				NodeSide _tmp14_;
				NodeSide _tmp15_;
				Node* _tmp16_;
				Node* _tmp17_;
#line 51 "../src/Layout.vala"
				if (!_tmp1_) {
#line 541 "Layout.c"
					gint _tmp2_;
#line 51 "../src/Layout.vala"
					_tmp2_ = i;
#line 51 "../src/Layout.vala"
					i = _tmp2_ + 1;
#line 547 "Layout.c"
				}
#line 51 "../src/Layout.vala"
				_tmp1_ = FALSE;
#line 51 "../src/Layout.vala"
				_tmp3_ = node_children (_data13_->parent);
#line 51 "../src/Layout.vala"
				_tmp4_ = _tmp3_;
#line 51 "../src/Layout.vala"
				_tmp5_ = !(((guint) i) < _tmp4_->len);
#line 51 "../src/Layout.vala"
				_g_array_unref0 (_tmp4_);
#line 51 "../src/Layout.vala"
				if (_tmp5_) {
#line 51 "../src/Layout.vala"
					break;
#line 563 "Layout.c"
				}
#line 52 "../src/Layout.vala"
				_tmp6_ = node_children (_data13_->parent);
#line 52 "../src/Layout.vala"
				_tmp7_ = _tmp6_;
#line 52 "../src/Layout.vala"
				_tmp8_ = g_array_index (_tmp7_, Node*, (guint) i);
#line 52 "../src/Layout.vala"
				_tmp9_ = _g_object_ref0 (_tmp8_);
#line 52 "../src/Layout.vala"
				_tmp10_ = _tmp9_;
#line 52 "../src/Layout.vala"
				_g_array_unref0 (_tmp7_);
#line 52 "../src/Layout.vala"
				n = _tmp10_;
#line 53 "../src/Layout.vala"
				_tmp11_ = n;
#line 53 "../src/Layout.vala"
				layout_initialize (self, _tmp11_);
#line 54 "../src/Layout.vala"
				_tmp12_ = n;
#line 54 "../src/Layout.vala"
				_tmp13_ = n;
#line 54 "../src/Layout.vala"
				_tmp14_ = node_get_side (_tmp13_);
#line 54 "../src/Layout.vala"
				_tmp15_ = _tmp14_;
#line 54 "../src/Layout.vala"
				node_set_side (_tmp12_, layout_side_mapping (self, _tmp15_));
#line 55 "../src/Layout.vala"
				_tmp16_ = n;
#line 55 "../src/Layout.vala"
				_tmp17_ = _g_object_ref0 (_tmp16_);
#line 55 "../src/Layout.vala"
				list = g_slist_append (list, _tmp17_);
#line 51 "../src/Layout.vala"
				_g_object_unref0 (n);
#line 601 "Layout.c"
			}
		}
	}
#line 57 "../src/Layout.vala"
	_tmp18_ = list;
#line 57 "../src/Layout.vala"
	g_slist_foreach (_tmp18_, ___lambda34__gfunc, self);
#line 60 "../src/Layout.vala"
	_tmp19_ = list;
#line 60 "../src/Layout.vala"
	g_slist_foreach (_tmp19_, ___lambda45__gfunc, _data13_);
#line 49 "../src/Layout.vala"
	(list == NULL) ? NULL : (list = (_g_slist_free__g_object_unref0_ (list), NULL));
#line 49 "../src/Layout.vala"
	block13_data_unref (_data13_);
#line 49 "../src/Layout.vala"
	_data13_ = NULL;
#line 619 "Layout.c"
}

void
layout_initialize (Layout* self,
                   Node* parent)
{
#line 49 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/Layout.vala"
	LAYOUT_GET_CLASS (self)->initialize (self, parent);
#line 630 "Layout.c"
}

static void
layout_real_bbox (Layout* self,
                  Node* parent,
                  gint side_mask,
                  gdouble* x,
                  gdouble* y,
                  gdouble* w,
                  gdouble* h)
{
	gdouble _vala_x = 0.0;
	gdouble _vala_y = 0.0;
	gdouble _vala_w = 0.0;
	gdouble _vala_h = 0.0;
	guint num_children = 0U;
	GArray* _tmp0_;
	GArray* _tmp1_;
	guint _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble x2 = 0.0;
	gdouble y2 = 0.0;
	gboolean _tmp7_ = FALSE;
#line 66 "../src/Layout.vala"
	g_return_if_fail (parent != NULL);
#line 68 "../src/Layout.vala"
	_tmp0_ = node_children (parent);
#line 68 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 68 "../src/Layout.vala"
	_tmp2_ = _tmp1_->len;
#line 68 "../src/Layout.vala"
	_g_array_unref0 (_tmp1_);
#line 68 "../src/Layout.vala"
	num_children = _tmp2_;
#line 70 "../src/Layout.vala"
	node_bbox (parent, &_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_);
#line 70 "../src/Layout.vala"
	_vala_x = _tmp3_;
#line 70 "../src/Layout.vala"
	_vala_y = _tmp4_;
#line 70 "../src/Layout.vala"
	_vala_w = _tmp5_;
#line 70 "../src/Layout.vala"
	_vala_h = _tmp6_;
#line 72 "../src/Layout.vala"
	x2 = _vala_x + _vala_w;
#line 73 "../src/Layout.vala"
	y2 = _vala_y + _vala_h;
#line 75 "../src/Layout.vala"
	if (num_children != ((guint) 0)) {
#line 685 "Layout.c"
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 75 "../src/Layout.vala"
		_tmp8_ = node_get_folded (parent);
#line 75 "../src/Layout.vala"
		_tmp9_ = _tmp8_;
#line 75 "../src/Layout.vala"
		_tmp7_ = !_tmp9_;
#line 694 "Layout.c"
	} else {
#line 75 "../src/Layout.vala"
		_tmp7_ = FALSE;
#line 698 "Layout.c"
	}
#line 75 "../src/Layout.vala"
	if (_tmp7_) {
#line 702 "Layout.c"
		gdouble cx = 0.0;
		gdouble cy = 0.0;
		gdouble cw = 0.0;
		gdouble ch = 0.0;
		{
			gint i = 0;
#line 77 "../src/Layout.vala"
			i = 0;
#line 711 "Layout.c"
			{
				gboolean _tmp10_ = FALSE;
#line 77 "../src/Layout.vala"
				_tmp10_ = TRUE;
#line 77 "../src/Layout.vala"
				while (TRUE) {
#line 718 "Layout.c"
					GArray* _tmp12_;
					GArray* _tmp13_;
					gboolean _tmp14_;
					GArray* _tmp15_;
					GArray* _tmp16_;
					Node* _tmp17_;
					NodeSide _tmp18_;
					NodeSide _tmp19_;
					gboolean _tmp20_;
#line 77 "../src/Layout.vala"
					if (!_tmp10_) {
#line 730 "Layout.c"
						gint _tmp11_;
#line 77 "../src/Layout.vala"
						_tmp11_ = i;
#line 77 "../src/Layout.vala"
						i = _tmp11_ + 1;
#line 736 "Layout.c"
					}
#line 77 "../src/Layout.vala"
					_tmp10_ = FALSE;
#line 77 "../src/Layout.vala"
					_tmp12_ = node_children (parent);
#line 77 "../src/Layout.vala"
					_tmp13_ = _tmp12_;
#line 77 "../src/Layout.vala"
					_tmp14_ = !(((guint) i) < _tmp13_->len);
#line 77 "../src/Layout.vala"
					_g_array_unref0 (_tmp13_);
#line 77 "../src/Layout.vala"
					if (_tmp14_) {
#line 77 "../src/Layout.vala"
						break;
#line 752 "Layout.c"
					}
#line 78 "../src/Layout.vala"
					_tmp15_ = node_children (parent);
#line 78 "../src/Layout.vala"
					_tmp16_ = _tmp15_;
#line 78 "../src/Layout.vala"
					_tmp17_ = g_array_index (_tmp16_, Node*, (guint) i);
#line 78 "../src/Layout.vala"
					_tmp18_ = node_get_side (_tmp17_);
#line 78 "../src/Layout.vala"
					_tmp19_ = _tmp18_;
#line 78 "../src/Layout.vala"
					_tmp20_ = (_tmp19_ & side_mask) != 0;
#line 78 "../src/Layout.vala"
					_g_array_unref0 (_tmp16_);
#line 78 "../src/Layout.vala"
					if (_tmp20_) {
#line 770 "Layout.c"
						GArray* _tmp21_;
						GArray* _tmp22_;
						Node* _tmp23_;
						gdouble _tmp24_ = 0.0;
						gdouble _tmp25_ = 0.0;
						gdouble _tmp26_ = 0.0;
						gdouble _tmp27_ = 0.0;
						gdouble _tmp28_ = 0.0;
						gdouble _tmp29_ = 0.0;
						gdouble _tmp30_ = 0.0;
						gdouble _tmp31_ = 0.0;
#line 79 "../src/Layout.vala"
						_tmp21_ = node_children (parent);
#line 79 "../src/Layout.vala"
						_tmp22_ = _tmp21_;
#line 79 "../src/Layout.vala"
						_tmp23_ = g_array_index (_tmp22_, Node*, (guint) i);
#line 79 "../src/Layout.vala"
						layout_bbox (self, _tmp23_, side_mask, &_tmp24_, &_tmp25_, &_tmp26_, &_tmp27_);
#line 79 "../src/Layout.vala"
						cx = _tmp24_;
#line 79 "../src/Layout.vala"
						cy = _tmp25_;
#line 79 "../src/Layout.vala"
						cw = _tmp26_;
#line 79 "../src/Layout.vala"
						ch = _tmp27_;
#line 79 "../src/Layout.vala"
						_g_array_unref0 (_tmp22_);
#line 80 "../src/Layout.vala"
						if (_vala_x < cx) {
#line 80 "../src/Layout.vala"
							_tmp28_ = _vala_x;
#line 804 "Layout.c"
						} else {
#line 80 "../src/Layout.vala"
							_tmp28_ = cx;
#line 808 "Layout.c"
						}
#line 80 "../src/Layout.vala"
						_vala_x = _tmp28_;
#line 81 "../src/Layout.vala"
						if (_vala_y < cy) {
#line 81 "../src/Layout.vala"
							_tmp29_ = _vala_y;
#line 816 "Layout.c"
						} else {
#line 81 "../src/Layout.vala"
							_tmp29_ = cy;
#line 820 "Layout.c"
						}
#line 81 "../src/Layout.vala"
						_vala_y = _tmp29_;
#line 82 "../src/Layout.vala"
						if (x2 < (cx + cw)) {
#line 82 "../src/Layout.vala"
							_tmp30_ = cx + cw;
#line 828 "Layout.c"
						} else {
#line 82 "../src/Layout.vala"
							_tmp30_ = x2;
#line 832 "Layout.c"
						}
#line 82 "../src/Layout.vala"
						x2 = _tmp30_;
#line 83 "../src/Layout.vala"
						if (y2 < (cy + ch)) {
#line 83 "../src/Layout.vala"
							_tmp31_ = cy + ch;
#line 840 "Layout.c"
						} else {
#line 83 "../src/Layout.vala"
							_tmp31_ = y2;
#line 844 "Layout.c"
						}
#line 83 "../src/Layout.vala"
						y2 = _tmp31_;
#line 848 "Layout.c"
					}
				}
			}
		}
	}
#line 88 "../src/Layout.vala"
	_vala_w = x2 - _vala_x;
#line 89 "../src/Layout.vala"
	_vala_h = y2 - _vala_y;
#line 66 "../src/Layout.vala"
	if (x) {
#line 66 "../src/Layout.vala"
		*x = _vala_x;
#line 862 "Layout.c"
	}
#line 66 "../src/Layout.vala"
	if (y) {
#line 66 "../src/Layout.vala"
		*y = _vala_y;
#line 868 "Layout.c"
	}
#line 66 "../src/Layout.vala"
	if (w) {
#line 66 "../src/Layout.vala"
		*w = _vala_w;
#line 874 "Layout.c"
	}
#line 66 "../src/Layout.vala"
	if (h) {
#line 66 "../src/Layout.vala"
		*h = _vala_h;
#line 880 "Layout.c"
	}
}

void
layout_bbox (Layout* self,
             Node* parent,
             gint side_mask,
             gdouble* x,
             gdouble* y,
             gdouble* w,
             gdouble* h)
{
#line 66 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 66 "../src/Layout.vala"
	LAYOUT_GET_CLASS (self)->bbox (self, parent, side_mask, x, y, w, h);
#line 897 "Layout.c"
}

static void
layout_update_tree_size (Layout* self,
                         Node* n)
{
	gdouble x = 0.0;
	gdouble y = 0.0;
	gdouble w = 0.0;
	gdouble h = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	NodeSide _tmp5_;
	NodeSide _tmp6_;
#line 94 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 94 "../src/Layout.vala"
	g_return_if_fail (n != NULL);
#line 98 "../src/Layout.vala"
	layout_bbox (self, n, -1, &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 98 "../src/Layout.vala"
	x = _tmp0_;
#line 98 "../src/Layout.vala"
	y = _tmp1_;
#line 98 "../src/Layout.vala"
	w = _tmp2_;
#line 98 "../src/Layout.vala"
	h = _tmp3_;
#line 101 "../src/Layout.vala"
	_tmp5_ = node_get_side (n);
#line 101 "../src/Layout.vala"
	_tmp6_ = _tmp5_;
#line 101 "../src/Layout.vala"
	if ((_tmp6_ & node_side_horizontal ()) != 0) {
#line 101 "../src/Layout.vala"
		_tmp4_ = h;
#line 937 "Layout.c"
	} else {
#line 101 "../src/Layout.vala"
		_tmp4_ = w;
#line 941 "Layout.c"
	}
#line 101 "../src/Layout.vala"
	node_set_tree_size (n, _tmp4_);
#line 945 "Layout.c"
}

gdouble
layout_get_adjust (Layout* self,
                   Node* parent)
{
	gdouble result = 0.0;
	gdouble orig_tree_size = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_ = 0.0;
#line 109 "../src/Layout.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 109 "../src/Layout.vala"
	g_return_val_if_fail (parent != NULL, 0.0);
#line 110 "../src/Layout.vala"
	_tmp0_ = node_get_tree_size (parent);
#line 110 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 110 "../src/Layout.vala"
	orig_tree_size = _tmp1_;
#line 111 "../src/Layout.vala"
	layout_update_tree_size (self, parent);
#line 112 "../src/Layout.vala"
	if (orig_tree_size == ((gdouble) 0)) {
#line 112 "../src/Layout.vala"
		_tmp2_ = (gdouble) 0;
#line 973 "Layout.c"
	} else {
		gdouble _tmp3_;
		gdouble _tmp4_;
#line 112 "../src/Layout.vala"
		_tmp3_ = node_get_tree_size (parent);
#line 112 "../src/Layout.vala"
		_tmp4_ = _tmp3_;
#line 112 "../src/Layout.vala"
		_tmp2_ = _tmp4_ - orig_tree_size;
#line 983 "Layout.c"
	}
#line 112 "../src/Layout.vala"
	result = _tmp2_;
#line 112 "../src/Layout.vala"
	return result;
#line 989 "Layout.c"
}

static void
layout_real_adjust_tree (Layout* self,
                         Node* parent,
                         gint child_index,
                         gint side_mask,
                         gdouble amount)
{
#line 116 "../src/Layout.vala"
	g_return_if_fail (parent != NULL);
#line 1001 "Layout.c"
	{
		gint i = 0;
#line 117 "../src/Layout.vala"
		i = 0;
#line 1006 "Layout.c"
		{
			gboolean _tmp0_ = FALSE;
#line 117 "../src/Layout.vala"
			_tmp0_ = TRUE;
#line 117 "../src/Layout.vala"
			while (TRUE) {
#line 1013 "Layout.c"
				GArray* _tmp2_;
				GArray* _tmp3_;
				gboolean _tmp4_;
#line 117 "../src/Layout.vala"
				if (!_tmp0_) {
#line 1019 "Layout.c"
					gint _tmp1_;
#line 117 "../src/Layout.vala"
					_tmp1_ = i;
#line 117 "../src/Layout.vala"
					i = _tmp1_ + 1;
#line 1025 "Layout.c"
				}
#line 117 "../src/Layout.vala"
				_tmp0_ = FALSE;
#line 117 "../src/Layout.vala"
				_tmp2_ = node_children (parent);
#line 117 "../src/Layout.vala"
				_tmp3_ = _tmp2_;
#line 117 "../src/Layout.vala"
				_tmp4_ = !(((guint) i) < _tmp3_->len);
#line 117 "../src/Layout.vala"
				_g_array_unref0 (_tmp3_);
#line 117 "../src/Layout.vala"
				if (_tmp4_) {
#line 117 "../src/Layout.vala"
					break;
#line 1041 "Layout.c"
				}
#line 118 "../src/Layout.vala"
				if (i != child_index) {
#line 1045 "Layout.c"
					Node* n = NULL;
					GArray* _tmp5_;
					GArray* _tmp6_;
					Node* _tmp7_;
					Node* _tmp8_;
					Node* _tmp9_;
					Node* _tmp10_;
					NodeSide _tmp11_;
					NodeSide _tmp12_;
#line 119 "../src/Layout.vala"
					_tmp5_ = node_children (parent);
#line 119 "../src/Layout.vala"
					_tmp6_ = _tmp5_;
#line 119 "../src/Layout.vala"
					_tmp7_ = g_array_index (_tmp6_, Node*, (guint) i);
#line 119 "../src/Layout.vala"
					_tmp8_ = _g_object_ref0 (_tmp7_);
#line 119 "../src/Layout.vala"
					_tmp9_ = _tmp8_;
#line 119 "../src/Layout.vala"
					_g_array_unref0 (_tmp6_);
#line 119 "../src/Layout.vala"
					n = _tmp9_;
#line 120 "../src/Layout.vala"
					_tmp10_ = n;
#line 120 "../src/Layout.vala"
					_tmp11_ = node_get_side (_tmp10_);
#line 120 "../src/Layout.vala"
					_tmp12_ = _tmp11_;
#line 120 "../src/Layout.vala"
					if ((_tmp12_ & side_mask) != 0) {
#line 1077 "Layout.c"
						Node* _tmp13_;
						NodeSide _tmp14_;
						NodeSide _tmp15_;
#line 121 "../src/Layout.vala"
						_tmp13_ = n;
#line 121 "../src/Layout.vala"
						_tmp14_ = node_get_side (_tmp13_);
#line 121 "../src/Layout.vala"
						_tmp15_ = _tmp14_;
#line 121 "../src/Layout.vala"
						if ((_tmp15_ & node_side_horizontal ()) != 0) {
#line 1089 "Layout.c"
							Node* _tmp16_;
							Node* _tmp17_;
							gdouble _tmp18_;
							gdouble _tmp19_;
#line 122 "../src/Layout.vala"
							_tmp16_ = n;
#line 122 "../src/Layout.vala"
							_tmp17_ = n;
#line 122 "../src/Layout.vala"
							_tmp18_ = node_get_posy (_tmp17_);
#line 122 "../src/Layout.vala"
							_tmp19_ = _tmp18_;
#line 122 "../src/Layout.vala"
							node_set_posy (_tmp17_, _tmp19_ + amount);
#line 1104 "Layout.c"
						} else {
							Node* _tmp20_;
							Node* _tmp21_;
							gdouble _tmp22_;
							gdouble _tmp23_;
#line 124 "../src/Layout.vala"
							_tmp20_ = n;
#line 124 "../src/Layout.vala"
							_tmp21_ = n;
#line 124 "../src/Layout.vala"
							_tmp22_ = node_get_posx (_tmp21_);
#line 124 "../src/Layout.vala"
							_tmp23_ = _tmp22_;
#line 124 "../src/Layout.vala"
							node_set_posx (_tmp21_, _tmp23_ + amount);
#line 1120 "Layout.c"
						}
					}
#line 118 "../src/Layout.vala"
					_g_object_unref0 (n);
#line 1125 "Layout.c"
				} else {
#line 128 "../src/Layout.vala"
					amount = 0 - amount;
#line 1129 "Layout.c"
				}
			}
		}
	}
}

void
layout_adjust_tree (Layout* self,
                    Node* parent,
                    gint child_index,
                    gint side_mask,
                    gdouble amount)
{
#line 116 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 116 "../src/Layout.vala"
	LAYOUT_GET_CLASS (self)->adjust_tree (self, parent, child_index, side_mask, amount);
#line 1147 "Layout.c"
}

static void
layout_real_adjust_tree_all (Layout* self,
                             Node* n,
                             gdouble amount)
{
	Node* parent = NULL;
	Node* _tmp0_;
	Node* _tmp1_;
	Node* _tmp2_;
	gint index = 0;
#line 134 "../src/Layout.vala"
	g_return_if_fail (n != NULL);
#line 135 "../src/Layout.vala"
	_tmp0_ = node_get_parent (n);
#line 135 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 135 "../src/Layout.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 135 "../src/Layout.vala"
	parent = _tmp2_;
#line 136 "../src/Layout.vala"
	index = node_index (n);
#line 137 "../src/Layout.vala"
	while (TRUE) {
#line 1174 "Layout.c"
		Node* _tmp3_;
		Node* _tmp4_;
		NodeSide _tmp5_;
		NodeSide _tmp6_;
		Node* _tmp7_;
		Node* _tmp8_;
		Node* _tmp9_;
		Node* _tmp10_;
		Node* _tmp11_;
		Node* _tmp12_;
#line 137 "../src/Layout.vala"
		_tmp3_ = parent;
#line 137 "../src/Layout.vala"
		if (!(_tmp3_ != NULL)) {
#line 137 "../src/Layout.vala"
			break;
#line 1191 "Layout.c"
		}
#line 138 "../src/Layout.vala"
		_tmp4_ = parent;
#line 138 "../src/Layout.vala"
		_tmp5_ = node_get_side (n);
#line 138 "../src/Layout.vala"
		_tmp6_ = _tmp5_;
#line 138 "../src/Layout.vala"
		layout_adjust_tree (self, _tmp4_, index, (gint) _tmp6_, amount);
#line 139 "../src/Layout.vala"
		_tmp7_ = parent;
#line 139 "../src/Layout.vala"
		amount = 0 - (layout_get_adjust (self, _tmp7_) / 2);
#line 140 "../src/Layout.vala"
		_tmp8_ = parent;
#line 140 "../src/Layout.vala"
		index = node_index (_tmp8_);
#line 141 "../src/Layout.vala"
		_tmp9_ = parent;
#line 141 "../src/Layout.vala"
		_tmp10_ = node_get_parent (_tmp9_);
#line 141 "../src/Layout.vala"
		_tmp11_ = _tmp10_;
#line 141 "../src/Layout.vala"
		_tmp12_ = _g_object_ref0 (_tmp11_);
#line 141 "../src/Layout.vala"
		_g_object_unref0 (parent);
#line 141 "../src/Layout.vala"
		parent = _tmp12_;
#line 1221 "Layout.c"
	}
#line 134 "../src/Layout.vala"
	_g_object_unref0 (parent);
#line 1225 "Layout.c"
}

void
layout_adjust_tree_all (Layout* self,
                        Node* n,
                        gdouble amount)
{
#line 134 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 134 "../src/Layout.vala"
	LAYOUT_GET_CLASS (self)->adjust_tree_all (self, n, amount);
#line 1237 "Layout.c"
}

static void
layout_real_propagate_side (Layout* self,
                            Node* parent,
                            NodeSide side)
{
	gdouble px = 0.0;
	gdouble py = 0.0;
	gdouble pw = 0.0;
	gdouble ph = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
#line 146 "../src/Layout.vala"
	g_return_if_fail (parent != NULL);
#line 148 "../src/Layout.vala"
	node_bbox (parent, &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 148 "../src/Layout.vala"
	px = _tmp0_;
#line 148 "../src/Layout.vala"
	py = _tmp1_;
#line 148 "../src/Layout.vala"
	pw = _tmp2_;
#line 148 "../src/Layout.vala"
	ph = _tmp3_;
#line 1265 "Layout.c"
	{
		gint i = 0;
#line 149 "../src/Layout.vala"
		i = 0;
#line 1270 "Layout.c"
		{
			gboolean _tmp4_ = FALSE;
#line 149 "../src/Layout.vala"
			_tmp4_ = TRUE;
#line 149 "../src/Layout.vala"
			while (TRUE) {
#line 1277 "Layout.c"
				GArray* _tmp6_;
				GArray* _tmp7_;
				gboolean _tmp8_;
				Node* n = NULL;
				GArray* _tmp9_;
				GArray* _tmp10_;
				Node* _tmp11_;
				Node* _tmp12_;
				Node* _tmp13_;
				Node* _tmp14_;
				NodeSide _tmp15_;
				NodeSide _tmp16_;
#line 149 "../src/Layout.vala"
				if (!_tmp4_) {
#line 1292 "Layout.c"
					gint _tmp5_;
#line 149 "../src/Layout.vala"
					_tmp5_ = i;
#line 149 "../src/Layout.vala"
					i = _tmp5_ + 1;
#line 1298 "Layout.c"
				}
#line 149 "../src/Layout.vala"
				_tmp4_ = FALSE;
#line 149 "../src/Layout.vala"
				_tmp6_ = node_children (parent);
#line 149 "../src/Layout.vala"
				_tmp7_ = _tmp6_;
#line 149 "../src/Layout.vala"
				_tmp8_ = !(((guint) i) < _tmp7_->len);
#line 149 "../src/Layout.vala"
				_g_array_unref0 (_tmp7_);
#line 149 "../src/Layout.vala"
				if (_tmp8_) {
#line 149 "../src/Layout.vala"
					break;
#line 1314 "Layout.c"
				}
#line 150 "../src/Layout.vala"
				_tmp9_ = node_children (parent);
#line 150 "../src/Layout.vala"
				_tmp10_ = _tmp9_;
#line 150 "../src/Layout.vala"
				_tmp11_ = g_array_index (_tmp10_, Node*, (guint) i);
#line 150 "../src/Layout.vala"
				_tmp12_ = _g_object_ref0 (_tmp11_);
#line 150 "../src/Layout.vala"
				_tmp13_ = _tmp12_;
#line 150 "../src/Layout.vala"
				_g_array_unref0 (_tmp10_);
#line 150 "../src/Layout.vala"
				n = _tmp13_;
#line 151 "../src/Layout.vala"
				_tmp14_ = n;
#line 151 "../src/Layout.vala"
				_tmp15_ = node_get_side (_tmp14_);
#line 151 "../src/Layout.vala"
				_tmp16_ = _tmp15_;
#line 151 "../src/Layout.vala"
				if (_tmp16_ != side) {
#line 1338 "Layout.c"
					Node* _tmp17_;
					Node* _tmp32_;
#line 152 "../src/Layout.vala"
					_tmp17_ = n;
#line 152 "../src/Layout.vala"
					node_set_side (_tmp17_, side);
#line 153 "../src/Layout.vala"
					switch (side) {
#line 153 "../src/Layout.vala"
						case NODE_SIDE_LEFT:
#line 1349 "Layout.c"
						{
							gdouble cx = 0.0;
							gdouble cy = 0.0;
							gdouble cw = 0.0;
							gdouble ch = 0.0;
							Node* _tmp18_;
							gdouble _tmp19_ = 0.0;
							gdouble _tmp20_ = 0.0;
							gdouble _tmp21_ = 0.0;
							gdouble _tmp22_ = 0.0;
							Node* _tmp23_;
#line 156 "../src/Layout.vala"
							_tmp18_ = n;
#line 156 "../src/Layout.vala"
							node_bbox (_tmp18_, &_tmp19_, &_tmp20_, &_tmp21_, &_tmp22_);
#line 156 "../src/Layout.vala"
							cx = _tmp19_;
#line 156 "../src/Layout.vala"
							cy = _tmp20_;
#line 156 "../src/Layout.vala"
							cw = _tmp21_;
#line 156 "../src/Layout.vala"
							ch = _tmp22_;
#line 157 "../src/Layout.vala"
							_tmp23_ = n;
#line 157 "../src/Layout.vala"
							node_set_posx (_tmp23_, (px - self->_pc_gap) - cw);
#line 158 "../src/Layout.vala"
							break;
#line 1379 "Layout.c"
						}
#line 153 "../src/Layout.vala"
						case NODE_SIDE_RIGHT:
#line 1383 "Layout.c"
						{
							Node* _tmp24_;
#line 160 "../src/Layout.vala"
							_tmp24_ = n;
#line 160 "../src/Layout.vala"
							node_set_posx (_tmp24_, (px + pw) + self->_pc_gap);
#line 161 "../src/Layout.vala"
							break;
#line 1392 "Layout.c"
						}
#line 153 "../src/Layout.vala"
						case NODE_SIDE_TOP:
#line 1396 "Layout.c"
						{
							gdouble cx = 0.0;
							gdouble cy = 0.0;
							gdouble cw = 0.0;
							gdouble ch = 0.0;
							Node* _tmp25_;
							gdouble _tmp26_ = 0.0;
							gdouble _tmp27_ = 0.0;
							gdouble _tmp28_ = 0.0;
							gdouble _tmp29_ = 0.0;
							Node* _tmp30_;
#line 164 "../src/Layout.vala"
							_tmp25_ = n;
#line 164 "../src/Layout.vala"
							node_bbox (_tmp25_, &_tmp26_, &_tmp27_, &_tmp28_, &_tmp29_);
#line 164 "../src/Layout.vala"
							cx = _tmp26_;
#line 164 "../src/Layout.vala"
							cy = _tmp27_;
#line 164 "../src/Layout.vala"
							cw = _tmp28_;
#line 164 "../src/Layout.vala"
							ch = _tmp29_;
#line 165 "../src/Layout.vala"
							_tmp30_ = n;
#line 165 "../src/Layout.vala"
							node_set_posy (_tmp30_, (py - self->_pc_gap) - ch);
#line 166 "../src/Layout.vala"
							break;
#line 1426 "Layout.c"
						}
#line 153 "../src/Layout.vala"
						case NODE_SIDE_BOTTOM:
#line 1430 "Layout.c"
						{
							Node* _tmp31_;
#line 168 "../src/Layout.vala"
							_tmp31_ = n;
#line 168 "../src/Layout.vala"
							node_set_posy (_tmp31_, (py + ph) + self->_pc_gap);
#line 169 "../src/Layout.vala"
							break;
#line 1439 "Layout.c"
						}
						default:
#line 153 "../src/Layout.vala"
						break;
#line 1444 "Layout.c"
					}
#line 171 "../src/Layout.vala"
					_tmp32_ = n;
#line 171 "../src/Layout.vala"
					layout_propagate_side (self, _tmp32_, side);
#line 1450 "Layout.c"
				}
#line 149 "../src/Layout.vala"
				_g_object_unref0 (n);
#line 1454 "Layout.c"
			}
		}
	}
}

void
layout_propagate_side (Layout* self,
                       Node* parent,
                       NodeSide side)
{
#line 146 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 146 "../src/Layout.vala"
	LAYOUT_GET_CLASS (self)->propagate_side (self, parent, side);
#line 1469 "Layout.c"
}

static NodeSide
layout_real_get_side (Layout* self,
                      Node* n)
{
	NodeSide result = 0;
	gdouble rx = 0.0;
	gdouble ry = 0.0;
	gdouble rw = 0.0;
	gdouble rh = 0.0;
	gdouble nx = 0.0;
	gdouble ny = 0.0;
	gdouble nw = 0.0;
	gdouble nh = 0.0;
	Node* _tmp0_;
	Node* _tmp1_;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	NodeSide _tmp10_;
	NodeSide _tmp11_;
#line 177 "../src/Layout.vala"
	g_return_val_if_fail (n != NULL, 0);
#line 180 "../src/Layout.vala"
	_tmp0_ = node_get_root (n);
#line 180 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 180 "../src/Layout.vala"
	node_bbox (_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 180 "../src/Layout.vala"
	rx = _tmp2_;
#line 180 "../src/Layout.vala"
	ry = _tmp3_;
#line 180 "../src/Layout.vala"
	rw = _tmp4_;
#line 180 "../src/Layout.vala"
	rh = _tmp5_;
#line 180 "../src/Layout.vala"
	_g_object_unref0 (_tmp1_);
#line 181 "../src/Layout.vala"
	node_bbox (n, &_tmp6_, &_tmp7_, &_tmp8_, &_tmp9_);
#line 181 "../src/Layout.vala"
	nx = _tmp6_;
#line 181 "../src/Layout.vala"
	ny = _tmp7_;
#line 181 "../src/Layout.vala"
	nw = _tmp8_;
#line 181 "../src/Layout.vala"
	nh = _tmp9_;
#line 182 "../src/Layout.vala"
	_tmp10_ = node_get_side (n);
#line 182 "../src/Layout.vala"
	_tmp11_ = _tmp10_;
#line 182 "../src/Layout.vala"
	if ((_tmp11_ & node_side_horizontal ()) != 0) {
#line 1531 "Layout.c"
		NodeSide _tmp12_ = 0;
#line 183 "../src/Layout.vala"
		if ((nx + (nw / 2)) > (rx + (rw / 2))) {
#line 183 "../src/Layout.vala"
			_tmp12_ = NODE_SIDE_RIGHT;
#line 1537 "Layout.c"
		} else {
#line 183 "../src/Layout.vala"
			_tmp12_ = NODE_SIDE_LEFT;
#line 1541 "Layout.c"
		}
#line 183 "../src/Layout.vala"
		result = _tmp12_;
#line 183 "../src/Layout.vala"
		return result;
#line 1547 "Layout.c"
	} else {
		NodeSide _tmp13_ = 0;
#line 185 "../src/Layout.vala"
		if ((ny + (nh / 2)) > (ry + (rh / 2))) {
#line 185 "../src/Layout.vala"
			_tmp13_ = NODE_SIDE_BOTTOM;
#line 1554 "Layout.c"
		} else {
#line 185 "../src/Layout.vala"
			_tmp13_ = NODE_SIDE_TOP;
#line 1558 "Layout.c"
		}
#line 185 "../src/Layout.vala"
		result = _tmp13_;
#line 185 "../src/Layout.vala"
		return result;
#line 1564 "Layout.c"
	}
}

NodeSide
layout_get_side (Layout* self,
                 Node* n)
{
#line 177 "../src/Layout.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 177 "../src/Layout.vala"
	return LAYOUT_GET_CLASS (self)->get_side (self, n);
#line 1576 "Layout.c"
}

static void
layout_real_set_side (Layout* self,
                      Node* current)
{
#line 190 "../src/Layout.vala"
	g_return_if_fail (current != NULL);
#line 191 "../src/Layout.vala"
	if (!node_is_root (current)) {
#line 1587 "Layout.c"
		NodeSide side = 0;
		NodeSide _tmp0_;
		NodeSide _tmp1_;
		NodeSide _tmp2_;
#line 192 "../src/Layout.vala"
		side = layout_get_side (self, current);
#line 193 "../src/Layout.vala"
		_tmp0_ = node_get_side (current);
#line 193 "../src/Layout.vala"
		_tmp1_ = _tmp0_;
#line 193 "../src/Layout.vala"
		_tmp2_ = side;
#line 193 "../src/Layout.vala"
		if (_tmp1_ != _tmp2_) {
#line 1602 "Layout.c"
			NodeSide _tmp3_;
			NodeSide _tmp4_;
#line 194 "../src/Layout.vala"
			_tmp3_ = side;
#line 194 "../src/Layout.vala"
			node_set_side (current, _tmp3_);
#line 195 "../src/Layout.vala"
			_tmp4_ = side;
#line 195 "../src/Layout.vala"
			layout_propagate_side (self, current, _tmp4_);
#line 1613 "Layout.c"
		}
	}
}

void
layout_set_side (Layout* self,
                 Node* current)
{
#line 190 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 190 "../src/Layout.vala"
	LAYOUT_GET_CLASS (self)->set_side (self, current);
#line 1626 "Layout.c"
}

static void
layout_real_handle_update_by_edit (Layout* self,
                                   Node* n,
                                   gdouble diffw,
                                   gdouble diffh)
{
	gdouble adjust = 0.0;
	NodeSide _tmp0_;
	NodeSide _tmp1_;
#line 201 "../src/Layout.vala"
	g_return_if_fail (n != NULL);
#line 202 "../src/Layout.vala"
	adjust = 0 - (layout_get_adjust (self, n) / 2);
#line 203 "../src/Layout.vala"
	_tmp0_ = node_get_side (n);
#line 203 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 203 "../src/Layout.vala"
	if ((_tmp1_ & node_side_horizontal ()) != 0) {
#line 1648 "Layout.c"
		gboolean _tmp2_ = FALSE;
		Node* _tmp3_;
		Node* _tmp4_;
#line 204 "../src/Layout.vala"
		_tmp3_ = node_get_parent (n);
#line 204 "../src/Layout.vala"
		_tmp4_ = _tmp3_;
#line 204 "../src/Layout.vala"
		if (_tmp4_ != NULL) {
#line 204 "../src/Layout.vala"
			_tmp2_ = diffh != ((gdouble) 0);
#line 1660 "Layout.c"
		} else {
#line 204 "../src/Layout.vala"
			_tmp2_ = FALSE;
#line 1664 "Layout.c"
		}
#line 204 "../src/Layout.vala"
		if (_tmp2_) {
#line 205 "../src/Layout.vala"
			node_adjust_posy_only (n, 0 - (diffh / 2));
#line 206 "../src/Layout.vala"
			layout_adjust_tree_all (self, n, adjust);
#line 1672 "Layout.c"
		}
#line 208 "../src/Layout.vala"
		if (diffw != ((gdouble) 0)) {
#line 1676 "Layout.c"
			NodeSide _tmp5_;
			NodeSide _tmp6_;
#line 209 "../src/Layout.vala"
			_tmp5_ = node_get_side (n);
#line 209 "../src/Layout.vala"
			_tmp6_ = _tmp5_;
#line 209 "../src/Layout.vala"
			if (_tmp6_ == NODE_SIDE_LEFT) {
#line 1685 "Layout.c"
				gdouble _tmp7_;
				gdouble _tmp8_;
#line 210 "../src/Layout.vala"
				_tmp7_ = node_get_posx (n);
#line 210 "../src/Layout.vala"
				_tmp8_ = _tmp7_;
#line 210 "../src/Layout.vala"
				node_set_posx (n, _tmp8_ - diffw);
#line 1694 "Layout.c"
			} else {
				{
					gint i = 0;
#line 212 "../src/Layout.vala"
					i = 0;
#line 1700 "Layout.c"
					{
						gboolean _tmp9_ = FALSE;
#line 212 "../src/Layout.vala"
						_tmp9_ = TRUE;
#line 212 "../src/Layout.vala"
						while (TRUE) {
#line 1707 "Layout.c"
							GArray* _tmp11_;
							GArray* _tmp12_;
							gboolean _tmp13_;
							GArray* _tmp14_;
							GArray* _tmp15_;
							Node* _tmp16_;
							GArray* _tmp17_;
							GArray* _tmp18_;
							Node* _tmp19_;
							gdouble _tmp20_;
							gdouble _tmp21_;
#line 212 "../src/Layout.vala"
							if (!_tmp9_) {
#line 1721 "Layout.c"
								gint _tmp10_;
#line 212 "../src/Layout.vala"
								_tmp10_ = i;
#line 212 "../src/Layout.vala"
								i = _tmp10_ + 1;
#line 1727 "Layout.c"
							}
#line 212 "../src/Layout.vala"
							_tmp9_ = FALSE;
#line 212 "../src/Layout.vala"
							_tmp11_ = node_children (n);
#line 212 "../src/Layout.vala"
							_tmp12_ = _tmp11_;
#line 212 "../src/Layout.vala"
							_tmp13_ = !(((guint) i) < _tmp12_->len);
#line 212 "../src/Layout.vala"
							_g_array_unref0 (_tmp12_);
#line 212 "../src/Layout.vala"
							if (_tmp13_) {
#line 212 "../src/Layout.vala"
								break;
#line 1743 "Layout.c"
							}
#line 213 "../src/Layout.vala"
							_tmp14_ = node_children (n);
#line 213 "../src/Layout.vala"
							_tmp15_ = _tmp14_;
#line 213 "../src/Layout.vala"
							_tmp16_ = g_array_index (_tmp15_, Node*, (guint) i);
#line 213 "../src/Layout.vala"
							_tmp17_ = node_children (n);
#line 213 "../src/Layout.vala"
							_tmp18_ = _tmp17_;
#line 213 "../src/Layout.vala"
							_tmp19_ = g_array_index (_tmp18_, Node*, (guint) i);
#line 213 "../src/Layout.vala"
							_tmp20_ = node_get_posx (_tmp19_);
#line 213 "../src/Layout.vala"
							_tmp21_ = _tmp20_;
#line 213 "../src/Layout.vala"
							node_set_posx (_tmp19_, _tmp21_ + diffw);
#line 213 "../src/Layout.vala"
							_g_array_unref0 (_tmp18_);
#line 213 "../src/Layout.vala"
							_g_array_unref0 (_tmp15_);
#line 1767 "Layout.c"
						}
					}
				}
			}
		}
	} else {
		gboolean _tmp22_ = FALSE;
		Node* _tmp23_;
		Node* _tmp24_;
#line 218 "../src/Layout.vala"
		_tmp23_ = node_get_parent (n);
#line 218 "../src/Layout.vala"
		_tmp24_ = _tmp23_;
#line 218 "../src/Layout.vala"
		if (_tmp24_ != NULL) {
#line 218 "../src/Layout.vala"
			_tmp22_ = diffw != ((gdouble) 0);
#line 1785 "Layout.c"
		} else {
#line 218 "../src/Layout.vala"
			_tmp22_ = FALSE;
#line 1789 "Layout.c"
		}
#line 218 "../src/Layout.vala"
		if (_tmp22_) {
#line 219 "../src/Layout.vala"
			node_adjust_posx_only (n, 0 - (diffw / 2));
#line 220 "../src/Layout.vala"
			layout_adjust_tree_all (self, n, adjust);
#line 1797 "Layout.c"
		}
#line 222 "../src/Layout.vala"
		if (diffh != ((gdouble) 0)) {
#line 1801 "Layout.c"
			NodeSide _tmp25_;
			NodeSide _tmp26_;
#line 223 "../src/Layout.vala"
			_tmp25_ = node_get_side (n);
#line 223 "../src/Layout.vala"
			_tmp26_ = _tmp25_;
#line 223 "../src/Layout.vala"
			if (_tmp26_ == NODE_SIDE_TOP) {
#line 1810 "Layout.c"
				gdouble _tmp27_;
				gdouble _tmp28_;
#line 224 "../src/Layout.vala"
				_tmp27_ = node_get_posy (n);
#line 224 "../src/Layout.vala"
				_tmp28_ = _tmp27_;
#line 224 "../src/Layout.vala"
				node_set_posy (n, _tmp28_ - diffh);
#line 1819 "Layout.c"
			} else {
				{
					gint i = 0;
#line 226 "../src/Layout.vala"
					i = 0;
#line 1825 "Layout.c"
					{
						gboolean _tmp29_ = FALSE;
#line 226 "../src/Layout.vala"
						_tmp29_ = TRUE;
#line 226 "../src/Layout.vala"
						while (TRUE) {
#line 1832 "Layout.c"
							GArray* _tmp31_;
							GArray* _tmp32_;
							gboolean _tmp33_;
							GArray* _tmp34_;
							GArray* _tmp35_;
							Node* _tmp36_;
							GArray* _tmp37_;
							GArray* _tmp38_;
							Node* _tmp39_;
							gdouble _tmp40_;
							gdouble _tmp41_;
#line 226 "../src/Layout.vala"
							if (!_tmp29_) {
#line 1846 "Layout.c"
								gint _tmp30_;
#line 226 "../src/Layout.vala"
								_tmp30_ = i;
#line 226 "../src/Layout.vala"
								i = _tmp30_ + 1;
#line 1852 "Layout.c"
							}
#line 226 "../src/Layout.vala"
							_tmp29_ = FALSE;
#line 226 "../src/Layout.vala"
							_tmp31_ = node_children (n);
#line 226 "../src/Layout.vala"
							_tmp32_ = _tmp31_;
#line 226 "../src/Layout.vala"
							_tmp33_ = !(((guint) i) < _tmp32_->len);
#line 226 "../src/Layout.vala"
							_g_array_unref0 (_tmp32_);
#line 226 "../src/Layout.vala"
							if (_tmp33_) {
#line 226 "../src/Layout.vala"
								break;
#line 1868 "Layout.c"
							}
#line 227 "../src/Layout.vala"
							_tmp34_ = node_children (n);
#line 227 "../src/Layout.vala"
							_tmp35_ = _tmp34_;
#line 227 "../src/Layout.vala"
							_tmp36_ = g_array_index (_tmp35_, Node*, (guint) i);
#line 227 "../src/Layout.vala"
							_tmp37_ = node_children (n);
#line 227 "../src/Layout.vala"
							_tmp38_ = _tmp37_;
#line 227 "../src/Layout.vala"
							_tmp39_ = g_array_index (_tmp38_, Node*, (guint) i);
#line 227 "../src/Layout.vala"
							_tmp40_ = node_get_posy (_tmp39_);
#line 227 "../src/Layout.vala"
							_tmp41_ = _tmp40_;
#line 227 "../src/Layout.vala"
							node_set_posy (_tmp39_, _tmp41_ + diffh);
#line 227 "../src/Layout.vala"
							_g_array_unref0 (_tmp38_);
#line 227 "../src/Layout.vala"
							_g_array_unref0 (_tmp35_);
#line 1892 "Layout.c"
						}
					}
				}
			}
		}
	}
}

void
layout_handle_update_by_edit (Layout* self,
                              Node* n,
                              gdouble diffw,
                              gdouble diffh)
{
#line 201 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 201 "../src/Layout.vala"
	LAYOUT_GET_CLASS (self)->handle_update_by_edit (self, n, diffw, diffh);
#line 1911 "Layout.c"
}

static void
layout_real_handle_update_by_fold (Layout* self,
                                   Node* n)
{
#line 235 "../src/Layout.vala"
	g_return_if_fail (n != NULL);
#line 236 "../src/Layout.vala"
	layout_adjust_tree_all (self, n, 0 - (layout_get_adjust (self, n) / 2));
#line 1922 "Layout.c"
}

void
layout_handle_update_by_fold (Layout* self,
                              Node* n)
{
#line 235 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 235 "../src/Layout.vala"
	LAYOUT_GET_CLASS (self)->handle_update_by_fold (self, n);
#line 1933 "Layout.c"
}

static void
layout_set_pc_gap (Layout* self,
                   Node* n)
{
	gdouble px = 0.0;
	gdouble py = 0.0;
	gdouble pw = 0.0;
	gdouble ph = 0.0;
	Node* _tmp0_;
	Node* _tmp1_;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	NodeSide _tmp6_;
	NodeSide _tmp7_;
#line 240 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 240 "../src/Layout.vala"
	g_return_if_fail (n != NULL);
#line 242 "../src/Layout.vala"
	_tmp0_ = node_get_parent (n);
#line 242 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 242 "../src/Layout.vala"
	node_bbox (_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 242 "../src/Layout.vala"
	px = _tmp2_;
#line 242 "../src/Layout.vala"
	py = _tmp3_;
#line 242 "../src/Layout.vala"
	pw = _tmp4_;
#line 242 "../src/Layout.vala"
	ph = _tmp5_;
#line 243 "../src/Layout.vala"
	_tmp6_ = node_get_side (n);
#line 243 "../src/Layout.vala"
	_tmp7_ = _tmp6_;
#line 243 "../src/Layout.vala"
	switch (_tmp7_) {
#line 243 "../src/Layout.vala"
		case NODE_SIDE_LEFT:
#line 1978 "Layout.c"
		{
			gdouble cx = 0.0;
			gdouble cy = 0.0;
			gdouble cw = 0.0;
			gdouble ch = 0.0;
			gdouble _tmp8_ = 0.0;
			gdouble _tmp9_ = 0.0;
			gdouble _tmp10_ = 0.0;
			gdouble _tmp11_ = 0.0;
#line 246 "../src/Layout.vala"
			node_bbox (n, &_tmp8_, &_tmp9_, &_tmp10_, &_tmp11_);
#line 246 "../src/Layout.vala"
			cx = _tmp8_;
#line 246 "../src/Layout.vala"
			cy = _tmp9_;
#line 246 "../src/Layout.vala"
			cw = _tmp10_;
#line 246 "../src/Layout.vala"
			ch = _tmp11_;
#line 247 "../src/Layout.vala"
			node_set_posx (n, px - (cw + self->_pc_gap));
#line 248 "../src/Layout.vala"
			break;
#line 2002 "Layout.c"
		}
#line 243 "../src/Layout.vala"
		case NODE_SIDE_RIGHT:
#line 2006 "Layout.c"
		{
			Node* _tmp12_;
			Node* _tmp13_;
#line 250 "../src/Layout.vala"
			_tmp12_ = node_get_parent (n);
#line 250 "../src/Layout.vala"
			_tmp13_ = _tmp12_;
#line 250 "../src/Layout.vala"
			node_set_posx (n, (px + (pw + self->_pc_gap)) - node_task_width (_tmp13_));
#line 251 "../src/Layout.vala"
			break;
#line 2018 "Layout.c"
		}
#line 243 "../src/Layout.vala"
		case NODE_SIDE_TOP:
#line 2022 "Layout.c"
		{
			gdouble cx = 0.0;
			gdouble cy = 0.0;
			gdouble cw = 0.0;
			gdouble ch = 0.0;
			gdouble _tmp14_ = 0.0;
			gdouble _tmp15_ = 0.0;
			gdouble _tmp16_ = 0.0;
			gdouble _tmp17_ = 0.0;
#line 254 "../src/Layout.vala"
			node_bbox (n, &_tmp14_, &_tmp15_, &_tmp16_, &_tmp17_);
#line 254 "../src/Layout.vala"
			cx = _tmp14_;
#line 254 "../src/Layout.vala"
			cy = _tmp15_;
#line 254 "../src/Layout.vala"
			cw = _tmp16_;
#line 254 "../src/Layout.vala"
			ch = _tmp17_;
#line 255 "../src/Layout.vala"
			node_set_posy (n, py - (ch + self->_pc_gap));
#line 256 "../src/Layout.vala"
			break;
#line 2046 "Layout.c"
		}
#line 243 "../src/Layout.vala"
		case NODE_SIDE_BOTTOM:
#line 2050 "Layout.c"
		{
#line 258 "../src/Layout.vala"
			node_set_posy (n, py + (ph + self->_pc_gap));
#line 259 "../src/Layout.vala"
			break;
#line 2056 "Layout.c"
		}
		default:
#line 243 "../src/Layout.vala"
		break;
#line 2061 "Layout.c"
	}
}

static gdouble
layout_real_get_insert_adjust (Layout* self,
                               Node* child)
{
	gdouble result = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
#line 264 "../src/Layout.vala"
	g_return_val_if_fail (child != NULL, 0.0);
#line 265 "../src/Layout.vala"
	_tmp0_ = node_get_tree_size (child);
#line 265 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 265 "../src/Layout.vala"
	result = _tmp1_ / 2;
#line 265 "../src/Layout.vala"
	return result;
#line 2082 "Layout.c"
}

gdouble
layout_get_insert_adjust (Layout* self,
                          Node* child)
{
#line 264 "../src/Layout.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 264 "../src/Layout.vala"
	return LAYOUT_GET_CLASS (self)->get_insert_adjust (self, child);
#line 2093 "Layout.c"
}

static void
layout_real_handle_update_by_insert (Layout* self,
                                     Node* parent,
                                     Node* child,
                                     gint pos)
{
	gdouble ox = 0.0;
	gdouble oy = 0.0;
	gdouble ow = 0.0;
	gdouble oh = 0.0;
	gdouble cx = 0.0;
	gdouble cy = 0.0;
	gdouble cw = 0.0;
	gdouble ch = 0.0;
	gdouble adjust = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	NodeSide _tmp4_;
	NodeSide _tmp5_;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	NodeSide _tmp10_;
	NodeSide _tmp11_;
#line 269 "../src/Layout.vala"
	g_return_if_fail (parent != NULL);
#line 269 "../src/Layout.vala"
	g_return_if_fail (child != NULL);
#line 275 "../src/Layout.vala"
	layout_update_tree_size (self, child);
#line 277 "../src/Layout.vala"
	node_bbox (child, &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 277 "../src/Layout.vala"
	ox = _tmp0_;
#line 277 "../src/Layout.vala"
	oy = _tmp1_;
#line 277 "../src/Layout.vala"
	ow = _tmp2_;
#line 277 "../src/Layout.vala"
	oh = _tmp3_;
#line 278 "../src/Layout.vala"
	_tmp4_ = node_get_side (child);
#line 278 "../src/Layout.vala"
	_tmp5_ = _tmp4_;
#line 278 "../src/Layout.vala"
	layout_bbox (self, child, (gint) _tmp5_, &_tmp6_, &_tmp7_, &_tmp8_, &_tmp9_);
#line 278 "../src/Layout.vala"
	cx = _tmp6_;
#line 278 "../src/Layout.vala"
	cy = _tmp7_;
#line 278 "../src/Layout.vala"
	cw = _tmp8_;
#line 278 "../src/Layout.vala"
	ch = _tmp9_;
#line 279 "../src/Layout.vala"
	layout_set_pc_gap (self, child);
#line 280 "../src/Layout.vala"
	adjust = layout_get_insert_adjust (self, child);
#line 286 "../src/Layout.vala"
	_tmp10_ = node_get_side (child);
#line 286 "../src/Layout.vala"
	_tmp11_ = _tmp10_;
#line 286 "../src/Layout.vala"
	if (node_side_count (parent, _tmp11_) == 1) {
#line 2163 "Layout.c"
		gdouble px = 0.0;
		gdouble py = 0.0;
		gdouble pw = 0.0;
		gdouble ph = 0.0;
		gdouble _tmp12_ = 0.0;
		gdouble _tmp13_ = 0.0;
		gdouble _tmp14_ = 0.0;
		gdouble _tmp15_ = 0.0;
		NodeSide _tmp16_;
		NodeSide _tmp17_;
#line 288 "../src/Layout.vala"
		node_bbox (parent, &_tmp12_, &_tmp13_, &_tmp14_, &_tmp15_);
#line 288 "../src/Layout.vala"
		px = _tmp12_;
#line 288 "../src/Layout.vala"
		py = _tmp13_;
#line 288 "../src/Layout.vala"
		pw = _tmp14_;
#line 288 "../src/Layout.vala"
		ph = _tmp15_;
#line 289 "../src/Layout.vala"
		_tmp16_ = node_get_side (child);
#line 289 "../src/Layout.vala"
		_tmp17_ = _tmp16_;
#line 289 "../src/Layout.vala"
		if ((_tmp17_ & node_side_horizontal ()) != 0) {
#line 290 "../src/Layout.vala"
			node_set_posy (child, py + ((ph / 2) - (oh / 2)));
#line 2192 "Layout.c"
		} else {
#line 292 "../src/Layout.vala"
			node_set_posx (child, px + ((pw / 2) - (ow / 2)));
#line 2196 "Layout.c"
		}
#line 294 "../src/Layout.vala"
		return;
#line 2200 "Layout.c"
	} else {
		gboolean _tmp18_ = FALSE;
		GArray* _tmp19_;
		GArray* _tmp20_;
		gboolean _tmp21_;
#line 300 "../src/Layout.vala"
		_tmp19_ = node_children (parent);
#line 300 "../src/Layout.vala"
		_tmp20_ = _tmp19_;
#line 300 "../src/Layout.vala"
		_tmp21_ = ((guint) (pos + 1)) == _tmp20_->len;
#line 300 "../src/Layout.vala"
		_g_array_unref0 (_tmp20_);
#line 300 "../src/Layout.vala"
		if (_tmp21_) {
#line 300 "../src/Layout.vala"
			_tmp18_ = TRUE;
#line 2218 "Layout.c"
		} else {
			GArray* _tmp22_;
			GArray* _tmp23_;
			Node* _tmp24_;
			NodeSide _tmp25_;
			NodeSide _tmp26_;
			NodeSide _tmp27_;
			NodeSide _tmp28_;
#line 300 "../src/Layout.vala"
			_tmp22_ = node_children (parent);
#line 300 "../src/Layout.vala"
			_tmp23_ = _tmp22_;
#line 300 "../src/Layout.vala"
			_tmp24_ = g_array_index (_tmp23_, Node*, (guint) (pos + 1));
#line 300 "../src/Layout.vala"
			_tmp25_ = node_get_side (_tmp24_);
#line 300 "../src/Layout.vala"
			_tmp26_ = _tmp25_;
#line 300 "../src/Layout.vala"
			_tmp27_ = node_get_side (child);
#line 300 "../src/Layout.vala"
			_tmp28_ = _tmp27_;
#line 300 "../src/Layout.vala"
			_tmp18_ = _tmp26_ != _tmp28_;
#line 300 "../src/Layout.vala"
			_g_array_unref0 (_tmp23_);
#line 2245 "Layout.c"
		}
#line 300 "../src/Layout.vala"
		if (_tmp18_) {
#line 2249 "Layout.c"
			gdouble sx = 0.0;
			gdouble sy = 0.0;
			gdouble sw = 0.0;
			gdouble sh = 0.0;
			GArray* _tmp29_;
			GArray* _tmp30_;
			Node* _tmp31_;
			NodeSide _tmp32_;
			NodeSide _tmp33_;
			gdouble _tmp34_ = 0.0;
			gdouble _tmp35_ = 0.0;
			gdouble _tmp36_ = 0.0;
			gdouble _tmp37_ = 0.0;
			NodeSide _tmp38_;
			NodeSide _tmp39_;
#line 302 "../src/Layout.vala"
			_tmp29_ = node_children (parent);
#line 302 "../src/Layout.vala"
			_tmp30_ = _tmp29_;
#line 302 "../src/Layout.vala"
			_tmp31_ = g_array_index (_tmp30_, Node*, (guint) (pos - 1));
#line 302 "../src/Layout.vala"
			_tmp32_ = node_get_side (child);
#line 302 "../src/Layout.vala"
			_tmp33_ = _tmp32_;
#line 302 "../src/Layout.vala"
			layout_bbox (self, _tmp31_, (gint) _tmp33_, &_tmp34_, &_tmp35_, &_tmp36_, &_tmp37_);
#line 302 "../src/Layout.vala"
			sx = _tmp34_;
#line 302 "../src/Layout.vala"
			sy = _tmp35_;
#line 302 "../src/Layout.vala"
			sw = _tmp36_;
#line 302 "../src/Layout.vala"
			sh = _tmp37_;
#line 302 "../src/Layout.vala"
			_g_array_unref0 (_tmp30_);
#line 303 "../src/Layout.vala"
			_tmp38_ = node_get_side (child);
#line 303 "../src/Layout.vala"
			_tmp39_ = _tmp38_;
#line 303 "../src/Layout.vala"
			if ((_tmp39_ & node_side_horizontal ()) != 0) {
#line 304 "../src/Layout.vala"
				node_set_posy (child, ((sy + sh) + (oy - cy)) - adjust);
#line 2295 "Layout.c"
			} else {
#line 306 "../src/Layout.vala"
				node_set_posx (child, ((sx + sw) + (ox - cx)) - adjust);
#line 2299 "Layout.c"
			}
		} else {
			gdouble sx = 0.0;
			gdouble sy = 0.0;
			gdouble sw = 0.0;
			gdouble sh = 0.0;
			GArray* _tmp40_;
			GArray* _tmp41_;
			Node* _tmp42_;
			NodeSide _tmp43_;
			NodeSide _tmp44_;
			gdouble _tmp45_ = 0.0;
			gdouble _tmp46_ = 0.0;
			gdouble _tmp47_ = 0.0;
			gdouble _tmp48_ = 0.0;
			NodeSide _tmp49_;
			NodeSide _tmp50_;
#line 312 "../src/Layout.vala"
			_tmp40_ = node_children (parent);
#line 312 "../src/Layout.vala"
			_tmp41_ = _tmp40_;
#line 312 "../src/Layout.vala"
			_tmp42_ = g_array_index (_tmp41_, Node*, (guint) (pos + 1));
#line 312 "../src/Layout.vala"
			_tmp43_ = node_get_side (child);
#line 312 "../src/Layout.vala"
			_tmp44_ = _tmp43_;
#line 312 "../src/Layout.vala"
			layout_bbox (self, _tmp42_, (gint) _tmp44_, &_tmp45_, &_tmp46_, &_tmp47_, &_tmp48_);
#line 312 "../src/Layout.vala"
			sx = _tmp45_;
#line 312 "../src/Layout.vala"
			sy = _tmp46_;
#line 312 "../src/Layout.vala"
			sw = _tmp47_;
#line 312 "../src/Layout.vala"
			sh = _tmp48_;
#line 312 "../src/Layout.vala"
			_g_array_unref0 (_tmp41_);
#line 313 "../src/Layout.vala"
			_tmp49_ = node_get_side (child);
#line 313 "../src/Layout.vala"
			_tmp50_ = _tmp49_;
#line 313 "../src/Layout.vala"
			if ((_tmp50_ & node_side_horizontal ()) != 0) {
#line 314 "../src/Layout.vala"
				node_set_posy (child, (sy + (oy - cy)) - adjust);
#line 2347 "Layout.c"
			} else {
#line 316 "../src/Layout.vala"
				node_set_posx (child, (sx + (ox - cx)) - adjust);
#line 2351 "Layout.c"
			}
		}
	}
#line 320 "../src/Layout.vala"
	layout_adjust_tree_all (self, child, 0 - adjust);
#line 2357 "Layout.c"
}

void
layout_handle_update_by_insert (Layout* self,
                                Node* parent,
                                Node* child,
                                gint pos)
{
#line 269 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 269 "../src/Layout.vala"
	LAYOUT_GET_CLASS (self)->handle_update_by_insert (self, parent, child, pos);
#line 2370 "Layout.c"
}

static void
layout_real_handle_update_by_delete (Layout* self,
                                     Node* parent,
                                     gint index,
                                     NodeSide side,
                                     gdouble size)
{
	gdouble adjust = 0.0;
	Node* _tmp25_;
	Node* _tmp26_;
#line 325 "../src/Layout.vala"
	g_return_if_fail (parent != NULL);
#line 327 "../src/Layout.vala"
	adjust = size / 2;
#line 2387 "Layout.c"
	{
		gint i = 0;
#line 330 "../src/Layout.vala"
		i = 0;
#line 2392 "Layout.c"
		{
			gboolean _tmp0_ = FALSE;
#line 330 "../src/Layout.vala"
			_tmp0_ = TRUE;
#line 330 "../src/Layout.vala"
			while (TRUE) {
#line 2399 "Layout.c"
				GArray* _tmp2_;
				GArray* _tmp3_;
				gboolean _tmp4_;
				Node* n = NULL;
				GArray* _tmp5_;
				GArray* _tmp6_;
				Node* _tmp7_;
				Node* _tmp8_;
				Node* _tmp9_;
				Node* _tmp10_;
				NodeSide _tmp11_;
				NodeSide _tmp12_;
#line 330 "../src/Layout.vala"
				if (!_tmp0_) {
#line 2414 "Layout.c"
					gint _tmp1_;
#line 330 "../src/Layout.vala"
					_tmp1_ = i;
#line 330 "../src/Layout.vala"
					i = _tmp1_ + 1;
#line 2420 "Layout.c"
				}
#line 330 "../src/Layout.vala"
				_tmp0_ = FALSE;
#line 330 "../src/Layout.vala"
				_tmp2_ = node_children (parent);
#line 330 "../src/Layout.vala"
				_tmp3_ = _tmp2_;
#line 330 "../src/Layout.vala"
				_tmp4_ = !(((guint) i) < _tmp3_->len);
#line 330 "../src/Layout.vala"
				_g_array_unref0 (_tmp3_);
#line 330 "../src/Layout.vala"
				if (_tmp4_) {
#line 330 "../src/Layout.vala"
					break;
#line 2436 "Layout.c"
				}
#line 331 "../src/Layout.vala"
				_tmp5_ = node_children (parent);
#line 331 "../src/Layout.vala"
				_tmp6_ = _tmp5_;
#line 331 "../src/Layout.vala"
				_tmp7_ = g_array_index (_tmp6_, Node*, (guint) i);
#line 331 "../src/Layout.vala"
				_tmp8_ = _g_object_ref0 (_tmp7_);
#line 331 "../src/Layout.vala"
				_tmp9_ = _tmp8_;
#line 331 "../src/Layout.vala"
				_g_array_unref0 (_tmp6_);
#line 331 "../src/Layout.vala"
				n = _tmp9_;
#line 332 "../src/Layout.vala"
				_tmp10_ = n;
#line 332 "../src/Layout.vala"
				_tmp11_ = node_get_side (_tmp10_);
#line 332 "../src/Layout.vala"
				_tmp12_ = _tmp11_;
#line 332 "../src/Layout.vala"
				if (_tmp12_ == side) {
#line 2460 "Layout.c"
					gdouble _tmp13_ = 0.0;
					gdouble current_adjust = 0.0;
					Node* _tmp14_;
					NodeSide _tmp15_;
					NodeSide _tmp16_;
#line 333 "../src/Layout.vala"
					if (i >= index) {
#line 333 "../src/Layout.vala"
						_tmp13_ = 0 - adjust;
#line 2470 "Layout.c"
					} else {
#line 333 "../src/Layout.vala"
						_tmp13_ = adjust;
#line 2474 "Layout.c"
					}
#line 333 "../src/Layout.vala"
					current_adjust = _tmp13_;
#line 334 "../src/Layout.vala"
					_tmp14_ = n;
#line 334 "../src/Layout.vala"
					_tmp15_ = node_get_side (_tmp14_);
#line 334 "../src/Layout.vala"
					_tmp16_ = _tmp15_;
#line 334 "../src/Layout.vala"
					if ((_tmp16_ & node_side_horizontal ()) != 0) {
#line 2486 "Layout.c"
						Node* _tmp17_;
						Node* _tmp18_;
						gdouble _tmp19_;
						gdouble _tmp20_;
#line 335 "../src/Layout.vala"
						_tmp17_ = n;
#line 335 "../src/Layout.vala"
						_tmp18_ = n;
#line 335 "../src/Layout.vala"
						_tmp19_ = node_get_posy (_tmp18_);
#line 335 "../src/Layout.vala"
						_tmp20_ = _tmp19_;
#line 335 "../src/Layout.vala"
						node_set_posy (_tmp18_, _tmp20_ + current_adjust);
#line 2501 "Layout.c"
					} else {
						Node* _tmp21_;
						Node* _tmp22_;
						gdouble _tmp23_;
						gdouble _tmp24_;
#line 337 "../src/Layout.vala"
						_tmp21_ = n;
#line 337 "../src/Layout.vala"
						_tmp22_ = n;
#line 337 "../src/Layout.vala"
						_tmp23_ = node_get_posx (_tmp22_);
#line 337 "../src/Layout.vala"
						_tmp24_ = _tmp23_;
#line 337 "../src/Layout.vala"
						node_set_posx (_tmp22_, _tmp24_ + current_adjust);
#line 2517 "Layout.c"
					}
				}
#line 330 "../src/Layout.vala"
				_g_object_unref0 (n);
#line 2522 "Layout.c"
			}
		}
	}
#line 343 "../src/Layout.vala"
	_tmp25_ = node_get_parent (parent);
#line 343 "../src/Layout.vala"
	_tmp26_ = _tmp25_;
#line 343 "../src/Layout.vala"
	if (_tmp26_ != NULL) {
#line 344 "../src/Layout.vala"
		layout_adjust_tree_all (self, parent, 0 - (layout_get_adjust (self, parent) / 2));
#line 2534 "Layout.c"
	}
}

void
layout_handle_update_by_delete (Layout* self,
                                Node* parent,
                                gint index,
                                NodeSide side,
                                gdouble size)
{
#line 325 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 325 "../src/Layout.vala"
	LAYOUT_GET_CLASS (self)->handle_update_by_delete (self, parent, index, side, size);
#line 2549 "Layout.c"
}

static void
layout_real_position_root (Layout* self,
                           Node* last,
                           Node* n)
{
	gdouble x = 0.0;
	gdouble y = 0.0;
	gdouble w = 0.0;
	gdouble h = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_;
	gdouble _tmp5_;
#line 350 "../src/Layout.vala"
	g_return_if_fail (last != NULL);
#line 350 "../src/Layout.vala"
	g_return_if_fail (n != NULL);
#line 352 "../src/Layout.vala"
	layout_bbox (self, last, -1, &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 352 "../src/Layout.vala"
	x = _tmp0_;
#line 352 "../src/Layout.vala"
	y = _tmp1_;
#line 352 "../src/Layout.vala"
	w = _tmp2_;
#line 352 "../src/Layout.vala"
	h = _tmp3_;
#line 353 "../src/Layout.vala"
	_tmp4_ = node_get_posx (last);
#line 353 "../src/Layout.vala"
	_tmp5_ = _tmp4_;
#line 353 "../src/Layout.vala"
	node_set_posx (n, _tmp5_);
#line 354 "../src/Layout.vala"
	node_set_posy (n, (y + h) + self->_rt_gap);
#line 2589 "Layout.c"
}

void
layout_position_root (Layout* self,
                      Node* last,
                      Node* n)
{
#line 350 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 350 "../src/Layout.vala"
	LAYOUT_GET_CLASS (self)->position_root (self, last, n);
#line 2601 "Layout.c"
}

const gchar*
layout_get_name (Layout* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 27 "../src/Layout.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../src/Layout.vala"
	_tmp0_ = self->priv->_name;
#line 27 "../src/Layout.vala"
	result = _tmp0_;
#line 27 "../src/Layout.vala"
	return result;
#line 2617 "Layout.c"
}

void
layout_set_name (Layout* self,
                 const gchar* value)
{
#line 27 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/Layout.vala"
	if (g_strcmp0 (value, layout_get_name (self)) != 0) {
#line 2628 "Layout.c"
		gchar* _tmp0_;
#line 27 "../src/Layout.vala"
		_tmp0_ = g_strdup (value);
#line 27 "../src/Layout.vala"
		_g_free0 (self->priv->_name);
#line 27 "../src/Layout.vala"
		self->priv->_name = _tmp0_;
#line 27 "../src/Layout.vala"
		g_object_notify_by_pspec ((GObject *) self, layout_properties[LAYOUT_NAME_PROPERTY]);
#line 2638 "Layout.c"
	}
}

const gchar*
layout_get_icon (Layout* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 28 "../src/Layout.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/Layout.vala"
	_tmp0_ = self->priv->_icon;
#line 28 "../src/Layout.vala"
	result = _tmp0_;
#line 28 "../src/Layout.vala"
	return result;
#line 2655 "Layout.c"
}

void
layout_set_icon (Layout* self,
                 const gchar* value)
{
#line 28 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Layout.vala"
	if (g_strcmp0 (value, layout_get_icon (self)) != 0) {
#line 2666 "Layout.c"
		gchar* _tmp0_;
#line 28 "../src/Layout.vala"
		_tmp0_ = g_strdup (value);
#line 28 "../src/Layout.vala"
		_g_free0 (self->priv->_icon);
#line 28 "../src/Layout.vala"
		self->priv->_icon = _tmp0_;
#line 28 "../src/Layout.vala"
		g_object_notify_by_pspec ((GObject *) self, layout_properties[LAYOUT_ICON_PROPERTY]);
#line 2676 "Layout.c"
	}
}

gboolean
layout_get_balanceable (Layout* self)
{
	gboolean result;
#line 29 "../src/Layout.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 29 "../src/Layout.vala"
	result = self->priv->_balanceable;
#line 29 "../src/Layout.vala"
	return result;
#line 2690 "Layout.c"
}

void
layout_set_balanceable (Layout* self,
                        gboolean value)
{
#line 29 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Layout.vala"
	if (layout_get_balanceable (self) != value) {
#line 29 "../src/Layout.vala"
		self->priv->_balanceable = value;
#line 29 "../src/Layout.vala"
		g_object_notify_by_pspec ((GObject *) self, layout_properties[LAYOUT_BALANCEABLE_PROPERTY]);
#line 2705 "Layout.c"
	}
}

static void
layout_class_init (LayoutClass * klass,
                   gpointer klass_data)
{
#line 22 "../src/Layout.vala"
	layout_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Layout.vala"
	g_type_class_adjust_private_offset (klass, &Layout_private_offset);
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->side_mapping = (NodeSide (*) (Layout*, NodeSide)) layout_real_side_mapping;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->initialize = (void (*) (Layout*, Node*)) layout_real_initialize;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->bbox = (void (*) (Layout*, Node*, gint, gdouble*, gdouble*, gdouble*, gdouble*)) layout_real_bbox;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->adjust_tree = (void (*) (Layout*, Node*, gint, gint, gdouble)) layout_real_adjust_tree;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->adjust_tree_all = (void (*) (Layout*, Node*, gdouble)) layout_real_adjust_tree_all;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->propagate_side = (void (*) (Layout*, Node*, NodeSide)) layout_real_propagate_side;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->get_side = (NodeSide (*) (Layout*, Node*)) layout_real_get_side;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->set_side = (void (*) (Layout*, Node*)) layout_real_set_side;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->handle_update_by_edit = (void (*) (Layout*, Node*, gdouble, gdouble)) layout_real_handle_update_by_edit;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->handle_update_by_fold = (void (*) (Layout*, Node*)) layout_real_handle_update_by_fold;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->get_insert_adjust = (gdouble (*) (Layout*, Node*)) layout_real_get_insert_adjust;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->handle_update_by_insert = (void (*) (Layout*, Node*, Node*, gint)) layout_real_handle_update_by_insert;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->handle_update_by_delete = (void (*) (Layout*, Node*, gint, NodeSide, gdouble)) layout_real_handle_update_by_delete;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->position_root = (void (*) (Layout*, Node*, Node*)) layout_real_position_root;
#line 22 "../src/Layout.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_layout_get_property;
#line 22 "../src/Layout.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_layout_set_property;
#line 22 "../src/Layout.vala"
	G_OBJECT_CLASS (klass)->finalize = layout_finalize;
#line 22 "../src/Layout.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LAYOUT_NAME_PROPERTY, layout_properties[LAYOUT_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Layout.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LAYOUT_ICON_PROPERTY, layout_properties[LAYOUT_ICON_PROPERTY] = g_param_spec_string ("icon", "icon", "icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Layout.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LAYOUT_BALANCEABLE_PROPERTY, layout_properties[LAYOUT_BALANCEABLE_PROPERTY] = g_param_spec_boolean ("balanceable", "balanceable", "balanceable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2757 "Layout.c"
}

static void
layout_instance_init (Layout * self,
                      gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 22 "../src/Layout.vala"
	self->priv = layout_get_instance_private (self);
#line 24 "../src/Layout.vala"
	self->_pc_gap = (gdouble) 100;
#line 25 "../src/Layout.vala"
	self->_rt_gap = (gdouble) 100;
#line 27 "../src/Layout.vala"
	_tmp0_ = g_strdup ("");
#line 27 "../src/Layout.vala"
	self->priv->_name = _tmp0_;
#line 28 "../src/Layout.vala"
	_tmp1_ = g_strdup ("");
#line 28 "../src/Layout.vala"
	self->priv->_icon = _tmp1_;
#line 29 "../src/Layout.vala"
	self->priv->_balanceable = FALSE;
#line 2782 "Layout.c"
}

static void
layout_finalize (GObject * obj)
{
	Layout * self;
#line 22 "../src/Layout.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LAYOUT, Layout);
#line 27 "../src/Layout.vala"
	_g_free0 (self->priv->_name);
#line 28 "../src/Layout.vala"
	_g_free0 (self->priv->_icon);
#line 22 "../src/Layout.vala"
	G_OBJECT_CLASS (layout_parent_class)->finalize (obj);
#line 2797 "Layout.c"
}

GType
layout_get_type (void)
{
	static volatile gsize layout_type_id__volatile = 0;
	if (g_once_init_enter (&layout_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LayoutClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) layout_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Layout), 0, (GInstanceInitFunc) layout_instance_init, NULL };
		GType layout_type_id;
		layout_type_id = g_type_register_static (G_TYPE_OBJECT, "Layout", &g_define_type_info, 0);
		Layout_private_offset = g_type_add_instance_private (layout_type_id, sizeof (LayoutPrivate));
		g_once_init_leave (&layout_type_id__volatile, layout_type_id);
	}
	return layout_type_id__volatile;
}

static void
_vala_layout_get_property (GObject * object,
                           guint property_id,
                           GValue * value,
                           GParamSpec * pspec)
{
	Layout * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_LAYOUT, Layout);
#line 22 "../src/Layout.vala"
	switch (property_id) {
#line 22 "../src/Layout.vala"
		case LAYOUT_NAME_PROPERTY:
#line 22 "../src/Layout.vala"
		g_value_set_string (value, layout_get_name (self));
#line 22 "../src/Layout.vala"
		break;
#line 22 "../src/Layout.vala"
		case LAYOUT_ICON_PROPERTY:
#line 22 "../src/Layout.vala"
		g_value_set_string (value, layout_get_icon (self));
#line 22 "../src/Layout.vala"
		break;
#line 22 "../src/Layout.vala"
		case LAYOUT_BALANCEABLE_PROPERTY:
#line 22 "../src/Layout.vala"
		g_value_set_boolean (value, layout_get_balanceable (self));
#line 22 "../src/Layout.vala"
		break;
#line 2842 "Layout.c"
		default:
#line 22 "../src/Layout.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Layout.vala"
		break;
#line 2848 "Layout.c"
	}
}

static void
_vala_layout_set_property (GObject * object,
                           guint property_id,
                           const GValue * value,
                           GParamSpec * pspec)
{
	Layout * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_LAYOUT, Layout);
#line 22 "../src/Layout.vala"
	switch (property_id) {
#line 22 "../src/Layout.vala"
		case LAYOUT_NAME_PROPERTY:
#line 22 "../src/Layout.vala"
		layout_set_name (self, g_value_get_string (value));
#line 22 "../src/Layout.vala"
		break;
#line 22 "../src/Layout.vala"
		case LAYOUT_ICON_PROPERTY:
#line 22 "../src/Layout.vala"
		layout_set_icon (self, g_value_get_string (value));
#line 22 "../src/Layout.vala"
		break;
#line 22 "../src/Layout.vala"
		case LAYOUT_BALANCEABLE_PROPERTY:
#line 22 "../src/Layout.vala"
		layout_set_balanceable (self, g_value_get_boolean (value));
#line 22 "../src/Layout.vala"
		break;
#line 2880 "Layout.c"
		default:
#line 22 "../src/Layout.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Layout.vala"
		break;
#line 2886 "Layout.c"
	}
}

