/* Partitioner.c generated by valac 0.45.3, the Vala compiler
 * generated from Partitioner.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/
/*
 This class stores a pointer to a node to partition as well as its pixel size
 that is used for balancing purposes.
*/

#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>

#define TYPE_PART_NODE (part_node_get_type ())
#define PART_NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PART_NODE, PartNode))
#define PART_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PART_NODE, PartNodeClass))
#define IS_PART_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PART_NODE))
#define IS_PART_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PART_NODE))
#define PART_NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PART_NODE, PartNodeClass))

typedef struct _PartNode PartNode;
typedef struct _PartNodeClass PartNodeClass;
typedef struct _PartNodePrivate PartNodePrivate;

#define TYPE_NODE (node_get_type ())
#define NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE, Node))
#define NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE, NodeClass))
#define IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE))
#define IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE))
#define NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE, NodeClass))

typedef struct _Node Node;
typedef struct _NodeClass NodeClass;
enum  {
	PART_NODE_0_PROPERTY,
	PART_NODE_NUM_PROPERTIES
};
static GParamSpec* part_node_properties[PART_NODE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_LAYOUT (layout_get_type ())
#define LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LAYOUT, Layout))
#define LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LAYOUT, LayoutClass))
#define IS_LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LAYOUT))
#define IS_LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LAYOUT))
#define LAYOUT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LAYOUT, LayoutClass))

typedef struct _Layout Layout;
typedef struct _LayoutClass LayoutClass;
typedef enum  {
	NODE_SIDE_LEFT = 1,
	NODE_SIDE_TOP = 2,
	NODE_SIDE_RIGHT = 4,
	NODE_SIDE_BOTTOM = 8
} NodeSide;

#define TYPE_NODE_SIDE (node_side_get_type ())

#define TYPE_PARTITIONER (partitioner_get_type ())
#define PARTITIONER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PARTITIONER, Partitioner))
#define PARTITIONER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PARTITIONER, PartitionerClass))
#define IS_PARTITIONER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PARTITIONER))
#define IS_PARTITIONER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PARTITIONER))
#define PARTITIONER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PARTITIONER, PartitionerClass))

typedef struct _Partitioner Partitioner;
typedef struct _PartitionerClass PartitionerClass;
typedef struct _PartitionerPrivate PartitionerPrivate;
enum  {
	PARTITIONER_0_PROPERTY,
	PARTITIONER_NUM_PROPERTIES
};
static GParamSpec* partitioner_properties[PARTITIONER_NUM_PROPERTIES];
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
typedef struct _Block19Data Block19Data;

struct _PartNode {
	GObject parent_instance;
	PartNodePrivate * priv;
};

struct _PartNodeClass {
	GObjectClass parent_class;
};

struct _PartNodePrivate {
	Node* _node;
	gdouble _size;
};

struct _Partitioner {
	GObject parent_instance;
	PartitionerPrivate * priv;
};

struct _PartitionerClass {
	GObjectClass parent_class;
	void (*partition) (Partitioner* self, Node* root, GSList* data);
};

struct _Block19Data {
	int _ref_count_;
	Partitioner* self;
	gdouble sum0;
	gdouble sum1;
	gint size0;
	Node* root;
};

static gint PartNode_private_offset;
static gpointer part_node_parent_class = NULL;
static gpointer partitioner_parent_class = NULL;

GType part_node_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PartNode, g_object_unref)
GType node_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Node, g_object_unref)
PartNode* part_node_new (Node* n);
PartNode* part_node_construct (GType object_type,
                               Node* n);
GType layout_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Layout, g_object_unref)
Layout* node_get_layout (Node* self);
void layout_bbox (Layout* self,
                  Node* parent,
                  gint side_mask,
                  gdouble* x,
                  gdouble* y,
                  gdouble* w,
                  gdouble* h);
GType node_side_get_type (void) G_GNUC_CONST;
NodeSide node_get_side (Node* self);
gdouble part_node_size (PartNode* self);
Node* part_node_node (PartNode* self);
void part_node_update_node (PartNode* self,
                            Node* root,
                            gint index,
                            gint side);
void node_set_side (Node* self,
                    NodeSide value);
void layout_propagate_side (Layout* self,
                            Node* parent,
                            NodeSide side);
void node_attach_init (Node* self,
                       Node* parent,
                       gint index);
static void part_node_finalize (GObject * obj);
GType partitioner_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Partitioner, g_object_unref)
Partitioner* partitioner_new (void);
Partitioner* partitioner_construct (GType object_type);
void partitioner_partition_node (Partitioner* self,
                                 Node* root);
GArray* node_children (Node* self);
static gint ___lambda64_ (PartNode* a,
                   PartNode* b);
gint node_id (Node* self);
static gint ____lambda64__gcompare_func (gconstpointer a,
                                  gconstpointer b);
static gint ___lambda65_ (PartNode* a,
                   PartNode* b);
static gint ____lambda65__gcompare_func (gconstpointer a,
                                  gconstpointer b);
void partitioner_partition (Partitioner* self,
                            Node* root,
                            GSList* data);
static void _g_object_unref0_ (gpointer var);
static inline void _g_slist_free__g_object_unref0_ (GSList* self);
static void partitioner_real_partition (Partitioner* self,
                                 Node* root,
                                 GSList* data);
static Block19Data* block19_data_ref (Block19Data* _data19_);
static void block19_data_unref (void * _userdata_);
static void __lambda66_ (Partitioner* self,
                  PartNode* item);
void node_detach (Node* self,
                  NodeSide side);
static void ___lambda66__gfunc (gconstpointer data,
                         gpointer self);
static void __lambda67_ (Block19Data* _data19_,
                  PartNode* item);
static void ___lambda67__gfunc (gconstpointer data,
                         gpointer self);

static inline gpointer
part_node_get_instance_private (PartNode* self)
{
	return G_STRUCT_MEMBER_P (self, PartNode_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 40 "../src/Partitioner.vala"
	return self ? g_object_ref (self) : NULL;
#line 217 "Partitioner.c"
}

PartNode*
part_node_construct (GType object_type,
                     Node* n)
{
	PartNode * self = NULL;
	gdouble x = 0.0;
	gdouble y = 0.0;
	gdouble w = 0.0;
	gdouble h = 0.0;
	Layout* _tmp0_;
	Layout* _tmp1_;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gboolean _tmp6_ = FALSE;
	NodeSide _tmp7_;
	NodeSide _tmp8_;
	Node* _tmp11_;
#line 32 "../src/Partitioner.vala"
	g_return_val_if_fail (n != NULL, NULL);
#line 32 "../src/Partitioner.vala"
	self = (PartNode*) g_object_new (object_type, NULL);
#line 34 "../src/Partitioner.vala"
	_tmp0_ = node_get_layout (n);
#line 34 "../src/Partitioner.vala"
	_tmp1_ = _tmp0_;
#line 34 "../src/Partitioner.vala"
	layout_bbox (_tmp1_, n, -1, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 34 "../src/Partitioner.vala"
	x = _tmp2_;
#line 34 "../src/Partitioner.vala"
	y = _tmp3_;
#line 34 "../src/Partitioner.vala"
	w = _tmp4_;
#line 34 "../src/Partitioner.vala"
	h = _tmp5_;
#line 35 "../src/Partitioner.vala"
	_tmp7_ = node_get_side (n);
#line 35 "../src/Partitioner.vala"
	_tmp8_ = _tmp7_;
#line 35 "../src/Partitioner.vala"
	if (_tmp8_ == NODE_SIDE_LEFT) {
#line 35 "../src/Partitioner.vala"
		_tmp6_ = TRUE;
#line 265 "Partitioner.c"
	} else {
		NodeSide _tmp9_;
		NodeSide _tmp10_;
#line 35 "../src/Partitioner.vala"
		_tmp9_ = node_get_side (n);
#line 35 "../src/Partitioner.vala"
		_tmp10_ = _tmp9_;
#line 35 "../src/Partitioner.vala"
		_tmp6_ = _tmp10_ == NODE_SIDE_RIGHT;
#line 275 "Partitioner.c"
	}
#line 35 "../src/Partitioner.vala"
	if (_tmp6_) {
#line 36 "../src/Partitioner.vala"
		self->priv->_size = h;
#line 281 "Partitioner.c"
	} else {
#line 38 "../src/Partitioner.vala"
		self->priv->_size = w;
#line 285 "Partitioner.c"
	}
#line 40 "../src/Partitioner.vala"
	_tmp11_ = _g_object_ref0 (n);
#line 40 "../src/Partitioner.vala"
	_g_object_unref0 (self->priv->_node);
#line 40 "../src/Partitioner.vala"
	self->priv->_node = _tmp11_;
#line 32 "../src/Partitioner.vala"
	return self;
#line 295 "Partitioner.c"
}

PartNode*
part_node_new (Node* n)
{
#line 32 "../src/Partitioner.vala"
	return part_node_construct (TYPE_PART_NODE, n);
#line 303 "Partitioner.c"
}

gdouble
part_node_size (PartNode* self)
{
	gdouble result = 0.0;
#line 44 "../src/Partitioner.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 44 "../src/Partitioner.vala"
	result = self->priv->_size;
#line 44 "../src/Partitioner.vala"
	return result;
#line 316 "Partitioner.c"
}

Node*
part_node_node (PartNode* self)
{
	Node* result = NULL;
	Node* _tmp0_;
	Node* _tmp1_;
#line 47 "../src/Partitioner.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 47 "../src/Partitioner.vala"
	_tmp0_ = self->priv->_node;
#line 47 "../src/Partitioner.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 47 "../src/Partitioner.vala"
	result = _tmp1_;
#line 47 "../src/Partitioner.vala"
	return result;
#line 335 "Partitioner.c"
}

void
part_node_update_node (PartNode* self,
                       Node* root,
                       gint index,
                       gint side)
{
	NodeSide orig_side = 0;
	Node* _tmp0_;
	NodeSide _tmp1_;
	NodeSide _tmp2_;
	gboolean _tmp3_ = FALSE;
	Node* _tmp4_;
	NodeSide _tmp5_;
	NodeSide _tmp6_;
	NodeSide _tmp14_;
	Node* _tmp15_;
	NodeSide _tmp16_;
	NodeSide _tmp17_;
	Node* _tmp25_;
#line 50 "../src/Partitioner.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/Partitioner.vala"
	g_return_if_fail (root != NULL);
#line 51 "../src/Partitioner.vala"
	_tmp0_ = self->priv->_node;
#line 51 "../src/Partitioner.vala"
	_tmp1_ = node_get_side (_tmp0_);
#line 51 "../src/Partitioner.vala"
	_tmp2_ = _tmp1_;
#line 51 "../src/Partitioner.vala"
	orig_side = _tmp2_;
#line 52 "../src/Partitioner.vala"
	_tmp4_ = self->priv->_node;
#line 52 "../src/Partitioner.vala"
	_tmp5_ = node_get_side (_tmp4_);
#line 52 "../src/Partitioner.vala"
	_tmp6_ = _tmp5_;
#line 52 "../src/Partitioner.vala"
	if (_tmp6_ == NODE_SIDE_LEFT) {
#line 52 "../src/Partitioner.vala"
		_tmp3_ = TRUE;
#line 379 "Partitioner.c"
	} else {
		Node* _tmp7_;
		NodeSide _tmp8_;
		NodeSide _tmp9_;
#line 52 "../src/Partitioner.vala"
		_tmp7_ = self->priv->_node;
#line 52 "../src/Partitioner.vala"
		_tmp8_ = node_get_side (_tmp7_);
#line 52 "../src/Partitioner.vala"
		_tmp9_ = _tmp8_;
#line 52 "../src/Partitioner.vala"
		_tmp3_ = _tmp9_ == NODE_SIDE_RIGHT;
#line 392 "Partitioner.c"
	}
#line 52 "../src/Partitioner.vala"
	if (_tmp3_) {
#line 396 "Partitioner.c"
		NodeSide _tmp10_ = 0;
		Node* _tmp11_;
#line 53 "../src/Partitioner.vala"
		if (side == 0) {
#line 53 "../src/Partitioner.vala"
			_tmp10_ = NODE_SIDE_LEFT;
#line 403 "Partitioner.c"
		} else {
#line 53 "../src/Partitioner.vala"
			_tmp10_ = NODE_SIDE_RIGHT;
#line 407 "Partitioner.c"
		}
#line 53 "../src/Partitioner.vala"
		_tmp11_ = self->priv->_node;
#line 53 "../src/Partitioner.vala"
		node_set_side (_tmp11_, _tmp10_);
#line 413 "Partitioner.c"
	} else {
		NodeSide _tmp12_ = 0;
		Node* _tmp13_;
#line 55 "../src/Partitioner.vala"
		if (side == 0) {
#line 55 "../src/Partitioner.vala"
			_tmp12_ = NODE_SIDE_TOP;
#line 421 "Partitioner.c"
		} else {
#line 55 "../src/Partitioner.vala"
			_tmp12_ = NODE_SIDE_BOTTOM;
#line 425 "Partitioner.c"
		}
#line 55 "../src/Partitioner.vala"
		_tmp13_ = self->priv->_node;
#line 55 "../src/Partitioner.vala"
		node_set_side (_tmp13_, _tmp12_);
#line 431 "Partitioner.c"
	}
#line 57 "../src/Partitioner.vala"
	_tmp14_ = orig_side;
#line 57 "../src/Partitioner.vala"
	_tmp15_ = self->priv->_node;
#line 57 "../src/Partitioner.vala"
	_tmp16_ = node_get_side (_tmp15_);
#line 57 "../src/Partitioner.vala"
	_tmp17_ = _tmp16_;
#line 57 "../src/Partitioner.vala"
	if (_tmp14_ != _tmp17_) {
#line 443 "Partitioner.c"
		Node* _tmp18_;
		Layout* _tmp19_;
		Layout* _tmp20_;
		Node* _tmp21_;
		Node* _tmp22_;
		NodeSide _tmp23_;
		NodeSide _tmp24_;
#line 58 "../src/Partitioner.vala"
		_tmp18_ = self->priv->_node;
#line 58 "../src/Partitioner.vala"
		_tmp19_ = node_get_layout (_tmp18_);
#line 58 "../src/Partitioner.vala"
		_tmp20_ = _tmp19_;
#line 58 "../src/Partitioner.vala"
		_tmp21_ = self->priv->_node;
#line 58 "../src/Partitioner.vala"
		_tmp22_ = self->priv->_node;
#line 58 "../src/Partitioner.vala"
		_tmp23_ = node_get_side (_tmp22_);
#line 58 "../src/Partitioner.vala"
		_tmp24_ = _tmp23_;
#line 58 "../src/Partitioner.vala"
		layout_propagate_side (_tmp20_, _tmp21_, _tmp24_);
#line 467 "Partitioner.c"
	}
#line 60 "../src/Partitioner.vala"
	_tmp25_ = self->priv->_node;
#line 60 "../src/Partitioner.vala"
	node_attach_init (_tmp25_, root, index);
#line 473 "Partitioner.c"
}

static void
part_node_class_init (PartNodeClass * klass,
                      gpointer klass_data)
{
#line 26 "../src/Partitioner.vala"
	part_node_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/Partitioner.vala"
	g_type_class_adjust_private_offset (klass, &PartNode_private_offset);
#line 26 "../src/Partitioner.vala"
	G_OBJECT_CLASS (klass)->finalize = part_node_finalize;
#line 486 "Partitioner.c"
}

static void
part_node_instance_init (PartNode * self,
                         gpointer klass)
{
#line 26 "../src/Partitioner.vala"
	self->priv = part_node_get_instance_private (self);
#line 28 "../src/Partitioner.vala"
	self->priv->_node = NULL;
#line 497 "Partitioner.c"
}

static void
part_node_finalize (GObject * obj)
{
	PartNode * self;
#line 26 "../src/Partitioner.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PART_NODE, PartNode);
#line 28 "../src/Partitioner.vala"
	_g_object_unref0 (self->priv->_node);
#line 26 "../src/Partitioner.vala"
	G_OBJECT_CLASS (part_node_parent_class)->finalize (obj);
#line 510 "Partitioner.c"
}

GType
part_node_get_type (void)
{
	static volatile gsize part_node_type_id__volatile = 0;
	if (g_once_init_enter (&part_node_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PartNodeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) part_node_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PartNode), 0, (GInstanceInitFunc) part_node_instance_init, NULL };
		GType part_node_type_id;
		part_node_type_id = g_type_register_static (G_TYPE_OBJECT, "PartNode", &g_define_type_info, 0);
		PartNode_private_offset = g_type_add_instance_private (part_node_type_id, sizeof (PartNodePrivate));
		g_once_init_leave (&part_node_type_id__volatile, part_node_type_id);
	}
	return part_node_type_id__volatile;
}

Partitioner*
partitioner_construct (GType object_type)
{
	Partitioner * self = NULL;
#line 72 "../src/Partitioner.vala"
	self = (Partitioner*) g_object_new (object_type, NULL);
#line 72 "../src/Partitioner.vala"
	return self;
#line 535 "Partitioner.c"
}

Partitioner*
partitioner_new (void)
{
#line 72 "../src/Partitioner.vala"
	return partitioner_construct (TYPE_PARTITIONER);
#line 543 "Partitioner.c"
}

static gint
___lambda64_ (PartNode* a,
              PartNode* b)
{
	gint result = 0;
	gint _tmp0_ = 0;
	Node* _tmp1_;
	Node* _tmp2_;
	Node* _tmp3_;
	Node* _tmp4_;
	gboolean _tmp5_;
#line 83 "../src/Partitioner.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 83 "../src/Partitioner.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 84 "../src/Partitioner.vala"
	_tmp1_ = part_node_node (a);
#line 84 "../src/Partitioner.vala"
	_tmp2_ = _tmp1_;
#line 84 "../src/Partitioner.vala"
	_tmp3_ = part_node_node (b);
#line 84 "../src/Partitioner.vala"
	_tmp4_ = _tmp3_;
#line 84 "../src/Partitioner.vala"
	_tmp5_ = node_id (_tmp2_) < node_id (_tmp4_);
#line 84 "../src/Partitioner.vala"
	_g_object_unref0 (_tmp4_);
#line 84 "../src/Partitioner.vala"
	_g_object_unref0 (_tmp2_);
#line 84 "../src/Partitioner.vala"
	if (_tmp5_) {
#line 84 "../src/Partitioner.vala"
		_tmp0_ = 1;
#line 579 "Partitioner.c"
	} else {
#line 84 "../src/Partitioner.vala"
		_tmp0_ = -1;
#line 583 "Partitioner.c"
	}
#line 84 "../src/Partitioner.vala"
	result = _tmp0_;
#line 84 "../src/Partitioner.vala"
	return result;
#line 589 "Partitioner.c"
}

static gint
____lambda64__gcompare_func (gconstpointer a,
                             gconstpointer b)
{
	gint result;
	result = ___lambda64_ ((PartNode*) a, (PartNode*) b);
#line 83 "../src/Partitioner.vala"
	return result;
#line 600 "Partitioner.c"
}

static gint
___lambda65_ (PartNode* a,
              PartNode* b)
{
	gint result = 0;
	gint _tmp0_ = 0;
#line 86 "../src/Partitioner.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 86 "../src/Partitioner.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 87 "../src/Partitioner.vala"
	if (part_node_size (a) < part_node_size (b)) {
#line 87 "../src/Partitioner.vala"
		_tmp0_ = 1;
#line 617 "Partitioner.c"
	} else {
		gint _tmp1_ = 0;
#line 87 "../src/Partitioner.vala"
		if (part_node_size (a) == part_node_size (b)) {
#line 87 "../src/Partitioner.vala"
			_tmp1_ = 0;
#line 624 "Partitioner.c"
		} else {
#line 87 "../src/Partitioner.vala"
			_tmp1_ = -1;
#line 628 "Partitioner.c"
		}
#line 87 "../src/Partitioner.vala"
		_tmp0_ = _tmp1_;
#line 632 "Partitioner.c"
	}
#line 87 "../src/Partitioner.vala"
	result = _tmp0_;
#line 87 "../src/Partitioner.vala"
	return result;
#line 638 "Partitioner.c"
}

static gint
____lambda65__gcompare_func (gconstpointer a,
                             gconstpointer b)
{
	gint result;
	result = ___lambda65_ ((PartNode*) a, (PartNode*) b);
#line 86 "../src/Partitioner.vala"
	return result;
#line 649 "Partitioner.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 76 "../src/Partitioner.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 657 "Partitioner.c"
}

static inline void
_g_slist_free__g_object_unref0_ (GSList* self)
{
#line 76 "../src/Partitioner.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 665 "Partitioner.c"
}

void
partitioner_partition_node (Partitioner* self,
                            Node* root)
{
	GArray* _tmp0_;
	GArray* _tmp1_;
	gboolean _tmp2_;
#line 75 "../src/Partitioner.vala"
	g_return_if_fail (self != NULL);
#line 75 "../src/Partitioner.vala"
	g_return_if_fail (root != NULL);
#line 76 "../src/Partitioner.vala"
	_tmp0_ = node_children (root);
#line 76 "../src/Partitioner.vala"
	_tmp1_ = _tmp0_;
#line 76 "../src/Partitioner.vala"
	_tmp2_ = _tmp1_->len > ((guint) 2);
#line 76 "../src/Partitioner.vala"
	_g_array_unref0 (_tmp1_);
#line 76 "../src/Partitioner.vala"
	if (_tmp2_) {
#line 689 "Partitioner.c"
		GSList* data = NULL;
		GCompareFunc pn_cmp1 = NULL;
		GCompareFunc pn_cmp2 = NULL;
		GCompareFunc _tmp17_;
		GCompareFunc _tmp18_;
		GSList* _tmp19_;
#line 77 "../src/Partitioner.vala"
		data = NULL;
#line 698 "Partitioner.c"
		{
			gint i = 0;
#line 78 "../src/Partitioner.vala"
			i = 0;
#line 703 "Partitioner.c"
			{
				gboolean _tmp3_ = FALSE;
#line 78 "../src/Partitioner.vala"
				_tmp3_ = TRUE;
#line 78 "../src/Partitioner.vala"
				while (TRUE) {
#line 710 "Partitioner.c"
					GArray* _tmp5_;
					GArray* _tmp6_;
					gboolean _tmp7_;
					Node* node = NULL;
					GArray* _tmp8_;
					GArray* _tmp9_;
					Node* _tmp10_;
					Node* _tmp11_;
					Node* _tmp12_;
					PartNode* pn = NULL;
					Node* _tmp13_;
					PartNode* _tmp14_;
					PartNode* _tmp15_;
					PartNode* _tmp16_;
#line 78 "../src/Partitioner.vala"
					if (!_tmp3_) {
#line 727 "Partitioner.c"
						gint _tmp4_;
#line 78 "../src/Partitioner.vala"
						_tmp4_ = i;
#line 78 "../src/Partitioner.vala"
						i = _tmp4_ + 1;
#line 733 "Partitioner.c"
					}
#line 78 "../src/Partitioner.vala"
					_tmp3_ = FALSE;
#line 78 "../src/Partitioner.vala"
					_tmp5_ = node_children (root);
#line 78 "../src/Partitioner.vala"
					_tmp6_ = _tmp5_;
#line 78 "../src/Partitioner.vala"
					_tmp7_ = !(((guint) i) < _tmp6_->len);
#line 78 "../src/Partitioner.vala"
					_g_array_unref0 (_tmp6_);
#line 78 "../src/Partitioner.vala"
					if (_tmp7_) {
#line 78 "../src/Partitioner.vala"
						break;
#line 749 "Partitioner.c"
					}
#line 79 "../src/Partitioner.vala"
					_tmp8_ = node_children (root);
#line 79 "../src/Partitioner.vala"
					_tmp9_ = _tmp8_;
#line 79 "../src/Partitioner.vala"
					_tmp10_ = g_array_index (_tmp9_, Node*, (guint) i);
#line 79 "../src/Partitioner.vala"
					_tmp11_ = _g_object_ref0 (_tmp10_);
#line 79 "../src/Partitioner.vala"
					_tmp12_ = _tmp11_;
#line 79 "../src/Partitioner.vala"
					_g_array_unref0 (_tmp9_);
#line 79 "../src/Partitioner.vala"
					node = _tmp12_;
#line 80 "../src/Partitioner.vala"
					_tmp13_ = node;
#line 80 "../src/Partitioner.vala"
					_tmp14_ = part_node_new (_tmp13_);
#line 80 "../src/Partitioner.vala"
					pn = _tmp14_;
#line 81 "../src/Partitioner.vala"
					_tmp15_ = pn;
#line 81 "../src/Partitioner.vala"
					_tmp16_ = _g_object_ref0 (_tmp15_);
#line 81 "../src/Partitioner.vala"
					data = g_slist_append (data, _tmp16_);
#line 78 "../src/Partitioner.vala"
					_g_object_unref0 (pn);
#line 78 "../src/Partitioner.vala"
					_g_object_unref0 (node);
#line 781 "Partitioner.c"
				}
			}
		}
#line 83 "../src/Partitioner.vala"
		pn_cmp1 = ____lambda64__gcompare_func;
#line 86 "../src/Partitioner.vala"
		pn_cmp2 = ____lambda65__gcompare_func;
#line 89 "../src/Partitioner.vala"
		_tmp17_ = pn_cmp1;
#line 89 "../src/Partitioner.vala"
		data = g_slist_sort (data, _tmp17_);
#line 90 "../src/Partitioner.vala"
		_tmp18_ = pn_cmp2;
#line 90 "../src/Partitioner.vala"
		data = g_slist_sort (data, _tmp18_);
#line 91 "../src/Partitioner.vala"
		_tmp19_ = data;
#line 91 "../src/Partitioner.vala"
		partitioner_partition (self, root, _tmp19_);
#line 76 "../src/Partitioner.vala"
		(data == NULL) ? NULL : (data = (_g_slist_free__g_object_unref0_ (data), NULL));
#line 803 "Partitioner.c"
	}
}

static Block19Data*
block19_data_ref (Block19Data* _data19_)
{
#line 101 "../src/Partitioner.vala"
	g_atomic_int_inc (&_data19_->_ref_count_);
#line 101 "../src/Partitioner.vala"
	return _data19_;
#line 814 "Partitioner.c"
}

static void
block19_data_unref (void * _userdata_)
{
	Block19Data* _data19_;
	_data19_ = (Block19Data*) _userdata_;
#line 101 "../src/Partitioner.vala"
	if (g_atomic_int_dec_and_test (&_data19_->_ref_count_)) {
#line 824 "Partitioner.c"
		Partitioner* self;
#line 101 "../src/Partitioner.vala"
		self = _data19_->self;
#line 101 "../src/Partitioner.vala"
		_g_object_unref0 (_data19_->root);
#line 101 "../src/Partitioner.vala"
		_g_object_unref0 (self);
#line 101 "../src/Partitioner.vala"
		g_slice_free (Block19Data, _data19_);
#line 834 "Partitioner.c"
	}
}

static void
__lambda66_ (Partitioner* self,
             PartNode* item)
{
	Node* _tmp0_;
	Node* _tmp1_;
	Node* _tmp2_;
	Node* _tmp3_;
	NodeSide _tmp4_;
	NodeSide _tmp5_;
#line 108 "../src/Partitioner.vala"
	g_return_if_fail (item != NULL);
#line 109 "../src/Partitioner.vala"
	_tmp0_ = part_node_node (item);
#line 109 "../src/Partitioner.vala"
	_tmp1_ = _tmp0_;
#line 109 "../src/Partitioner.vala"
	_tmp2_ = part_node_node (item);
#line 109 "../src/Partitioner.vala"
	_tmp3_ = _tmp2_;
#line 109 "../src/Partitioner.vala"
	_tmp4_ = node_get_side (_tmp3_);
#line 109 "../src/Partitioner.vala"
	_tmp5_ = _tmp4_;
#line 109 "../src/Partitioner.vala"
	node_detach (_tmp1_, _tmp5_);
#line 109 "../src/Partitioner.vala"
	_g_object_unref0 (_tmp3_);
#line 109 "../src/Partitioner.vala"
	_g_object_unref0 (_tmp1_);
#line 868 "Partitioner.c"
}

static void
___lambda66__gfunc (gconstpointer data,
                    gpointer self)
{
#line 108 "../src/Partitioner.vala"
	__lambda66_ ((Partitioner*) self, (PartNode*) data);
#line 877 "Partitioner.c"
}

static void
__lambda67_ (Block19Data* _data19_,
             PartNode* item)
{
	Partitioner* self;
#line 113 "../src/Partitioner.vala"
	self = _data19_->self;
#line 113 "../src/Partitioner.vala"
	g_return_if_fail (item != NULL);
#line 114 "../src/Partitioner.vala"
	if (_data19_->sum0 < _data19_->sum1) {
#line 891 "Partitioner.c"
		gint _tmp0_;
#line 115 "../src/Partitioner.vala"
		_data19_->sum0 += part_node_size (item);
#line 116 "../src/Partitioner.vala"
		part_node_update_node (item, _data19_->root, _data19_->size0, 0);
#line 117 "../src/Partitioner.vala"
		_tmp0_ = _data19_->size0;
#line 117 "../src/Partitioner.vala"
		_data19_->size0 = _tmp0_ + 1;
#line 901 "Partitioner.c"
	} else {
#line 119 "../src/Partitioner.vala"
		_data19_->sum1 += part_node_size (item);
#line 120 "../src/Partitioner.vala"
		part_node_update_node (item, _data19_->root, -1, 1);
#line 907 "Partitioner.c"
	}
}

static void
___lambda67__gfunc (gconstpointer data,
                    gpointer self)
{
#line 113 "../src/Partitioner.vala"
	__lambda67_ (self, (PartNode*) data);
#line 917 "Partitioner.c"
}

static void
partitioner_real_partition (Partitioner* self,
                            Node* root,
                            GSList* data)
{
	Block19Data* _data19_;
	Node* _tmp0_;
#line 101 "../src/Partitioner.vala"
	g_return_if_fail (root != NULL);
#line 101 "../src/Partitioner.vala"
	_data19_ = g_slice_new0 (Block19Data);
#line 101 "../src/Partitioner.vala"
	_data19_->_ref_count_ = 1;
#line 101 "../src/Partitioner.vala"
	_data19_->self = g_object_ref (self);
#line 101 "../src/Partitioner.vala"
	_tmp0_ = _g_object_ref0 (root);
#line 101 "../src/Partitioner.vala"
	_g_object_unref0 (_data19_->root);
#line 101 "../src/Partitioner.vala"
	_data19_->root = _tmp0_;
#line 103 "../src/Partitioner.vala"
	_data19_->sum0 = (gdouble) 0;
#line 104 "../src/Partitioner.vala"
	_data19_->sum1 = (gdouble) 0;
#line 105 "../src/Partitioner.vala"
	_data19_->size0 = 0;
#line 108 "../src/Partitioner.vala"
	g_slist_foreach (data, ___lambda66__gfunc, self);
#line 113 "../src/Partitioner.vala"
	g_slist_foreach (data, ___lambda67__gfunc, _data19_);
#line 101 "../src/Partitioner.vala"
	block19_data_unref (_data19_);
#line 101 "../src/Partitioner.vala"
	_data19_ = NULL;
#line 955 "Partitioner.c"
}

void
partitioner_partition (Partitioner* self,
                       Node* root,
                       GSList* data)
{
#line 101 "../src/Partitioner.vala"
	g_return_if_fail (self != NULL);
#line 101 "../src/Partitioner.vala"
	PARTITIONER_GET_CLASS (self)->partition (self, root, data);
#line 967 "Partitioner.c"
}

static void
partitioner_class_init (PartitionerClass * klass,
                        gpointer klass_data)
{
#line 69 "../src/Partitioner.vala"
	partitioner_parent_class = g_type_class_peek_parent (klass);
#line 69 "../src/Partitioner.vala"
	((PartitionerClass *) klass)->partition = (void (*) (Partitioner*, Node*, GSList*)) partitioner_real_partition;
#line 978 "Partitioner.c"
}

static void
partitioner_instance_init (Partitioner * self,
                           gpointer klass)
{
}

GType
partitioner_get_type (void)
{
	static volatile gsize partitioner_type_id__volatile = 0;
	if (g_once_init_enter (&partitioner_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PartitionerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) partitioner_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Partitioner), 0, (GInstanceInitFunc) partitioner_instance_init, NULL };
		GType partitioner_type_id;
		partitioner_type_id = g_type_register_static (G_TYPE_OBJECT, "Partitioner", &g_define_type_info, 0);
		g_once_init_leave (&partitioner_type_id__volatile, partitioner_type_id);
	}
	return partitioner_type_id__volatile;
}

