/* Style.c generated by valac 0.45.3, the Vala compiler
 * generated from Style.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>
#include <libxml/tree.h>
#include <gobject/gvaluecollector.h>

#define TYPE_STYLE (style_get_type ())
#define STYLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STYLE, Style))
#define STYLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STYLE, StyleClass))
#define IS_STYLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STYLE))
#define IS_STYLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STYLE))
#define STYLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STYLE, StyleClass))

typedef struct _Style Style;
typedef struct _StyleClass StyleClass;
typedef struct _StylePrivate StylePrivate;

#define TYPE_LINK_TYPE (link_type_get_type ())
#define LINK_TYPE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LINK_TYPE, LinkType))
#define IS_LINK_TYPE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LINK_TYPE))
#define LINK_TYPE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_LINK_TYPE, LinkTypeIface))

typedef struct _LinkType LinkType;
typedef struct _LinkTypeIface LinkTypeIface;

#define TYPE_LINK_DASH (link_dash_get_type ())
#define LINK_DASH(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LINK_DASH, LinkDash))
#define LINK_DASH_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LINK_DASH, LinkDashClass))
#define IS_LINK_DASH(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LINK_DASH))
#define IS_LINK_DASH_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LINK_DASH))
#define LINK_DASH_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LINK_DASH, LinkDashClass))

typedef struct _LinkDash LinkDash;
typedef struct _LinkDashClass LinkDashClass;

#define TYPE_NODE_BORDER (node_border_get_type ())
#define NODE_BORDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE_BORDER, NodeBorder))
#define IS_NODE_BORDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE_BORDER))
#define NODE_BORDER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_NODE_BORDER, NodeBorderIface))

typedef struct _NodeBorder NodeBorder;
typedef struct _NodeBorderIface NodeBorderIface;
typedef enum  {
	NODE_SIDE_LEFT = 1,
	NODE_SIDE_TOP = 2,
	NODE_SIDE_RIGHT = 4,
	NODE_SIDE_BOTTOM = 8
} NodeSide;

#define TYPE_NODE_SIDE (node_side_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))
typedef struct _LinkDashPrivate LinkDashPrivate;

#define TYPE_STYLES (styles_get_type ())
#define STYLES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STYLES, Styles))
#define STYLES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STYLES, StylesClass))
#define IS_STYLES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STYLES))
#define IS_STYLES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STYLES))
#define STYLES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STYLES, StylesClass))

typedef struct _Styles Styles;
typedef struct _StylesClass StylesClass;
typedef struct _ParamSpecStyle ParamSpecStyle;

struct _Style {
	GTypeInstance parent_instance;
	volatile int ref_count;
	StylePrivate * priv;
};

struct _StyleClass {
	GTypeClass parent_class;
	void (*finalize) (Style *self);
};

struct _LinkTypeIface {
	GTypeInterface parent_iface;
	gchar* (*name) (LinkType* self);
	gchar* (*display_name) (LinkType* self);
	gchar* (*icon_name) (LinkType* self);
	void (*draw) (LinkType* self, cairo_t* ctx, gdouble from_x, gdouble from_y, gdouble to_x, gdouble to_y, gboolean horizontal, gdouble* fx, gdouble* fy, gdouble* tx, gdouble* ty);
};

struct _NodeBorderIface {
	GTypeInterface parent_iface;
	gchar* (*name) (NodeBorder* self);
	gchar* (*display_name) (NodeBorder* self);
	gchar* (*icon_name) (NodeBorder* self);
	gboolean (*is_fillable) (NodeBorder* self);
	void (*draw_border) (NodeBorder* self, cairo_t* ctx, gdouble x, gdouble y, gdouble w, gdouble h, NodeSide s);
	void (*draw_fill) (NodeBorder* self, cairo_t* ctx, gdouble x, gdouble y, gdouble w, gdouble h, NodeSide s);
};

struct _StylePrivate {
	gboolean _template;
	LinkType* _link_type;
	gint* _link_width;
	gboolean* _link_arrow;
	LinkDash* _link_dash;
	NodeBorder* _node_border;
	gint* _node_width;
	gint* _node_borderwidth;
	gboolean* _node_fill;
	gint* _node_margin;
	gint* _node_padding;
	PangoFontDescription* _node_font;
	gboolean* _node_markup;
	LinkDash* _connection_dash;
	gint* _connection_width;
	gchar* _connection_arrow;
	gint* _connection_padding;
	PangoFontDescription* _connection_font;
};

struct _LinkDash {
	GObject parent_instance;
	LinkDashPrivate * priv;
	gchar* name;
	gchar* display_name;
	gdouble* pattern;
	gint pattern_length1;
};

struct _LinkDashClass {
	GObjectClass parent_class;
};

struct _ParamSpecStyle {
	GParamSpec parent_instance;
};

static gint Style_private_offset;
static gpointer style_parent_class = NULL;
extern Styles* style_inspector_styles;

gpointer style_ref (gpointer instance);
void style_unref (gpointer instance);
GParamSpec* param_spec_style (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags);
void value_set_style (GValue* value,
                      gpointer v_object);
void value_take_style (GValue* value,
                       gpointer v_object);
gpointer value_get_style (const GValue* value);
GType style_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Style, style_unref)
GType link_type_get_type (void) G_GNUC_CONST;
GType link_dash_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LinkDash, g_object_unref)
GType node_side_get_type (void) G_GNUC_CONST;
GType node_border_get_type (void) G_GNUC_CONST;
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
Style* style_new (void);
Style* style_construct (GType object_type);
void style_set_node_font (Style* self,
                          PangoFontDescription* value);
PangoFontDescription* style_get_node_font (Style* self);
void style_set_connection_font (Style* self,
                                PangoFontDescription* value);
PangoFontDescription* style_get_connection_font (Style* self);
Style* style_new_templated (void);
Style* style_construct_templated (GType object_type);
gboolean style_is_fillable (Style* self);
gboolean* style_get_node_fill (Style* self);
NodeBorder* style_get_node_border (Style* self);
gboolean node_border_is_fillable (NodeBorder* self);
void style_clear_template (Style* self);
void style_set_link_type (Style* self,
                          LinkType* value);
void style_set_link_width (Style* self,
                           gint* value);
void style_set_link_arrow (Style* self,
                           gboolean* value);
void style_set_link_dash (Style* self,
                          LinkDash* value);
void style_set_node_border (Style* self,
                            NodeBorder* value);
void style_set_node_width (Style* self,
                           gint* value);
void style_set_node_borderwidth (Style* self,
                                 gint* value);
void style_set_node_fill (Style* self,
                          gboolean* value);
void style_set_node_margin (Style* self,
                            gint* value);
void style_set_node_padding (Style* self,
                             gint* value);
void style_set_node_markup (Style* self,
                            gboolean* value);
void style_set_connection_dash (Style* self,
                                LinkDash* value);
void style_set_connection_width (Style* self,
                                 gint* value);
void style_set_connection_arrow (Style* self,
                                 const gchar* value);
void style_set_connection_padding (Style* self,
                                   gint* value);
gboolean style_copy (Style* self,
                     Style* s);
LinkType* style_get_link_type (Style* self);
gint* style_get_link_width (Style* self);
static gboolean _int_equal (const gint * s1,
                     const gint * s2);
gboolean* style_get_link_arrow (Style* self);
static gboolean _bool_equal (const gboolean * s1,
                      const gboolean * s2);
LinkDash* style_get_link_dash (Style* self);
gint* style_get_node_width (Style* self);
gint* style_get_node_borderwidth (Style* self);
gint* style_get_node_margin (Style* self);
gint* style_get_node_padding (Style* self);
gboolean* style_get_node_markup (Style* self);
LinkDash* style_get_connection_dash (Style* self);
gint* style_get_connection_width (Style* self);
const gchar* style_get_connection_arrow (Style* self);
gint* style_get_connection_padding (Style* self);
gchar* style_to_string (Style* self);
gchar* link_type_name (LinkType* self);
static void _vala_array_add3 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add4 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add5 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add6 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
gchar* node_border_name (NodeBorder* self);
static void _vala_array_add7 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add8 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add9 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add10 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add11 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add12 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add13 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add14 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add15 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add16 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add17 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add18 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add19 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
void style_load_node (Style* self,
                      xmlNode* node);
gpointer styles_ref (gpointer instance);
void styles_unref (gpointer instance);
GParamSpec* param_spec_styles (const gchar* name,
                               const gchar* nick,
                               const gchar* blurb,
                               GType object_type,
                               GParamFlags flags);
void value_set_styles (GValue* value,
                       gpointer v_object);
void value_take_styles (GValue* value,
                        gpointer v_object);
gpointer value_get_styles (const GValue* value);
GType styles_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Styles, styles_unref)
LinkType* styles_get_link_type (Styles* self,
                                const gchar* name);
LinkDash* styles_get_link_dash (Styles* self,
                                const gchar* name);
NodeBorder* styles_get_node_border (Styles* self,
                                    const gchar* name);
void style_load_connection (Style* self,
                            xmlNode* node);
void style_save_node_in_node (Style* self,
                              xmlNode* n);
void style_save_node (Style* self,
                      xmlNode* parent);
void style_save_connection_in_node (Style* self,
                                    xmlNode* n);
void style_save_connection (Style* self,
                            xmlNode* parent);
void style_draw_link (Style* self,
                      cairo_t* ctx,
                      Style* parent_style,
                      gdouble from_x,
                      gdouble from_y,
                      gdouble to_x,
                      gdouble to_y,
                      gboolean horizontal,
                      gdouble* tailx,
                      gdouble* taily,
                      gdouble* tipx,
                      gdouble* tipy);
void link_dash_set_context (LinkDash* self,
                            cairo_t* ctx,
                            gint line_width);
void link_type_draw (LinkType* self,
                     cairo_t* ctx,
                     gdouble from_x,
                     gdouble from_y,
                     gdouble to_x,
                     gdouble to_y,
                     gboolean horizontal,
                     gdouble* fx,
                     gdouble* fy,
                     gdouble* tx,
                     gdouble* ty);
void style_draw_node_border (Style* self,
                             cairo_t* ctx,
                             gdouble x,
                             gdouble y,
                             gdouble w,
                             gdouble h,
                             NodeSide s);
void node_border_draw_border (NodeBorder* self,
                              cairo_t* ctx,
                              gdouble x,
                              gdouble y,
                              gdouble w,
                              gdouble h,
                              NodeSide s);
void style_draw_node_fill (Style* self,
                           cairo_t* ctx,
                           gdouble x,
                           gdouble y,
                           gdouble w,
                           gdouble h,
                           NodeSide s);
void node_border_draw_fill (NodeBorder* self,
                            cairo_t* ctx,
                            gdouble x,
                            gdouble y,
                            gdouble w,
                            gdouble h,
                            NodeSide s);
void style_draw_connection (Style* self,
                            cairo_t* ctx);
static gint* _int_dup (gint* self);
static gboolean* _bool_dup (gboolean* self);
static PangoFontDescription* _vala_PangoFontDescription_copy (PangoFontDescription* self);
static void style_finalize (Style * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
style_get_instance_private (Style* self)
{
	return G_STRUCT_MEMBER_P (self, Style_private_offset);
}

static void
_vala_PangoFontDescription_free (PangoFontDescription* self)
{
#line 38 "../src/Style.vala"
	g_boxed_free (pango_font_description_get_type (), self);
#line 433 "Style.c"
}

Style*
style_construct (GType object_type)
{
	Style* self = NULL;
	PangoFontDescription* _tmp0_;
	PangoFontDescription* _tmp1_;
	PangoFontDescription* _tmp2_;
	PangoFontDescription* _tmp3_;
	PangoFontDescription* _tmp4_;
	PangoFontDescription* _tmp5_;
	PangoFontDescription* _tmp6_;
	PangoFontDescription* _tmp7_;
#line 47 "../src/Style.vala"
	self = (Style*) g_type_create_instance (object_type);
#line 49 "../src/Style.vala"
	self->priv->_template = FALSE;
#line 51 "../src/Style.vala"
	_tmp0_ = pango_font_description_new ();
#line 51 "../src/Style.vala"
	_tmp1_ = _tmp0_;
#line 51 "../src/Style.vala"
	style_set_node_font (self, _tmp1_);
#line 51 "../src/Style.vala"
	__vala_PangoFontDescription_free0 (_tmp1_);
#line 52 "../src/Style.vala"
	_tmp2_ = self->priv->_node_font;
#line 52 "../src/Style.vala"
	pango_font_description_set_family (_tmp2_, "Sans");
#line 53 "../src/Style.vala"
	_tmp3_ = self->priv->_node_font;
#line 53 "../src/Style.vala"
	pango_font_description_set_size (_tmp3_, 11 * PANGO_SCALE);
#line 55 "../src/Style.vala"
	_tmp4_ = pango_font_description_new ();
#line 55 "../src/Style.vala"
	_tmp5_ = _tmp4_;
#line 55 "../src/Style.vala"
	style_set_connection_font (self, _tmp5_);
#line 55 "../src/Style.vala"
	__vala_PangoFontDescription_free0 (_tmp5_);
#line 56 "../src/Style.vala"
	_tmp6_ = self->priv->_connection_font;
#line 56 "../src/Style.vala"
	pango_font_description_set_family (_tmp6_, "Sans");
#line 57 "../src/Style.vala"
	_tmp7_ = self->priv->_connection_font;
#line 57 "../src/Style.vala"
	pango_font_description_set_size (_tmp7_, 10 * PANGO_SCALE);
#line 47 "../src/Style.vala"
	return self;
#line 486 "Style.c"
}

Style*
style_new (void)
{
#line 47 "../src/Style.vala"
	return style_construct (TYPE_STYLE);
#line 494 "Style.c"
}

Style*
style_construct_templated (GType object_type)
{
	Style* self = NULL;
#line 62 "../src/Style.vala"
	self = (Style*) g_type_create_instance (object_type);
#line 63 "../src/Style.vala"
	self->priv->_template = TRUE;
#line 62 "../src/Style.vala"
	return self;
#line 507 "Style.c"
}

Style*
style_new_templated (void)
{
#line 62 "../src/Style.vala"
	return style_construct_templated (TYPE_STYLE);
#line 515 "Style.c"
}

gboolean
style_is_fillable (Style* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean* _tmp1_;
#line 67 "../src/Style.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 68 "../src/Style.vala"
	_tmp1_ = self->priv->_node_fill;
#line 68 "../src/Style.vala"
	if (*_tmp1_) {
#line 530 "Style.c"
		NodeBorder* _tmp2_;
#line 68 "../src/Style.vala"
		_tmp2_ = self->priv->_node_border;
#line 68 "../src/Style.vala"
		_tmp0_ = node_border_is_fillable (_tmp2_);
#line 536 "Style.c"
	} else {
#line 68 "../src/Style.vala"
		_tmp0_ = FALSE;
#line 540 "Style.c"
	}
#line 68 "../src/Style.vala"
	result = _tmp0_;
#line 68 "../src/Style.vala"
	return result;
#line 546 "Style.c"
}

void
style_clear_template (Style* self)
{
#line 72 "../src/Style.vala"
	g_return_if_fail (self != NULL);
#line 74 "../src/Style.vala"
	if (self->priv->_template) {
#line 75 "../src/Style.vala"
		style_set_link_type (self, NULL);
#line 76 "../src/Style.vala"
		style_set_link_width (self, NULL);
#line 77 "../src/Style.vala"
		style_set_link_arrow (self, NULL);
#line 78 "../src/Style.vala"
		style_set_link_dash (self, NULL);
#line 79 "../src/Style.vala"
		style_set_node_border (self, NULL);
#line 80 "../src/Style.vala"
		style_set_node_width (self, NULL);
#line 81 "../src/Style.vala"
		style_set_node_borderwidth (self, NULL);
#line 82 "../src/Style.vala"
		style_set_node_fill (self, NULL);
#line 83 "../src/Style.vala"
		style_set_node_margin (self, NULL);
#line 84 "../src/Style.vala"
		style_set_node_padding (self, NULL);
#line 85 "../src/Style.vala"
		style_set_node_font (self, NULL);
#line 86 "../src/Style.vala"
		style_set_node_markup (self, NULL);
#line 87 "../src/Style.vala"
		style_set_connection_dash (self, NULL);
#line 88 "../src/Style.vala"
		style_set_connection_width (self, NULL);
#line 89 "../src/Style.vala"
		style_set_connection_arrow (self, NULL);
#line 90 "../src/Style.vala"
		style_set_connection_padding (self, NULL);
#line 91 "../src/Style.vala"
		style_set_connection_font (self, NULL);
#line 590 "Style.c"
	}
}

static gboolean
_int_equal (const gint * s1,
            const gint * s2)
{
#line 102 "../src/Style.vala"
	if (s1 == s2) {
#line 102 "../src/Style.vala"
		return TRUE;
#line 602 "Style.c"
	}
#line 102 "../src/Style.vala"
	if (s1 == NULL) {
#line 102 "../src/Style.vala"
		return FALSE;
#line 608 "Style.c"
	}
#line 102 "../src/Style.vala"
	if (s2 == NULL) {
#line 102 "../src/Style.vala"
		return FALSE;
#line 614 "Style.c"
	}
#line 102 "../src/Style.vala"
	return (*s1) == (*s2);
#line 618 "Style.c"
}

static gboolean
_bool_equal (const gboolean * s1,
             const gboolean * s2)
{
#line 103 "../src/Style.vala"
	if (s1 == s2) {
#line 103 "../src/Style.vala"
		return TRUE;
#line 629 "Style.c"
	}
#line 103 "../src/Style.vala"
	if (s1 == NULL) {
#line 103 "../src/Style.vala"
		return FALSE;
#line 635 "Style.c"
	}
#line 103 "../src/Style.vala"
	if (s2 == NULL) {
#line 103 "../src/Style.vala"
		return FALSE;
#line 641 "Style.c"
	}
#line 103 "../src/Style.vala"
	return (*s1) == (*s2);
#line 645 "Style.c"
}

gboolean
style_copy (Style* self,
            Style* s)
{
	gboolean result = FALSE;
	gboolean changed = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	LinkType* _tmp2_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gint* _tmp8_;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	gboolean* _tmp14_;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	LinkDash* _tmp20_;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_ = FALSE;
	NodeBorder* _tmp26_;
	gboolean _tmp30_ = FALSE;
	gboolean _tmp31_ = FALSE;
	gint* _tmp32_;
	gboolean _tmp36_ = FALSE;
	gboolean _tmp37_ = FALSE;
	gint* _tmp38_;
	gboolean _tmp42_ = FALSE;
	gboolean _tmp43_ = FALSE;
	gboolean* _tmp44_;
	gboolean _tmp48_ = FALSE;
	gboolean _tmp49_ = FALSE;
	gint* _tmp50_;
	gboolean _tmp54_ = FALSE;
	gboolean _tmp55_ = FALSE;
	gint* _tmp56_;
	gboolean _tmp60_ = FALSE;
	PangoFontDescription* _tmp61_;
	gboolean _tmp65_ = FALSE;
	gboolean _tmp66_ = FALSE;
	gboolean* _tmp67_;
	gboolean _tmp71_ = FALSE;
	gboolean _tmp72_ = FALSE;
	LinkDash* _tmp73_;
	gboolean _tmp77_ = FALSE;
	gboolean _tmp78_ = FALSE;
	gint* _tmp79_;
	gboolean _tmp83_ = FALSE;
	gboolean _tmp84_ = FALSE;
	const gchar* _tmp85_;
	gboolean _tmp89_ = FALSE;
	gboolean _tmp90_ = FALSE;
	gint* _tmp91_;
	gboolean _tmp95_ = FALSE;
	PangoFontDescription* _tmp96_;
#line 97 "../src/Style.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 97 "../src/Style.vala"
	g_return_val_if_fail (s != NULL, FALSE);
#line 99 "../src/Style.vala"
	changed = FALSE;
#line 101 "../src/Style.vala"
	_tmp2_ = s->priv->_link_type;
#line 101 "../src/Style.vala"
	if (_tmp2_ != NULL) {
#line 101 "../src/Style.vala"
		_tmp1_ = TRUE;
#line 715 "Style.c"
	} else {
#line 101 "../src/Style.vala"
		_tmp1_ = !s->priv->_template;
#line 719 "Style.c"
	}
#line 101 "../src/Style.vala"
	if (_tmp1_) {
#line 723 "Style.c"
		LinkType* _tmp3_;
		LinkType* _tmp4_;
#line 101 "../src/Style.vala"
		_tmp3_ = self->priv->_link_type;
#line 101 "../src/Style.vala"
		_tmp4_ = s->priv->_link_type;
#line 101 "../src/Style.vala"
		_tmp0_ = _tmp3_ != _tmp4_;
#line 732 "Style.c"
	} else {
#line 101 "../src/Style.vala"
		_tmp0_ = FALSE;
#line 736 "Style.c"
	}
#line 101 "../src/Style.vala"
	if (_tmp0_) {
#line 740 "Style.c"
		LinkType* _tmp5_;
#line 101 "../src/Style.vala"
		changed = TRUE;
#line 101 "../src/Style.vala"
		_tmp5_ = s->priv->_link_type;
#line 101 "../src/Style.vala"
		style_set_link_type (self, _tmp5_);
#line 748 "Style.c"
	}
#line 102 "../src/Style.vala"
	_tmp8_ = s->priv->_link_width;
#line 102 "../src/Style.vala"
	if (_tmp8_ != NULL) {
#line 102 "../src/Style.vala"
		_tmp7_ = TRUE;
#line 756 "Style.c"
	} else {
#line 102 "../src/Style.vala"
		_tmp7_ = !s->priv->_template;
#line 760 "Style.c"
	}
#line 102 "../src/Style.vala"
	if (_tmp7_) {
#line 764 "Style.c"
		gint* _tmp9_;
		gint* _tmp10_;
#line 102 "../src/Style.vala"
		_tmp9_ = self->priv->_link_width;
#line 102 "../src/Style.vala"
		_tmp10_ = s->priv->_link_width;
#line 102 "../src/Style.vala"
		_tmp6_ = _int_equal (_tmp9_, _tmp10_) != TRUE;
#line 773 "Style.c"
	} else {
#line 102 "../src/Style.vala"
		_tmp6_ = FALSE;
#line 777 "Style.c"
	}
#line 102 "../src/Style.vala"
	if (_tmp6_) {
#line 781 "Style.c"
		gint* _tmp11_;
#line 102 "../src/Style.vala"
		changed = TRUE;
#line 102 "../src/Style.vala"
		_tmp11_ = s->priv->_link_width;
#line 102 "../src/Style.vala"
		style_set_link_width (self, _tmp11_);
#line 789 "Style.c"
	}
#line 103 "../src/Style.vala"
	_tmp14_ = s->priv->_link_arrow;
#line 103 "../src/Style.vala"
	if (_tmp14_ != NULL) {
#line 103 "../src/Style.vala"
		_tmp13_ = TRUE;
#line 797 "Style.c"
	} else {
#line 103 "../src/Style.vala"
		_tmp13_ = !s->priv->_template;
#line 801 "Style.c"
	}
#line 103 "../src/Style.vala"
	if (_tmp13_) {
#line 805 "Style.c"
		gboolean* _tmp15_;
		gboolean* _tmp16_;
#line 103 "../src/Style.vala"
		_tmp15_ = self->priv->_link_arrow;
#line 103 "../src/Style.vala"
		_tmp16_ = s->priv->_link_arrow;
#line 103 "../src/Style.vala"
		_tmp12_ = _bool_equal (_tmp15_, _tmp16_) != TRUE;
#line 814 "Style.c"
	} else {
#line 103 "../src/Style.vala"
		_tmp12_ = FALSE;
#line 818 "Style.c"
	}
#line 103 "../src/Style.vala"
	if (_tmp12_) {
#line 822 "Style.c"
		gboolean* _tmp17_;
#line 103 "../src/Style.vala"
		changed = TRUE;
#line 103 "../src/Style.vala"
		_tmp17_ = s->priv->_link_arrow;
#line 103 "../src/Style.vala"
		style_set_link_arrow (self, _tmp17_);
#line 830 "Style.c"
	}
#line 104 "../src/Style.vala"
	_tmp20_ = s->priv->_link_dash;
#line 104 "../src/Style.vala"
	if (_tmp20_ != NULL) {
#line 104 "../src/Style.vala"
		_tmp19_ = TRUE;
#line 838 "Style.c"
	} else {
#line 104 "../src/Style.vala"
		_tmp19_ = !s->priv->_template;
#line 842 "Style.c"
	}
#line 104 "../src/Style.vala"
	if (_tmp19_) {
#line 846 "Style.c"
		LinkDash* _tmp21_;
		LinkDash* _tmp22_;
#line 104 "../src/Style.vala"
		_tmp21_ = self->priv->_link_dash;
#line 104 "../src/Style.vala"
		_tmp22_ = s->priv->_link_dash;
#line 104 "../src/Style.vala"
		_tmp18_ = _tmp21_ != _tmp22_;
#line 855 "Style.c"
	} else {
#line 104 "../src/Style.vala"
		_tmp18_ = FALSE;
#line 859 "Style.c"
	}
#line 104 "../src/Style.vala"
	if (_tmp18_) {
#line 863 "Style.c"
		LinkDash* _tmp23_;
#line 104 "../src/Style.vala"
		changed = TRUE;
#line 104 "../src/Style.vala"
		_tmp23_ = s->priv->_link_dash;
#line 104 "../src/Style.vala"
		style_set_link_dash (self, _tmp23_);
#line 871 "Style.c"
	}
#line 105 "../src/Style.vala"
	_tmp26_ = s->priv->_node_border;
#line 105 "../src/Style.vala"
	if (_tmp26_ != NULL) {
#line 105 "../src/Style.vala"
		_tmp25_ = TRUE;
#line 879 "Style.c"
	} else {
#line 105 "../src/Style.vala"
		_tmp25_ = !s->priv->_template;
#line 883 "Style.c"
	}
#line 105 "../src/Style.vala"
	if (_tmp25_) {
#line 887 "Style.c"
		NodeBorder* _tmp27_;
		NodeBorder* _tmp28_;
#line 105 "../src/Style.vala"
		_tmp27_ = self->priv->_node_border;
#line 105 "../src/Style.vala"
		_tmp28_ = s->priv->_node_border;
#line 105 "../src/Style.vala"
		_tmp24_ = _tmp27_ != _tmp28_;
#line 896 "Style.c"
	} else {
#line 105 "../src/Style.vala"
		_tmp24_ = FALSE;
#line 900 "Style.c"
	}
#line 105 "../src/Style.vala"
	if (_tmp24_) {
#line 904 "Style.c"
		NodeBorder* _tmp29_;
#line 105 "../src/Style.vala"
		changed = TRUE;
#line 105 "../src/Style.vala"
		_tmp29_ = s->priv->_node_border;
#line 105 "../src/Style.vala"
		style_set_node_border (self, _tmp29_);
#line 912 "Style.c"
	}
#line 106 "../src/Style.vala"
	_tmp32_ = s->priv->_node_width;
#line 106 "../src/Style.vala"
	if (_tmp32_ != NULL) {
#line 106 "../src/Style.vala"
		_tmp31_ = TRUE;
#line 920 "Style.c"
	} else {
#line 106 "../src/Style.vala"
		_tmp31_ = !s->priv->_template;
#line 924 "Style.c"
	}
#line 106 "../src/Style.vala"
	if (_tmp31_) {
#line 928 "Style.c"
		gint* _tmp33_;
		gint* _tmp34_;
#line 106 "../src/Style.vala"
		_tmp33_ = self->priv->_node_width;
#line 106 "../src/Style.vala"
		_tmp34_ = s->priv->_node_width;
#line 106 "../src/Style.vala"
		_tmp30_ = _int_equal (_tmp33_, _tmp34_) != TRUE;
#line 937 "Style.c"
	} else {
#line 106 "../src/Style.vala"
		_tmp30_ = FALSE;
#line 941 "Style.c"
	}
#line 106 "../src/Style.vala"
	if (_tmp30_) {
#line 945 "Style.c"
		gint* _tmp35_;
#line 106 "../src/Style.vala"
		changed = TRUE;
#line 106 "../src/Style.vala"
		_tmp35_ = s->priv->_node_width;
#line 106 "../src/Style.vala"
		style_set_node_width (self, _tmp35_);
#line 953 "Style.c"
	}
#line 107 "../src/Style.vala"
	_tmp38_ = s->priv->_node_borderwidth;
#line 107 "../src/Style.vala"
	if (_tmp38_ != NULL) {
#line 107 "../src/Style.vala"
		_tmp37_ = TRUE;
#line 961 "Style.c"
	} else {
#line 107 "../src/Style.vala"
		_tmp37_ = !s->priv->_template;
#line 965 "Style.c"
	}
#line 107 "../src/Style.vala"
	if (_tmp37_) {
#line 969 "Style.c"
		gint* _tmp39_;
		gint* _tmp40_;
#line 107 "../src/Style.vala"
		_tmp39_ = self->priv->_node_borderwidth;
#line 107 "../src/Style.vala"
		_tmp40_ = s->priv->_node_borderwidth;
#line 107 "../src/Style.vala"
		_tmp36_ = _int_equal (_tmp39_, _tmp40_) != TRUE;
#line 978 "Style.c"
	} else {
#line 107 "../src/Style.vala"
		_tmp36_ = FALSE;
#line 982 "Style.c"
	}
#line 107 "../src/Style.vala"
	if (_tmp36_) {
#line 986 "Style.c"
		gint* _tmp41_;
#line 107 "../src/Style.vala"
		changed = TRUE;
#line 107 "../src/Style.vala"
		_tmp41_ = s->priv->_node_borderwidth;
#line 107 "../src/Style.vala"
		style_set_node_borderwidth (self, _tmp41_);
#line 994 "Style.c"
	}
#line 108 "../src/Style.vala"
	_tmp44_ = s->priv->_node_fill;
#line 108 "../src/Style.vala"
	if (_tmp44_ != NULL) {
#line 108 "../src/Style.vala"
		_tmp43_ = TRUE;
#line 1002 "Style.c"
	} else {
#line 108 "../src/Style.vala"
		_tmp43_ = !s->priv->_template;
#line 1006 "Style.c"
	}
#line 108 "../src/Style.vala"
	if (_tmp43_) {
#line 1010 "Style.c"
		gboolean* _tmp45_;
		gboolean* _tmp46_;
#line 108 "../src/Style.vala"
		_tmp45_ = self->priv->_node_fill;
#line 108 "../src/Style.vala"
		_tmp46_ = s->priv->_node_fill;
#line 108 "../src/Style.vala"
		_tmp42_ = _bool_equal (_tmp45_, _tmp46_) != TRUE;
#line 1019 "Style.c"
	} else {
#line 108 "../src/Style.vala"
		_tmp42_ = FALSE;
#line 1023 "Style.c"
	}
#line 108 "../src/Style.vala"
	if (_tmp42_) {
#line 1027 "Style.c"
		gboolean* _tmp47_;
#line 108 "../src/Style.vala"
		changed = TRUE;
#line 108 "../src/Style.vala"
		_tmp47_ = s->priv->_node_fill;
#line 108 "../src/Style.vala"
		style_set_node_fill (self, _tmp47_);
#line 1035 "Style.c"
	}
#line 109 "../src/Style.vala"
	_tmp50_ = s->priv->_node_margin;
#line 109 "../src/Style.vala"
	if (_tmp50_ != NULL) {
#line 109 "../src/Style.vala"
		_tmp49_ = TRUE;
#line 1043 "Style.c"
	} else {
#line 109 "../src/Style.vala"
		_tmp49_ = !s->priv->_template;
#line 1047 "Style.c"
	}
#line 109 "../src/Style.vala"
	if (_tmp49_) {
#line 1051 "Style.c"
		gint* _tmp51_;
		gint* _tmp52_;
#line 109 "../src/Style.vala"
		_tmp51_ = self->priv->_node_margin;
#line 109 "../src/Style.vala"
		_tmp52_ = s->priv->_node_margin;
#line 109 "../src/Style.vala"
		_tmp48_ = _int_equal (_tmp51_, _tmp52_) != TRUE;
#line 1060 "Style.c"
	} else {
#line 109 "../src/Style.vala"
		_tmp48_ = FALSE;
#line 1064 "Style.c"
	}
#line 109 "../src/Style.vala"
	if (_tmp48_) {
#line 1068 "Style.c"
		gint* _tmp53_;
#line 109 "../src/Style.vala"
		changed = TRUE;
#line 109 "../src/Style.vala"
		_tmp53_ = s->priv->_node_margin;
#line 109 "../src/Style.vala"
		style_set_node_margin (self, _tmp53_);
#line 1076 "Style.c"
	}
#line 110 "../src/Style.vala"
	_tmp56_ = s->priv->_node_padding;
#line 110 "../src/Style.vala"
	if (_tmp56_ != NULL) {
#line 110 "../src/Style.vala"
		_tmp55_ = TRUE;
#line 1084 "Style.c"
	} else {
#line 110 "../src/Style.vala"
		_tmp55_ = !s->priv->_template;
#line 1088 "Style.c"
	}
#line 110 "../src/Style.vala"
	if (_tmp55_) {
#line 1092 "Style.c"
		gint* _tmp57_;
		gint* _tmp58_;
#line 110 "../src/Style.vala"
		_tmp57_ = self->priv->_node_padding;
#line 110 "../src/Style.vala"
		_tmp58_ = s->priv->_node_padding;
#line 110 "../src/Style.vala"
		_tmp54_ = _int_equal (_tmp57_, _tmp58_) != TRUE;
#line 1101 "Style.c"
	} else {
#line 110 "../src/Style.vala"
		_tmp54_ = FALSE;
#line 1105 "Style.c"
	}
#line 110 "../src/Style.vala"
	if (_tmp54_) {
#line 1109 "Style.c"
		gint* _tmp59_;
#line 110 "../src/Style.vala"
		changed = TRUE;
#line 110 "../src/Style.vala"
		_tmp59_ = s->priv->_node_padding;
#line 110 "../src/Style.vala"
		style_set_node_padding (self, _tmp59_);
#line 1117 "Style.c"
	}
#line 111 "../src/Style.vala"
	_tmp61_ = s->priv->_node_font;
#line 111 "../src/Style.vala"
	if (_tmp61_ != NULL) {
#line 111 "../src/Style.vala"
		_tmp60_ = TRUE;
#line 1125 "Style.c"
	} else {
#line 111 "../src/Style.vala"
		_tmp60_ = !s->priv->_template;
#line 1129 "Style.c"
	}
#line 111 "../src/Style.vala"
	if (_tmp60_) {
#line 1133 "Style.c"
		PangoFontDescription* _tmp62_;
		PangoFontDescription* _tmp63_;
		PangoFontDescription* _tmp64_;
#line 111 "../src/Style.vala"
		changed = TRUE;
#line 111 "../src/Style.vala"
		_tmp62_ = s->priv->_node_font;
#line 111 "../src/Style.vala"
		_tmp63_ = pango_font_description_copy (_tmp62_);
#line 111 "../src/Style.vala"
		_tmp64_ = _tmp63_;
#line 111 "../src/Style.vala"
		style_set_node_font (self, _tmp64_);
#line 111 "../src/Style.vala"
		__vala_PangoFontDescription_free0 (_tmp64_);
#line 1149 "Style.c"
	}
#line 112 "../src/Style.vala"
	_tmp67_ = s->priv->_node_markup;
#line 112 "../src/Style.vala"
	if (_tmp67_ != NULL) {
#line 112 "../src/Style.vala"
		_tmp66_ = TRUE;
#line 1157 "Style.c"
	} else {
#line 112 "../src/Style.vala"
		_tmp66_ = !s->priv->_template;
#line 1161 "Style.c"
	}
#line 112 "../src/Style.vala"
	if (_tmp66_) {
#line 1165 "Style.c"
		gboolean* _tmp68_;
		gboolean* _tmp69_;
#line 112 "../src/Style.vala"
		_tmp68_ = self->priv->_node_markup;
#line 112 "../src/Style.vala"
		_tmp69_ = s->priv->_node_markup;
#line 112 "../src/Style.vala"
		_tmp65_ = _bool_equal (_tmp68_, _tmp69_) != TRUE;
#line 1174 "Style.c"
	} else {
#line 112 "../src/Style.vala"
		_tmp65_ = FALSE;
#line 1178 "Style.c"
	}
#line 112 "../src/Style.vala"
	if (_tmp65_) {
#line 1182 "Style.c"
		gboolean* _tmp70_;
#line 112 "../src/Style.vala"
		changed = TRUE;
#line 112 "../src/Style.vala"
		_tmp70_ = s->priv->_node_markup;
#line 112 "../src/Style.vala"
		style_set_node_markup (self, _tmp70_);
#line 1190 "Style.c"
	}
#line 113 "../src/Style.vala"
	_tmp73_ = s->priv->_connection_dash;
#line 113 "../src/Style.vala"
	if (_tmp73_ != NULL) {
#line 113 "../src/Style.vala"
		_tmp72_ = TRUE;
#line 1198 "Style.c"
	} else {
#line 113 "../src/Style.vala"
		_tmp72_ = !s->priv->_template;
#line 1202 "Style.c"
	}
#line 113 "../src/Style.vala"
	if (_tmp72_) {
#line 1206 "Style.c"
		LinkDash* _tmp74_;
		LinkDash* _tmp75_;
#line 113 "../src/Style.vala"
		_tmp74_ = self->priv->_connection_dash;
#line 113 "../src/Style.vala"
		_tmp75_ = s->priv->_connection_dash;
#line 113 "../src/Style.vala"
		_tmp71_ = _tmp74_ != _tmp75_;
#line 1215 "Style.c"
	} else {
#line 113 "../src/Style.vala"
		_tmp71_ = FALSE;
#line 1219 "Style.c"
	}
#line 113 "../src/Style.vala"
	if (_tmp71_) {
#line 1223 "Style.c"
		LinkDash* _tmp76_;
#line 113 "../src/Style.vala"
		changed = TRUE;
#line 113 "../src/Style.vala"
		_tmp76_ = s->priv->_connection_dash;
#line 113 "../src/Style.vala"
		style_set_connection_dash (self, _tmp76_);
#line 1231 "Style.c"
	}
#line 114 "../src/Style.vala"
	_tmp79_ = s->priv->_connection_width;
#line 114 "../src/Style.vala"
	if (_tmp79_ != NULL) {
#line 114 "../src/Style.vala"
		_tmp78_ = TRUE;
#line 1239 "Style.c"
	} else {
#line 114 "../src/Style.vala"
		_tmp78_ = !s->priv->_template;
#line 1243 "Style.c"
	}
#line 114 "../src/Style.vala"
	if (_tmp78_) {
#line 1247 "Style.c"
		gint* _tmp80_;
		gint* _tmp81_;
#line 114 "../src/Style.vala"
		_tmp80_ = self->priv->_connection_width;
#line 114 "../src/Style.vala"
		_tmp81_ = s->priv->_connection_width;
#line 114 "../src/Style.vala"
		_tmp77_ = _int_equal (_tmp80_, _tmp81_) != TRUE;
#line 1256 "Style.c"
	} else {
#line 114 "../src/Style.vala"
		_tmp77_ = FALSE;
#line 1260 "Style.c"
	}
#line 114 "../src/Style.vala"
	if (_tmp77_) {
#line 1264 "Style.c"
		gint* _tmp82_;
#line 114 "../src/Style.vala"
		changed = TRUE;
#line 114 "../src/Style.vala"
		_tmp82_ = s->priv->_connection_width;
#line 114 "../src/Style.vala"
		style_set_connection_width (self, _tmp82_);
#line 1272 "Style.c"
	}
#line 115 "../src/Style.vala"
	_tmp85_ = s->priv->_connection_arrow;
#line 115 "../src/Style.vala"
	if (_tmp85_ != NULL) {
#line 115 "../src/Style.vala"
		_tmp84_ = TRUE;
#line 1280 "Style.c"
	} else {
#line 115 "../src/Style.vala"
		_tmp84_ = !s->priv->_template;
#line 1284 "Style.c"
	}
#line 115 "../src/Style.vala"
	if (_tmp84_) {
#line 1288 "Style.c"
		const gchar* _tmp86_;
		const gchar* _tmp87_;
#line 115 "../src/Style.vala"
		_tmp86_ = self->priv->_connection_arrow;
#line 115 "../src/Style.vala"
		_tmp87_ = s->priv->_connection_arrow;
#line 115 "../src/Style.vala"
		_tmp83_ = g_strcmp0 (_tmp86_, _tmp87_) != 0;
#line 1297 "Style.c"
	} else {
#line 115 "../src/Style.vala"
		_tmp83_ = FALSE;
#line 1301 "Style.c"
	}
#line 115 "../src/Style.vala"
	if (_tmp83_) {
#line 1305 "Style.c"
		const gchar* _tmp88_;
#line 115 "../src/Style.vala"
		changed = TRUE;
#line 115 "../src/Style.vala"
		_tmp88_ = s->priv->_connection_arrow;
#line 115 "../src/Style.vala"
		style_set_connection_arrow (self, _tmp88_);
#line 1313 "Style.c"
	}
#line 116 "../src/Style.vala"
	_tmp91_ = s->priv->_connection_padding;
#line 116 "../src/Style.vala"
	if (_tmp91_ != NULL) {
#line 116 "../src/Style.vala"
		_tmp90_ = TRUE;
#line 1321 "Style.c"
	} else {
#line 116 "../src/Style.vala"
		_tmp90_ = !s->priv->_template;
#line 1325 "Style.c"
	}
#line 116 "../src/Style.vala"
	if (_tmp90_) {
#line 1329 "Style.c"
		gint* _tmp92_;
		gint* _tmp93_;
#line 116 "../src/Style.vala"
		_tmp92_ = self->priv->_connection_padding;
#line 116 "../src/Style.vala"
		_tmp93_ = s->priv->_connection_padding;
#line 116 "../src/Style.vala"
		_tmp89_ = _int_equal (_tmp92_, _tmp93_) != TRUE;
#line 1338 "Style.c"
	} else {
#line 116 "../src/Style.vala"
		_tmp89_ = FALSE;
#line 1342 "Style.c"
	}
#line 116 "../src/Style.vala"
	if (_tmp89_) {
#line 1346 "Style.c"
		gint* _tmp94_;
#line 116 "../src/Style.vala"
		changed = TRUE;
#line 116 "../src/Style.vala"
		_tmp94_ = s->priv->_connection_padding;
#line 116 "../src/Style.vala"
		style_set_connection_padding (self, _tmp94_);
#line 1354 "Style.c"
	}
#line 117 "../src/Style.vala"
	_tmp96_ = s->priv->_connection_font;
#line 117 "../src/Style.vala"
	if (_tmp96_ != NULL) {
#line 117 "../src/Style.vala"
		_tmp95_ = TRUE;
#line 1362 "Style.c"
	} else {
#line 117 "../src/Style.vala"
		_tmp95_ = !s->priv->_template;
#line 1366 "Style.c"
	}
#line 117 "../src/Style.vala"
	if (_tmp95_) {
#line 1370 "Style.c"
		PangoFontDescription* _tmp97_;
		PangoFontDescription* _tmp98_;
		PangoFontDescription* _tmp99_;
#line 117 "../src/Style.vala"
		changed = TRUE;
#line 117 "../src/Style.vala"
		_tmp97_ = s->priv->_connection_font;
#line 117 "../src/Style.vala"
		_tmp98_ = pango_font_description_copy (_tmp97_);
#line 117 "../src/Style.vala"
		_tmp99_ = _tmp98_;
#line 117 "../src/Style.vala"
		style_set_connection_font (self, _tmp99_);
#line 117 "../src/Style.vala"
		__vala_PangoFontDescription_free0 (_tmp99_);
#line 1386 "Style.c"
	}
#line 119 "../src/Style.vala"
	result = changed;
#line 119 "../src/Style.vala"
	return result;
#line 1392 "Style.c"
}

static void
_vala_array_add3 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 125 "../src/Style.vala"
	if ((*length) == (*size)) {
#line 125 "../src/Style.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 125 "../src/Style.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1407 "Style.c"
	}
#line 125 "../src/Style.vala"
	(*array)[(*length)++] = value;
#line 125 "../src/Style.vala"
	(*array)[*length] = NULL;
#line 1413 "Style.c"
}

static void
_vala_array_add4 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 126 "../src/Style.vala"
	if ((*length) == (*size)) {
#line 126 "../src/Style.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 126 "../src/Style.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1428 "Style.c"
	}
#line 126 "../src/Style.vala"
	(*array)[(*length)++] = value;
#line 126 "../src/Style.vala"
	(*array)[*length] = NULL;
#line 1434 "Style.c"
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result = NULL;
#line 37 "glib-2.0.vapi"
	if (self) {
#line 1443 "Style.c"
		gchar* _tmp0_;
#line 38 "glib-2.0.vapi"
		_tmp0_ = g_strdup ("true");
#line 38 "glib-2.0.vapi"
		result = _tmp0_;
#line 38 "glib-2.0.vapi"
		return result;
#line 1451 "Style.c"
	} else {
		gchar* _tmp1_;
#line 40 "glib-2.0.vapi"
		_tmp1_ = g_strdup ("false");
#line 40 "glib-2.0.vapi"
		result = _tmp1_;
#line 40 "glib-2.0.vapi"
		return result;
#line 1460 "Style.c"
	}
}

static void
_vala_array_add5 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 127 "../src/Style.vala"
	if ((*length) == (*size)) {
#line 127 "../src/Style.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 127 "../src/Style.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1476 "Style.c"
	}
#line 127 "../src/Style.vala"
	(*array)[(*length)++] = value;
#line 127 "../src/Style.vala"
	(*array)[*length] = NULL;
#line 1482 "Style.c"
}

static void
_vala_array_add6 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 128 "../src/Style.vala"
	if ((*length) == (*size)) {
#line 128 "../src/Style.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 128 "../src/Style.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1497 "Style.c"
	}
#line 128 "../src/Style.vala"
	(*array)[(*length)++] = value;
#line 128 "../src/Style.vala"
	(*array)[*length] = NULL;
#line 1503 "Style.c"
}

static void
_vala_array_add7 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 129 "../src/Style.vala"
	if ((*length) == (*size)) {
#line 129 "../src/Style.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 129 "../src/Style.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1518 "Style.c"
	}
#line 129 "../src/Style.vala"
	(*array)[(*length)++] = value;
#line 129 "../src/Style.vala"
	(*array)[*length] = NULL;
#line 1524 "Style.c"
}

static void
_vala_array_add8 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 130 "../src/Style.vala"
	if ((*length) == (*size)) {
#line 130 "../src/Style.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 130 "../src/Style.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1539 "Style.c"
	}
#line 130 "../src/Style.vala"
	(*array)[(*length)++] = value;
#line 130 "../src/Style.vala"
	(*array)[*length] = NULL;
#line 1545 "Style.c"
}

static void
_vala_array_add9 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 131 "../src/Style.vala"
	if ((*length) == (*size)) {
#line 131 "../src/Style.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 131 "../src/Style.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1560 "Style.c"
	}
#line 131 "../src/Style.vala"
	(*array)[(*length)++] = value;
#line 131 "../src/Style.vala"
	(*array)[*length] = NULL;
#line 1566 "Style.c"
}

static void
_vala_array_add10 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 132 "../src/Style.vala"
	if ((*length) == (*size)) {
#line 132 "../src/Style.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 132 "../src/Style.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1581 "Style.c"
	}
#line 132 "../src/Style.vala"
	(*array)[(*length)++] = value;
#line 132 "../src/Style.vala"
	(*array)[*length] = NULL;
#line 1587 "Style.c"
}

static void
_vala_array_add11 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 133 "../src/Style.vala"
	if ((*length) == (*size)) {
#line 133 "../src/Style.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 133 "../src/Style.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1602 "Style.c"
	}
#line 133 "../src/Style.vala"
	(*array)[(*length)++] = value;
#line 133 "../src/Style.vala"
	(*array)[*length] = NULL;
#line 1608 "Style.c"
}

static void
_vala_array_add12 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 134 "../src/Style.vala"
	if ((*length) == (*size)) {
#line 134 "../src/Style.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 134 "../src/Style.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1623 "Style.c"
	}
#line 134 "../src/Style.vala"
	(*array)[(*length)++] = value;
#line 134 "../src/Style.vala"
	(*array)[*length] = NULL;
#line 1629 "Style.c"
}

static void
_vala_array_add13 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 135 "../src/Style.vala"
	if ((*length) == (*size)) {
#line 135 "../src/Style.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 135 "../src/Style.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1644 "Style.c"
	}
#line 135 "../src/Style.vala"
	(*array)[(*length)++] = value;
#line 135 "../src/Style.vala"
	(*array)[*length] = NULL;
#line 1650 "Style.c"
}

static void
_vala_array_add14 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 136 "../src/Style.vala"
	if ((*length) == (*size)) {
#line 136 "../src/Style.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 136 "../src/Style.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1665 "Style.c"
	}
#line 136 "../src/Style.vala"
	(*array)[(*length)++] = value;
#line 136 "../src/Style.vala"
	(*array)[*length] = NULL;
#line 1671 "Style.c"
}

static void
_vala_array_add15 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 137 "../src/Style.vala"
	if ((*length) == (*size)) {
#line 137 "../src/Style.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 137 "../src/Style.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1686 "Style.c"
	}
#line 137 "../src/Style.vala"
	(*array)[(*length)++] = value;
#line 137 "../src/Style.vala"
	(*array)[*length] = NULL;
#line 1692 "Style.c"
}

static void
_vala_array_add16 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 138 "../src/Style.vala"
	if ((*length) == (*size)) {
#line 138 "../src/Style.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 138 "../src/Style.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1707 "Style.c"
	}
#line 138 "../src/Style.vala"
	(*array)[(*length)++] = value;
#line 138 "../src/Style.vala"
	(*array)[*length] = NULL;
#line 1713 "Style.c"
}

static void
_vala_array_add17 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 139 "../src/Style.vala"
	if ((*length) == (*size)) {
#line 139 "../src/Style.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 139 "../src/Style.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1728 "Style.c"
	}
#line 139 "../src/Style.vala"
	(*array)[(*length)++] = value;
#line 139 "../src/Style.vala"
	(*array)[*length] = NULL;
#line 1734 "Style.c"
}

static void
_vala_array_add18 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 140 "../src/Style.vala"
	if ((*length) == (*size)) {
#line 140 "../src/Style.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 140 "../src/Style.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1749 "Style.c"
	}
#line 140 "../src/Style.vala"
	(*array)[(*length)++] = value;
#line 140 "../src/Style.vala"
	(*array)[*length] = NULL;
#line 1755 "Style.c"
}

static void
_vala_array_add19 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 141 "../src/Style.vala"
	if ((*length) == (*size)) {
#line 141 "../src/Style.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 141 "../src/Style.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1770 "Style.c"
	}
#line 141 "../src/Style.vala"
	(*array)[(*length)++] = value;
#line 141 "../src/Style.vala"
	(*array)[*length] = NULL;
#line 1776 "Style.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
#line 1148 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1149 "glib-2.0.vapi"
		separator = "";
#line 1790 "Style.c"
	}
#line 1151 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 1794 "Style.c"
		gboolean _tmp1_ = FALSE;
#line 1151 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1151 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 1800 "Style.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1151 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 1805 "Style.c"
				const gchar* _tmp3_;
#line 1151 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1151 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 1811 "Style.c"
			} else {
#line 1151 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 1815 "Style.c"
			}
#line 1151 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 1819 "Style.c"
		}
#line 1151 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 1823 "Style.c"
	} else {
#line 1151 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1827 "Style.c"
	}
#line 1151 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1831 "Style.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		void* ptr = NULL;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		void* _tmp21_;
		const gchar* _tmp31_;
#line 1153 "glib-2.0.vapi"
		len = (gsize) 1;
#line 1845 "Style.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1154 "glib-2.0.vapi"
			i = 0;
#line 1154 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1154 "glib-2.0.vapi"
			while (TRUE) {
#line 1854 "Style.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1154 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 1861 "Style.c"
					gint _tmp5_;
#line 1154 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1154 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 1867 "Style.c"
				}
#line 1154 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1154 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1154 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 1875 "Style.c"
				} else {
#line 1154 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 1879 "Style.c"
				}
#line 1154 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1154 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 1885 "Style.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1154 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 1890 "Style.c"
						const gchar* _tmp9_;
#line 1154 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1154 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 1896 "Style.c"
					} else {
#line 1154 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 1900 "Style.c"
					}
#line 1154 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 1904 "Style.c"
				}
#line 1154 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1154 "glib-2.0.vapi"
					break;
#line 1910 "Style.c"
				}
#line 1155 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1155 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 1916 "Style.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1155 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1155 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1155 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1155 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 1928 "Style.c"
				} else {
#line 1155 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 1932 "Style.c"
				}
#line 1155 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 1936 "Style.c"
			}
		}
#line 1157 "glib-2.0.vapi"
		if (i == 0) {
#line 1941 "Style.c"
			gchar* _tmp15_;
#line 1158 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1158 "glib-2.0.vapi"
			result = _tmp15_;
#line 1158 "glib-2.0.vapi"
			return result;
#line 1949 "Style.c"
		}
#line 1160 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1161 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1161 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1161 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1163 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1163 "glib-2.0.vapi"
		res = _tmp18_;
#line 1164 "glib-2.0.vapi"
		_tmp19_ = res;
#line 1164 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1164 "glib-2.0.vapi"
		_tmp21_ = g_stpcpy ((void*) _tmp19_, (const gchar*) _tmp20_);
#line 1164 "glib-2.0.vapi"
		ptr = _tmp21_;
#line 1971 "Style.c"
		{
			gboolean _tmp22_ = FALSE;
#line 1165 "glib-2.0.vapi"
			i = 1;
#line 1165 "glib-2.0.vapi"
			_tmp22_ = TRUE;
#line 1165 "glib-2.0.vapi"
			while (TRUE) {
#line 1980 "Style.c"
				void* _tmp24_;
				void* _tmp25_;
				const gchar* _tmp26_ = NULL;
				const gchar* _tmp27_;
				void* _tmp29_;
				void* _tmp30_;
#line 1165 "glib-2.0.vapi"
				if (!_tmp22_) {
#line 1989 "Style.c"
					gint _tmp23_;
#line 1165 "glib-2.0.vapi"
					_tmp23_ = i;
#line 1165 "glib-2.0.vapi"
					i = _tmp23_ + 1;
#line 1995 "Style.c"
				}
#line 1165 "glib-2.0.vapi"
				_tmp22_ = FALSE;
#line 1165 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1165 "glib-2.0.vapi"
					break;
#line 2003 "Style.c"
				}
#line 1166 "glib-2.0.vapi"
				_tmp24_ = ptr;
#line 1166 "glib-2.0.vapi"
				_tmp25_ = g_stpcpy (_tmp24_, (const gchar*) separator);
#line 1166 "glib-2.0.vapi"
				ptr = _tmp25_;
#line 1167 "glib-2.0.vapi"
				_tmp27_ = str_array[i];
#line 1167 "glib-2.0.vapi"
				if (_tmp27_ != NULL) {
#line 2015 "Style.c"
					const gchar* _tmp28_;
#line 1167 "glib-2.0.vapi"
					_tmp28_ = str_array[i];
#line 1167 "glib-2.0.vapi"
					_tmp26_ = (const gchar*) _tmp28_;
#line 2021 "Style.c"
				} else {
#line 1167 "glib-2.0.vapi"
					_tmp26_ = "";
#line 2025 "Style.c"
				}
#line 1167 "glib-2.0.vapi"
				_tmp29_ = ptr;
#line 1167 "glib-2.0.vapi"
				_tmp30_ = g_stpcpy (_tmp29_, _tmp26_);
#line 1167 "glib-2.0.vapi"
				ptr = _tmp30_;
#line 2033 "Style.c"
			}
		}
#line 1170 "glib-2.0.vapi"
		_tmp31_ = res;
#line 1170 "glib-2.0.vapi"
		res = NULL;
#line 1170 "glib-2.0.vapi"
		result = (gchar*) _tmp31_;
#line 1170 "glib-2.0.vapi"
		return result;
#line 2044 "Style.c"
	} else {
		gchar* _tmp32_;
#line 1172 "glib-2.0.vapi"
		_tmp32_ = g_strdup ("");
#line 1172 "glib-2.0.vapi"
		result = _tmp32_;
#line 1172 "glib-2.0.vapi"
		return result;
#line 2053 "Style.c"
	}
}

gchar*
style_to_string (Style* self)
{
	gchar* result = NULL;
	gchar** arr = NULL;
	gchar** _tmp0_;
	gint arr_length1;
	gint _arr_size_;
	LinkType* _tmp1_;
	gint* _tmp7_;
	gboolean* _tmp11_;
	LinkDash* _tmp17_;
	NodeBorder* _tmp22_;
	gint* _tmp28_;
	gint* _tmp32_;
	gboolean* _tmp36_;
	gint* _tmp42_;
	gint* _tmp46_;
	PangoFontDescription* _tmp50_;
	gboolean* _tmp53_;
	LinkDash* _tmp59_;
	gint* _tmp64_;
	const gchar* _tmp68_;
	gint* _tmp72_;
	PangoFontDescription* _tmp76_;
	gchar** _tmp79_;
	gint _tmp79__length1;
	gchar* _tmp80_;
#line 123 "../src/Style.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 124 "../src/Style.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 124 "../src/Style.vala"
	arr = _tmp0_;
#line 124 "../src/Style.vala"
	arr_length1 = 0;
#line 124 "../src/Style.vala"
	_arr_size_ = arr_length1;
#line 125 "../src/Style.vala"
	_tmp1_ = self->priv->_link_type;
#line 125 "../src/Style.vala"
	if (_tmp1_ != NULL) {
#line 2099 "Style.c"
		gchar** _tmp2_;
		gint _tmp2__length1;
		LinkType* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 125 "../src/Style.vala"
		_tmp2_ = arr;
#line 125 "../src/Style.vala"
		_tmp2__length1 = arr_length1;
#line 125 "../src/Style.vala"
		_tmp3_ = self->priv->_link_type;
#line 125 "../src/Style.vala"
		_tmp4_ = link_type_name (_tmp3_);
#line 125 "../src/Style.vala"
		_tmp5_ = _tmp4_;
#line 125 "../src/Style.vala"
		_tmp6_ = g_strdup_printf ("ltype[%s]", _tmp5_);
#line 125 "../src/Style.vala"
		_vala_array_add3 (&arr, &arr_length1, &_arr_size_, _tmp6_);
#line 125 "../src/Style.vala"
		_g_free0 (_tmp5_);
#line 2122 "Style.c"
	}
#line 126 "../src/Style.vala"
	_tmp7_ = self->priv->_link_width;
#line 126 "../src/Style.vala"
	if (_tmp7_ != NULL) {
#line 2128 "Style.c"
		gchar** _tmp8_;
		gint _tmp8__length1;
		gint* _tmp9_;
		gchar* _tmp10_;
#line 126 "../src/Style.vala"
		_tmp8_ = arr;
#line 126 "../src/Style.vala"
		_tmp8__length1 = arr_length1;
#line 126 "../src/Style.vala"
		_tmp9_ = self->priv->_link_width;
#line 126 "../src/Style.vala"
		_tmp10_ = g_strdup_printf ("lwidth[%d]", *_tmp9_);
#line 126 "../src/Style.vala"
		_vala_array_add4 (&arr, &arr_length1, &_arr_size_, _tmp10_);
#line 2143 "Style.c"
	}
#line 127 "../src/Style.vala"
	_tmp11_ = self->priv->_link_arrow;
#line 127 "../src/Style.vala"
	if (_tmp11_ != NULL) {
#line 2149 "Style.c"
		gchar** _tmp12_;
		gint _tmp12__length1;
		gboolean* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 127 "../src/Style.vala"
		_tmp12_ = arr;
#line 127 "../src/Style.vala"
		_tmp12__length1 = arr_length1;
#line 127 "../src/Style.vala"
		_tmp13_ = self->priv->_link_arrow;
#line 127 "../src/Style.vala"
		_tmp14_ = bool_to_string (*_tmp13_);
#line 127 "../src/Style.vala"
		_tmp15_ = _tmp14_;
#line 127 "../src/Style.vala"
		_tmp16_ = g_strdup_printf ("larrow[%s]", _tmp15_);
#line 127 "../src/Style.vala"
		_vala_array_add5 (&arr, &arr_length1, &_arr_size_, _tmp16_);
#line 127 "../src/Style.vala"
		_g_free0 (_tmp15_);
#line 2172 "Style.c"
	}
#line 128 "../src/Style.vala"
	_tmp17_ = self->priv->_link_dash;
#line 128 "../src/Style.vala"
	if (_tmp17_ != NULL) {
#line 2178 "Style.c"
		gchar** _tmp18_;
		gint _tmp18__length1;
		LinkDash* _tmp19_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
#line 128 "../src/Style.vala"
		_tmp18_ = arr;
#line 128 "../src/Style.vala"
		_tmp18__length1 = arr_length1;
#line 128 "../src/Style.vala"
		_tmp19_ = self->priv->_link_dash;
#line 128 "../src/Style.vala"
		_tmp20_ = _tmp19_->name;
#line 128 "../src/Style.vala"
		_tmp21_ = g_strdup_printf ("ldash[%s]", _tmp20_);
#line 128 "../src/Style.vala"
		_vala_array_add6 (&arr, &arr_length1, &_arr_size_, _tmp21_);
#line 2196 "Style.c"
	}
#line 129 "../src/Style.vala"
	_tmp22_ = self->priv->_node_border;
#line 129 "../src/Style.vala"
	if (_tmp22_ != NULL) {
#line 2202 "Style.c"
		gchar** _tmp23_;
		gint _tmp23__length1;
		NodeBorder* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
#line 129 "../src/Style.vala"
		_tmp23_ = arr;
#line 129 "../src/Style.vala"
		_tmp23__length1 = arr_length1;
#line 129 "../src/Style.vala"
		_tmp24_ = self->priv->_node_border;
#line 129 "../src/Style.vala"
		_tmp25_ = node_border_name (_tmp24_);
#line 129 "../src/Style.vala"
		_tmp26_ = _tmp25_;
#line 129 "../src/Style.vala"
		_tmp27_ = g_strdup_printf ("nborder[%s]", _tmp26_);
#line 129 "../src/Style.vala"
		_vala_array_add7 (&arr, &arr_length1, &_arr_size_, _tmp27_);
#line 129 "../src/Style.vala"
		_g_free0 (_tmp26_);
#line 2225 "Style.c"
	}
#line 130 "../src/Style.vala"
	_tmp28_ = self->priv->_node_width;
#line 130 "../src/Style.vala"
	if (_tmp28_ != NULL) {
#line 2231 "Style.c"
		gchar** _tmp29_;
		gint _tmp29__length1;
		gint* _tmp30_;
		gchar* _tmp31_;
#line 130 "../src/Style.vala"
		_tmp29_ = arr;
#line 130 "../src/Style.vala"
		_tmp29__length1 = arr_length1;
#line 130 "../src/Style.vala"
		_tmp30_ = self->priv->_node_width;
#line 130 "../src/Style.vala"
		_tmp31_ = g_strdup_printf ("nwidth[%d]", *_tmp30_);
#line 130 "../src/Style.vala"
		_vala_array_add8 (&arr, &arr_length1, &_arr_size_, _tmp31_);
#line 2246 "Style.c"
	}
#line 131 "../src/Style.vala"
	_tmp32_ = self->priv->_node_borderwidth;
#line 131 "../src/Style.vala"
	if (_tmp32_ != NULL) {
#line 2252 "Style.c"
		gchar** _tmp33_;
		gint _tmp33__length1;
		gint* _tmp34_;
		gchar* _tmp35_;
#line 131 "../src/Style.vala"
		_tmp33_ = arr;
#line 131 "../src/Style.vala"
		_tmp33__length1 = arr_length1;
#line 131 "../src/Style.vala"
		_tmp34_ = self->priv->_node_borderwidth;
#line 131 "../src/Style.vala"
		_tmp35_ = g_strdup_printf ("nbwidth[%d]", *_tmp34_);
#line 131 "../src/Style.vala"
		_vala_array_add9 (&arr, &arr_length1, &_arr_size_, _tmp35_);
#line 2267 "Style.c"
	}
#line 132 "../src/Style.vala"
	_tmp36_ = self->priv->_node_fill;
#line 132 "../src/Style.vala"
	if (_tmp36_ != NULL) {
#line 2273 "Style.c"
		gchar** _tmp37_;
		gint _tmp37__length1;
		gboolean* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
#line 132 "../src/Style.vala"
		_tmp37_ = arr;
#line 132 "../src/Style.vala"
		_tmp37__length1 = arr_length1;
#line 132 "../src/Style.vala"
		_tmp38_ = self->priv->_node_fill;
#line 132 "../src/Style.vala"
		_tmp39_ = bool_to_string (*_tmp38_);
#line 132 "../src/Style.vala"
		_tmp40_ = _tmp39_;
#line 132 "../src/Style.vala"
		_tmp41_ = g_strdup_printf ("nfill[%s]", _tmp40_);
#line 132 "../src/Style.vala"
		_vala_array_add10 (&arr, &arr_length1, &_arr_size_, _tmp41_);
#line 132 "../src/Style.vala"
		_g_free0 (_tmp40_);
#line 2296 "Style.c"
	}
#line 133 "../src/Style.vala"
	_tmp42_ = self->priv->_node_margin;
#line 133 "../src/Style.vala"
	if (_tmp42_ != NULL) {
#line 2302 "Style.c"
		gchar** _tmp43_;
		gint _tmp43__length1;
		gint* _tmp44_;
		gchar* _tmp45_;
#line 133 "../src/Style.vala"
		_tmp43_ = arr;
#line 133 "../src/Style.vala"
		_tmp43__length1 = arr_length1;
#line 133 "../src/Style.vala"
		_tmp44_ = self->priv->_node_margin;
#line 133 "../src/Style.vala"
		_tmp45_ = g_strdup_printf ("nmargin[%d]", *_tmp44_);
#line 133 "../src/Style.vala"
		_vala_array_add11 (&arr, &arr_length1, &_arr_size_, _tmp45_);
#line 2317 "Style.c"
	}
#line 134 "../src/Style.vala"
	_tmp46_ = self->priv->_node_padding;
#line 134 "../src/Style.vala"
	if (_tmp46_ != NULL) {
#line 2323 "Style.c"
		gchar** _tmp47_;
		gint _tmp47__length1;
		gint* _tmp48_;
		gchar* _tmp49_;
#line 134 "../src/Style.vala"
		_tmp47_ = arr;
#line 134 "../src/Style.vala"
		_tmp47__length1 = arr_length1;
#line 134 "../src/Style.vala"
		_tmp48_ = self->priv->_node_padding;
#line 134 "../src/Style.vala"
		_tmp49_ = g_strdup_printf ("npad[%d]", *_tmp48_);
#line 134 "../src/Style.vala"
		_vala_array_add12 (&arr, &arr_length1, &_arr_size_, _tmp49_);
#line 2338 "Style.c"
	}
#line 135 "../src/Style.vala"
	_tmp50_ = self->priv->_node_font;
#line 135 "../src/Style.vala"
	if (_tmp50_ != NULL) {
#line 2344 "Style.c"
		gchar** _tmp51_;
		gint _tmp51__length1;
		gchar* _tmp52_;
#line 135 "../src/Style.vala"
		_tmp51_ = arr;
#line 135 "../src/Style.vala"
		_tmp51__length1 = arr_length1;
#line 135 "../src/Style.vala"
		_tmp52_ = g_strdup ("nfont");
#line 135 "../src/Style.vala"
		_vala_array_add13 (&arr, &arr_length1, &_arr_size_, _tmp52_);
#line 2356 "Style.c"
	}
#line 136 "../src/Style.vala"
	_tmp53_ = self->priv->_node_markup;
#line 136 "../src/Style.vala"
	if (_tmp53_ != NULL) {
#line 2362 "Style.c"
		gchar** _tmp54_;
		gint _tmp54__length1;
		gboolean* _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
		gchar* _tmp58_;
#line 136 "../src/Style.vala"
		_tmp54_ = arr;
#line 136 "../src/Style.vala"
		_tmp54__length1 = arr_length1;
#line 136 "../src/Style.vala"
		_tmp55_ = self->priv->_node_markup;
#line 136 "../src/Style.vala"
		_tmp56_ = bool_to_string (*_tmp55_);
#line 136 "../src/Style.vala"
		_tmp57_ = _tmp56_;
#line 136 "../src/Style.vala"
		_tmp58_ = g_strdup_printf ("nmarkup[%s]", _tmp57_);
#line 136 "../src/Style.vala"
		_vala_array_add14 (&arr, &arr_length1, &_arr_size_, _tmp58_);
#line 136 "../src/Style.vala"
		_g_free0 (_tmp57_);
#line 2385 "Style.c"
	}
#line 137 "../src/Style.vala"
	_tmp59_ = self->priv->_connection_dash;
#line 137 "../src/Style.vala"
	if (_tmp59_ != NULL) {
#line 2391 "Style.c"
		gchar** _tmp60_;
		gint _tmp60__length1;
		LinkDash* _tmp61_;
		const gchar* _tmp62_;
		gchar* _tmp63_;
#line 137 "../src/Style.vala"
		_tmp60_ = arr;
#line 137 "../src/Style.vala"
		_tmp60__length1 = arr_length1;
#line 137 "../src/Style.vala"
		_tmp61_ = self->priv->_connection_dash;
#line 137 "../src/Style.vala"
		_tmp62_ = _tmp61_->name;
#line 137 "../src/Style.vala"
		_tmp63_ = g_strdup_printf ("cdash[%s]", _tmp62_);
#line 137 "../src/Style.vala"
		_vala_array_add15 (&arr, &arr_length1, &_arr_size_, _tmp63_);
#line 2409 "Style.c"
	}
#line 138 "../src/Style.vala"
	_tmp64_ = self->priv->_connection_width;
#line 138 "../src/Style.vala"
	if (_tmp64_ != NULL) {
#line 2415 "Style.c"
		gchar** _tmp65_;
		gint _tmp65__length1;
		gint* _tmp66_;
		gchar* _tmp67_;
#line 138 "../src/Style.vala"
		_tmp65_ = arr;
#line 138 "../src/Style.vala"
		_tmp65__length1 = arr_length1;
#line 138 "../src/Style.vala"
		_tmp66_ = self->priv->_connection_width;
#line 138 "../src/Style.vala"
		_tmp67_ = g_strdup_printf ("cwidth[%d]", *_tmp66_);
#line 138 "../src/Style.vala"
		_vala_array_add16 (&arr, &arr_length1, &_arr_size_, _tmp67_);
#line 2430 "Style.c"
	}
#line 139 "../src/Style.vala"
	_tmp68_ = self->priv->_connection_arrow;
#line 139 "../src/Style.vala"
	if (_tmp68_ != NULL) {
#line 2436 "Style.c"
		gchar** _tmp69_;
		gint _tmp69__length1;
		const gchar* _tmp70_;
		gchar* _tmp71_;
#line 139 "../src/Style.vala"
		_tmp69_ = arr;
#line 139 "../src/Style.vala"
		_tmp69__length1 = arr_length1;
#line 139 "../src/Style.vala"
		_tmp70_ = self->priv->_connection_arrow;
#line 139 "../src/Style.vala"
		_tmp71_ = g_strdup_printf ("carrow[%s]", _tmp70_);
#line 139 "../src/Style.vala"
		_vala_array_add17 (&arr, &arr_length1, &_arr_size_, _tmp71_);
#line 2451 "Style.c"
	}
#line 140 "../src/Style.vala"
	_tmp72_ = self->priv->_connection_padding;
#line 140 "../src/Style.vala"
	if (_tmp72_ != NULL) {
#line 2457 "Style.c"
		gchar** _tmp73_;
		gint _tmp73__length1;
		gint* _tmp74_;
		gchar* _tmp75_;
#line 140 "../src/Style.vala"
		_tmp73_ = arr;
#line 140 "../src/Style.vala"
		_tmp73__length1 = arr_length1;
#line 140 "../src/Style.vala"
		_tmp74_ = self->priv->_connection_padding;
#line 140 "../src/Style.vala"
		_tmp75_ = g_strdup_printf ("cpad[%d]", *_tmp74_);
#line 140 "../src/Style.vala"
		_vala_array_add18 (&arr, &arr_length1, &_arr_size_, _tmp75_);
#line 2472 "Style.c"
	}
#line 141 "../src/Style.vala"
	_tmp76_ = self->priv->_connection_font;
#line 141 "../src/Style.vala"
	if (_tmp76_ != NULL) {
#line 2478 "Style.c"
		gchar** _tmp77_;
		gint _tmp77__length1;
		gchar* _tmp78_;
#line 141 "../src/Style.vala"
		_tmp77_ = arr;
#line 141 "../src/Style.vala"
		_tmp77__length1 = arr_length1;
#line 141 "../src/Style.vala"
		_tmp78_ = g_strdup ("cfont");
#line 141 "../src/Style.vala"
		_vala_array_add19 (&arr, &arr_length1, &_arr_size_, _tmp78_);
#line 2490 "Style.c"
	}
#line 142 "../src/Style.vala"
	_tmp79_ = arr;
#line 142 "../src/Style.vala"
	_tmp79__length1 = arr_length1;
#line 142 "../src/Style.vala"
	_tmp80_ = _vala_g_strjoinv ("+", _tmp79_, (gint) _tmp79__length1);
#line 142 "../src/Style.vala"
	result = _tmp80_;
#line 142 "../src/Style.vala"
	arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 142 "../src/Style.vala"
	return result;
#line 2504 "Style.c"
}

static gboolean
bool_parse (const gchar* str)
{
	gboolean result = FALSE;
#line 44 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 45 "glib-2.0.vapi"
	if (g_strcmp0 (str, "true") == 0) {
#line 46 "glib-2.0.vapi"
		result = TRUE;
#line 46 "glib-2.0.vapi"
		return result;
#line 2519 "Style.c"
	} else {
#line 48 "glib-2.0.vapi"
		result = FALSE;
#line 48 "glib-2.0.vapi"
		return result;
#line 2525 "Style.c"
	}
}

void
style_load_node (Style* self,
                 xmlNode* node)
{
	gchar* lt = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* lw = NULL;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* la = NULL;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* ld = NULL;
	gchar* _tmp14_;
	const gchar* _tmp15_;
	gchar* nb = NULL;
	gchar* _tmp20_;
	const gchar* _tmp21_;
	gchar* nw = NULL;
	gchar* _tmp26_;
	const gchar* _tmp27_;
	gchar* nbw = NULL;
	gchar* _tmp30_;
	const gchar* _tmp31_;
	gchar* nlf = NULL;
	gchar* _tmp34_;
	const gchar* _tmp35_;
	gchar* nm = NULL;
	gchar* _tmp38_;
	const gchar* _tmp39_;
	gchar* np = NULL;
	gchar* _tmp42_;
	const gchar* _tmp43_;
	gchar* nf = NULL;
	gchar* _tmp46_;
	const gchar* _tmp47_;
	gchar* nmu = NULL;
	gchar* _tmp51_;
	const gchar* _tmp52_;
#line 146 "../src/Style.vala"
	g_return_if_fail (self != NULL);
#line 148 "../src/Style.vala"
	_tmp0_ = (gchar*) xmlGetProp (node, (xmlChar*) "linktype");
#line 148 "../src/Style.vala"
	lt = _tmp0_;
#line 149 "../src/Style.vala"
	_tmp1_ = lt;
#line 149 "../src/Style.vala"
	if (_tmp1_ != NULL) {
#line 2579 "Style.c"
		Styles* _tmp2_;
		const gchar* _tmp3_;
		LinkType* _tmp4_;
		LinkType* _tmp5_;
#line 150 "../src/Style.vala"
		_tmp2_ = style_inspector_styles;
#line 150 "../src/Style.vala"
		_tmp3_ = lt;
#line 150 "../src/Style.vala"
		_tmp4_ = styles_get_link_type (_tmp2_, _tmp3_);
#line 150 "../src/Style.vala"
		_tmp5_ = _tmp4_;
#line 150 "../src/Style.vala"
		style_set_link_type (self, _tmp5_);
#line 150 "../src/Style.vala"
		_g_object_unref0 (_tmp5_);
#line 2596 "Style.c"
	}
#line 152 "../src/Style.vala"
	_tmp6_ = (gchar*) xmlGetProp (node, (xmlChar*) "linkwidth");
#line 152 "../src/Style.vala"
	lw = _tmp6_;
#line 153 "../src/Style.vala"
	_tmp7_ = lw;
#line 153 "../src/Style.vala"
	if (_tmp7_ != NULL) {
#line 2606 "Style.c"
		const gchar* _tmp8_;
		gint _tmp9_;
#line 154 "../src/Style.vala"
		_tmp8_ = lw;
#line 154 "../src/Style.vala"
		_tmp9_ = atoi (_tmp8_);
#line 154 "../src/Style.vala"
		style_set_link_width (self, &_tmp9_);
#line 2615 "Style.c"
	}
#line 156 "../src/Style.vala"
	_tmp10_ = (gchar*) xmlGetProp (node, (xmlChar*) "linkarrow");
#line 156 "../src/Style.vala"
	la = _tmp10_;
#line 157 "../src/Style.vala"
	_tmp11_ = la;
#line 157 "../src/Style.vala"
	if (_tmp11_ != NULL) {
#line 2625 "Style.c"
		const gchar* _tmp12_;
		gboolean _tmp13_;
#line 158 "../src/Style.vala"
		_tmp12_ = la;
#line 158 "../src/Style.vala"
		_tmp13_ = bool_parse (_tmp12_);
#line 158 "../src/Style.vala"
		style_set_link_arrow (self, &_tmp13_);
#line 2634 "Style.c"
	}
#line 160 "../src/Style.vala"
	_tmp14_ = (gchar*) xmlGetProp (node, (xmlChar*) "linkdash");
#line 160 "../src/Style.vala"
	ld = _tmp14_;
#line 161 "../src/Style.vala"
	_tmp15_ = ld;
#line 161 "../src/Style.vala"
	if (_tmp15_ != NULL) {
#line 2644 "Style.c"
		Styles* _tmp16_;
		const gchar* _tmp17_;
		LinkDash* _tmp18_;
		LinkDash* _tmp19_;
#line 162 "../src/Style.vala"
		_tmp16_ = style_inspector_styles;
#line 162 "../src/Style.vala"
		_tmp17_ = ld;
#line 162 "../src/Style.vala"
		_tmp18_ = styles_get_link_dash (_tmp16_, _tmp17_);
#line 162 "../src/Style.vala"
		_tmp19_ = _tmp18_;
#line 162 "../src/Style.vala"
		style_set_link_dash (self, _tmp19_);
#line 162 "../src/Style.vala"
		_g_object_unref0 (_tmp19_);
#line 2661 "Style.c"
	}
#line 165 "../src/Style.vala"
	_tmp20_ = (gchar*) xmlGetProp (node, (xmlChar*) "nodeborder");
#line 165 "../src/Style.vala"
	nb = _tmp20_;
#line 166 "../src/Style.vala"
	_tmp21_ = nb;
#line 166 "../src/Style.vala"
	if (_tmp21_ != NULL) {
#line 2671 "Style.c"
		Styles* _tmp22_;
		const gchar* _tmp23_;
		NodeBorder* _tmp24_;
		NodeBorder* _tmp25_;
#line 167 "../src/Style.vala"
		_tmp22_ = style_inspector_styles;
#line 167 "../src/Style.vala"
		_tmp23_ = nb;
#line 167 "../src/Style.vala"
		_tmp24_ = styles_get_node_border (_tmp22_, _tmp23_);
#line 167 "../src/Style.vala"
		_tmp25_ = _tmp24_;
#line 167 "../src/Style.vala"
		style_set_node_border (self, _tmp25_);
#line 167 "../src/Style.vala"
		_g_object_unref0 (_tmp25_);
#line 2688 "Style.c"
	}
#line 169 "../src/Style.vala"
	_tmp26_ = (gchar*) xmlGetProp (node, (xmlChar*) "nodewidth");
#line 169 "../src/Style.vala"
	nw = _tmp26_;
#line 170 "../src/Style.vala"
	_tmp27_ = nw;
#line 170 "../src/Style.vala"
	if (_tmp27_ != NULL) {
#line 2698 "Style.c"
		const gchar* _tmp28_;
		gint _tmp29_;
#line 171 "../src/Style.vala"
		_tmp28_ = nw;
#line 171 "../src/Style.vala"
		_tmp29_ = atoi (_tmp28_);
#line 171 "../src/Style.vala"
		style_set_node_width (self, &_tmp29_);
#line 2707 "Style.c"
	}
#line 173 "../src/Style.vala"
	_tmp30_ = (gchar*) xmlGetProp (node, (xmlChar*) "nodeborderwidth");
#line 173 "../src/Style.vala"
	nbw = _tmp30_;
#line 174 "../src/Style.vala"
	_tmp31_ = nbw;
#line 174 "../src/Style.vala"
	if (_tmp31_ != NULL) {
#line 2717 "Style.c"
		const gchar* _tmp32_;
		gint _tmp33_;
#line 175 "../src/Style.vala"
		_tmp32_ = nbw;
#line 175 "../src/Style.vala"
		_tmp33_ = atoi (_tmp32_);
#line 175 "../src/Style.vala"
		style_set_node_borderwidth (self, &_tmp33_);
#line 2726 "Style.c"
	}
#line 177 "../src/Style.vala"
	_tmp34_ = (gchar*) xmlGetProp (node, (xmlChar*) "nodefill");
#line 177 "../src/Style.vala"
	nlf = _tmp34_;
#line 178 "../src/Style.vala"
	_tmp35_ = nlf;
#line 178 "../src/Style.vala"
	if (_tmp35_ != NULL) {
#line 2736 "Style.c"
		const gchar* _tmp36_;
		gboolean _tmp37_;
#line 179 "../src/Style.vala"
		_tmp36_ = nlf;
#line 179 "../src/Style.vala"
		_tmp37_ = bool_parse (_tmp36_);
#line 179 "../src/Style.vala"
		style_set_node_fill (self, &_tmp37_);
#line 2745 "Style.c"
	}
#line 181 "../src/Style.vala"
	_tmp38_ = (gchar*) xmlGetProp (node, (xmlChar*) "nodemargin");
#line 181 "../src/Style.vala"
	nm = _tmp38_;
#line 182 "../src/Style.vala"
	_tmp39_ = nm;
#line 182 "../src/Style.vala"
	if (_tmp39_ != NULL) {
#line 2755 "Style.c"
		const gchar* _tmp40_;
		gint _tmp41_;
#line 183 "../src/Style.vala"
		_tmp40_ = nm;
#line 183 "../src/Style.vala"
		_tmp41_ = atoi (_tmp40_);
#line 183 "../src/Style.vala"
		style_set_node_margin (self, &_tmp41_);
#line 2764 "Style.c"
	}
#line 185 "../src/Style.vala"
	_tmp42_ = (gchar*) xmlGetProp (node, (xmlChar*) "nodepadding");
#line 185 "../src/Style.vala"
	np = _tmp42_;
#line 186 "../src/Style.vala"
	_tmp43_ = np;
#line 186 "../src/Style.vala"
	if (_tmp43_ != NULL) {
#line 2774 "Style.c"
		const gchar* _tmp44_;
		gint _tmp45_;
#line 187 "../src/Style.vala"
		_tmp44_ = np;
#line 187 "../src/Style.vala"
		_tmp45_ = atoi (_tmp44_);
#line 187 "../src/Style.vala"
		style_set_node_padding (self, &_tmp45_);
#line 2783 "Style.c"
	}
#line 189 "../src/Style.vala"
	_tmp46_ = (gchar*) xmlGetProp (node, (xmlChar*) "nodefont");
#line 189 "../src/Style.vala"
	nf = _tmp46_;
#line 190 "../src/Style.vala"
	_tmp47_ = nf;
#line 190 "../src/Style.vala"
	if (_tmp47_ != NULL) {
#line 2793 "Style.c"
		const gchar* _tmp48_;
		PangoFontDescription* _tmp49_;
		PangoFontDescription* _tmp50_;
#line 191 "../src/Style.vala"
		_tmp48_ = nf;
#line 191 "../src/Style.vala"
		_tmp49_ = pango_font_description_from_string (_tmp48_);
#line 191 "../src/Style.vala"
		_tmp50_ = _tmp49_;
#line 191 "../src/Style.vala"
		style_set_node_font (self, _tmp50_);
#line 191 "../src/Style.vala"
		__vala_PangoFontDescription_free0 (_tmp50_);
#line 2807 "Style.c"
	}
#line 193 "../src/Style.vala"
	_tmp51_ = (gchar*) xmlGetProp (node, (xmlChar*) "nodemarkup");
#line 193 "../src/Style.vala"
	nmu = _tmp51_;
#line 194 "../src/Style.vala"
	_tmp52_ = nmu;
#line 194 "../src/Style.vala"
	if (_tmp52_ != NULL) {
#line 2817 "Style.c"
		const gchar* _tmp53_;
		gboolean _tmp54_;
#line 195 "../src/Style.vala"
		_tmp53_ = nmu;
#line 195 "../src/Style.vala"
		_tmp54_ = bool_parse (_tmp53_);
#line 195 "../src/Style.vala"
		style_set_node_markup (self, &_tmp54_);
#line 2826 "Style.c"
	}
#line 146 "../src/Style.vala"
	_g_free0 (nmu);
#line 146 "../src/Style.vala"
	_g_free0 (nf);
#line 146 "../src/Style.vala"
	_g_free0 (np);
#line 146 "../src/Style.vala"
	_g_free0 (nm);
#line 146 "../src/Style.vala"
	_g_free0 (nlf);
#line 146 "../src/Style.vala"
	_g_free0 (nbw);
#line 146 "../src/Style.vala"
	_g_free0 (nw);
#line 146 "../src/Style.vala"
	_g_free0 (nb);
#line 146 "../src/Style.vala"
	_g_free0 (ld);
#line 146 "../src/Style.vala"
	_g_free0 (la);
#line 146 "../src/Style.vala"
	_g_free0 (lw);
#line 146 "../src/Style.vala"
	_g_free0 (lt);
#line 2852 "Style.c"
}

void
style_load_connection (Style* self,
                       xmlNode* node)
{
	gchar* d = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* w = NULL;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* a = NULL;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* p = NULL;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* f = NULL;
	gchar* _tmp17_;
	const gchar* _tmp18_;
#line 201 "../src/Style.vala"
	g_return_if_fail (self != NULL);
#line 203 "../src/Style.vala"
	_tmp0_ = (gchar*) xmlGetProp (node, (xmlChar*) "connectiondash");
#line 203 "../src/Style.vala"
	d = _tmp0_;
#line 204 "../src/Style.vala"
	_tmp1_ = d;
#line 204 "../src/Style.vala"
	if (_tmp1_ != NULL) {
#line 2884 "Style.c"
		Styles* _tmp2_;
		const gchar* _tmp3_;
		LinkDash* _tmp4_;
		LinkDash* _tmp5_;
#line 205 "../src/Style.vala"
		_tmp2_ = style_inspector_styles;
#line 205 "../src/Style.vala"
		_tmp3_ = d;
#line 205 "../src/Style.vala"
		_tmp4_ = styles_get_link_dash (_tmp2_, _tmp3_);
#line 205 "../src/Style.vala"
		_tmp5_ = _tmp4_;
#line 205 "../src/Style.vala"
		style_set_connection_dash (self, _tmp5_);
#line 205 "../src/Style.vala"
		_g_object_unref0 (_tmp5_);
#line 2901 "Style.c"
	}
#line 207 "../src/Style.vala"
	_tmp6_ = (gchar*) xmlGetProp (node, (xmlChar*) "connectionwidth");
#line 207 "../src/Style.vala"
	w = _tmp6_;
#line 208 "../src/Style.vala"
	_tmp7_ = w;
#line 208 "../src/Style.vala"
	if (_tmp7_ != NULL) {
#line 2911 "Style.c"
		const gchar* _tmp8_;
		gint _tmp9_;
#line 209 "../src/Style.vala"
		_tmp8_ = w;
#line 209 "../src/Style.vala"
		_tmp9_ = atoi (_tmp8_);
#line 209 "../src/Style.vala"
		style_set_connection_width (self, &_tmp9_);
#line 2920 "Style.c"
	}
#line 211 "../src/Style.vala"
	_tmp10_ = (gchar*) xmlGetProp (node, (xmlChar*) "connectionarrow");
#line 211 "../src/Style.vala"
	a = _tmp10_;
#line 212 "../src/Style.vala"
	_tmp11_ = a;
#line 212 "../src/Style.vala"
	if (_tmp11_ != NULL) {
#line 2930 "Style.c"
		const gchar* _tmp12_;
#line 213 "../src/Style.vala"
		_tmp12_ = a;
#line 213 "../src/Style.vala"
		style_set_connection_arrow (self, _tmp12_);
#line 2936 "Style.c"
	}
#line 215 "../src/Style.vala"
	_tmp13_ = (gchar*) xmlGetProp (node, (xmlChar*) "connectionpadding");
#line 215 "../src/Style.vala"
	p = _tmp13_;
#line 216 "../src/Style.vala"
	_tmp14_ = p;
#line 216 "../src/Style.vala"
	if (_tmp14_ != NULL) {
#line 2946 "Style.c"
		const gchar* _tmp15_;
		gint _tmp16_;
#line 217 "../src/Style.vala"
		_tmp15_ = p;
#line 217 "../src/Style.vala"
		_tmp16_ = atoi (_tmp15_);
#line 217 "../src/Style.vala"
		style_set_connection_padding (self, &_tmp16_);
#line 2955 "Style.c"
	}
#line 219 "../src/Style.vala"
	_tmp17_ = (gchar*) xmlGetProp (node, (xmlChar*) "connectionfont");
#line 219 "../src/Style.vala"
	f = _tmp17_;
#line 220 "../src/Style.vala"
	_tmp18_ = f;
#line 220 "../src/Style.vala"
	if (_tmp18_ != NULL) {
#line 2965 "Style.c"
		const gchar* _tmp19_;
		PangoFontDescription* _tmp20_;
		PangoFontDescription* _tmp21_;
#line 221 "../src/Style.vala"
		_tmp19_ = f;
#line 221 "../src/Style.vala"
		_tmp20_ = pango_font_description_from_string (_tmp19_);
#line 221 "../src/Style.vala"
		_tmp21_ = _tmp20_;
#line 221 "../src/Style.vala"
		style_set_connection_font (self, _tmp21_);
#line 221 "../src/Style.vala"
		__vala_PangoFontDescription_free0 (_tmp21_);
#line 2979 "Style.c"
	}
#line 201 "../src/Style.vala"
	_g_free0 (f);
#line 201 "../src/Style.vala"
	_g_free0 (p);
#line 201 "../src/Style.vala"
	_g_free0 (a);
#line 201 "../src/Style.vala"
	_g_free0 (w);
#line 201 "../src/Style.vala"
	_g_free0 (d);
#line 2991 "Style.c"
}

void
style_save_node_in_node (Style* self,
                         xmlNode* n)
{
	LinkType* _tmp0_;
	gint* _tmp4_;
	gboolean* _tmp8_;
	LinkDash* _tmp12_;
	NodeBorder* _tmp15_;
	gint* _tmp19_;
	gint* _tmp23_;
	gboolean* _tmp27_;
	gint* _tmp31_;
	gint* _tmp35_;
	PangoFontDescription* _tmp39_;
	gboolean* _tmp43_;
#line 226 "../src/Style.vala"
	g_return_if_fail (self != NULL);
#line 228 "../src/Style.vala"
	_tmp0_ = self->priv->_link_type;
#line 228 "../src/Style.vala"
	if (_tmp0_ != NULL) {
#line 3016 "Style.c"
		LinkType* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 229 "../src/Style.vala"
		_tmp1_ = self->priv->_link_type;
#line 229 "../src/Style.vala"
		_tmp2_ = link_type_name (_tmp1_);
#line 229 "../src/Style.vala"
		_tmp3_ = _tmp2_;
#line 229 "../src/Style.vala"
		xmlSetProp (n, (xmlChar*) "linktype", (xmlChar*) _tmp3_);
#line 229 "../src/Style.vala"
		_g_free0 (_tmp3_);
#line 3030 "Style.c"
	}
#line 231 "../src/Style.vala"
	_tmp4_ = self->priv->_link_width;
#line 231 "../src/Style.vala"
	if (_tmp4_ != NULL) {
#line 3036 "Style.c"
		gint* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 232 "../src/Style.vala"
		_tmp5_ = self->priv->_link_width;
#line 232 "../src/Style.vala"
		_tmp6_ = g_strdup_printf ("%i", *_tmp5_);
#line 232 "../src/Style.vala"
		_tmp7_ = _tmp6_;
#line 232 "../src/Style.vala"
		xmlSetProp (n, (xmlChar*) "linkwidth", (xmlChar*) _tmp7_);
#line 232 "../src/Style.vala"
		_g_free0 (_tmp7_);
#line 3050 "Style.c"
	}
#line 234 "../src/Style.vala"
	_tmp8_ = self->priv->_link_arrow;
#line 234 "../src/Style.vala"
	if (_tmp8_ != NULL) {
#line 3056 "Style.c"
		gboolean* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 235 "../src/Style.vala"
		_tmp9_ = self->priv->_link_arrow;
#line 235 "../src/Style.vala"
		_tmp10_ = bool_to_string (*_tmp9_);
#line 235 "../src/Style.vala"
		_tmp11_ = _tmp10_;
#line 235 "../src/Style.vala"
		xmlSetProp (n, (xmlChar*) "linkarrow", (xmlChar*) _tmp11_);
#line 235 "../src/Style.vala"
		_g_free0 (_tmp11_);
#line 3070 "Style.c"
	}
#line 237 "../src/Style.vala"
	_tmp12_ = self->priv->_link_dash;
#line 237 "../src/Style.vala"
	if (_tmp12_ != NULL) {
#line 3076 "Style.c"
		LinkDash* _tmp13_;
		const gchar* _tmp14_;
#line 238 "../src/Style.vala"
		_tmp13_ = self->priv->_link_dash;
#line 238 "../src/Style.vala"
		_tmp14_ = _tmp13_->name;
#line 238 "../src/Style.vala"
		xmlSetProp (n, (xmlChar*) "linkdash", (xmlChar*) _tmp14_);
#line 3085 "Style.c"
	}
#line 241 "../src/Style.vala"
	_tmp15_ = self->priv->_node_border;
#line 241 "../src/Style.vala"
	if (_tmp15_ != NULL) {
#line 3091 "Style.c"
		NodeBorder* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
#line 242 "../src/Style.vala"
		_tmp16_ = self->priv->_node_border;
#line 242 "../src/Style.vala"
		_tmp17_ = node_border_name (_tmp16_);
#line 242 "../src/Style.vala"
		_tmp18_ = _tmp17_;
#line 242 "../src/Style.vala"
		xmlSetProp (n, (xmlChar*) "nodeborder", (xmlChar*) _tmp18_);
#line 242 "../src/Style.vala"
		_g_free0 (_tmp18_);
#line 3105 "Style.c"
	}
#line 244 "../src/Style.vala"
	_tmp19_ = self->priv->_node_width;
#line 244 "../src/Style.vala"
	if (_tmp19_ != NULL) {
#line 3111 "Style.c"
		gint* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
#line 245 "../src/Style.vala"
		_tmp20_ = self->priv->_node_width;
#line 245 "../src/Style.vala"
		_tmp21_ = g_strdup_printf ("%i", *_tmp20_);
#line 245 "../src/Style.vala"
		_tmp22_ = _tmp21_;
#line 245 "../src/Style.vala"
		xmlSetProp (n, (xmlChar*) "nodewidth", (xmlChar*) _tmp22_);
#line 245 "../src/Style.vala"
		_g_free0 (_tmp22_);
#line 3125 "Style.c"
	}
#line 247 "../src/Style.vala"
	_tmp23_ = self->priv->_node_borderwidth;
#line 247 "../src/Style.vala"
	if (_tmp23_ != NULL) {
#line 3131 "Style.c"
		gint* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
#line 248 "../src/Style.vala"
		_tmp24_ = self->priv->_node_borderwidth;
#line 248 "../src/Style.vala"
		_tmp25_ = g_strdup_printf ("%i", *_tmp24_);
#line 248 "../src/Style.vala"
		_tmp26_ = _tmp25_;
#line 248 "../src/Style.vala"
		xmlSetProp (n, (xmlChar*) "nodeborderwidth", (xmlChar*) _tmp26_);
#line 248 "../src/Style.vala"
		_g_free0 (_tmp26_);
#line 3145 "Style.c"
	}
#line 250 "../src/Style.vala"
	_tmp27_ = self->priv->_node_fill;
#line 250 "../src/Style.vala"
	if (_tmp27_ != NULL) {
#line 3151 "Style.c"
		gboolean* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
#line 251 "../src/Style.vala"
		_tmp28_ = self->priv->_node_fill;
#line 251 "../src/Style.vala"
		_tmp29_ = bool_to_string (*_tmp28_);
#line 251 "../src/Style.vala"
		_tmp30_ = _tmp29_;
#line 251 "../src/Style.vala"
		xmlSetProp (n, (xmlChar*) "nodefill", (xmlChar*) _tmp30_);
#line 251 "../src/Style.vala"
		_g_free0 (_tmp30_);
#line 3165 "Style.c"
	}
#line 253 "../src/Style.vala"
	_tmp31_ = self->priv->_node_margin;
#line 253 "../src/Style.vala"
	if (_tmp31_ != NULL) {
#line 3171 "Style.c"
		gint* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
#line 254 "../src/Style.vala"
		_tmp32_ = self->priv->_node_margin;
#line 254 "../src/Style.vala"
		_tmp33_ = g_strdup_printf ("%i", *_tmp32_);
#line 254 "../src/Style.vala"
		_tmp34_ = _tmp33_;
#line 254 "../src/Style.vala"
		xmlSetProp (n, (xmlChar*) "nodemargin", (xmlChar*) _tmp34_);
#line 254 "../src/Style.vala"
		_g_free0 (_tmp34_);
#line 3185 "Style.c"
	}
#line 256 "../src/Style.vala"
	_tmp35_ = self->priv->_node_padding;
#line 256 "../src/Style.vala"
	if (_tmp35_ != NULL) {
#line 3191 "Style.c"
		gint* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
#line 257 "../src/Style.vala"
		_tmp36_ = self->priv->_node_padding;
#line 257 "../src/Style.vala"
		_tmp37_ = g_strdup_printf ("%i", *_tmp36_);
#line 257 "../src/Style.vala"
		_tmp38_ = _tmp37_;
#line 257 "../src/Style.vala"
		xmlSetProp (n, (xmlChar*) "nodepadding", (xmlChar*) _tmp38_);
#line 257 "../src/Style.vala"
		_g_free0 (_tmp38_);
#line 3205 "Style.c"
	}
#line 259 "../src/Style.vala"
	_tmp39_ = self->priv->_node_font;
#line 259 "../src/Style.vala"
	if (_tmp39_ != NULL) {
#line 3211 "Style.c"
		PangoFontDescription* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
#line 260 "../src/Style.vala"
		_tmp40_ = self->priv->_node_font;
#line 260 "../src/Style.vala"
		_tmp41_ = pango_font_description_to_string (_tmp40_);
#line 260 "../src/Style.vala"
		_tmp42_ = _tmp41_;
#line 260 "../src/Style.vala"
		xmlSetProp (n, (xmlChar*) "nodefont", (xmlChar*) _tmp42_);
#line 260 "../src/Style.vala"
		_g_free0 (_tmp42_);
#line 3225 "Style.c"
	}
#line 262 "../src/Style.vala"
	_tmp43_ = self->priv->_node_markup;
#line 262 "../src/Style.vala"
	if (_tmp43_ != NULL) {
#line 3231 "Style.c"
		gboolean* _tmp44_;
		gchar* _tmp45_;
		gchar* _tmp46_;
#line 263 "../src/Style.vala"
		_tmp44_ = self->priv->_node_markup;
#line 263 "../src/Style.vala"
		_tmp45_ = bool_to_string (*_tmp44_);
#line 263 "../src/Style.vala"
		_tmp46_ = _tmp45_;
#line 263 "../src/Style.vala"
		xmlSetProp (n, (xmlChar*) "nodemarkup", (xmlChar*) _tmp46_);
#line 263 "../src/Style.vala"
		_g_free0 (_tmp46_);
#line 3245 "Style.c"
	}
}

void
style_save_node (Style* self,
                 xmlNode* parent)
{
	xmlNode* n = NULL;
	xmlNode* _tmp0_;
#line 269 "../src/Style.vala"
	g_return_if_fail (self != NULL);
#line 271 "../src/Style.vala"
	_tmp0_ = xmlNewNode (NULL, (xmlChar*) "style");
#line 271 "../src/Style.vala"
	n = _tmp0_;
#line 272 "../src/Style.vala"
	style_save_node_in_node (self, n);
#line 273 "../src/Style.vala"
	xmlAddChild (parent, n);
#line 3265 "Style.c"
}

void
style_save_connection_in_node (Style* self,
                               xmlNode* n)
{
	LinkDash* _tmp0_;
	gint* _tmp3_;
	const gchar* _tmp7_;
	gint* _tmp9_;
	PangoFontDescription* _tmp13_;
#line 277 "../src/Style.vala"
	g_return_if_fail (self != NULL);
#line 279 "../src/Style.vala"
	_tmp0_ = self->priv->_connection_dash;
#line 279 "../src/Style.vala"
	if (_tmp0_ != NULL) {
#line 3283 "Style.c"
		LinkDash* _tmp1_;
		const gchar* _tmp2_;
#line 280 "../src/Style.vala"
		_tmp1_ = self->priv->_connection_dash;
#line 280 "../src/Style.vala"
		_tmp2_ = _tmp1_->name;
#line 280 "../src/Style.vala"
		xmlSetProp (n, (xmlChar*) "connectiondash", (xmlChar*) _tmp2_);
#line 3292 "Style.c"
	}
#line 282 "../src/Style.vala"
	_tmp3_ = self->priv->_connection_width;
#line 282 "../src/Style.vala"
	if (_tmp3_ != NULL) {
#line 3298 "Style.c"
		gint* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 283 "../src/Style.vala"
		_tmp4_ = self->priv->_connection_width;
#line 283 "../src/Style.vala"
		_tmp5_ = g_strdup_printf ("%i", *_tmp4_);
#line 283 "../src/Style.vala"
		_tmp6_ = _tmp5_;
#line 283 "../src/Style.vala"
		xmlSetProp (n, (xmlChar*) "connectionwidth", (xmlChar*) _tmp6_);
#line 283 "../src/Style.vala"
		_g_free0 (_tmp6_);
#line 3312 "Style.c"
	}
#line 285 "../src/Style.vala"
	_tmp7_ = self->priv->_connection_arrow;
#line 285 "../src/Style.vala"
	if (_tmp7_ != NULL) {
#line 3318 "Style.c"
		const gchar* _tmp8_;
#line 286 "../src/Style.vala"
		_tmp8_ = self->priv->_connection_arrow;
#line 286 "../src/Style.vala"
		xmlSetProp (n, (xmlChar*) "connectionarrow", (xmlChar*) _tmp8_);
#line 3324 "Style.c"
	}
#line 288 "../src/Style.vala"
	_tmp9_ = self->priv->_connection_padding;
#line 288 "../src/Style.vala"
	if (_tmp9_ != NULL) {
#line 3330 "Style.c"
		gint* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
#line 289 "../src/Style.vala"
		_tmp10_ = self->priv->_connection_padding;
#line 289 "../src/Style.vala"
		_tmp11_ = g_strdup_printf ("%i", *_tmp10_);
#line 289 "../src/Style.vala"
		_tmp12_ = _tmp11_;
#line 289 "../src/Style.vala"
		xmlSetProp (n, (xmlChar*) "connectionpadding", (xmlChar*) _tmp12_);
#line 289 "../src/Style.vala"
		_g_free0 (_tmp12_);
#line 3344 "Style.c"
	}
#line 291 "../src/Style.vala"
	_tmp13_ = self->priv->_connection_font;
#line 291 "../src/Style.vala"
	if (_tmp13_ != NULL) {
#line 3350 "Style.c"
		PangoFontDescription* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 292 "../src/Style.vala"
		_tmp14_ = self->priv->_connection_font;
#line 292 "../src/Style.vala"
		_tmp15_ = pango_font_description_to_string (_tmp14_);
#line 292 "../src/Style.vala"
		_tmp16_ = _tmp15_;
#line 292 "../src/Style.vala"
		xmlSetProp (n, (xmlChar*) "connectionfont", (xmlChar*) _tmp16_);
#line 292 "../src/Style.vala"
		_g_free0 (_tmp16_);
#line 3364 "Style.c"
	}
}

void
style_save_connection (Style* self,
                       xmlNode* parent)
{
	xmlNode* n = NULL;
	xmlNode* _tmp0_;
#line 298 "../src/Style.vala"
	g_return_if_fail (self != NULL);
#line 300 "../src/Style.vala"
	_tmp0_ = xmlNewNode (NULL, (xmlChar*) "style");
#line 300 "../src/Style.vala"
	n = _tmp0_;
#line 301 "../src/Style.vala"
	style_save_connection_in_node (self, n);
#line 302 "../src/Style.vala"
	xmlAddChild (parent, n);
#line 3384 "Style.c"
}

void
style_draw_link (Style* self,
                 cairo_t* ctx,
                 Style* parent_style,
                 gdouble from_x,
                 gdouble from_y,
                 gdouble to_x,
                 gdouble to_y,
                 gboolean horizontal,
                 gdouble* tailx,
                 gdouble* taily,
                 gdouble* tipx,
                 gdouble* tipy)
{
	gdouble _vala_tailx = 0.0;
	gdouble _vala_taily = 0.0;
	gdouble _vala_tipx = 0.0;
	gdouble _vala_tipy = 0.0;
	gint* _tmp0_;
	LinkDash* _tmp1_;
	gint* _tmp2_;
	LinkType* _tmp3_;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
#line 307 "../src/Style.vala"
	g_return_if_fail (self != NULL);
#line 307 "../src/Style.vala"
	g_return_if_fail (ctx != NULL);
#line 307 "../src/Style.vala"
	g_return_if_fail (parent_style != NULL);
#line 311 "../src/Style.vala"
	cairo_save (ctx);
#line 312 "../src/Style.vala"
	_tmp0_ = self->priv->_link_width;
#line 312 "../src/Style.vala"
	cairo_set_line_width (ctx, *_tmp0_);
#line 313 "../src/Style.vala"
	_tmp1_ = self->priv->_link_dash;
#line 313 "../src/Style.vala"
	_tmp2_ = self->priv->_link_width;
#line 313 "../src/Style.vala"
	link_dash_set_context (_tmp1_, ctx, *_tmp2_);
#line 314 "../src/Style.vala"
	_tmp3_ = parent_style->priv->_link_type;
#line 314 "../src/Style.vala"
	link_type_draw (_tmp3_, ctx, from_x, from_y, to_x, to_y, horizontal, &_tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
#line 314 "../src/Style.vala"
	_vala_tailx = _tmp4_;
#line 314 "../src/Style.vala"
	_vala_taily = _tmp5_;
#line 314 "../src/Style.vala"
	_vala_tipx = _tmp6_;
#line 314 "../src/Style.vala"
	_vala_tipy = _tmp7_;
#line 315 "../src/Style.vala"
	cairo_restore (ctx);
#line 307 "../src/Style.vala"
	if (tailx) {
#line 307 "../src/Style.vala"
		*tailx = _vala_tailx;
#line 3449 "Style.c"
	}
#line 307 "../src/Style.vala"
	if (taily) {
#line 307 "../src/Style.vala"
		*taily = _vala_taily;
#line 3455 "Style.c"
	}
#line 307 "../src/Style.vala"
	if (tipx) {
#line 307 "../src/Style.vala"
		*tipx = _vala_tipx;
#line 3461 "Style.c"
	}
#line 307 "../src/Style.vala"
	if (tipy) {
#line 307 "../src/Style.vala"
		*tipy = _vala_tipy;
#line 3467 "Style.c"
	}
}

void
style_draw_node_border (Style* self,
                        cairo_t* ctx,
                        gdouble x,
                        gdouble y,
                        gdouble w,
                        gdouble h,
                        NodeSide s)
{
	gint* _tmp0_;
	NodeBorder* _tmp1_;
#line 320 "../src/Style.vala"
	g_return_if_fail (self != NULL);
#line 320 "../src/Style.vala"
	g_return_if_fail (ctx != NULL);
#line 322 "../src/Style.vala"
	cairo_save (ctx);
#line 323 "../src/Style.vala"
	_tmp0_ = self->priv->_node_borderwidth;
#line 323 "../src/Style.vala"
	cairo_set_line_width (ctx, *_tmp0_);
#line 324 "../src/Style.vala"
	_tmp1_ = self->priv->_node_border;
#line 324 "../src/Style.vala"
	node_border_draw_border (_tmp1_, ctx, x, y, w, h, s);
#line 325 "../src/Style.vala"
	cairo_restore (ctx);
#line 3498 "Style.c"
}

void
style_draw_node_fill (Style* self,
                      cairo_t* ctx,
                      gdouble x,
                      gdouble y,
                      gdouble w,
                      gdouble h,
                      NodeSide s)
{
	NodeBorder* _tmp0_;
#line 330 "../src/Style.vala"
	g_return_if_fail (self != NULL);
#line 330 "../src/Style.vala"
	g_return_if_fail (ctx != NULL);
#line 332 "../src/Style.vala"
	_tmp0_ = self->priv->_node_border;
#line 332 "../src/Style.vala"
	node_border_draw_fill (_tmp0_, ctx, x, y, w, h, s);
#line 3519 "Style.c"
}

void
style_draw_connection (Style* self,
                       cairo_t* ctx)
{
	gint* _tmp0_;
	LinkDash* _tmp1_;
	gint* _tmp2_;
#line 337 "../src/Style.vala"
	g_return_if_fail (self != NULL);
#line 337 "../src/Style.vala"
	g_return_if_fail (ctx != NULL);
#line 339 "../src/Style.vala"
	_tmp0_ = self->priv->_connection_width;
#line 339 "../src/Style.vala"
	cairo_set_line_width (ctx, *_tmp0_);
#line 340 "../src/Style.vala"
	_tmp1_ = self->priv->_connection_dash;
#line 340 "../src/Style.vala"
	_tmp2_ = self->priv->_connection_width;
#line 340 "../src/Style.vala"
	link_dash_set_context (_tmp1_, ctx, *_tmp2_);
#line 3543 "Style.c"
}

LinkType*
style_get_link_type (Style* self)
{
	LinkType* result;
	LinkType* _tmp0_;
#line 28 "../src/Style.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/Style.vala"
	_tmp0_ = self->priv->_link_type;
#line 28 "../src/Style.vala"
	result = _tmp0_;
#line 28 "../src/Style.vala"
	return result;
#line 3559 "Style.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 28 "../src/Style.vala"
	return self ? g_object_ref (self) : NULL;
#line 3567 "Style.c"
}

void
style_set_link_type (Style* self,
                     LinkType* value)
{
	LinkType* _tmp0_;
#line 28 "../src/Style.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Style.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 28 "../src/Style.vala"
	_g_object_unref0 (self->priv->_link_type);
#line 28 "../src/Style.vala"
	self->priv->_link_type = _tmp0_;
#line 3583 "Style.c"
}

gint*
style_get_link_width (Style* self)
{
	gint* result;
	gint* _tmp0_;
#line 29 "../src/Style.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../src/Style.vala"
	_tmp0_ = self->priv->_link_width;
#line 29 "../src/Style.vala"
	result = _tmp0_;
#line 29 "../src/Style.vala"
	return result;
#line 3599 "Style.c"
}

static gint*
_int_dup (gint* self)
{
	gint* dup;
#line 29 "../src/Style.vala"
	dup = g_new0 (gint, 1);
#line 29 "../src/Style.vala"
	memcpy (dup, self, sizeof (gint));
#line 29 "../src/Style.vala"
	return dup;
#line 3612 "Style.c"
}

static gpointer
__int_dup0 (gpointer self)
{
#line 29 "../src/Style.vala"
	return self ? _int_dup (self) : NULL;
#line 3620 "Style.c"
}

void
style_set_link_width (Style* self,
                      gint* value)
{
	gint* _tmp0_;
#line 29 "../src/Style.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Style.vala"
	_tmp0_ = __int_dup0 (value);
#line 29 "../src/Style.vala"
	_g_free0 (self->priv->_link_width);
#line 29 "../src/Style.vala"
	self->priv->_link_width = _tmp0_;
#line 3636 "Style.c"
}

gboolean*
style_get_link_arrow (Style* self)
{
	gboolean* result;
	gboolean* _tmp0_;
#line 30 "../src/Style.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/Style.vala"
	_tmp0_ = self->priv->_link_arrow;
#line 30 "../src/Style.vala"
	result = _tmp0_;
#line 30 "../src/Style.vala"
	return result;
#line 3652 "Style.c"
}

static gboolean*
_bool_dup (gboolean* self)
{
	gboolean* dup;
#line 30 "../src/Style.vala"
	dup = g_new0 (gboolean, 1);
#line 30 "../src/Style.vala"
	memcpy (dup, self, sizeof (gboolean));
#line 30 "../src/Style.vala"
	return dup;
#line 3665 "Style.c"
}

static gpointer
__bool_dup0 (gpointer self)
{
#line 30 "../src/Style.vala"
	return self ? _bool_dup (self) : NULL;
#line 3673 "Style.c"
}

void
style_set_link_arrow (Style* self,
                      gboolean* value)
{
	gboolean* _tmp0_;
#line 30 "../src/Style.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/Style.vala"
	_tmp0_ = __bool_dup0 (value);
#line 30 "../src/Style.vala"
	_g_free0 (self->priv->_link_arrow);
#line 30 "../src/Style.vala"
	self->priv->_link_arrow = _tmp0_;
#line 3689 "Style.c"
}

LinkDash*
style_get_link_dash (Style* self)
{
	LinkDash* result;
	LinkDash* _tmp0_;
#line 31 "../src/Style.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../src/Style.vala"
	_tmp0_ = self->priv->_link_dash;
#line 31 "../src/Style.vala"
	result = _tmp0_;
#line 31 "../src/Style.vala"
	return result;
#line 3705 "Style.c"
}

void
style_set_link_dash (Style* self,
                     LinkDash* value)
{
	LinkDash* _tmp0_;
#line 31 "../src/Style.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/Style.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 31 "../src/Style.vala"
	_g_object_unref0 (self->priv->_link_dash);
#line 31 "../src/Style.vala"
	self->priv->_link_dash = _tmp0_;
#line 3721 "Style.c"
}

NodeBorder*
style_get_node_border (Style* self)
{
	NodeBorder* result;
	NodeBorder* _tmp0_;
#line 32 "../src/Style.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../src/Style.vala"
	_tmp0_ = self->priv->_node_border;
#line 32 "../src/Style.vala"
	result = _tmp0_;
#line 32 "../src/Style.vala"
	return result;
#line 3737 "Style.c"
}

void
style_set_node_border (Style* self,
                       NodeBorder* value)
{
	NodeBorder* _tmp0_;
#line 32 "../src/Style.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/Style.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 32 "../src/Style.vala"
	_g_object_unref0 (self->priv->_node_border);
#line 32 "../src/Style.vala"
	self->priv->_node_border = _tmp0_;
#line 3753 "Style.c"
}

gint*
style_get_node_width (Style* self)
{
	gint* result;
	gint* _tmp0_;
#line 33 "../src/Style.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../src/Style.vala"
	_tmp0_ = self->priv->_node_width;
#line 33 "../src/Style.vala"
	result = _tmp0_;
#line 33 "../src/Style.vala"
	return result;
#line 3769 "Style.c"
}

void
style_set_node_width (Style* self,
                      gint* value)
{
	gint* _tmp0_;
#line 33 "../src/Style.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/Style.vala"
	_tmp0_ = __int_dup0 (value);
#line 33 "../src/Style.vala"
	_g_free0 (self->priv->_node_width);
#line 33 "../src/Style.vala"
	self->priv->_node_width = _tmp0_;
#line 3785 "Style.c"
}

gint*
style_get_node_borderwidth (Style* self)
{
	gint* result;
	gint* _tmp0_;
#line 34 "../src/Style.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../src/Style.vala"
	_tmp0_ = self->priv->_node_borderwidth;
#line 34 "../src/Style.vala"
	result = _tmp0_;
#line 34 "../src/Style.vala"
	return result;
#line 3801 "Style.c"
}

void
style_set_node_borderwidth (Style* self,
                            gint* value)
{
	gint* _tmp0_;
#line 34 "../src/Style.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/Style.vala"
	_tmp0_ = __int_dup0 (value);
#line 34 "../src/Style.vala"
	_g_free0 (self->priv->_node_borderwidth);
#line 34 "../src/Style.vala"
	self->priv->_node_borderwidth = _tmp0_;
#line 3817 "Style.c"
}

gboolean*
style_get_node_fill (Style* self)
{
	gboolean* result;
	gboolean* _tmp0_;
#line 35 "../src/Style.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../src/Style.vala"
	_tmp0_ = self->priv->_node_fill;
#line 35 "../src/Style.vala"
	result = _tmp0_;
#line 35 "../src/Style.vala"
	return result;
#line 3833 "Style.c"
}

void
style_set_node_fill (Style* self,
                     gboolean* value)
{
	gboolean* _tmp0_;
#line 35 "../src/Style.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/Style.vala"
	_tmp0_ = __bool_dup0 (value);
#line 35 "../src/Style.vala"
	_g_free0 (self->priv->_node_fill);
#line 35 "../src/Style.vala"
	self->priv->_node_fill = _tmp0_;
#line 3849 "Style.c"
}

gint*
style_get_node_margin (Style* self)
{
	gint* result;
	gint* _tmp0_;
#line 36 "../src/Style.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "../src/Style.vala"
	_tmp0_ = self->priv->_node_margin;
#line 36 "../src/Style.vala"
	result = _tmp0_;
#line 36 "../src/Style.vala"
	return result;
#line 3865 "Style.c"
}

void
style_set_node_margin (Style* self,
                       gint* value)
{
	gint* _tmp0_;
#line 36 "../src/Style.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/Style.vala"
	_tmp0_ = __int_dup0 (value);
#line 36 "../src/Style.vala"
	_g_free0 (self->priv->_node_margin);
#line 36 "../src/Style.vala"
	self->priv->_node_margin = _tmp0_;
#line 3881 "Style.c"
}

gint*
style_get_node_padding (Style* self)
{
	gint* result;
	gint* _tmp0_;
#line 37 "../src/Style.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "../src/Style.vala"
	_tmp0_ = self->priv->_node_padding;
#line 37 "../src/Style.vala"
	result = _tmp0_;
#line 37 "../src/Style.vala"
	return result;
#line 3897 "Style.c"
}

void
style_set_node_padding (Style* self,
                        gint* value)
{
	gint* _tmp0_;
#line 37 "../src/Style.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/Style.vala"
	_tmp0_ = __int_dup0 (value);
#line 37 "../src/Style.vala"
	_g_free0 (self->priv->_node_padding);
#line 37 "../src/Style.vala"
	self->priv->_node_padding = _tmp0_;
#line 3913 "Style.c"
}

PangoFontDescription*
style_get_node_font (Style* self)
{
	PangoFontDescription* result;
	PangoFontDescription* _tmp0_;
#line 38 "../src/Style.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../src/Style.vala"
	_tmp0_ = self->priv->_node_font;
#line 38 "../src/Style.vala"
	result = _tmp0_;
#line 38 "../src/Style.vala"
	return result;
#line 3929 "Style.c"
}

static PangoFontDescription*
_vala_PangoFontDescription_copy (PangoFontDescription* self)
{
#line 38 "../src/Style.vala"
	return g_boxed_copy (pango_font_description_get_type (), self);
#line 3937 "Style.c"
}

static gpointer
__vala_PangoFontDescription_copy0 (gpointer self)
{
#line 38 "../src/Style.vala"
	return self ? _vala_PangoFontDescription_copy (self) : NULL;
#line 3945 "Style.c"
}

void
style_set_node_font (Style* self,
                     PangoFontDescription* value)
{
	PangoFontDescription* _tmp0_;
#line 38 "../src/Style.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/Style.vala"
	_tmp0_ = __vala_PangoFontDescription_copy0 (value);
#line 38 "../src/Style.vala"
	__vala_PangoFontDescription_free0 (self->priv->_node_font);
#line 38 "../src/Style.vala"
	self->priv->_node_font = _tmp0_;
#line 3961 "Style.c"
}

gboolean*
style_get_node_markup (Style* self)
{
	gboolean* result;
	gboolean* _tmp0_;
#line 39 "../src/Style.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../src/Style.vala"
	_tmp0_ = self->priv->_node_markup;
#line 39 "../src/Style.vala"
	result = _tmp0_;
#line 39 "../src/Style.vala"
	return result;
#line 3977 "Style.c"
}

void
style_set_node_markup (Style* self,
                       gboolean* value)
{
	gboolean* _tmp0_;
#line 39 "../src/Style.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/Style.vala"
	_tmp0_ = __bool_dup0 (value);
#line 39 "../src/Style.vala"
	_g_free0 (self->priv->_node_markup);
#line 39 "../src/Style.vala"
	self->priv->_node_markup = _tmp0_;
#line 3993 "Style.c"
}

LinkDash*
style_get_connection_dash (Style* self)
{
	LinkDash* result;
	LinkDash* _tmp0_;
#line 40 "../src/Style.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "../src/Style.vala"
	_tmp0_ = self->priv->_connection_dash;
#line 40 "../src/Style.vala"
	result = _tmp0_;
#line 40 "../src/Style.vala"
	return result;
#line 4009 "Style.c"
}

void
style_set_connection_dash (Style* self,
                           LinkDash* value)
{
	LinkDash* _tmp0_;
#line 40 "../src/Style.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/Style.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 40 "../src/Style.vala"
	_g_object_unref0 (self->priv->_connection_dash);
#line 40 "../src/Style.vala"
	self->priv->_connection_dash = _tmp0_;
#line 4025 "Style.c"
}

gint*
style_get_connection_width (Style* self)
{
	gint* result;
	gint* _tmp0_;
#line 41 "../src/Style.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "../src/Style.vala"
	_tmp0_ = self->priv->_connection_width;
#line 41 "../src/Style.vala"
	result = _tmp0_;
#line 41 "../src/Style.vala"
	return result;
#line 4041 "Style.c"
}

void
style_set_connection_width (Style* self,
                            gint* value)
{
	gint* _tmp0_;
#line 41 "../src/Style.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/Style.vala"
	_tmp0_ = __int_dup0 (value);
#line 41 "../src/Style.vala"
	_g_free0 (self->priv->_connection_width);
#line 41 "../src/Style.vala"
	self->priv->_connection_width = _tmp0_;
#line 4057 "Style.c"
}

const gchar*
style_get_connection_arrow (Style* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 42 "../src/Style.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "../src/Style.vala"
	_tmp0_ = self->priv->_connection_arrow;
#line 42 "../src/Style.vala"
	result = _tmp0_;
#line 42 "../src/Style.vala"
	return result;
#line 4073 "Style.c"
}

void
style_set_connection_arrow (Style* self,
                            const gchar* value)
{
	gchar* _tmp0_;
#line 42 "../src/Style.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/Style.vala"
	_tmp0_ = g_strdup (value);
#line 42 "../src/Style.vala"
	_g_free0 (self->priv->_connection_arrow);
#line 42 "../src/Style.vala"
	self->priv->_connection_arrow = _tmp0_;
#line 4089 "Style.c"
}

gint*
style_get_connection_padding (Style* self)
{
	gint* result;
	gint* _tmp0_;
#line 43 "../src/Style.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "../src/Style.vala"
	_tmp0_ = self->priv->_connection_padding;
#line 43 "../src/Style.vala"
	result = _tmp0_;
#line 43 "../src/Style.vala"
	return result;
#line 4105 "Style.c"
}

void
style_set_connection_padding (Style* self,
                              gint* value)
{
	gint* _tmp0_;
#line 43 "../src/Style.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/Style.vala"
	_tmp0_ = __int_dup0 (value);
#line 43 "../src/Style.vala"
	_g_free0 (self->priv->_connection_padding);
#line 43 "../src/Style.vala"
	self->priv->_connection_padding = _tmp0_;
#line 4121 "Style.c"
}

PangoFontDescription*
style_get_connection_font (Style* self)
{
	PangoFontDescription* result;
	PangoFontDescription* _tmp0_;
#line 44 "../src/Style.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "../src/Style.vala"
	_tmp0_ = self->priv->_connection_font;
#line 44 "../src/Style.vala"
	result = _tmp0_;
#line 44 "../src/Style.vala"
	return result;
#line 4137 "Style.c"
}

void
style_set_connection_font (Style* self,
                           PangoFontDescription* value)
{
	PangoFontDescription* _tmp0_;
#line 44 "../src/Style.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/Style.vala"
	_tmp0_ = __vala_PangoFontDescription_copy0 (value);
#line 44 "../src/Style.vala"
	__vala_PangoFontDescription_free0 (self->priv->_connection_font);
#line 44 "../src/Style.vala"
	self->priv->_connection_font = _tmp0_;
#line 4153 "Style.c"
}

static void
value_style_init (GValue* value)
{
#line 24 "../src/Style.vala"
	value->data[0].v_pointer = NULL;
#line 4161 "Style.c"
}

static void
value_style_free_value (GValue* value)
{
#line 24 "../src/Style.vala"
	if (value->data[0].v_pointer) {
#line 24 "../src/Style.vala"
		style_unref (value->data[0].v_pointer);
#line 4171 "Style.c"
	}
}

static void
value_style_copy_value (const GValue* src_value,
                        GValue* dest_value)
{
#line 24 "../src/Style.vala"
	if (src_value->data[0].v_pointer) {
#line 24 "../src/Style.vala"
		dest_value->data[0].v_pointer = style_ref (src_value->data[0].v_pointer);
#line 4183 "Style.c"
	} else {
#line 24 "../src/Style.vala"
		dest_value->data[0].v_pointer = NULL;
#line 4187 "Style.c"
	}
}

static gpointer
value_style_peek_pointer (const GValue* value)
{
#line 24 "../src/Style.vala"
	return value->data[0].v_pointer;
#line 4196 "Style.c"
}

static gchar*
value_style_collect_value (GValue* value,
                           guint n_collect_values,
                           GTypeCValue* collect_values,
                           guint collect_flags)
{
#line 24 "../src/Style.vala"
	if (collect_values[0].v_pointer) {
#line 4207 "Style.c"
		Style * object;
		object = collect_values[0].v_pointer;
#line 24 "../src/Style.vala"
		if (object->parent_instance.g_class == NULL) {
#line 24 "../src/Style.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4214 "Style.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 24 "../src/Style.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4218 "Style.c"
		}
#line 24 "../src/Style.vala"
		value->data[0].v_pointer = style_ref (object);
#line 4222 "Style.c"
	} else {
#line 24 "../src/Style.vala"
		value->data[0].v_pointer = NULL;
#line 4226 "Style.c"
	}
#line 24 "../src/Style.vala"
	return NULL;
#line 4230 "Style.c"
}

static gchar*
value_style_lcopy_value (const GValue* value,
                         guint n_collect_values,
                         GTypeCValue* collect_values,
                         guint collect_flags)
{
	Style ** object_p;
	object_p = collect_values[0].v_pointer;
#line 24 "../src/Style.vala"
	if (!object_p) {
#line 24 "../src/Style.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 4245 "Style.c"
	}
#line 24 "../src/Style.vala"
	if (!value->data[0].v_pointer) {
#line 24 "../src/Style.vala"
		*object_p = NULL;
#line 4251 "Style.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 24 "../src/Style.vala"
		*object_p = value->data[0].v_pointer;
#line 4255 "Style.c"
	} else {
#line 24 "../src/Style.vala"
		*object_p = style_ref (value->data[0].v_pointer);
#line 4259 "Style.c"
	}
#line 24 "../src/Style.vala"
	return NULL;
#line 4263 "Style.c"
}

GParamSpec*
param_spec_style (const gchar* name,
                  const gchar* nick,
                  const gchar* blurb,
                  GType object_type,
                  GParamFlags flags)
{
	ParamSpecStyle* spec;
#line 24 "../src/Style.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_STYLE), NULL);
#line 24 "../src/Style.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 24 "../src/Style.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 24 "../src/Style.vala"
	return G_PARAM_SPEC (spec);
#line 4282 "Style.c"
}

gpointer
value_get_style (const GValue* value)
{
#line 24 "../src/Style.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_STYLE), NULL);
#line 24 "../src/Style.vala"
	return value->data[0].v_pointer;
#line 4292 "Style.c"
}

void
value_set_style (GValue* value,
                 gpointer v_object)
{
	Style * old;
#line 24 "../src/Style.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_STYLE));
#line 24 "../src/Style.vala"
	old = value->data[0].v_pointer;
#line 24 "../src/Style.vala"
	if (v_object) {
#line 24 "../src/Style.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_STYLE));
#line 24 "../src/Style.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 24 "../src/Style.vala"
		value->data[0].v_pointer = v_object;
#line 24 "../src/Style.vala"
		style_ref (value->data[0].v_pointer);
#line 4314 "Style.c"
	} else {
#line 24 "../src/Style.vala"
		value->data[0].v_pointer = NULL;
#line 4318 "Style.c"
	}
#line 24 "../src/Style.vala"
	if (old) {
#line 24 "../src/Style.vala"
		style_unref (old);
#line 4324 "Style.c"
	}
}

void
value_take_style (GValue* value,
                  gpointer v_object)
{
	Style * old;
#line 24 "../src/Style.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_STYLE));
#line 24 "../src/Style.vala"
	old = value->data[0].v_pointer;
#line 24 "../src/Style.vala"
	if (v_object) {
#line 24 "../src/Style.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_STYLE));
#line 24 "../src/Style.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 24 "../src/Style.vala"
		value->data[0].v_pointer = v_object;
#line 4345 "Style.c"
	} else {
#line 24 "../src/Style.vala"
		value->data[0].v_pointer = NULL;
#line 4349 "Style.c"
	}
#line 24 "../src/Style.vala"
	if (old) {
#line 24 "../src/Style.vala"
		style_unref (old);
#line 4355 "Style.c"
	}
}

static void
style_class_init (StyleClass * klass,
                  gpointer klass_data)
{
#line 24 "../src/Style.vala"
	style_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/Style.vala"
	((StyleClass *) klass)->finalize = style_finalize;
#line 24 "../src/Style.vala"
	g_type_class_adjust_private_offset (klass, &Style_private_offset);
#line 4369 "Style.c"
}

static void
style_instance_init (Style * self,
                     gpointer klass)
{
#line 24 "../src/Style.vala"
	self->priv = style_get_instance_private (self);
#line 28 "../src/Style.vala"
	self->priv->_link_type = NULL;
#line 29 "../src/Style.vala"
	self->priv->_link_width = NULL;
#line 30 "../src/Style.vala"
	self->priv->_link_arrow = NULL;
#line 31 "../src/Style.vala"
	self->priv->_link_dash = NULL;
#line 32 "../src/Style.vala"
	self->priv->_node_border = NULL;
#line 33 "../src/Style.vala"
	self->priv->_node_width = NULL;
#line 34 "../src/Style.vala"
	self->priv->_node_borderwidth = NULL;
#line 35 "../src/Style.vala"
	self->priv->_node_fill = NULL;
#line 36 "../src/Style.vala"
	self->priv->_node_margin = NULL;
#line 37 "../src/Style.vala"
	self->priv->_node_padding = NULL;
#line 38 "../src/Style.vala"
	self->priv->_node_font = NULL;
#line 39 "../src/Style.vala"
	self->priv->_node_markup = NULL;
#line 40 "../src/Style.vala"
	self->priv->_connection_dash = NULL;
#line 41 "../src/Style.vala"
	self->priv->_connection_width = NULL;
#line 42 "../src/Style.vala"
	self->priv->_connection_arrow = NULL;
#line 43 "../src/Style.vala"
	self->priv->_connection_padding = NULL;
#line 44 "../src/Style.vala"
	self->priv->_connection_font = NULL;
#line 24 "../src/Style.vala"
	self->ref_count = 1;
#line 4414 "Style.c"
}

static void
style_finalize (Style * obj)
{
	Style * self;
#line 24 "../src/Style.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_STYLE, Style);
#line 24 "../src/Style.vala"
	g_signal_handlers_destroy (self);
#line 28 "../src/Style.vala"
	_g_object_unref0 (self->priv->_link_type);
#line 29 "../src/Style.vala"
	_g_free0 (self->priv->_link_width);
#line 30 "../src/Style.vala"
	_g_free0 (self->priv->_link_arrow);
#line 31 "../src/Style.vala"
	_g_object_unref0 (self->priv->_link_dash);
#line 32 "../src/Style.vala"
	_g_object_unref0 (self->priv->_node_border);
#line 33 "../src/Style.vala"
	_g_free0 (self->priv->_node_width);
#line 34 "../src/Style.vala"
	_g_free0 (self->priv->_node_borderwidth);
#line 35 "../src/Style.vala"
	_g_free0 (self->priv->_node_fill);
#line 36 "../src/Style.vala"
	_g_free0 (self->priv->_node_margin);
#line 37 "../src/Style.vala"
	_g_free0 (self->priv->_node_padding);
#line 38 "../src/Style.vala"
	__vala_PangoFontDescription_free0 (self->priv->_node_font);
#line 39 "../src/Style.vala"
	_g_free0 (self->priv->_node_markup);
#line 40 "../src/Style.vala"
	_g_object_unref0 (self->priv->_connection_dash);
#line 41 "../src/Style.vala"
	_g_free0 (self->priv->_connection_width);
#line 42 "../src/Style.vala"
	_g_free0 (self->priv->_connection_arrow);
#line 43 "../src/Style.vala"
	_g_free0 (self->priv->_connection_padding);
#line 44 "../src/Style.vala"
	__vala_PangoFontDescription_free0 (self->priv->_connection_font);
#line 4459 "Style.c"
}

GType
style_get_type (void)
{
	static volatile gsize style_type_id__volatile = 0;
	if (g_once_init_enter (&style_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_style_init, value_style_free_value, value_style_copy_value, value_style_peek_pointer, "p", value_style_collect_value, "p", value_style_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (StyleClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) style_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Style), 0, (GInstanceInitFunc) style_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType style_type_id;
		style_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Style", &g_define_type_info, &g_define_type_fundamental_info, 0);
		Style_private_offset = g_type_add_instance_private (style_type_id, sizeof (StylePrivate));
		g_once_init_leave (&style_type_id__volatile, style_type_id);
	}
	return style_type_id__volatile;
}

gpointer
style_ref (gpointer instance)
{
	Style * self;
	self = instance;
#line 24 "../src/Style.vala"
	g_atomic_int_inc (&self->ref_count);
#line 24 "../src/Style.vala"
	return instance;
#line 4487 "Style.c"
}

void
style_unref (gpointer instance)
{
	Style * self;
	self = instance;
#line 24 "../src/Style.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 24 "../src/Style.vala"
		STYLE_GET_CLASS (self)->finalize (self);
#line 24 "../src/Style.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 4501 "Style.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

