/* Theme.c generated by valac 0.45.3, the Vala compiler
 * generated from Theme.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <stdio.h>
#include <cairo.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>
#include <pango/pangocairo.h>

#define TYPE_THEME (theme_get_type ())
#define THEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME, Theme))
#define THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME, ThemeClass))
#define IS_THEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME))
#define IS_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME))
#define THEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME, ThemeClass))

typedef struct _Theme Theme;
typedef struct _ThemeClass ThemeClass;
typedef struct _ThemePrivate ThemePrivate;
enum  {
	THEME_0_PROPERTY,
	THEME_NAME_PROPERTY,
	THEME_ICON_PROPERTY,
	THEME_BACKGROUND_PROPERTY,
	THEME_FOREGROUND_PROPERTY,
	THEME_ROOT_BACKGROUND_PROPERTY,
	THEME_ROOT_FOREGROUND_PROPERTY,
	THEME_NODESEL_BACKGROUND_PROPERTY,
	THEME_NODESEL_FOREGROUND_PROPERTY,
	THEME_TEXTSEL_BACKGROUND_PROPERTY,
	THEME_TEXTSEL_FOREGROUND_PROPERTY,
	THEME_TEXT_CURSOR_PROPERTY,
	THEME_ATTACHABLE_COLOR_PROPERTY,
	THEME_CONNECTION_COLOR_PROPERTY,
	THEME_PREFER_DARK_PROPERTY,
	THEME_INDEX_PROPERTY,
	THEME_NUM_PROPERTIES
};
static GParamSpec* theme_properties[THEME_NUM_PROPERTIES];
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))

struct _Theme {
	GObject parent_instance;
	ThemePrivate * priv;
};

struct _ThemeClass {
	GObjectClass parent_class;
};

struct _ThemePrivate {
	gint _index;
	GArray* _link_colors;
	gchar* _name;
	GtkImage* _icon;
	GdkRGBA _background;
	GdkRGBA _foreground;
	GdkRGBA _root_background;
	GdkRGBA _root_foreground;
	GdkRGBA _nodesel_background;
	GdkRGBA _nodesel_foreground;
	GdkRGBA _textsel_background;
	GdkRGBA _textsel_foreground;
	GdkRGBA _text_cursor;
	GdkRGBA _attachable_color;
	GdkRGBA _connection_color;
	gboolean _prefer_dark;
};

static gint Theme_private_offset;
static gpointer theme_parent_class = NULL;

GType theme_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Theme, g_object_unref)
Theme* theme_new (void);
Theme* theme_construct (GType object_type);
static void _g_free0_ (gpointer var);
static void _vala_GdkRGBA_free_function_content_of (gpointer data);
void theme_add_link_color (Theme* self,
                           GdkRGBA* color);
static GdkRGBA* _gdk_rgba_dup (GdkRGBA* self);
void theme_next_color (Theme* self,
                       GdkRGBA* result);
gint theme_num_link_colors (Theme* self);
void theme_link_color (Theme* self,
                       gint index,
                       GdkRGBA* result);
gint theme_get_color_index (Theme* self,
                            GdkRGBA* color);
void theme_get_color (Theme* self,
                      const gchar* value,
                      GdkRGBA* result);
GtkCssProvider* theme_get_css_provider (Theme* self);
void theme_get_background (Theme* self,
                           GdkRGBA * result);
static void theme_set_context_color (Theme* self,
                              cairo_t* ctx,
                              GdkRGBA* color);
cairo_surface_t* theme_make_icon (Theme* self);
const gchar* theme_get_name (Theme* self);
void theme_get_root_background (Theme* self,
                                GdkRGBA * result);
void theme_get_root_foreground (Theme* self,
                                GdkRGBA * result);
void theme_get_foreground (Theme* self,
                           GdkRGBA * result);
void theme_get_connection_color (Theme* self,
                                 GdkRGBA * result);
void connection_draw_arrow (cairo_t* ctx,
                            gint line_width,
                            gdouble tipx,
                            gdouble tipy,
                            gdouble tailx,
                            gdouble taily,
                            gdouble arrowLength);
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
void theme_set_name (Theme* self,
                     const gchar* value);
GtkImage* theme_get_icon (Theme* self);
void theme_set_icon (Theme* self,
                     GtkImage* value);
void theme_set_background (Theme* self,
                           GdkRGBA * value);
static gboolean _gdk_rgba_equal (const GdkRGBA * s1,
                          const GdkRGBA * s2);
void theme_set_foreground (Theme* self,
                           GdkRGBA * value);
void theme_set_root_background (Theme* self,
                                GdkRGBA * value);
void theme_set_root_foreground (Theme* self,
                                GdkRGBA * value);
void theme_get_nodesel_background (Theme* self,
                                   GdkRGBA * result);
void theme_set_nodesel_background (Theme* self,
                                   GdkRGBA * value);
void theme_get_nodesel_foreground (Theme* self,
                                   GdkRGBA * result);
void theme_set_nodesel_foreground (Theme* self,
                                   GdkRGBA * value);
void theme_get_textsel_background (Theme* self,
                                   GdkRGBA * result);
void theme_set_textsel_background (Theme* self,
                                   GdkRGBA * value);
void theme_get_textsel_foreground (Theme* self,
                                   GdkRGBA * result);
void theme_set_textsel_foreground (Theme* self,
                                   GdkRGBA * value);
void theme_get_text_cursor (Theme* self,
                            GdkRGBA * result);
void theme_set_text_cursor (Theme* self,
                            GdkRGBA * value);
void theme_get_attachable_color (Theme* self,
                                 GdkRGBA * result);
void theme_set_attachable_color (Theme* self,
                                 GdkRGBA * value);
void theme_set_connection_color (Theme* self,
                                 GdkRGBA * value);
gboolean theme_get_prefer_dark (Theme* self);
void theme_set_prefer_dark (Theme* self,
                            gboolean value);
gint theme_get_index (Theme* self);
void theme_set_index (Theme* self,
                      gint value);
static void theme_finalize (GObject * obj);
static void _vala_theme_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec);
static void _vala_theme_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec);

static inline gpointer
theme_get_instance_private (Theme* self)
{
	return G_STRUCT_MEMBER_P (self, Theme_private_offset);
}

static void
_g_free0_ (gpointer var)
{
#line 57 "../src/Theme.vala"
	(var == NULL) ? NULL : (var = (g_free (var), NULL));
#line 220 "Theme.c"
}

static void
_vala_GdkRGBA_free_function_content_of (gpointer data)
{
	GdkRGBA* self;
#line 57 "../src/Theme.vala"
	self = *((GdkRGBA**) data);
#line 57 "../src/Theme.vala"
	_g_free0_ (self);
#line 231 "Theme.c"
}

Theme*
theme_construct (GType object_type)
{
	Theme * self = NULL;
	GArray* _tmp0_;
#line 55 "../src/Theme.vala"
	self = (Theme*) g_object_new (object_type, NULL);
#line 56 "../src/Theme.vala"
	self->priv->_index = 0;
#line 57 "../src/Theme.vala"
	_tmp0_ = g_array_new (TRUE, TRUE, sizeof (GdkRGBA*));
#line 57 "../src/Theme.vala"
	g_array_set_clear_func (_tmp0_, (GDestroyNotify) _vala_GdkRGBA_free_function_content_of);
#line 57 "../src/Theme.vala"
	_g_array_unref0 (self->priv->_link_colors);
#line 57 "../src/Theme.vala"
	self->priv->_link_colors = _tmp0_;
#line 55 "../src/Theme.vala"
	return self;
#line 253 "Theme.c"
}

Theme*
theme_new (void)
{
#line 55 "../src/Theme.vala"
	return theme_construct (TYPE_THEME);
#line 261 "Theme.c"
}

static GdkRGBA*
_gdk_rgba_dup (GdkRGBA* self)
{
	GdkRGBA* dup;
#line 62 "../src/Theme.vala"
	dup = g_new0 (GdkRGBA, 1);
#line 62 "../src/Theme.vala"
	memcpy (dup, self, sizeof (GdkRGBA));
#line 62 "../src/Theme.vala"
	return dup;
#line 274 "Theme.c"
}

static gpointer
__gdk_rgba_dup0 (gpointer self)
{
#line 62 "../src/Theme.vala"
	return self ? _gdk_rgba_dup (self) : NULL;
#line 282 "Theme.c"
}

void
theme_add_link_color (Theme* self,
                      GdkRGBA* color)
{
	GArray* _tmp0_;
	GdkRGBA _tmp1_;
	GdkRGBA* _tmp2_;
#line 61 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 61 "../src/Theme.vala"
	g_return_if_fail (color != NULL);
#line 62 "../src/Theme.vala"
	_tmp0_ = self->priv->_link_colors;
#line 62 "../src/Theme.vala"
	_tmp1_ = *color;
#line 62 "../src/Theme.vala"
	_tmp2_ = __gdk_rgba_dup0 (&_tmp1_);
#line 62 "../src/Theme.vala"
	g_array_append_val (_tmp0_, _tmp2_);
#line 304 "Theme.c"
}

void
theme_next_color (Theme* self,
                  GdkRGBA* result)
{
	GArray* _tmp0_;
	gint _tmp1_;
	GArray* _tmp2_;
#line 66 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 67 "../src/Theme.vala"
	_tmp0_ = self->priv->_link_colors;
#line 67 "../src/Theme.vala"
	_tmp1_ = self->priv->_index;
#line 67 "../src/Theme.vala"
	self->priv->_index = _tmp1_ + 1;
#line 67 "../src/Theme.vala"
	_tmp2_ = self->priv->_link_colors;
#line 67 "../src/Theme.vala"
	*result = *g_array_index (_tmp0_, GdkRGBA*, _tmp1_ % _tmp2_->len);
#line 67 "../src/Theme.vala"
	return;
#line 328 "Theme.c"
}

gint
theme_num_link_colors (Theme* self)
{
	gint result = 0;
	GArray* _tmp0_;
#line 71 "../src/Theme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 72 "../src/Theme.vala"
	_tmp0_ = self->priv->_link_colors;
#line 72 "../src/Theme.vala"
	result = (gint) _tmp0_->len;
#line 72 "../src/Theme.vala"
	return result;
#line 344 "Theme.c"
}

void
theme_link_color (Theme* self,
                  gint index,
                  GdkRGBA* result)
{
	GArray* _tmp0_;
	GArray* _tmp1_;
#line 76 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 77 "../src/Theme.vala"
	_tmp0_ = self->priv->_link_colors;
#line 77 "../src/Theme.vala"
	_tmp1_ = self->priv->_link_colors;
#line 77 "../src/Theme.vala"
	*result = *g_array_index (_tmp0_, GdkRGBA*, index % _tmp1_->len);
#line 77 "../src/Theme.vala"
	return;
#line 364 "Theme.c"
}

gint
theme_get_color_index (Theme* self,
                       GdkRGBA* color)
{
	gint result = 0;
	gchar* color_str = NULL;
	gchar* _tmp0_;
#line 85 "../src/Theme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 85 "../src/Theme.vala"
	g_return_val_if_fail (color != NULL, 0);
#line 86 "../src/Theme.vala"
	_tmp0_ = gdk_rgba_to_string (color);
#line 86 "../src/Theme.vala"
	color_str = _tmp0_;
#line 382 "Theme.c"
	{
		gint i = 0;
#line 87 "../src/Theme.vala"
		i = 0;
#line 387 "Theme.c"
		{
			gboolean _tmp1_ = FALSE;
#line 87 "../src/Theme.vala"
			_tmp1_ = TRUE;
#line 87 "../src/Theme.vala"
			while (TRUE) {
#line 394 "Theme.c"
				GArray* _tmp3_;
				GArray* _tmp4_;
				GdkRGBA _tmp5_;
				gchar* _tmp6_;
				gchar* _tmp7_;
				const gchar* _tmp8_;
				gboolean _tmp9_;
#line 87 "../src/Theme.vala"
				if (!_tmp1_) {
#line 404 "Theme.c"
					gint _tmp2_;
#line 87 "../src/Theme.vala"
					_tmp2_ = i;
#line 87 "../src/Theme.vala"
					i = _tmp2_ + 1;
#line 410 "Theme.c"
				}
#line 87 "../src/Theme.vala"
				_tmp1_ = FALSE;
#line 87 "../src/Theme.vala"
				_tmp3_ = self->priv->_link_colors;
#line 87 "../src/Theme.vala"
				if (!(((guint) i) < _tmp3_->len)) {
#line 87 "../src/Theme.vala"
					break;
#line 420 "Theme.c"
				}
#line 88 "../src/Theme.vala"
				_tmp4_ = self->priv->_link_colors;
#line 88 "../src/Theme.vala"
				_tmp5_ = *g_array_index (_tmp4_, GdkRGBA*, (guint) i);
#line 88 "../src/Theme.vala"
				_tmp6_ = gdk_rgba_to_string (&_tmp5_);
#line 88 "../src/Theme.vala"
				_tmp7_ = _tmp6_;
#line 88 "../src/Theme.vala"
				_tmp8_ = color_str;
#line 88 "../src/Theme.vala"
				_tmp9_ = g_strcmp0 (_tmp7_, _tmp8_) == 0;
#line 88 "../src/Theme.vala"
				_g_free0 (_tmp7_);
#line 88 "../src/Theme.vala"
				if (_tmp9_) {
#line 89 "../src/Theme.vala"
					result = i;
#line 89 "../src/Theme.vala"
					_g_free0 (color_str);
#line 89 "../src/Theme.vala"
					return result;
#line 444 "Theme.c"
				}
			}
		}
	}
#line 92 "../src/Theme.vala"
	result = -1;
#line 92 "../src/Theme.vala"
	_g_free0 (color_str);
#line 92 "../src/Theme.vala"
	return result;
#line 455 "Theme.c"
}

void
theme_get_color (Theme* self,
                 const gchar* value,
                 GdkRGBA* result)
{
	GdkRGBA c = {0};
	GdkRGBA _tmp0_ = {0};
#line 96 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 96 "../src/Theme.vala"
	g_return_if_fail (value != NULL);
#line 97 "../src/Theme.vala"
	_tmp0_.red = 1.0;
#line 97 "../src/Theme.vala"
	_tmp0_.green = 1.0;
#line 97 "../src/Theme.vala"
	_tmp0_.blue = 1.0;
#line 97 "../src/Theme.vala"
	_tmp0_.alpha = 1.0;
#line 97 "../src/Theme.vala"
	c = _tmp0_;
#line 98 "../src/Theme.vala"
	gdk_rgba_parse (&c, value);
#line 99 "../src/Theme.vala"
	*result = c;
#line 99 "../src/Theme.vala"
	return;
#line 485 "Theme.c"
}

GtkCssProvider*
theme_get_css_provider (Theme* self)
{
	GtkCssProvider* result = NULL;
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 103 "../src/Theme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 104 "../src/Theme.vala"
	_tmp0_ = gtk_css_provider_new ();
#line 104 "../src/Theme.vala"
	provider = _tmp0_;
#line 501 "Theme.c"
	{
		gchar* css_data = NULL;
		GdkRGBA _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 106 "../src/Theme.vala"
		_tmp1_ = self->priv->_background;
#line 106 "../src/Theme.vala"
		_tmp2_ = gdk_rgba_to_string (&_tmp1_);
#line 106 "../src/Theme.vala"
		_tmp3_ = _tmp2_;
#line 106 "../src/Theme.vala"
		_tmp4_ = g_strconcat ("@define-color colorPrimary #603461; " "@define-color textColorPrimary @SILVER_100; " "@define-color colorAccent #603461; " ".theme-selected { background: #087DFF; } " ".canvas { background: ", _tmp3_, NULL);
#line 106 "../src/Theme.vala"
		_tmp5_ = _tmp4_;
#line 106 "../src/Theme.vala"
		_tmp6_ = g_strconcat (_tmp5_, "; }", NULL);
#line 106 "../src/Theme.vala"
		_tmp7_ = _tmp6_;
#line 106 "../src/Theme.vala"
		_g_free0 (_tmp5_);
#line 106 "../src/Theme.vala"
		_g_free0 (_tmp3_);
#line 106 "../src/Theme.vala"
		css_data = _tmp7_;
#line 112 "../src/Theme.vala"
		gtk_css_provider_load_from_data (provider, css_data, (gssize) -1, &_inner_error0_);
#line 112 "../src/Theme.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 112 "../src/Theme.vala"
			_g_free0 (css_data);
#line 537 "Theme.c"
			goto __catch23_g_error;
		}
#line 105 "../src/Theme.vala"
		_g_free0 (css_data);
#line 542 "Theme.c"
	}
	goto __finally23;
	__catch23_g_error:
	{
		GError* e = NULL;
		FILE* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 105 "../src/Theme.vala"
		e = _inner_error0_;
#line 105 "../src/Theme.vala"
		_inner_error0_ = NULL;
#line 114 "../src/Theme.vala"
		_tmp8_ = stdout;
#line 114 "../src/Theme.vala"
		_tmp9_ = e;
#line 114 "../src/Theme.vala"
		_tmp10_ = _tmp9_->message;
#line 114 "../src/Theme.vala"
		fprintf (_tmp8_, "Unable to load background color: %s", _tmp10_);
#line 105 "../src/Theme.vala"
		_g_error_free0 (e);
#line 565 "Theme.c"
	}
	__finally23:
#line 105 "../src/Theme.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 105 "../src/Theme.vala"
		_g_object_unref0 (provider);
#line 105 "../src/Theme.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 105 "../src/Theme.vala"
		g_clear_error (&_inner_error0_);
#line 105 "../src/Theme.vala"
		return NULL;
#line 578 "Theme.c"
	}
#line 116 "../src/Theme.vala"
	result = provider;
#line 116 "../src/Theme.vala"
	return result;
#line 584 "Theme.c"
}

static void
theme_set_context_color (Theme* self,
                         cairo_t* ctx,
                         GdkRGBA* color)
{
	GdkRGBA _tmp0_;
	GdkRGBA _tmp1_;
	GdkRGBA _tmp2_;
	GdkRGBA _tmp3_;
#line 120 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 120 "../src/Theme.vala"
	g_return_if_fail (ctx != NULL);
#line 120 "../src/Theme.vala"
	g_return_if_fail (color != NULL);
#line 121 "../src/Theme.vala"
	_tmp0_ = *color;
#line 121 "../src/Theme.vala"
	_tmp1_ = *color;
#line 121 "../src/Theme.vala"
	_tmp2_ = *color;
#line 121 "../src/Theme.vala"
	_tmp3_ = *color;
#line 121 "../src/Theme.vala"
	cairo_set_source_rgba (ctx, _tmp0_.red, _tmp1_.green, _tmp2_.blue, _tmp3_.alpha);
#line 612 "Theme.c"
}

static void
_vala_PangoFontDescription_free (PangoFontDescription* self)
{
#line 293 "../src/Theme.vala"
	g_boxed_free (pango_font_description_get_type (), self);
#line 620 "Theme.c"
}

cairo_surface_t*
theme_make_icon (Theme* self)
{
	cairo_surface_t* result = NULL;
	cairo_surface_t* surface = NULL;
	cairo_surface_t* _tmp0_;
	cairo_t* ctx = NULL;
	cairo_t* _tmp1_;
	gint width = 0;
	gint height = 0;
	PangoFontDescription* font_desc = NULL;
	PangoFontDescription* _tmp2_;
	GdkRGBA _tmp3_;
	GArray* _tmp4_;
	GdkRGBA _tmp5_;
	GArray* _tmp6_;
	GdkRGBA _tmp7_;
	GArray* _tmp8_;
	GdkRGBA _tmp9_;
	GArray* _tmp10_;
	GdkRGBA _tmp11_;
	GArray* _tmp12_;
	GdkRGBA _tmp13_;
	GArray* _tmp14_;
	GdkRGBA _tmp15_;
	GArray* _tmp16_;
	GdkRGBA _tmp17_;
	GArray* _tmp18_;
	GdkRGBA _tmp19_;
	GArray* _tmp20_;
	GdkRGBA _tmp21_;
	GArray* _tmp22_;
	GdkRGBA _tmp23_;
	PangoLayout* root_text = NULL;
	PangoLayout* _tmp24_;
	const gchar* _tmp25_;
	gint _tmp26_ = 0;
	gint _tmp27_ = 0;
	gdouble r = 0.0;
	gdouble x = 0.0;
	gdouble y = 0.0;
	gdouble w = 0.0;
	gdouble h = 0.0;
	GdkRGBA _tmp28_;
	PangoLayout* node_text = NULL;
	PangoLayout* _tmp29_;
	GdkRGBA _tmp30_;
	gint _tmp31_ = 0;
	gint _tmp32_ = 0;
	GdkRGBA _tmp33_;
	GdkRGBA _tmp34_;
	GdkRGBA _tmp35_;
	GdkRGBA _tmp36_;
	GdkRGBA _tmp37_;
	GdkRGBA _tmp38_;
	GdkRGBA _tmp39_;
	gdouble p[6] = {0};
	gdouble _tmp40_[6] = {0};
	gdouble* _tmp41_;
	gdouble* _tmp42_;
	gint _tmp42__length1;
	gdouble _tmp43_;
	gdouble _tmp44_;
	gdouble _tmp45_;
	gdouble _tmp46_;
	gdouble _tmp47_;
	gdouble _tmp48_;
	gdouble _tmp49_;
	gdouble _tmp50_;
	gdouble _tmp51_;
	gdouble _tmp52_;
	gdouble _tmp53_;
	gdouble _tmp54_;
	gdouble _tmp55_;
	gdouble _tmp56_;
	gdouble _tmp57_;
	gdouble _tmp58_;
	gdouble _tmp59_;
	gdouble _tmp60_;
	gdouble _tmp61_;
	gdouble _tmp62_;
#line 125 "../src/Theme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 127 "../src/Theme.vala"
	_tmp0_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, 200, 100);
#line 127 "../src/Theme.vala"
	surface = _tmp0_;
#line 128 "../src/Theme.vala"
	_tmp1_ = cairo_create (surface);
#line 128 "../src/Theme.vala"
	ctx = _tmp1_;
#line 131 "../src/Theme.vala"
	_tmp2_ = pango_font_description_new ();
#line 131 "../src/Theme.vala"
	font_desc = _tmp2_;
#line 132 "../src/Theme.vala"
	pango_font_description_set_family (font_desc, "Sans");
#line 133 "../src/Theme.vala"
	pango_font_description_set_size (font_desc, 10 * PANGO_SCALE);
#line 136 "../src/Theme.vala"
	_tmp3_ = self->priv->_background;
#line 136 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp3_);
#line 137 "../src/Theme.vala"
	cairo_rectangle (ctx, (gdouble) 0, (gdouble) 0, (gdouble) 200, (gdouble) 100);
#line 138 "../src/Theme.vala"
	cairo_fill (ctx);
#line 141 "../src/Theme.vala"
	_tmp4_ = self->priv->_link_colors;
#line 141 "../src/Theme.vala"
	_tmp5_ = *g_array_index (_tmp4_, GdkRGBA*, (guint) 0);
#line 141 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp5_);
#line 142 "../src/Theme.vala"
	cairo_set_line_cap (ctx, CAIRO_LINE_CAP_ROUND);
#line 143 "../src/Theme.vala"
	cairo_set_line_width (ctx, (gdouble) 4);
#line 144 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) 100, (gdouble) 50);
#line 145 "../src/Theme.vala"
	cairo_line_to (ctx, (gdouble) 50, (gdouble) 25);
#line 146 "../src/Theme.vala"
	cairo_stroke (ctx);
#line 147 "../src/Theme.vala"
	_tmp6_ = self->priv->_link_colors;
#line 147 "../src/Theme.vala"
	_tmp7_ = *g_array_index (_tmp6_, GdkRGBA*, (guint) 0);
#line 147 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp7_);
#line 148 "../src/Theme.vala"
	cairo_set_line_cap (ctx, CAIRO_LINE_CAP_ROUND);
#line 149 "../src/Theme.vala"
	cairo_set_line_width (ctx, (gdouble) 4);
#line 150 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) 50, (gdouble) 25);
#line 151 "../src/Theme.vala"
	cairo_line_to (ctx, (gdouble) 10, (gdouble) 25);
#line 152 "../src/Theme.vala"
	cairo_stroke (ctx);
#line 154 "../src/Theme.vala"
	_tmp8_ = self->priv->_link_colors;
#line 154 "../src/Theme.vala"
	_tmp9_ = *g_array_index (_tmp8_, GdkRGBA*, (guint) 1);
#line 154 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp9_);
#line 155 "../src/Theme.vala"
	cairo_set_line_cap (ctx, CAIRO_LINE_CAP_ROUND);
#line 156 "../src/Theme.vala"
	cairo_set_line_width (ctx, (gdouble) 4);
#line 157 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) 100, (gdouble) 50);
#line 158 "../src/Theme.vala"
	cairo_line_to (ctx, (gdouble) 10, (gdouble) 50);
#line 159 "../src/Theme.vala"
	cairo_stroke (ctx);
#line 161 "../src/Theme.vala"
	_tmp10_ = self->priv->_link_colors;
#line 161 "../src/Theme.vala"
	_tmp11_ = *g_array_index (_tmp10_, GdkRGBA*, (guint) 2);
#line 161 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp11_);
#line 162 "../src/Theme.vala"
	cairo_set_line_cap (ctx, CAIRO_LINE_CAP_ROUND);
#line 163 "../src/Theme.vala"
	cairo_set_line_width (ctx, (gdouble) 4);
#line 164 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) 100, (gdouble) 50);
#line 165 "../src/Theme.vala"
	cairo_line_to (ctx, (gdouble) 50, (gdouble) 75);
#line 166 "../src/Theme.vala"
	cairo_stroke (ctx);
#line 167 "../src/Theme.vala"
	_tmp12_ = self->priv->_link_colors;
#line 167 "../src/Theme.vala"
	_tmp13_ = *g_array_index (_tmp12_, GdkRGBA*, (guint) 2);
#line 167 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp13_);
#line 168 "../src/Theme.vala"
	cairo_set_line_cap (ctx, CAIRO_LINE_CAP_ROUND);
#line 169 "../src/Theme.vala"
	cairo_set_line_width (ctx, (gdouble) 4);
#line 170 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) 50, (gdouble) 75);
#line 171 "../src/Theme.vala"
	cairo_line_to (ctx, (gdouble) 10, (gdouble) 75);
#line 172 "../src/Theme.vala"
	cairo_stroke (ctx);
#line 174 "../src/Theme.vala"
	_tmp14_ = self->priv->_link_colors;
#line 174 "../src/Theme.vala"
	_tmp15_ = *g_array_index (_tmp14_, GdkRGBA*, (guint) 3);
#line 174 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp15_);
#line 175 "../src/Theme.vala"
	cairo_set_line_cap (ctx, CAIRO_LINE_CAP_ROUND);
#line 176 "../src/Theme.vala"
	cairo_set_line_width (ctx, (gdouble) 4);
#line 177 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) 100, (gdouble) 50);
#line 178 "../src/Theme.vala"
	cairo_line_to (ctx, (gdouble) 150, (gdouble) 25);
#line 179 "../src/Theme.vala"
	cairo_stroke (ctx);
#line 180 "../src/Theme.vala"
	_tmp16_ = self->priv->_link_colors;
#line 180 "../src/Theme.vala"
	_tmp17_ = *g_array_index (_tmp16_, GdkRGBA*, (guint) 3);
#line 180 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp17_);
#line 181 "../src/Theme.vala"
	cairo_set_line_cap (ctx, CAIRO_LINE_CAP_ROUND);
#line 182 "../src/Theme.vala"
	cairo_set_line_width (ctx, (gdouble) 4);
#line 183 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) 150, (gdouble) 25);
#line 184 "../src/Theme.vala"
	cairo_line_to (ctx, (gdouble) 190, (gdouble) 25);
#line 185 "../src/Theme.vala"
	cairo_stroke (ctx);
#line 187 "../src/Theme.vala"
	_tmp18_ = self->priv->_link_colors;
#line 187 "../src/Theme.vala"
	_tmp19_ = *g_array_index (_tmp18_, GdkRGBA*, (guint) 4);
#line 187 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp19_);
#line 188 "../src/Theme.vala"
	cairo_set_line_cap (ctx, CAIRO_LINE_CAP_ROUND);
#line 189 "../src/Theme.vala"
	cairo_set_line_width (ctx, (gdouble) 4);
#line 190 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) 100, (gdouble) 50);
#line 191 "../src/Theme.vala"
	cairo_line_to (ctx, (gdouble) 190, (gdouble) 50);
#line 192 "../src/Theme.vala"
	cairo_stroke (ctx);
#line 194 "../src/Theme.vala"
	_tmp20_ = self->priv->_link_colors;
#line 194 "../src/Theme.vala"
	_tmp21_ = *g_array_index (_tmp20_, GdkRGBA*, (guint) 5);
#line 194 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp21_);
#line 195 "../src/Theme.vala"
	cairo_set_line_cap (ctx, CAIRO_LINE_CAP_ROUND);
#line 196 "../src/Theme.vala"
	cairo_set_line_width (ctx, (gdouble) 4);
#line 197 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) 100, (gdouble) 50);
#line 198 "../src/Theme.vala"
	cairo_line_to (ctx, (gdouble) 150, (gdouble) 75);
#line 199 "../src/Theme.vala"
	cairo_stroke (ctx);
#line 200 "../src/Theme.vala"
	_tmp22_ = self->priv->_link_colors;
#line 200 "../src/Theme.vala"
	_tmp23_ = *g_array_index (_tmp22_, GdkRGBA*, (guint) 5);
#line 200 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp23_);
#line 201 "../src/Theme.vala"
	cairo_set_line_cap (ctx, CAIRO_LINE_CAP_ROUND);
#line 202 "../src/Theme.vala"
	cairo_set_line_width (ctx, (gdouble) 4);
#line 203 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) 150, (gdouble) 75);
#line 204 "../src/Theme.vala"
	cairo_line_to (ctx, (gdouble) 190, (gdouble) 75);
#line 205 "../src/Theme.vala"
	cairo_stroke (ctx);
#line 208 "../src/Theme.vala"
	_tmp24_ = pango_cairo_create_layout (ctx);
#line 208 "../src/Theme.vala"
	root_text = _tmp24_;
#line 209 "../src/Theme.vala"
	pango_layout_set_font_description (root_text, font_desc);
#line 210 "../src/Theme.vala"
	pango_layout_set_width (root_text, 70 * PANGO_SCALE);
#line 211 "../src/Theme.vala"
	pango_layout_set_wrap (root_text, PANGO_WRAP_WORD_CHAR);
#line 212 "../src/Theme.vala"
	_tmp25_ = self->priv->_name;
#line 212 "../src/Theme.vala"
	pango_layout_set_text (root_text, _tmp25_, -1);
#line 213 "../src/Theme.vala"
	pango_layout_get_pixel_size (root_text, &_tmp26_, &_tmp27_);
#line 213 "../src/Theme.vala"
	width = _tmp26_;
#line 213 "../src/Theme.vala"
	height = _tmp27_;
#line 215 "../src/Theme.vala"
	height += 4;
#line 218 "../src/Theme.vala"
	r = (gdouble) 4;
#line 219 "../src/Theme.vala"
	x = (gdouble) 65;
#line 220 "../src/Theme.vala"
	y = (gdouble) ((100 - height) / 2);
#line 221 "../src/Theme.vala"
	w = (gdouble) 70;
#line 222 "../src/Theme.vala"
	h = (gdouble) height;
#line 223 "../src/Theme.vala"
	_tmp28_ = self->priv->_root_background;
#line 223 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp28_);
#line 224 "../src/Theme.vala"
	cairo_set_line_width (ctx, (gdouble) 1);
#line 225 "../src/Theme.vala"
	cairo_move_to (ctx, x + r, y);
#line 226 "../src/Theme.vala"
	cairo_line_to (ctx, (x + w) - r, y);
#line 227 "../src/Theme.vala"
	cairo_curve_to (ctx, x + w, y, x + w, y, x + w, y + r);
#line 228 "../src/Theme.vala"
	cairo_line_to (ctx, x + w, (y + h) - r);
#line 229 "../src/Theme.vala"
	cairo_curve_to (ctx, x + w, y + h, x + w, y + h, (x + w) - r, y + h);
#line 230 "../src/Theme.vala"
	cairo_line_to (ctx, x + r, y + h);
#line 231 "../src/Theme.vala"
	cairo_curve_to (ctx, x, y + h, x, y + h, x, (y + h) - r);
#line 232 "../src/Theme.vala"
	cairo_line_to (ctx, x, y + r);
#line 233 "../src/Theme.vala"
	cairo_curve_to (ctx, x, y, x, y, x + r, y);
#line 234 "../src/Theme.vala"
	cairo_fill (ctx);
#line 237 "../src/Theme.vala"
	_tmp29_ = pango_cairo_create_layout (ctx);
#line 237 "../src/Theme.vala"
	node_text = _tmp29_;
#line 238 "../src/Theme.vala"
	pango_layout_set_font_description (node_text, font_desc);
#line 239 "../src/Theme.vala"
	pango_layout_set_width (node_text, 40 * PANGO_SCALE);
#line 240 "../src/Theme.vala"
	pango_layout_set_wrap (node_text, PANGO_WRAP_WORD_CHAR);
#line 241 "../src/Theme.vala"
	pango_layout_set_text (node_text, "Node", -1);
#line 244 "../src/Theme.vala"
	_tmp30_ = self->priv->_root_foreground;
#line 244 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp30_);
#line 245 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) (100 - (width / 2)), (gdouble) (50 - (height / 2)));
#line 246 "../src/Theme.vala"
	pango_cairo_show_layout (ctx, root_text);
#line 248 "../src/Theme.vala"
	pango_layout_get_size (node_text, &_tmp31_, &_tmp32_);
#line 248 "../src/Theme.vala"
	width = _tmp31_;
#line 248 "../src/Theme.vala"
	height = _tmp32_;
#line 249 "../src/Theme.vala"
	width /= PANGO_SCALE;
#line 250 "../src/Theme.vala"
	height /= PANGO_SCALE;
#line 252 "../src/Theme.vala"
	_tmp33_ = self->priv->_foreground;
#line 252 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp33_);
#line 253 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) (30 - (width / 2)), (gdouble) (25 - (height + 2)));
#line 254 "../src/Theme.vala"
	pango_cairo_show_layout (ctx, node_text);
#line 256 "../src/Theme.vala"
	_tmp34_ = self->priv->_foreground;
#line 256 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp34_);
#line 257 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) (30 - (width / 2)), (gdouble) (50 - (height + 2)));
#line 258 "../src/Theme.vala"
	pango_cairo_show_layout (ctx, node_text);
#line 260 "../src/Theme.vala"
	_tmp35_ = self->priv->_foreground;
#line 260 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp35_);
#line 261 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) (30 - (width / 2)), (gdouble) (75 - (height + 2)));
#line 262 "../src/Theme.vala"
	pango_cairo_show_layout (ctx, node_text);
#line 264 "../src/Theme.vala"
	_tmp36_ = self->priv->_foreground;
#line 264 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp36_);
#line 265 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) (170 - (width / 2)), (gdouble) (25 - (height + 2)));
#line 266 "../src/Theme.vala"
	pango_cairo_show_layout (ctx, node_text);
#line 268 "../src/Theme.vala"
	_tmp37_ = self->priv->_foreground;
#line 268 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp37_);
#line 269 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) (170 - (width / 2)), (gdouble) (50 - (height + 2)));
#line 270 "../src/Theme.vala"
	pango_cairo_show_layout (ctx, node_text);
#line 272 "../src/Theme.vala"
	_tmp38_ = self->priv->_foreground;
#line 272 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp38_);
#line 273 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) (170 - (width / 2)), (gdouble) (75 - (height + 2)));
#line 274 "../src/Theme.vala"
	pango_cairo_show_layout (ctx, node_text);
#line 277 "../src/Theme.vala"
	_tmp39_ = self->priv->_connection_color;
#line 277 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp39_);
#line 278 "../src/Theme.vala"
	_tmp40_[0] = (gdouble) 60;
#line 278 "../src/Theme.vala"
	_tmp40_[1] = (gdouble) 15;
#line 278 "../src/Theme.vala"
	_tmp40_[2] = (gdouble) 100;
#line 278 "../src/Theme.vala"
	_tmp40_[3] = (gdouble) 5;
#line 278 "../src/Theme.vala"
	_tmp40_[4] = (gdouble) 140;
#line 278 "../src/Theme.vala"
	_tmp40_[5] = (gdouble) 15;
#line 278 "../src/Theme.vala"
	memcpy (p, _tmp40_, 6 * sizeof (gdouble));
#line 279 "../src/Theme.vala"
	cairo_set_line_width (ctx, (gdouble) 2);
#line 280 "../src/Theme.vala"
	_tmp41_ = g_new0 (gdouble, 2);
#line 280 "../src/Theme.vala"
	_tmp41_[0] = (gdouble) 3;
#line 280 "../src/Theme.vala"
	_tmp41_[1] = (gdouble) 5;
#line 280 "../src/Theme.vala"
	_tmp42_ = _tmp41_;
#line 280 "../src/Theme.vala"
	_tmp42__length1 = 2;
#line 280 "../src/Theme.vala"
	cairo_set_dash (ctx, _tmp42_, (gint) 2, (gdouble) 0);
#line 280 "../src/Theme.vala"
	_tmp42_ = (g_free (_tmp42_), NULL);
#line 281 "../src/Theme.vala"
	_tmp43_ = p[0];
#line 281 "../src/Theme.vala"
	_tmp44_ = p[1];
#line 281 "../src/Theme.vala"
	cairo_move_to (ctx, _tmp43_, _tmp44_);
#line 282 "../src/Theme.vala"
	_tmp45_ = p[2];
#line 282 "../src/Theme.vala"
	_tmp46_ = p[0];
#line 282 "../src/Theme.vala"
	_tmp47_ = p[3];
#line 282 "../src/Theme.vala"
	_tmp48_ = p[1];
#line 282 "../src/Theme.vala"
	_tmp49_ = p[2];
#line 282 "../src/Theme.vala"
	_tmp50_ = p[4];
#line 282 "../src/Theme.vala"
	_tmp51_ = p[3];
#line 282 "../src/Theme.vala"
	_tmp52_ = p[5];
#line 282 "../src/Theme.vala"
	_tmp53_ = p[4];
#line 282 "../src/Theme.vala"
	_tmp54_ = p[5];
#line 282 "../src/Theme.vala"
	cairo_curve_to (ctx, ((2.0 / 3.0) * _tmp45_) + ((1.0 / 3.0) * _tmp46_), ((2.0 / 3.0) * _tmp47_) + ((1.0 / 3.0) * _tmp48_), ((2.0 / 3.0) * _tmp49_) + ((1.0 / 3.0) * _tmp50_), ((2.0 / 3.0) * _tmp51_) + ((1.0 / 3.0) * _tmp52_), _tmp53_, _tmp54_);
#line 289 "../src/Theme.vala"
	cairo_stroke (ctx);
#line 290 "../src/Theme.vala"
	_tmp55_ = p[0];
#line 290 "../src/Theme.vala"
	_tmp56_ = p[1];
#line 290 "../src/Theme.vala"
	_tmp57_ = p[2];
#line 290 "../src/Theme.vala"
	_tmp58_ = p[3];
#line 290 "../src/Theme.vala"
	connection_draw_arrow (ctx, 2, _tmp55_, _tmp56_, _tmp57_, _tmp58_, (gdouble) 7);
#line 291 "../src/Theme.vala"
	_tmp59_ = p[4];
#line 291 "../src/Theme.vala"
	_tmp60_ = p[5];
#line 291 "../src/Theme.vala"
	_tmp61_ = p[2];
#line 291 "../src/Theme.vala"
	_tmp62_ = p[3];
#line 291 "../src/Theme.vala"
	connection_draw_arrow (ctx, 2, _tmp59_, _tmp60_, _tmp61_, _tmp62_, (gdouble) 7);
#line 293 "../src/Theme.vala"
	result = surface;
#line 293 "../src/Theme.vala"
	_g_object_unref0 (node_text);
#line 293 "../src/Theme.vala"
	_g_object_unref0 (root_text);
#line 293 "../src/Theme.vala"
	__vala_PangoFontDescription_free0 (font_desc);
#line 293 "../src/Theme.vala"
	_cairo_destroy0 (ctx);
#line 293 "../src/Theme.vala"
	return result;
#line 1122 "Theme.c"
}

const gchar*
theme_get_name (Theme* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 30 "../src/Theme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/Theme.vala"
	_tmp0_ = self->priv->_name;
#line 30 "../src/Theme.vala"
	result = _tmp0_;
#line 30 "../src/Theme.vala"
	return result;
#line 1138 "Theme.c"
}

void
theme_set_name (Theme* self,
                const gchar* value)
{
#line 30 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/Theme.vala"
	if (g_strcmp0 (value, theme_get_name (self)) != 0) {
#line 1149 "Theme.c"
		gchar* _tmp0_;
#line 30 "../src/Theme.vala"
		_tmp0_ = g_strdup (value);
#line 30 "../src/Theme.vala"
		_g_free0 (self->priv->_name);
#line 30 "../src/Theme.vala"
		self->priv->_name = _tmp0_;
#line 30 "../src/Theme.vala"
		g_object_notify_by_pspec ((GObject *) self, theme_properties[THEME_NAME_PROPERTY]);
#line 1159 "Theme.c"
	}
}

GtkImage*
theme_get_icon (Theme* self)
{
	GtkImage* result;
	GtkImage* _tmp0_;
#line 31 "../src/Theme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../src/Theme.vala"
	_tmp0_ = self->priv->_icon;
#line 31 "../src/Theme.vala"
	result = _tmp0_;
#line 31 "../src/Theme.vala"
	return result;
#line 1176 "Theme.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 31 "../src/Theme.vala"
	return self ? g_object_ref (self) : NULL;
#line 1184 "Theme.c"
}

void
theme_set_icon (Theme* self,
                GtkImage* value)
{
#line 31 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/Theme.vala"
	if (theme_get_icon (self) != value) {
#line 1195 "Theme.c"
		GtkImage* _tmp0_;
#line 31 "../src/Theme.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 31 "../src/Theme.vala"
		_g_object_unref0 (self->priv->_icon);
#line 31 "../src/Theme.vala"
		self->priv->_icon = _tmp0_;
#line 31 "../src/Theme.vala"
		g_object_notify_by_pspec ((GObject *) self, theme_properties[THEME_ICON_PROPERTY]);
#line 1205 "Theme.c"
	}
}

void
theme_get_background (Theme* self,
                      GdkRGBA * result)
{
	GdkRGBA _tmp0_;
#line 32 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/Theme.vala"
	_tmp0_ = self->priv->_background;
#line 32 "../src/Theme.vala"
	*result = _tmp0_;
#line 32 "../src/Theme.vala"
	return;
#line 1222 "Theme.c"
}

static gboolean
_gdk_rgba_equal (const GdkRGBA * s1,
                 const GdkRGBA * s2)
{
#line 32 "../src/Theme.vala"
	if (s1 == s2) {
#line 32 "../src/Theme.vala"
		return TRUE;
#line 1233 "Theme.c"
	}
#line 32 "../src/Theme.vala"
	if (s1 == NULL) {
#line 32 "../src/Theme.vala"
		return FALSE;
#line 1239 "Theme.c"
	}
#line 32 "../src/Theme.vala"
	if (s2 == NULL) {
#line 32 "../src/Theme.vala"
		return FALSE;
#line 1245 "Theme.c"
	}
#line 32 "../src/Theme.vala"
	if (s1->red != s2->red) {
#line 32 "../src/Theme.vala"
		return FALSE;
#line 1251 "Theme.c"
	}
#line 32 "../src/Theme.vala"
	if (s1->green != s2->green) {
#line 32 "../src/Theme.vala"
		return FALSE;
#line 1257 "Theme.c"
	}
#line 32 "../src/Theme.vala"
	if (s1->blue != s2->blue) {
#line 32 "../src/Theme.vala"
		return FALSE;
#line 1263 "Theme.c"
	}
#line 32 "../src/Theme.vala"
	if (s1->alpha != s2->alpha) {
#line 32 "../src/Theme.vala"
		return FALSE;
#line 1269 "Theme.c"
	}
#line 32 "../src/Theme.vala"
	return TRUE;
#line 1273 "Theme.c"
}

void
theme_set_background (Theme* self,
                      GdkRGBA * value)
{
	GdkRGBA old_value;
#line 32 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/Theme.vala"
	theme_get_background (self, &old_value);
#line 32 "../src/Theme.vala"
	if (_gdk_rgba_equal (value, &old_value) != TRUE) {
#line 1287 "Theme.c"
		GdkRGBA _tmp0_;
#line 32 "../src/Theme.vala"
		_tmp0_ = *value;
#line 32 "../src/Theme.vala"
		self->priv->_background = _tmp0_;
#line 32 "../src/Theme.vala"
		g_object_notify_by_pspec ((GObject *) self, theme_properties[THEME_BACKGROUND_PROPERTY]);
#line 1295 "Theme.c"
	}
}

void
theme_get_foreground (Theme* self,
                      GdkRGBA * result)
{
	GdkRGBA _tmp0_;
#line 33 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/Theme.vala"
	_tmp0_ = self->priv->_foreground;
#line 33 "../src/Theme.vala"
	*result = _tmp0_;
#line 33 "../src/Theme.vala"
	return;
#line 1312 "Theme.c"
}

void
theme_set_foreground (Theme* self,
                      GdkRGBA * value)
{
	GdkRGBA old_value;
#line 33 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/Theme.vala"
	theme_get_foreground (self, &old_value);
#line 33 "../src/Theme.vala"
	if (_gdk_rgba_equal (value, &old_value) != TRUE) {
#line 1326 "Theme.c"
		GdkRGBA _tmp0_;
#line 33 "../src/Theme.vala"
		_tmp0_ = *value;
#line 33 "../src/Theme.vala"
		self->priv->_foreground = _tmp0_;
#line 33 "../src/Theme.vala"
		g_object_notify_by_pspec ((GObject *) self, theme_properties[THEME_FOREGROUND_PROPERTY]);
#line 1334 "Theme.c"
	}
}

void
theme_get_root_background (Theme* self,
                           GdkRGBA * result)
{
	GdkRGBA _tmp0_;
#line 34 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/Theme.vala"
	_tmp0_ = self->priv->_root_background;
#line 34 "../src/Theme.vala"
	*result = _tmp0_;
#line 34 "../src/Theme.vala"
	return;
#line 1351 "Theme.c"
}

void
theme_set_root_background (Theme* self,
                           GdkRGBA * value)
{
	GdkRGBA old_value;
#line 34 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/Theme.vala"
	theme_get_root_background (self, &old_value);
#line 34 "../src/Theme.vala"
	if (_gdk_rgba_equal (value, &old_value) != TRUE) {
#line 1365 "Theme.c"
		GdkRGBA _tmp0_;
#line 34 "../src/Theme.vala"
		_tmp0_ = *value;
#line 34 "../src/Theme.vala"
		self->priv->_root_background = _tmp0_;
#line 34 "../src/Theme.vala"
		g_object_notify_by_pspec ((GObject *) self, theme_properties[THEME_ROOT_BACKGROUND_PROPERTY]);
#line 1373 "Theme.c"
	}
}

void
theme_get_root_foreground (Theme* self,
                           GdkRGBA * result)
{
	GdkRGBA _tmp0_;
#line 35 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/Theme.vala"
	_tmp0_ = self->priv->_root_foreground;
#line 35 "../src/Theme.vala"
	*result = _tmp0_;
#line 35 "../src/Theme.vala"
	return;
#line 1390 "Theme.c"
}

void
theme_set_root_foreground (Theme* self,
                           GdkRGBA * value)
{
	GdkRGBA old_value;
#line 35 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/Theme.vala"
	theme_get_root_foreground (self, &old_value);
#line 35 "../src/Theme.vala"
	if (_gdk_rgba_equal (value, &old_value) != TRUE) {
#line 1404 "Theme.c"
		GdkRGBA _tmp0_;
#line 35 "../src/Theme.vala"
		_tmp0_ = *value;
#line 35 "../src/Theme.vala"
		self->priv->_root_foreground = _tmp0_;
#line 35 "../src/Theme.vala"
		g_object_notify_by_pspec ((GObject *) self, theme_properties[THEME_ROOT_FOREGROUND_PROPERTY]);
#line 1412 "Theme.c"
	}
}

void
theme_get_nodesel_background (Theme* self,
                              GdkRGBA * result)
{
	GdkRGBA _tmp0_;
#line 36 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/Theme.vala"
	_tmp0_ = self->priv->_nodesel_background;
#line 36 "../src/Theme.vala"
	*result = _tmp0_;
#line 36 "../src/Theme.vala"
	return;
#line 1429 "Theme.c"
}

void
theme_set_nodesel_background (Theme* self,
                              GdkRGBA * value)
{
	GdkRGBA old_value;
#line 36 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/Theme.vala"
	theme_get_nodesel_background (self, &old_value);
#line 36 "../src/Theme.vala"
	if (_gdk_rgba_equal (value, &old_value) != TRUE) {
#line 1443 "Theme.c"
		GdkRGBA _tmp0_;
#line 36 "../src/Theme.vala"
		_tmp0_ = *value;
#line 36 "../src/Theme.vala"
		self->priv->_nodesel_background = _tmp0_;
#line 36 "../src/Theme.vala"
		g_object_notify_by_pspec ((GObject *) self, theme_properties[THEME_NODESEL_BACKGROUND_PROPERTY]);
#line 1451 "Theme.c"
	}
}

void
theme_get_nodesel_foreground (Theme* self,
                              GdkRGBA * result)
{
	GdkRGBA _tmp0_;
#line 37 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/Theme.vala"
	_tmp0_ = self->priv->_nodesel_foreground;
#line 37 "../src/Theme.vala"
	*result = _tmp0_;
#line 37 "../src/Theme.vala"
	return;
#line 1468 "Theme.c"
}

void
theme_set_nodesel_foreground (Theme* self,
                              GdkRGBA * value)
{
	GdkRGBA old_value;
#line 37 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/Theme.vala"
	theme_get_nodesel_foreground (self, &old_value);
#line 37 "../src/Theme.vala"
	if (_gdk_rgba_equal (value, &old_value) != TRUE) {
#line 1482 "Theme.c"
		GdkRGBA _tmp0_;
#line 37 "../src/Theme.vala"
		_tmp0_ = *value;
#line 37 "../src/Theme.vala"
		self->priv->_nodesel_foreground = _tmp0_;
#line 37 "../src/Theme.vala"
		g_object_notify_by_pspec ((GObject *) self, theme_properties[THEME_NODESEL_FOREGROUND_PROPERTY]);
#line 1490 "Theme.c"
	}
}

void
theme_get_textsel_background (Theme* self,
                              GdkRGBA * result)
{
	GdkRGBA _tmp0_;
#line 38 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/Theme.vala"
	_tmp0_ = self->priv->_textsel_background;
#line 38 "../src/Theme.vala"
	*result = _tmp0_;
#line 38 "../src/Theme.vala"
	return;
#line 1507 "Theme.c"
}

void
theme_set_textsel_background (Theme* self,
                              GdkRGBA * value)
{
	GdkRGBA old_value;
#line 38 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/Theme.vala"
	theme_get_textsel_background (self, &old_value);
#line 38 "../src/Theme.vala"
	if (_gdk_rgba_equal (value, &old_value) != TRUE) {
#line 1521 "Theme.c"
		GdkRGBA _tmp0_;
#line 38 "../src/Theme.vala"
		_tmp0_ = *value;
#line 38 "../src/Theme.vala"
		self->priv->_textsel_background = _tmp0_;
#line 38 "../src/Theme.vala"
		g_object_notify_by_pspec ((GObject *) self, theme_properties[THEME_TEXTSEL_BACKGROUND_PROPERTY]);
#line 1529 "Theme.c"
	}
}

void
theme_get_textsel_foreground (Theme* self,
                              GdkRGBA * result)
{
	GdkRGBA _tmp0_;
#line 39 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/Theme.vala"
	_tmp0_ = self->priv->_textsel_foreground;
#line 39 "../src/Theme.vala"
	*result = _tmp0_;
#line 39 "../src/Theme.vala"
	return;
#line 1546 "Theme.c"
}

void
theme_set_textsel_foreground (Theme* self,
                              GdkRGBA * value)
{
	GdkRGBA old_value;
#line 39 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/Theme.vala"
	theme_get_textsel_foreground (self, &old_value);
#line 39 "../src/Theme.vala"
	if (_gdk_rgba_equal (value, &old_value) != TRUE) {
#line 1560 "Theme.c"
		GdkRGBA _tmp0_;
#line 39 "../src/Theme.vala"
		_tmp0_ = *value;
#line 39 "../src/Theme.vala"
		self->priv->_textsel_foreground = _tmp0_;
#line 39 "../src/Theme.vala"
		g_object_notify_by_pspec ((GObject *) self, theme_properties[THEME_TEXTSEL_FOREGROUND_PROPERTY]);
#line 1568 "Theme.c"
	}
}

void
theme_get_text_cursor (Theme* self,
                       GdkRGBA * result)
{
	GdkRGBA _tmp0_;
#line 40 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/Theme.vala"
	_tmp0_ = self->priv->_text_cursor;
#line 40 "../src/Theme.vala"
	*result = _tmp0_;
#line 40 "../src/Theme.vala"
	return;
#line 1585 "Theme.c"
}

void
theme_set_text_cursor (Theme* self,
                       GdkRGBA * value)
{
	GdkRGBA old_value;
#line 40 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/Theme.vala"
	theme_get_text_cursor (self, &old_value);
#line 40 "../src/Theme.vala"
	if (_gdk_rgba_equal (value, &old_value) != TRUE) {
#line 1599 "Theme.c"
		GdkRGBA _tmp0_;
#line 40 "../src/Theme.vala"
		_tmp0_ = *value;
#line 40 "../src/Theme.vala"
		self->priv->_text_cursor = _tmp0_;
#line 40 "../src/Theme.vala"
		g_object_notify_by_pspec ((GObject *) self, theme_properties[THEME_TEXT_CURSOR_PROPERTY]);
#line 1607 "Theme.c"
	}
}

void
theme_get_attachable_color (Theme* self,
                            GdkRGBA * result)
{
	GdkRGBA _tmp0_;
#line 41 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/Theme.vala"
	_tmp0_ = self->priv->_attachable_color;
#line 41 "../src/Theme.vala"
	*result = _tmp0_;
#line 41 "../src/Theme.vala"
	return;
#line 1624 "Theme.c"
}

void
theme_set_attachable_color (Theme* self,
                            GdkRGBA * value)
{
	GdkRGBA old_value;
#line 41 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/Theme.vala"
	theme_get_attachable_color (self, &old_value);
#line 41 "../src/Theme.vala"
	if (_gdk_rgba_equal (value, &old_value) != TRUE) {
#line 1638 "Theme.c"
		GdkRGBA _tmp0_;
#line 41 "../src/Theme.vala"
		_tmp0_ = *value;
#line 41 "../src/Theme.vala"
		self->priv->_attachable_color = _tmp0_;
#line 41 "../src/Theme.vala"
		g_object_notify_by_pspec ((GObject *) self, theme_properties[THEME_ATTACHABLE_COLOR_PROPERTY]);
#line 1646 "Theme.c"
	}
}

void
theme_get_connection_color (Theme* self,
                            GdkRGBA * result)
{
	GdkRGBA _tmp0_;
#line 42 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/Theme.vala"
	_tmp0_ = self->priv->_connection_color;
#line 42 "../src/Theme.vala"
	*result = _tmp0_;
#line 42 "../src/Theme.vala"
	return;
#line 1663 "Theme.c"
}

void
theme_set_connection_color (Theme* self,
                            GdkRGBA * value)
{
	GdkRGBA old_value;
#line 42 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/Theme.vala"
	theme_get_connection_color (self, &old_value);
#line 42 "../src/Theme.vala"
	if (_gdk_rgba_equal (value, &old_value) != TRUE) {
#line 1677 "Theme.c"
		GdkRGBA _tmp0_;
#line 42 "../src/Theme.vala"
		_tmp0_ = *value;
#line 42 "../src/Theme.vala"
		self->priv->_connection_color = _tmp0_;
#line 42 "../src/Theme.vala"
		g_object_notify_by_pspec ((GObject *) self, theme_properties[THEME_CONNECTION_COLOR_PROPERTY]);
#line 1685 "Theme.c"
	}
}

gboolean
theme_get_prefer_dark (Theme* self)
{
	gboolean result;
#line 43 "../src/Theme.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 43 "../src/Theme.vala"
	result = self->priv->_prefer_dark;
#line 43 "../src/Theme.vala"
	return result;
#line 1699 "Theme.c"
}

void
theme_set_prefer_dark (Theme* self,
                       gboolean value)
{
#line 43 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/Theme.vala"
	if (theme_get_prefer_dark (self) != value) {
#line 43 "../src/Theme.vala"
		self->priv->_prefer_dark = value;
#line 43 "../src/Theme.vala"
		g_object_notify_by_pspec ((GObject *) self, theme_properties[THEME_PREFER_DARK_PROPERTY]);
#line 1714 "Theme.c"
	}
}

gint
theme_get_index (Theme* self)
{
	gint result;
#line 49 "../src/Theme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 50 "../src/Theme.vala"
	result = self->priv->_index;
#line 50 "../src/Theme.vala"
	return result;
#line 1728 "Theme.c"
}

void
theme_set_index (Theme* self,
                 gint value)
{
#line 46 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 47 "../src/Theme.vala"
	self->priv->_index = value;
#line 46 "../src/Theme.vala"
	g_object_notify_by_pspec ((GObject *) self, theme_properties[THEME_INDEX_PROPERTY]);
#line 1741 "Theme.c"
}

static void
theme_class_init (ThemeClass * klass,
                  gpointer klass_data)
{
#line 25 "../src/Theme.vala"
	theme_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/Theme.vala"
	g_type_class_adjust_private_offset (klass, &Theme_private_offset);
#line 25 "../src/Theme.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_theme_get_property;
#line 25 "../src/Theme.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_theme_set_property;
#line 25 "../src/Theme.vala"
	G_OBJECT_CLASS (klass)->finalize = theme_finalize;
#line 25 "../src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_NAME_PROPERTY, theme_properties[THEME_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_ICON_PROPERTY, theme_properties[THEME_ICON_PROPERTY] = g_param_spec_object ("icon", "icon", "icon", gtk_image_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_BACKGROUND_PROPERTY, theme_properties[THEME_BACKGROUND_PROPERTY] = g_param_spec_boxed ("background", "background", "background", gdk_rgba_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_FOREGROUND_PROPERTY, theme_properties[THEME_FOREGROUND_PROPERTY] = g_param_spec_boxed ("foreground", "foreground", "foreground", gdk_rgba_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_ROOT_BACKGROUND_PROPERTY, theme_properties[THEME_ROOT_BACKGROUND_PROPERTY] = g_param_spec_boxed ("root-background", "root-background", "root-background", gdk_rgba_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_ROOT_FOREGROUND_PROPERTY, theme_properties[THEME_ROOT_FOREGROUND_PROPERTY] = g_param_spec_boxed ("root-foreground", "root-foreground", "root-foreground", gdk_rgba_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_NODESEL_BACKGROUND_PROPERTY, theme_properties[THEME_NODESEL_BACKGROUND_PROPERTY] = g_param_spec_boxed ("nodesel-background", "nodesel-background", "nodesel-background", gdk_rgba_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_NODESEL_FOREGROUND_PROPERTY, theme_properties[THEME_NODESEL_FOREGROUND_PROPERTY] = g_param_spec_boxed ("nodesel-foreground", "nodesel-foreground", "nodesel-foreground", gdk_rgba_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_TEXTSEL_BACKGROUND_PROPERTY, theme_properties[THEME_TEXTSEL_BACKGROUND_PROPERTY] = g_param_spec_boxed ("textsel-background", "textsel-background", "textsel-background", gdk_rgba_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_TEXTSEL_FOREGROUND_PROPERTY, theme_properties[THEME_TEXTSEL_FOREGROUND_PROPERTY] = g_param_spec_boxed ("textsel-foreground", "textsel-foreground", "textsel-foreground", gdk_rgba_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_TEXT_CURSOR_PROPERTY, theme_properties[THEME_TEXT_CURSOR_PROPERTY] = g_param_spec_boxed ("text-cursor", "text-cursor", "text-cursor", gdk_rgba_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_ATTACHABLE_COLOR_PROPERTY, theme_properties[THEME_ATTACHABLE_COLOR_PROPERTY] = g_param_spec_boxed ("attachable-color", "attachable-color", "attachable-color", gdk_rgba_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_CONNECTION_COLOR_PROPERTY, theme_properties[THEME_CONNECTION_COLOR_PROPERTY] = g_param_spec_boxed ("connection-color", "connection-color", "connection-color", gdk_rgba_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_PREFER_DARK_PROPERTY, theme_properties[THEME_PREFER_DARK_PROPERTY] = g_param_spec_boolean ("prefer-dark", "prefer-dark", "prefer-dark", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_INDEX_PROPERTY, theme_properties[THEME_INDEX_PROPERTY] = g_param_spec_int ("index", "index", "index", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1788 "Theme.c"
}

static void
theme_instance_init (Theme * self,
                     gpointer klass)
{
#line 25 "../src/Theme.vala"
	self->priv = theme_get_instance_private (self);
#line 1797 "Theme.c"
}

static void
theme_finalize (GObject * obj)
{
	Theme * self;
#line 25 "../src/Theme.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_THEME, Theme);
#line 28 "../src/Theme.vala"
	_g_array_unref0 (self->priv->_link_colors);
#line 30 "../src/Theme.vala"
	_g_free0 (self->priv->_name);
#line 31 "../src/Theme.vala"
	_g_object_unref0 (self->priv->_icon);
#line 25 "../src/Theme.vala"
	G_OBJECT_CLASS (theme_parent_class)->finalize (obj);
#line 1814 "Theme.c"
}

GType
theme_get_type (void)
{
	static volatile gsize theme_type_id__volatile = 0;
	if (g_once_init_enter (&theme_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ThemeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) theme_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Theme), 0, (GInstanceInitFunc) theme_instance_init, NULL };
		GType theme_type_id;
		theme_type_id = g_type_register_static (G_TYPE_OBJECT, "Theme", &g_define_type_info, 0);
		Theme_private_offset = g_type_add_instance_private (theme_type_id, sizeof (ThemePrivate));
		g_once_init_leave (&theme_type_id__volatile, theme_type_id);
	}
	return theme_type_id__volatile;
}

static void
_vala_theme_get_property (GObject * object,
                          guint property_id,
                          GValue * value,
                          GParamSpec * pspec)
{
	Theme * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_THEME, Theme);
#line 25 "../src/Theme.vala"
	switch (property_id) {
#line 25 "../src/Theme.vala"
		case THEME_NAME_PROPERTY:
#line 25 "../src/Theme.vala"
		g_value_set_string (value, theme_get_name (self));
#line 25 "../src/Theme.vala"
		break;
#line 25 "../src/Theme.vala"
		case THEME_ICON_PROPERTY:
#line 25 "../src/Theme.vala"
		g_value_set_object (value, theme_get_icon (self));
#line 25 "../src/Theme.vala"
		break;
#line 25 "../src/Theme.vala"
		case THEME_BACKGROUND_PROPERTY:
#line 1855 "Theme.c"
		{
			GdkRGBA boxed;
#line 25 "../src/Theme.vala"
			theme_get_background (self, &boxed);
#line 25 "../src/Theme.vala"
			g_value_set_boxed (value, &boxed);
#line 1862 "Theme.c"
		}
#line 25 "../src/Theme.vala"
		break;
#line 25 "../src/Theme.vala"
		case THEME_FOREGROUND_PROPERTY:
#line 1868 "Theme.c"
		{
			GdkRGBA boxed;
#line 25 "../src/Theme.vala"
			theme_get_foreground (self, &boxed);
#line 25 "../src/Theme.vala"
			g_value_set_boxed (value, &boxed);
#line 1875 "Theme.c"
		}
#line 25 "../src/Theme.vala"
		break;
#line 25 "../src/Theme.vala"
		case THEME_ROOT_BACKGROUND_PROPERTY:
#line 1881 "Theme.c"
		{
			GdkRGBA boxed;
#line 25 "../src/Theme.vala"
			theme_get_root_background (self, &boxed);
#line 25 "../src/Theme.vala"
			g_value_set_boxed (value, &boxed);
#line 1888 "Theme.c"
		}
#line 25 "../src/Theme.vala"
		break;
#line 25 "../src/Theme.vala"
		case THEME_ROOT_FOREGROUND_PROPERTY:
#line 1894 "Theme.c"
		{
			GdkRGBA boxed;
#line 25 "../src/Theme.vala"
			theme_get_root_foreground (self, &boxed);
#line 25 "../src/Theme.vala"
			g_value_set_boxed (value, &boxed);
#line 1901 "Theme.c"
		}
#line 25 "../src/Theme.vala"
		break;
#line 25 "../src/Theme.vala"
		case THEME_NODESEL_BACKGROUND_PROPERTY:
#line 1907 "Theme.c"
		{
			GdkRGBA boxed;
#line 25 "../src/Theme.vala"
			theme_get_nodesel_background (self, &boxed);
#line 25 "../src/Theme.vala"
			g_value_set_boxed (value, &boxed);
#line 1914 "Theme.c"
		}
#line 25 "../src/Theme.vala"
		break;
#line 25 "../src/Theme.vala"
		case THEME_NODESEL_FOREGROUND_PROPERTY:
#line 1920 "Theme.c"
		{
			GdkRGBA boxed;
#line 25 "../src/Theme.vala"
			theme_get_nodesel_foreground (self, &boxed);
#line 25 "../src/Theme.vala"
			g_value_set_boxed (value, &boxed);
#line 1927 "Theme.c"
		}
#line 25 "../src/Theme.vala"
		break;
#line 25 "../src/Theme.vala"
		case THEME_TEXTSEL_BACKGROUND_PROPERTY:
#line 1933 "Theme.c"
		{
			GdkRGBA boxed;
#line 25 "../src/Theme.vala"
			theme_get_textsel_background (self, &boxed);
#line 25 "../src/Theme.vala"
			g_value_set_boxed (value, &boxed);
#line 1940 "Theme.c"
		}
#line 25 "../src/Theme.vala"
		break;
#line 25 "../src/Theme.vala"
		case THEME_TEXTSEL_FOREGROUND_PROPERTY:
#line 1946 "Theme.c"
		{
			GdkRGBA boxed;
#line 25 "../src/Theme.vala"
			theme_get_textsel_foreground (self, &boxed);
#line 25 "../src/Theme.vala"
			g_value_set_boxed (value, &boxed);
#line 1953 "Theme.c"
		}
#line 25 "../src/Theme.vala"
		break;
#line 25 "../src/Theme.vala"
		case THEME_TEXT_CURSOR_PROPERTY:
#line 1959 "Theme.c"
		{
			GdkRGBA boxed;
#line 25 "../src/Theme.vala"
			theme_get_text_cursor (self, &boxed);
#line 25 "../src/Theme.vala"
			g_value_set_boxed (value, &boxed);
#line 1966 "Theme.c"
		}
#line 25 "../src/Theme.vala"
		break;
#line 25 "../src/Theme.vala"
		case THEME_ATTACHABLE_COLOR_PROPERTY:
#line 1972 "Theme.c"
		{
			GdkRGBA boxed;
#line 25 "../src/Theme.vala"
			theme_get_attachable_color (self, &boxed);
#line 25 "../src/Theme.vala"
			g_value_set_boxed (value, &boxed);
#line 1979 "Theme.c"
		}
#line 25 "../src/Theme.vala"
		break;
#line 25 "../src/Theme.vala"
		case THEME_CONNECTION_COLOR_PROPERTY:
#line 1985 "Theme.c"
		{
			GdkRGBA boxed;
#line 25 "../src/Theme.vala"
			theme_get_connection_color (self, &boxed);
#line 25 "../src/Theme.vala"
			g_value_set_boxed (value, &boxed);
#line 1992 "Theme.c"
		}
#line 25 "../src/Theme.vala"
		break;
#line 25 "../src/Theme.vala"
		case THEME_PREFER_DARK_PROPERTY:
#line 25 "../src/Theme.vala"
		g_value_set_boolean (value, theme_get_prefer_dark (self));
#line 25 "../src/Theme.vala"
		break;
#line 25 "../src/Theme.vala"
		case THEME_INDEX_PROPERTY:
#line 25 "../src/Theme.vala"
		g_value_set_int (value, theme_get_index (self));
#line 25 "../src/Theme.vala"
		break;
#line 2008 "Theme.c"
		default:
#line 25 "../src/Theme.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../src/Theme.vala"
		break;
#line 2014 "Theme.c"
	}
}

static void
_vala_theme_set_property (GObject * object,
                          guint property_id,
                          const GValue * value,
                          GParamSpec * pspec)
{
	Theme * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_THEME, Theme);
#line 25 "../src/Theme.vala"
	switch (property_id) {
#line 25 "../src/Theme.vala"
		case THEME_NAME_PROPERTY:
#line 25 "../src/Theme.vala"
		theme_set_name (self, g_value_get_string (value));
#line 25 "../src/Theme.vala"
		break;
#line 25 "../src/Theme.vala"
		case THEME_ICON_PROPERTY:
#line 25 "../src/Theme.vala"
		theme_set_icon (self, g_value_get_object (value));
#line 25 "../src/Theme.vala"
		break;
#line 25 "../src/Theme.vala"
		case THEME_BACKGROUND_PROPERTY:
#line 25 "../src/Theme.vala"
		theme_set_background (self, g_value_get_boxed (value));
#line 25 "../src/Theme.vala"
		break;
#line 25 "../src/Theme.vala"
		case THEME_FOREGROUND_PROPERTY:
#line 25 "../src/Theme.vala"
		theme_set_foreground (self, g_value_get_boxed (value));
#line 25 "../src/Theme.vala"
		break;
#line 25 "../src/Theme.vala"
		case THEME_ROOT_BACKGROUND_PROPERTY:
#line 25 "../src/Theme.vala"
		theme_set_root_background (self, g_value_get_boxed (value));
#line 25 "../src/Theme.vala"
		break;
#line 25 "../src/Theme.vala"
		case THEME_ROOT_FOREGROUND_PROPERTY:
#line 25 "../src/Theme.vala"
		theme_set_root_foreground (self, g_value_get_boxed (value));
#line 25 "../src/Theme.vala"
		break;
#line 25 "../src/Theme.vala"
		case THEME_NODESEL_BACKGROUND_PROPERTY:
#line 25 "../src/Theme.vala"
		theme_set_nodesel_background (self, g_value_get_boxed (value));
#line 25 "../src/Theme.vala"
		break;
#line 25 "../src/Theme.vala"
		case THEME_NODESEL_FOREGROUND_PROPERTY:
#line 25 "../src/Theme.vala"
		theme_set_nodesel_foreground (self, g_value_get_boxed (value));
#line 25 "../src/Theme.vala"
		break;
#line 25 "../src/Theme.vala"
		case THEME_TEXTSEL_BACKGROUND_PROPERTY:
#line 25 "../src/Theme.vala"
		theme_set_textsel_background (self, g_value_get_boxed (value));
#line 25 "../src/Theme.vala"
		break;
#line 25 "../src/Theme.vala"
		case THEME_TEXTSEL_FOREGROUND_PROPERTY:
#line 25 "../src/Theme.vala"
		theme_set_textsel_foreground (self, g_value_get_boxed (value));
#line 25 "../src/Theme.vala"
		break;
#line 25 "../src/Theme.vala"
		case THEME_TEXT_CURSOR_PROPERTY:
#line 25 "../src/Theme.vala"
		theme_set_text_cursor (self, g_value_get_boxed (value));
#line 25 "../src/Theme.vala"
		break;
#line 25 "../src/Theme.vala"
		case THEME_ATTACHABLE_COLOR_PROPERTY:
#line 25 "../src/Theme.vala"
		theme_set_attachable_color (self, g_value_get_boxed (value));
#line 25 "../src/Theme.vala"
		break;
#line 25 "../src/Theme.vala"
		case THEME_CONNECTION_COLOR_PROPERTY:
#line 25 "../src/Theme.vala"
		theme_set_connection_color (self, g_value_get_boxed (value));
#line 25 "../src/Theme.vala"
		break;
#line 25 "../src/Theme.vala"
		case THEME_PREFER_DARK_PROPERTY:
#line 25 "../src/Theme.vala"
		theme_set_prefer_dark (self, g_value_get_boolean (value));
#line 25 "../src/Theme.vala"
		break;
#line 25 "../src/Theme.vala"
		case THEME_INDEX_PROPERTY:
#line 25 "../src/Theme.vala"
		theme_set_index (self, g_value_get_int (value));
#line 25 "../src/Theme.vala"
		break;
#line 2118 "Theme.c"
		default:
#line 25 "../src/Theme.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../src/Theme.vala"
		break;
#line 2124 "Theme.c"
	}
}

