/* ExportText.c generated by valac 0.45.3, the Vala compiler
 * generated from ExportText.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gio/gio.h>

#define TYPE_EXPORT_TEXT (export_text_get_type ())
#define EXPORT_TEXT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EXPORT_TEXT, ExportText))
#define EXPORT_TEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EXPORT_TEXT, ExportTextClass))
#define IS_EXPORT_TEXT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EXPORT_TEXT))
#define IS_EXPORT_TEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EXPORT_TEXT))
#define EXPORT_TEXT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EXPORT_TEXT, ExportTextClass))

typedef struct _ExportText ExportText;
typedef struct _ExportTextClass ExportTextClass;
typedef struct _ExportTextPrivate ExportTextPrivate;
enum  {
	EXPORT_TEXT_0_PROPERTY,
	EXPORT_TEXT_NUM_PROPERTIES
};
static GParamSpec* export_text_properties[EXPORT_TEXT_NUM_PROPERTIES];

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_NODE (node_get_type ())
#define NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE, Node))
#define NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE, NodeClass))
#define IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE))
#define IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE))
#define NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE, NodeClass))

typedef struct _Node Node;
typedef struct _NodeClass NodeClass;

#define TYPE_CANVAS_TEXT (canvas_text_get_type ())
#define CANVAS_TEXT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CANVAS_TEXT, CanvasText))
#define CANVAS_TEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CANVAS_TEXT, CanvasTextClass))
#define IS_CANVAS_TEXT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CANVAS_TEXT))
#define IS_CANVAS_TEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CANVAS_TEXT))
#define CANVAS_TEXT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CANVAS_TEXT, CanvasTextClass))

typedef struct _CanvasText CanvasText;
typedef struct _CanvasTextClass CanvasTextClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))

struct _ExportText {
	GObject parent_instance;
	ExportTextPrivate * priv;
};

struct _ExportTextClass {
	GObjectClass parent_class;
};

static gpointer export_text_parent_class = NULL;

GType export_text_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ExportText, g_object_unref)
GType draw_area_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DrawArea, g_object_unref)
gboolean export_text_export (const gchar* fname,
                             DrawArea* da);
static void export_text_export_top_nodes (GFileOutputStream* os,
                                   DrawArea* da);
GType node_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Node, g_object_unref)
GArray* draw_area_get_nodes (DrawArea* self);
GType canvas_text_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CanvasText, g_object_unref)
CanvasText* node_get_name (Node* self);
const gchar* canvas_text_get_text (CanvasText* self);
GArray* node_children (Node* self);
static void export_text_export_node (GFileOutputStream* os,
                              Node* node,
                              const gchar* prefix);
gboolean node_is_task (Node* self);
gboolean node_is_task_done (Node* self);
const gchar* node_get_note (Node* self);
ExportText* export_text_new (void);
ExportText* export_text_construct (GType object_type);

gboolean
export_text_export (const gchar* fname,
                    DrawArea* da)
{
	gboolean result = FALSE;
	GFile* file = NULL;
	GFile* _tmp0_;
	gboolean retval = FALSE;
	GError* _inner_error0_ = NULL;
#line 27 "../src/exports/ExportText.vala"
	g_return_val_if_fail (fname != NULL, FALSE);
#line 27 "../src/exports/ExportText.vala"
	g_return_val_if_fail (da != NULL, FALSE);
#line 28 "../src/exports/ExportText.vala"
	_tmp0_ = g_file_new_for_path (fname);
#line 28 "../src/exports/ExportText.vala"
	file = _tmp0_;
#line 29 "../src/exports/ExportText.vala"
	retval = TRUE;
#line 138 "ExportText.c"
	{
		GFileOutputStream* os = NULL;
		GFileOutputStream* _tmp1_;
#line 31 "../src/exports/ExportText.vala"
		_tmp1_ = g_file_create (file, G_FILE_CREATE_PRIVATE, NULL, &_inner_error0_);
#line 31 "../src/exports/ExportText.vala"
		os = _tmp1_;
#line 31 "../src/exports/ExportText.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 148 "ExportText.c"
			goto __catch14_g_error;
		}
#line 32 "../src/exports/ExportText.vala"
		export_text_export_top_nodes (os, da);
#line 30 "../src/exports/ExportText.vala"
		_g_object_unref0 (os);
#line 155 "ExportText.c"
	}
	goto __finally14;
	__catch14_g_error:
	{
		GError* e = NULL;
#line 30 "../src/exports/ExportText.vala"
		e = _inner_error0_;
#line 30 "../src/exports/ExportText.vala"
		_inner_error0_ = NULL;
#line 34 "../src/exports/ExportText.vala"
		retval = FALSE;
#line 30 "../src/exports/ExportText.vala"
		_g_error_free0 (e);
#line 169 "ExportText.c"
	}
	__finally14:
#line 30 "../src/exports/ExportText.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 174 "ExportText.c"
		gboolean _tmp2_ = FALSE;
#line 30 "../src/exports/ExportText.vala"
		_g_object_unref0 (file);
#line 30 "../src/exports/ExportText.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 30 "../src/exports/ExportText.vala"
		g_clear_error (&_inner_error0_);
#line 30 "../src/exports/ExportText.vala"
		return _tmp2_;
#line 184 "ExportText.c"
	}
#line 36 "../src/exports/ExportText.vala"
	result = retval;
#line 36 "../src/exports/ExportText.vala"
	_g_object_unref0 (file);
#line 36 "../src/exports/ExportText.vala"
	return result;
#line 192 "ExportText.c"
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	guint8* _tmp3_;
	gint _tmp3__length1;
#line 1501 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1502 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1502 "glib-2.0.vapi"
	res_length1 = -1;
#line 1502 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1503 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1503 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1503 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1504 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1504 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1504 "glib-2.0.vapi"
	_tmp3_ = _tmp2_;
#line 1504 "glib-2.0.vapi"
	_tmp3__length1 = _tmp2__length1;
#line 1504 "glib-2.0.vapi"
	if (result_length1) {
#line 1504 "glib-2.0.vapi"
		*result_length1 = _tmp3__length1;
#line 235 "ExportText.c"
	}
#line 1504 "glib-2.0.vapi"
	result = _tmp3_;
#line 1504 "glib-2.0.vapi"
	return result;
#line 241 "ExportText.c"
}

static void
export_text_export_top_nodes (GFileOutputStream* os,
                              DrawArea* da)
{
	GError* _inner_error0_ = NULL;
#line 40 "../src/exports/ExportText.vala"
	g_return_if_fail (os != NULL);
#line 40 "../src/exports/ExportText.vala"
	g_return_if_fail (da != NULL);
#line 253 "ExportText.c"
	{
		GArray* nodes = NULL;
		GArray* _tmp0_;
#line 44 "../src/exports/ExportText.vala"
		_tmp0_ = draw_area_get_nodes (da);
#line 44 "../src/exports/ExportText.vala"
		nodes = _tmp0_;
#line 261 "ExportText.c"
		{
			gint i = 0;
#line 45 "../src/exports/ExportText.vala"
			i = 0;
#line 266 "ExportText.c"
			{
				gboolean _tmp1_ = FALSE;
#line 45 "../src/exports/ExportText.vala"
				_tmp1_ = TRUE;
#line 45 "../src/exports/ExportText.vala"
				while (TRUE) {
#line 273 "ExportText.c"
					GArray* _tmp3_;
					gchar* title = NULL;
					GArray* _tmp4_;
					Node* _tmp5_;
					CanvasText* _tmp6_;
					CanvasText* _tmp7_;
					const gchar* _tmp8_;
					const gchar* _tmp9_;
					gchar* _tmp10_;
					const gchar* _tmp11_;
					guint8* _tmp12_;
					gint _tmp12__length1;
					guint8* _tmp13_;
					gint _tmp13__length1;
					GArray* children = NULL;
					GArray* _tmp14_;
					Node* _tmp15_;
					GArray* _tmp16_;
#line 45 "../src/exports/ExportText.vala"
					if (!_tmp1_) {
#line 294 "ExportText.c"
						gint _tmp2_;
#line 45 "../src/exports/ExportText.vala"
						_tmp2_ = i;
#line 45 "../src/exports/ExportText.vala"
						i = _tmp2_ + 1;
#line 300 "ExportText.c"
					}
#line 45 "../src/exports/ExportText.vala"
					_tmp1_ = FALSE;
#line 45 "../src/exports/ExportText.vala"
					_tmp3_ = nodes;
#line 45 "../src/exports/ExportText.vala"
					if (!(((guint) i) < _tmp3_->len)) {
#line 45 "../src/exports/ExportText.vala"
						break;
#line 310 "ExportText.c"
					}
#line 46 "../src/exports/ExportText.vala"
					_tmp4_ = nodes;
#line 46 "../src/exports/ExportText.vala"
					_tmp5_ = g_array_index (_tmp4_, Node*, (guint) i);
#line 46 "../src/exports/ExportText.vala"
					_tmp6_ = node_get_name (_tmp5_);
#line 46 "../src/exports/ExportText.vala"
					_tmp7_ = _tmp6_;
#line 46 "../src/exports/ExportText.vala"
					_tmp8_ = canvas_text_get_text (_tmp7_);
#line 46 "../src/exports/ExportText.vala"
					_tmp9_ = _tmp8_;
#line 46 "../src/exports/ExportText.vala"
					_tmp10_ = g_strconcat (_tmp9_, "\n", NULL);
#line 46 "../src/exports/ExportText.vala"
					title = _tmp10_;
#line 47 "../src/exports/ExportText.vala"
					_tmp11_ = title;
#line 47 "../src/exports/ExportText.vala"
					_tmp12_ = string_get_data (_tmp11_, &_tmp12__length1);
#line 47 "../src/exports/ExportText.vala"
					_tmp13_ = _tmp12_;
#line 47 "../src/exports/ExportText.vala"
					_tmp13__length1 = _tmp12__length1;
#line 47 "../src/exports/ExportText.vala"
					g_output_stream_write ((GOutputStream*) os, _tmp13_, (gsize) _tmp13__length1, NULL, &_inner_error0_);
#line 47 "../src/exports/ExportText.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 47 "../src/exports/ExportText.vala"
						_g_free0 (title);
#line 47 "../src/exports/ExportText.vala"
						_g_array_unref0 (nodes);
#line 344 "ExportText.c"
						goto __catch15_g_error;
					}
#line 48 "../src/exports/ExportText.vala"
					_tmp14_ = nodes;
#line 48 "../src/exports/ExportText.vala"
					_tmp15_ = g_array_index (_tmp14_, Node*, (guint) i);
#line 48 "../src/exports/ExportText.vala"
					_tmp16_ = node_children (_tmp15_);
#line 48 "../src/exports/ExportText.vala"
					children = _tmp16_;
#line 355 "ExportText.c"
					{
						gint j = 0;
#line 49 "../src/exports/ExportText.vala"
						j = 0;
#line 360 "ExportText.c"
						{
							gboolean _tmp17_ = FALSE;
#line 49 "../src/exports/ExportText.vala"
							_tmp17_ = TRUE;
#line 49 "../src/exports/ExportText.vala"
							while (TRUE) {
#line 367 "ExportText.c"
								GArray* _tmp19_;
								GArray* _tmp20_;
								Node* _tmp21_;
#line 49 "../src/exports/ExportText.vala"
								if (!_tmp17_) {
#line 373 "ExportText.c"
									gint _tmp18_;
#line 49 "../src/exports/ExportText.vala"
									_tmp18_ = j;
#line 49 "../src/exports/ExportText.vala"
									j = _tmp18_ + 1;
#line 379 "ExportText.c"
								}
#line 49 "../src/exports/ExportText.vala"
								_tmp17_ = FALSE;
#line 49 "../src/exports/ExportText.vala"
								_tmp19_ = children;
#line 49 "../src/exports/ExportText.vala"
								if (!(((guint) j) < _tmp19_->len)) {
#line 49 "../src/exports/ExportText.vala"
									break;
#line 389 "ExportText.c"
								}
#line 50 "../src/exports/ExportText.vala"
								_tmp20_ = children;
#line 50 "../src/exports/ExportText.vala"
								_tmp21_ = g_array_index (_tmp20_, Node*, (guint) j);
#line 50 "../src/exports/ExportText.vala"
								export_text_export_node (os, _tmp21_, "        ");
#line 397 "ExportText.c"
							}
						}
					}
#line 45 "../src/exports/ExportText.vala"
					_g_array_unref0 (children);
#line 45 "../src/exports/ExportText.vala"
					_g_free0 (title);
#line 405 "ExportText.c"
				}
			}
		}
#line 42 "../src/exports/ExportText.vala"
		_g_array_unref0 (nodes);
#line 411 "ExportText.c"
	}
	goto __finally15;
	__catch15_g_error:
	{
		GError* e = NULL;
#line 42 "../src/exports/ExportText.vala"
		e = _inner_error0_;
#line 42 "../src/exports/ExportText.vala"
		_inner_error0_ = NULL;
#line 42 "../src/exports/ExportText.vala"
		_g_error_free0 (e);
#line 423 "ExportText.c"
	}
	__finally15:
#line 42 "../src/exports/ExportText.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 42 "../src/exports/ExportText.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 42 "../src/exports/ExportText.vala"
		g_clear_error (&_inner_error0_);
#line 42 "../src/exports/ExportText.vala"
		return;
#line 434 "ExportText.c"
	}
}

static void
export_text_export_node (GFileOutputStream* os,
                         Node* node,
                         const gchar* prefix)
{
	GError* _inner_error0_ = NULL;
#line 61 "../src/exports/ExportText.vala"
	g_return_if_fail (os != NULL);
#line 61 "../src/exports/ExportText.vala"
	g_return_if_fail (node != NULL);
#line 61 "../src/exports/ExportText.vala"
	g_return_if_fail (prefix != NULL);
#line 450 "ExportText.c"
	{
		gchar* title = NULL;
		gchar* _tmp0_;
		const gchar* _tmp5_;
		CanvasText* _tmp6_;
		CanvasText* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		const gchar* _tmp13_;
		guint8* _tmp14_;
		gint _tmp14__length1;
		guint8* _tmp15_;
		gint _tmp15__length1;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		GArray* children = NULL;
		GArray* _tmp29_;
#line 65 "../src/exports/ExportText.vala"
		_tmp0_ = g_strdup (prefix);
#line 65 "../src/exports/ExportText.vala"
		title = _tmp0_;
#line 67 "../src/exports/ExportText.vala"
		if (node_is_task (node)) {
#line 68 "../src/exports/ExportText.vala"
			if (node_is_task_done (node)) {
#line 479 "ExportText.c"
				const gchar* _tmp1_;
				gchar* _tmp2_;
#line 69 "../src/exports/ExportText.vala"
				_tmp1_ = title;
#line 69 "../src/exports/ExportText.vala"
				_tmp2_ = g_strconcat (_tmp1_, "- [x] ", NULL);
#line 69 "../src/exports/ExportText.vala"
				_g_free0 (title);
#line 69 "../src/exports/ExportText.vala"
				title = _tmp2_;
#line 490 "ExportText.c"
			} else {
				const gchar* _tmp3_;
				gchar* _tmp4_;
#line 71 "../src/exports/ExportText.vala"
				_tmp3_ = title;
#line 71 "../src/exports/ExportText.vala"
				_tmp4_ = g_strconcat (_tmp3_, "- [ ] ", NULL);
#line 71 "../src/exports/ExportText.vala"
				_g_free0 (title);
#line 71 "../src/exports/ExportText.vala"
				title = _tmp4_;
#line 502 "ExportText.c"
			}
		}
#line 75 "../src/exports/ExportText.vala"
		_tmp5_ = title;
#line 75 "../src/exports/ExportText.vala"
		_tmp6_ = node_get_name (node);
#line 75 "../src/exports/ExportText.vala"
		_tmp7_ = _tmp6_;
#line 75 "../src/exports/ExportText.vala"
		_tmp8_ = canvas_text_get_text (_tmp7_);
#line 75 "../src/exports/ExportText.vala"
		_tmp9_ = _tmp8_;
#line 75 "../src/exports/ExportText.vala"
		_tmp10_ = g_strconcat (_tmp9_, "\n", NULL);
#line 75 "../src/exports/ExportText.vala"
		_tmp11_ = _tmp10_;
#line 75 "../src/exports/ExportText.vala"
		_tmp12_ = g_strconcat (_tmp5_, _tmp11_, NULL);
#line 75 "../src/exports/ExportText.vala"
		_g_free0 (title);
#line 75 "../src/exports/ExportText.vala"
		title = _tmp12_;
#line 75 "../src/exports/ExportText.vala"
		_g_free0 (_tmp11_);
#line 77 "../src/exports/ExportText.vala"
		_tmp13_ = title;
#line 77 "../src/exports/ExportText.vala"
		_tmp14_ = string_get_data (_tmp13_, &_tmp14__length1);
#line 77 "../src/exports/ExportText.vala"
		_tmp15_ = _tmp14_;
#line 77 "../src/exports/ExportText.vala"
		_tmp15__length1 = _tmp14__length1;
#line 77 "../src/exports/ExportText.vala"
		g_output_stream_write ((GOutputStream*) os, _tmp15_, (gsize) _tmp15__length1, NULL, &_inner_error0_);
#line 77 "../src/exports/ExportText.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 77 "../src/exports/ExportText.vala"
			_g_free0 (title);
#line 541 "ExportText.c"
			goto __catch16_g_error;
		}
#line 79 "../src/exports/ExportText.vala"
		_tmp16_ = node_get_note (node);
#line 79 "../src/exports/ExportText.vala"
		_tmp17_ = _tmp16_;
#line 79 "../src/exports/ExportText.vala"
		if (g_strcmp0 (_tmp17_, "") != 0) {
#line 550 "ExportText.c"
			gchar* note = NULL;
			gchar* _tmp18_;
			gchar* _tmp19_;
			const gchar* _tmp20_;
			const gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
			const gchar* _tmp26_;
			guint8* _tmp27_;
			gint _tmp27__length1;
			guint8* _tmp28_;
			gint _tmp28__length1;
#line 80 "../src/exports/ExportText.vala"
			_tmp18_ = g_strconcat (prefix, "  ", NULL);
#line 80 "../src/exports/ExportText.vala"
			_tmp19_ = _tmp18_;
#line 80 "../src/exports/ExportText.vala"
			_tmp20_ = node_get_note (node);
#line 80 "../src/exports/ExportText.vala"
			_tmp21_ = _tmp20_;
#line 80 "../src/exports/ExportText.vala"
			_tmp22_ = g_strconcat (_tmp19_, _tmp21_, NULL);
#line 80 "../src/exports/ExportText.vala"
			_tmp23_ = _tmp22_;
#line 80 "../src/exports/ExportText.vala"
			_tmp24_ = g_strconcat (_tmp23_, "\n", NULL);
#line 80 "../src/exports/ExportText.vala"
			_tmp25_ = _tmp24_;
#line 80 "../src/exports/ExportText.vala"
			_g_free0 (_tmp23_);
#line 80 "../src/exports/ExportText.vala"
			_g_free0 (_tmp19_);
#line 80 "../src/exports/ExportText.vala"
			note = _tmp25_;
#line 81 "../src/exports/ExportText.vala"
			_tmp26_ = note;
#line 81 "../src/exports/ExportText.vala"
			_tmp27_ = string_get_data (_tmp26_, &_tmp27__length1);
#line 81 "../src/exports/ExportText.vala"
			_tmp28_ = _tmp27_;
#line 81 "../src/exports/ExportText.vala"
			_tmp28__length1 = _tmp27__length1;
#line 81 "../src/exports/ExportText.vala"
			g_output_stream_write ((GOutputStream*) os, _tmp28_, (gsize) _tmp28__length1, NULL, &_inner_error0_);
#line 81 "../src/exports/ExportText.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 81 "../src/exports/ExportText.vala"
				_g_free0 (note);
#line 81 "../src/exports/ExportText.vala"
				_g_free0 (title);
#line 603 "ExportText.c"
				goto __catch16_g_error;
			}
#line 79 "../src/exports/ExportText.vala"
			_g_free0 (note);
#line 608 "ExportText.c"
		}
#line 84 "../src/exports/ExportText.vala"
		_tmp29_ = node_children (node);
#line 84 "../src/exports/ExportText.vala"
		children = _tmp29_;
#line 614 "ExportText.c"
		{
			gint i = 0;
#line 85 "../src/exports/ExportText.vala"
			i = 0;
#line 619 "ExportText.c"
			{
				gboolean _tmp30_ = FALSE;
#line 85 "../src/exports/ExportText.vala"
				_tmp30_ = TRUE;
#line 85 "../src/exports/ExportText.vala"
				while (TRUE) {
#line 626 "ExportText.c"
					GArray* _tmp32_;
					GArray* _tmp33_;
					Node* _tmp34_;
					gchar* _tmp35_;
					gchar* _tmp36_;
#line 85 "../src/exports/ExportText.vala"
					if (!_tmp30_) {
#line 634 "ExportText.c"
						gint _tmp31_;
#line 85 "../src/exports/ExportText.vala"
						_tmp31_ = i;
#line 85 "../src/exports/ExportText.vala"
						i = _tmp31_ + 1;
#line 640 "ExportText.c"
					}
#line 85 "../src/exports/ExportText.vala"
					_tmp30_ = FALSE;
#line 85 "../src/exports/ExportText.vala"
					_tmp32_ = children;
#line 85 "../src/exports/ExportText.vala"
					if (!(((guint) i) < _tmp32_->len)) {
#line 85 "../src/exports/ExportText.vala"
						break;
#line 650 "ExportText.c"
					}
#line 86 "../src/exports/ExportText.vala"
					_tmp33_ = children;
#line 86 "../src/exports/ExportText.vala"
					_tmp34_ = g_array_index (_tmp33_, Node*, (guint) i);
#line 86 "../src/exports/ExportText.vala"
					_tmp35_ = g_strconcat (prefix, "        ", NULL);
#line 86 "../src/exports/ExportText.vala"
					_tmp36_ = _tmp35_;
#line 86 "../src/exports/ExportText.vala"
					export_text_export_node (os, _tmp34_, _tmp36_);
#line 86 "../src/exports/ExportText.vala"
					_g_free0 (_tmp36_);
#line 664 "ExportText.c"
				}
			}
		}
#line 63 "../src/exports/ExportText.vala"
		_g_array_unref0 (children);
#line 63 "../src/exports/ExportText.vala"
		_g_free0 (title);
#line 672 "ExportText.c"
	}
	goto __finally16;
	__catch16_g_error:
	{
		GError* e = NULL;
#line 63 "../src/exports/ExportText.vala"
		e = _inner_error0_;
#line 63 "../src/exports/ExportText.vala"
		_inner_error0_ = NULL;
#line 63 "../src/exports/ExportText.vala"
		_g_error_free0 (e);
#line 684 "ExportText.c"
	}
	__finally16:
#line 63 "../src/exports/ExportText.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 63 "../src/exports/ExportText.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 63 "../src/exports/ExportText.vala"
		g_clear_error (&_inner_error0_);
#line 63 "../src/exports/ExportText.vala"
		return;
#line 695 "ExportText.c"
	}
}

ExportText*
export_text_construct (GType object_type)
{
	ExportText * self = NULL;
#line 24 "../src/exports/ExportText.vala"
	self = (ExportText*) g_object_new (object_type, NULL);
#line 24 "../src/exports/ExportText.vala"
	return self;
#line 707 "ExportText.c"
}

ExportText*
export_text_new (void)
{
#line 24 "../src/exports/ExportText.vala"
	return export_text_construct (TYPE_EXPORT_TEXT);
#line 715 "ExportText.c"
}

static void
export_text_class_init (ExportTextClass * klass,
                        gpointer klass_data)
{
#line 24 "../src/exports/ExportText.vala"
	export_text_parent_class = g_type_class_peek_parent (klass);
#line 724 "ExportText.c"
}

static void
export_text_instance_init (ExportText * self,
                           gpointer klass)
{
}

GType
export_text_get_type (void)
{
	static volatile gsize export_text_type_id__volatile = 0;
	if (g_once_init_enter (&export_text_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ExportTextClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) export_text_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ExportText), 0, (GInstanceInitFunc) export_text_instance_init, NULL };
		GType export_text_type_id;
		export_text_type_id = g_type_register_static (G_TYPE_OBJECT, "ExportText", &g_define_type_info, 0);
		g_once_init_leave (&export_text_type_id__volatile, export_text_type_id);
	}
	return export_text_type_id__volatile;
}

